#include<bits/stdc++.h>

#define int long long
using namespace std;

int nx(int x, int n) {
    return (x + 1) % n;
}

const int N = 8;
map<int, int> g[N][N], ig[N][N];

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    int msk = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        msk |= (1 << (a[i] - 1));
    }
    int y = g[n][k][msk];
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if ((y >> i) & 1) {
            ans.push_back(i);
        }
    }
    sort(ans.begin(), ans.end());
    for (auto i: ans) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}

int pr(int a, int n) {
    return (a - 1 + n) % n;
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k);
    int msk = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        msk |= (1 << (a[i] - 1));
    }
    int y = ig[n][k][msk];
    vector<int> ans;
    for (int i = 0; i < n; ++i) {
        if ((y >> i) & 1) {
            ans.push_back(i);
        }
    }
    sort(ans.begin(), ans.end());
    for (auto i: ans) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}

int fact(int n) {
    int ans = 1;
    for (int i = 1; i <= n; ++i) {
        ans *= i;
    }
    return ans;
}

mt19937 rndd(2281337);

vector<int> toss[N][N];


int32_t main() {

    toss[7][2] = {24,80,48,34,36,66,72,68,40,96,6,20,18,65,12,10,9,33,5,3,17};
    toss[6][2] = {40,10,9,20,48,3,36,33,34,6,24,5,18,17,12};
    toss[5][2] = {20,24,9,18,17,3,6,12,10,5};
    for (int n = 1; n <= 7; ++n) {
        for (int k = 0; k * 2 <= n; ++k) {
            vector<int> gm;
            for (int i = 0; i < (1 << n); ++i) {
                int c1 = 0;
                for (int t = 0; t < n; ++t) {
                    c1 += ((i >> t) & 1);
                }
                if (c1 != k) continue;
                gm.push_back(i);
            }
            set<int> used;
            bool gfl = true;
            for (auto i: gm) {
                bool fl = false;
                for (auto j: gm) {
                    if (j < i) continue;
                    if (((i ^ j) == (i | j)) && !used.count(j)) {
                        g[n][k][i] = j;
                        ig[n][k][j] = i;
                        used.insert(j);
                        fl = true;
                        break;
                    }
                }
                for (auto j: gm) {
                    if (fl) continue;
                    if (((i ^ j) == (i | j)) && !used.count(j)) {
                        g[n][k][i] = j;
                        ig[n][k][j] = i;
                        used.insert(j);
                        fl = true;
                        break;
                    }
                }
                if (!fl) {
                    gfl = false;
                    break;
                }
            }
            if (!gfl) {
                vector<int> to = gm;
//                cerr << n << ' ' << k << "\n";
                if(toss[n][k].size() > 0){
                    to = toss[n][k];
                } else{
                    int rep = 0;
                    while (true) {
                        shuffle(to.begin(), to.end(), rndd);
                        bool fl = true;
                        for (int i = 0; i < gm.size(); ++i) {
                            if ((gm[i] ^ to[i]) != (gm[i] | to[i])) fl = false;

                        }

                        if (fl) break;
                        next_permutation(to.begin(), to.end());
                    }
                }
                for (int i = 0; i < gm.size(); ++i) {
                    g[n][k][gm[i]] = to[i];
                    ig[n][k][to[i]] = gm[i];
                    cerr << to[i] << ',';
                }
                cerr << "\n";
            }

        }
    }
    int typ;
    cin >> typ;
    if (typ == 1) {
        int t;
        cin >> t;
        while (t--) {
            solve1();
        }
    } else {
        int t;
        cin >> t;
        while (t--) {
            solve2();
        }
    }
}

