#include <bits/stdc++.h>
using namespace std;
#define pb push_back

int maxn = 2e5 + 1;
int n, k, q;
vector<vector<int>> g(maxn);

vector<int> ans(maxn);

// prev = 0 => l, prev = 1 => r;
void dfs(int u, bool prev, int rev=0) {
    if (g[u].empty()) {
        if (rev <= k) ans[u] = 1;
        return;
    }
    if (prev) {
        dfs(g[u][0], 0, rev + 1);
        dfs(g[u][1], 1, rev);
        ans[u] = ans[g[u][0]] + ans[g[u][1]];
    } else {
        dfs(g[u][0], 0, rev);
        dfs(g[u][1], 1, rev + 1);
        ans[u] = ans[g[u][0]] + ans[g[u][1]];
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> k >> q;
    for (int i = 1; i <= n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int u, v;
            cin >> u >> v;
            g[i].pb(u);
            g[i].pb(v);
        }
    }
    if (n != 1) {
        dfs(g[1][0], 0);
        dfs(g[1][1], 1);
        ans[1] = ans[g[1][0]] + ans[g[1][1]];
    }
    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        cout << ans[u] << '\n';
    }
}
