#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define int long long
#define int128 __int128

vector<vector<int>> g;
vector<int> dp0, dp1;

void dfs(int u, int p = -1) {
    for (auto it: g[u]) {
        if (it != p) {
            dfs(it, u);
            dp1[u] += dp0[it];
            dp0[u] += max(dp0[it], dp1[it]);
        }
    }
}

void solve() {
    int n, q, x, y, m;
    cin >> n >> q >> x >> y >> m;
    g.assign(n + 1, {});
    dp0.assign(n + 1, 0);
    dp1.assign(n + 1, 0);
    int128 bebra = 0;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    vector<int> inp;
    for (int i = 1; i <= n; ++i) {
        int l, r;
        cin >> l >> r;
        inp.pb(l);
        bebra = (bebra ^ ((x * i + y * l * l) % m));
        dp1[i] = l;
    }
    dfs(1);
    vector<int> req;
    for (int i = 1; i <= q; ++i) {
        int v;
        cin >> v;
        req.pb(v);
    }
    int i = 1;
    for (auto v: req) {
        if (v == max(dp0[1], dp1[1])) {
            vector<int> ans;
            while (bebra > 0) {
                ans.pb(bebra % 10);
            }
            reverse(ans.begin(), ans.end());
            for (auto it: ans) {
                cout << it;
            }
        } else {
            cout << "-1 ";
        }
        cout << endl;
        ++i;
    }
    cout << endl;
    cin >> i;
    while (i != 0) {
        if (req[i - 1] == max(dp0[1], dp1[1])) {
            for (auto it: inp) {
                cout << it << " ";
            }
        } else {
            cout << "-1";
        }
        cout << endl;
        cin >> i;
    }
    cout << endl;
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}