#include <bits/stdc++.h>

#define int long long

using namespace std;

struct elem{
    int r, ar, am;

    elem(int r, int ar, int am) : r(r), ar(ar), am(am) {}

    elem upd(int type, int val) {
        if (type == 0) { //val to records
            if (val > r) {
                return {val, ar, am + 1};
            }
            return {r, ar, am};
        } else {
            if (val < ar) {
                return {r, val, am + 1};
            }
            return {r, ar, am};
        }
    }


};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }

    int ans = 0;

    vector<vector<int>> dp(n + 1, vector<int> (n + 1, 0));

    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= n; ++j) {
            if (i == j) {
                continue;
            }

            for (int k = 0; k < i; ++k) {
                if (k == 0 || a[i] > a[k]) {
                    dp[i][j] = max(dp[i][j], dp[k][j] + 1);
                }
            }

            for (int k = 0; k < j; ++k) {
                if (k == 0 || a[j] < a[k]) {
                    dp[i][j] = max(dp[i][j], dp[i][k] + 1);
                }
            }

            ans = max(ans, dp[i][j]);
        }
    }

//    for (int i = 0; i <= n; ++i) {
//        for (int j = 0; j <= n; ++j) {
//            cout << dp[i][j] << ' ';
//        }
//        cout << '\n';
//    }

    cout << ans << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
