#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <random>
#include <bitset>
using namespace std;
typedef long long ll;
typedef long double ld;
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }
#define all(a) a.begin(), a.end()
const long long INF = 2e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;
const ll MX = 1501;

bitset<MX> dp[MX];
bitset<MX> stdp[MX];
bitset<MX> bl;
ll fir[MX][MX];

struct Q{
    ll a, b, k, i;
    bool operator<(const Q& f) const{
        return k < f.k;
    }
};

// 1
// 2
// 3
// 7
// 8
// 9
// 10
// 15
// 16
// 17
// 18

int main() {
	fastio();
    ll n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (ll i = 0;i<n;i++) cin >> w[i];
    sort(all(w));
    ll zzz;
    cin >> zzz;
    while(q--){
        ll a, b, k;
        cin >> k >> a >> b;
        vector<ll> v;
        ll f = 1;
        for (ll i = 0;i<n;i++){
            if (w[i] <= k) {
                v.push_back(w[i]);
                f*=3;
            }
        }
        set<pair<ll, ll>> st;
        for (ll mask = 0;mask<f;mask++){
            ll x = 0, y = 0;
            ll stm = mask;
            for (ll i = 0;i<v.size();i++){
                if (mask % 3 == 1) x+=v[i];
                if (mask % 3 == 2) y+=v[i];
                mask/=3;
            }
            if (x <=a && y <= b) st.insert({x, y});
            mask = stm;
        }
        if (st.size() == (a+1)*(b+1)) cout << "Yes\n";
        else cout << "No\n";
    }
    cout << endl;
	return 0;
}