#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<vector<int>> g;
vector<int> pref, tour, tin, tout;

void dfs(int v, int dir) {
    tour.push_back({g[v].empty() ? pref[v] : INF});
    tin[v] = tour.size() - 1;
    if (!g[v].empty()) {
        pref[g[v][0]] = pref[v] + (dir == 1);
        dfs(g[v][0], 0);
        pref[g[v][1]] = pref[v] + (dir == 0);
        dfs(g[v][1], 1);
    }
    tout[v] = tour.size();
}

vector<vector<int>> qq;
vector<int> ans;
int k;

multiset<int> dfs2(int v) {
    multiset<int> cur{tour[tin[v]]};
    for (auto u : g[v]) {
        auto x = dfs2(u);
        if (cur.size() < x.size()) {
            cur.swap(x);
        }
        for (auto i : x) {
            cur.insert(i);
        }
    }
    while (!cur.empty() && *prev(cur.end()) > k) {
        cur.erase(prev(cur.end()));
    }
    for (auto i : qq[v]) {
        ans[i] = cur.size();
    }
    return cur;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, q;
    cin >> n >> k >> q;
    g.resize(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        for (int j = 0; j < t; ++j) {
            int x;
            cin >> x;
            --x;
            g[i].push_back(x);
        }
    }
    pref.resize(n);
    tin.resize(n);
    tout.resize(n);
    dfs(0, -1);
    qq.resize(n);
    ans.resize(q);
    for (int i = 0; i < q; ++i) {
        int u;
        cin >> u;
        --u;
        qq[u].push_back(i);
    }
    dfs2(0);
    for (auto i : ans) {
        cout << i << "\n";
    }
}
