#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>
#define int int64_t
#define double long double
//#define MULTITASK
#define NO_INTERACTIVE
using namespace std;
using namespace __gnu_pbds;
void solve();
int32_t main() {
#ifdef NO_INTERACTIVE
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
#ifdef BIBIKOV
    freopen("input", "r", stdin);
    freopen("output", "w", stdout);
#endif
#endif
    int tt = 1;
#ifdef MULTITASK
    cin >> tt;
#endif
    while (tt--) {
        solve();
#ifdef MULTITASK
        cout << '\n';
#endif
    }
}

void solve() {
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> a(k), b(k);
    for (int i = 0; i < k; i++)
        cin >> a[i] >> b[i];
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    int ma = h - a.back() + a[0] - 1, mb = w - b.back() + b[0] - 1, ha = 0, hb = 0;
    for (int i = 0; i < k - 1; i++) {
        int l1 = min(a[i], a[i + 1]), l2 = h - max(a[i], a[i + 1]) + 1, l = min(l1, l2);
        if (ma < abs(a[i] - a[i + 1]) - 1 || (ma == abs(a[i] - a[i + 1]) - 1 && l < ha))
            ma = abs(a[i] - a[i + 1]) - 1, ha = l;
    }
    for (int i = 0; i < k - 1; i++) {
        int l1 = min(b[i], b[i + 1]), l2 = w - max(b[i], b[i + 1]) + 1, l = min(l1, l2);
        if (mb < abs(b[i] - b[i + 1]) - 1 || (mb == abs(b[i] - b[i + 1]) - 1 && l < hb))
            mb = abs(b[i] - b[i + 1]) - 1, hb = l;
    }
    cout << (h - ma) * (w - mb) << ' ' << ha + hb;
}
