#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<vector<ll>> g;
vector<ll> a;
vector<ll> dp1, dp2;

void dfs(ll v, ll p) {
    dp1[v] = a[v];
    for (auto &to: g[v]) {
        if (to != p) {
            dfs(to, v);
            dp1[v] += dp2[to];
            dp2[v] += max(dp1[to], dp2[to]);
        }
    }
}

void solve() {
    ll n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    g.assign(n, {});
    a.assign(n, 0);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        g[u - 1].push_back(v - 1);
        g[v - 1].push_back(u - 1);
    }
    vector<ll> l(n), r(n);
    bool p = true;
    for (ll i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        a[i] = l[i];
        if (l[i] != r[i]) {
            p = false;
        }
    }
    if (p) {
        dp1.assign(n, 0);
        dp2.assign(n, 0);
        dfs(0, 0);
        ll mx = max(dp1[0], dp2[0]);
        ll k = 0;
        for (ll i = 0; i < n; i++) {
            ll gg = (x * (i + 1) + y * (a[i] * a[i] % m)) % m;
            k = k ^ gg;
        }
        vector<ll> v(q);
        for (ll i = 0; i < q; i++) {
            cin >> v[i];
        }
        for (ll i = 0; i < q; i++) {
            if (v[i] == mx) {
                cout << k << ' ';
            } else {
                cout << "-1 ";
            }
        }
        cout << endl;
        while (true) {
            ll i;
            cin >> i;
            if (i == 0) {
                break;
            }
            i--;
            if (v[i] == mx) {
                for (ll j = 0; j < n; j++) {
                    cout << a[j] << ' ';
                }
                cout << endl;
            } else {
                cout << -1 << endl;
            }
        }
        return;
    }
    ll l0 = l[0], r0 = r[0];
    l.erase(l.begin());
    r.erase(r.begin());
    n--;
    ll sum_l = 0, sum_r = 0;
    for (ll i = 0; i < n; i++) {
        sum_l += l[i];
        sum_r += r[i];
    }
    ll k1 = 0;
    for (ll i = 0; i <= n; i++) {
        k1 = (k1 + x * (i + 1)) % m;
    }
    vector<ll> pr(n + 1);
    for (ll i = 1; i <= n; i++) {
        pr[i] = (pr[i - 1] + r[i - 1] * r[i - 1]) % m;
    }
    vector<ll> pl(n + 1);
    for (ll i = 1; i <= n; i++) {
        pl[i] = (pl[i - 1] + l[n - i] * l[n - i]) % m;
    }
    vector<ll> pref(n + 1);

    for (ll i = 1; i <= n; i++) {
        pref[i] = pref[i - 1] + r[i - 1] - l[i - 1];
    }

    vector<ll> v(q);
    for (ll i = 0; i < q; i++) {
        cin >> v[i];
    }
    for (ll i = 0; i < q; i++) {
        if (l0 <= v[i] && v[i] <= r0 && v[i] >= sum_l) {
            ll k = k1; 
            k = (k + y * v[i] * v[i]) % m;
            k = (k + y * pl[n]) % m;
            cout << k << ' ';
        } else if (sum_l <= v[i] && v[i] < sum_r && v[i] >= l0) {
            ll ind = lower_bound(pref.begin(), pref.end(), v[i] - sum_l) - pref.begin();
            ind--;
            ll k = k1;
            k = (k + y * l0 * l0) % m;
            k = (k + y * pr[ind]) % m;
            k = (k + y * pl[n - ind - 1]) % m;
            ll gg = v[i] - sum_l - pref[ind] + l[ind];
            k = (k + y * (gg * gg % m)) % m;
            cout << k << ' ';

        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    while (true) {
        ll i;
        cin >> i;
        if (i == 0) {
            break;
        }
        i--;
        if (l0 <= v[i] && v[i] <= r0 && v[i] >= sum_l) {
            cout << v[i] << ' ';
            for (ll j = 0; j < n; j++) {
                cout << l[j] << ' ';
            }
            cout << endl;
        } else if (sum_l <= v[i] && v[i] < sum_r && v[i] >= l0) {
            ll ind = lower_bound(pref.begin(), pref.end(), v[i] - sum_l) - pref.begin();
            ind--;
            ll gg = v[i] - sum_l - pref[ind] + l[ind];
            cout << l0 << ' ';
            for (ll j = 0; j < ind; j++) {
                cout << r[j] << ' ';
            }
            cout << gg << ' ';
            for (ll j = ind + 1; j < n; j++) {
                cout << l[j] << ' ';
            }
            cout << endl;
        } else {
            cout << "-1" << endl;
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
}