#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

void solve11(vector<int>& t, int n){
    int add = n / 2;
    vector<int> r;
    for (auto d: t) {
        if (d + add <= n) {
            r.push_back(d + add);
        } else {
            r.push_back(add - n + d);
        }
    }
    sort(r.begin(), r.end());
    for (auto d: r) cout << d << " ";
    cout << endl;
}

void solve12(vector<int>& t, int n){
    int add = n / 2;
    vector<int> r;
    for (auto d: t) {
        if (d - add >= 1) {
            r.push_back(d - add);
        } else {
            r.push_back(n + d - add);
        }
    }
    sort(r.begin(), r.end());
    for (auto d: r) cout << d << " ";
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int c;
    cin >> c;
    if (c == 1) {
        int m;
        cin >> m;
        while (m--) {
            int n, k;
            cin >> n >> k;
            vector<int> t(k);
            for (int i = 0; i < k; ++i) {
                cin >> t[i];
            }
            if ((max(t[1], t[0]) - min(t[0], t[1]) == 1) || (max(t[1], t[0]) == n && min(t[1], t[0]) == 1)){
                solve11(t, n);
            }else{
                vector<int> res;
                for (auto d: t) {
                    if (d == n){
                        res.push_back(1);
                    }else{
                        res.push_back(d+1);
                    }
                }
                sort(res.begin(), res.end());
                for (auto d : res) cout << d << " ";
                cout << endl;
            }
        }
    } else {
        int m;
        cin >> m;
        while (m--) {
            int n, k;
            cin >> n >> k;
            vector<int> t(k);
            for (int i = 0; i < k; ++i) {
                cin >> t[i];
            }
            if ((max(t[1], t[0]) - min(t[0], t[1]) == 1) || (max(t[1], t[0]) == n && min(t[1], t[0]) == 1)){
                solve12(t, n);
            }else{
                vector<int> res;
                for (auto d: t) {
                    if (d == 1){
                        res.push_back(n);
                    }else{
                        res.push_back(d-1);
                    }
                }
                sort(res.begin(), res.end());
                for (auto d : res) cout << d << " ";
                cout << endl;
                cout << endl;
            }
        }
    }
}