#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")

using namespace std;

int f(const vector<int> &a) {
	int n = a.size();
	if (n == 0) return 0;
	vector<int> dp(n, 1);
	int mx = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (a[j] < a[i]) dp[i] = max(dp[j] + 1, dp[i]);
		}
		mx = max(mx, dp[i]);
	}
	return mx;
}

int g(const vector<int> &a) {
	int n = a.size();
	if (n == 0) return 0;
	vector<int> dp(n, 1);
	int mx = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (a[j] > a[i]) dp[i] = max(dp[j] + 1, dp[i]);
		}
		mx = max(mx, dp[i]);
	}
	return mx;
}

int count(const vector<int> &a, int mask) {
	int n = a.size();
	vector<int> x, y;
	for (int i = 0; i < n; ++i) {
		if ((mask >> i) & 1) x.emplace_back(a[i]);
		else y.emplace_back(a[i]);
	}
	return f(x) + g(y);
}

void solve() {
	int n;
	cin >> n;
	vector<int> p(n);
	for (auto &it : p) cin >> it;
	int mx = 1;
	for (int mask = 0; mask < (1 << n); ++mask) {
		mx = max(mx, count(p, mask));
	}
	cout << mx << endl;
}

signed main() {
	int t;
	cin >> t;
	while (t--) solve();
	return 0;
}

