#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll INF = 1e18;

void solve(){
    ll n, q, z;
    cin >> n >> q;
    vector<ll> w(n);
    for(ll i = 0; i < n; i++){
        cin >> w[i];
    }
    sort(w.begin(), w.end());
    ll mx = 0, last = 0;
    map<ll, ll> mp;
    for(ll i = 0; i < n; i++){
        if(mx + 1 < w[i]){
            mp[w[i]] = last;
        } else {
            mx += w[i];
            mp[w[i]] = mx;
            last = mx;
        }
    }
    cin >> z;
    for(ll it = 0; it < q; it++){
        ll j, c, d;
        cin >> j >> c >> d;
        ll l = -1, r = n;
        while(r - l > 1){
            ll mid = (l + r) / 2;
            if(w[mid] <= j){
                l = mid;
            } else {
                r = mid;
            }
        }
        if(l == -1 || mp[w[l]] <= c){
            cout << "No" << '\n';
        } else {
            cout << "Yes" << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}
