#include <iostream>
#include <deque>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <map>

using namespace std;

typedef long long ll;

ll inf = 1e9;

#define mod(a, m) ((a%m)+m)%m

ll mods(ll a, ll m)
{
	a %= m;
	if (!a) a = m;
	return a;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll a, m;
	cin >> a >> m;
	for (int i = 0; i < m; i++)
	{
		ll n, k, x1, x2;
		cin >> n >> k;
		if (a == 1)
		{
			vector<ll> v(k), a(k);
			map<ll, ll> mp;
			set<ll> st; // not used
			for (int i = 1; i <= n; i++)
			{
				st.insert(i);
			}
			for (int i = 0; i < k; i++)
			{
				cin >> v[i];
				st.erase(v[i]);
			}
			a = v;
			sort(v.begin(), v.end());
			for (int i = 0; i < k; i++)
			{
				auto dp = st.upper_bound(v[i]);
				if (dp == st.end())
					dp = st.begin();
				mp[v[i]] = *dp;
				st.erase(dp);
			}
			for (int i = 0; i < k; i++)
			{
				cout << mp[a[i]] << " ";
			}
		}
		else
		{
			vector<ll> v(k), a(k);
			map<ll, ll> mp;
			set<ll> st; // not used
			for (int i = 1; i <= n; i++)
			{
				st.insert(-i);
			}
			for (int i = 0; i < k; i++)
			{
				cin >> v[i];
				st.erase(-v[i]);
			}
			a = v;
			sort(v.begin(), v.end());
			for (int i = k-1; i >= 0; i--)
			{
				auto dp = st.upper_bound(-v[i]);
				if (dp == st.end())
					dp = st.begin();
				mp[v[i]] = -(*dp);
				st.erase(dp);
			}
			for (int i = 0; i < k; i++)
			{
				cout << mp[a[i]] << " ";
			}
		}
		cout << endl;
	}
}


