#include <bits/stdc++.h>


using namespace std;


#define int long long
#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


const ll inf = 1e18;
mt19937 rnd(23424);

template<class T>
void print(const vector<T> &a){
    for(auto x: a){
        cout << x << " ";
    }
    cout << "\n";
}


int n, q;
vector<ll> w;
vector<ll> va, vb, vk;
ll z;
vector<vector<vector<ll>>> dp;

const ll mxa = 300;
const ll mxb = 300;

void print_bool(bool x){
    if(x){
        cout << "Yes" << "\n";
    } else{
        cout << "No" << "\n";
    }
}


int32_t main(){
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    cin >> n >> q;
    w.resize(n);
    for(int i = 0; i < n; i += 1){
        cin >> w[i];
    }
    sort(all(w));
    cin >> z;
    vk.resize(q);
    va.resize(q);
    vb.resize(q);
    dp.assign(n + 1, vector<vector<ll>>(mxa + 1, vector<ll>(mxb + 1, 0)));
    dp[0][0][0] = 1;
    for(int i = 1; i <= n; i += 1){
        ll mw = w[i - 1];
        dp[i] = dp[i - 1];
        for(ll a = 0; a <= mxa; a += 1){
            for(ll b = 0; b <= mxb; b += 1){
                if(dp[i - 1][a][b]){
                    if(a + mw <= mxa){
                        dp[i][a + mw][b] = 1;
                    }
                    if(b + mw <= mxb){
                        dp[i][a][b + mw] = 1;
                    }
                }
                
            }
        }
    }
    for(int i = 1; i <= n; i += 1){
        for(ll a = 0; a <= mxa; a += 1){
            for(ll b = 0; b <= mxb; b += 1){
                if(a > 0 && dp[i][a - 1][b] == 0){
                    dp[i][a][b] = 0;
                }
                if(b > 0 && dp[i][a][b - 1] == 0){
                    dp[i][a][b] = 0;
                }
            }
        }
    }
    for(int itr = 0; itr < q; itr += 1){
        cin >> vk[itr] >> va[itr] >> vb[itr];
    }
    for(int itr = 0; itr < q; itr += 1){
        ll k = vk[itr];
        ll pos = upper_bound(all(w), k) - w.begin();
        ll a = va[itr];
        ll b = vb[itr];
        print_bool(dp[pos][a][b]);
    }
    return 0;
}

/*
8 5
17 1 3 2 100 5 6 1
0
6 0 3
9 4 4
5 15 3
17 34 1
16 33 2

*/