#include <iostream>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <queue>
#include <algorithm>
#include <numeric>

using namespace std;

#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' ';
#define debnl(x) cout << #x << '=' << x << endl;
#define print(a) {cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define print(a)

#endif

typedef long long ll;
typedef pair<int, int> ii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e18 + 1;

void solve();

signed main() {
	fastIO();
	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}
}

int my_popcount(int x){
    int cnt = 0;
    while (x > 0) cnt += x % 2, x /= 2;
    return cnt;
}

vii bs;

bool comp(int i, int j) {
	return bs[i].second < bs[j].second;
}

int check(vi inds) {
    vi ans = {inds[0]};
    for (auto i: inds) {
        if (bs[ans.back()].second < bs[i].first) ans.push_back(i);
    }

    return ans.size();
}

void solve() {
    int n;
    cin >> n;
    bs = vii(n);
    for (int i = 0; i < n; i++){
        cin >> bs[i].first >> bs[i].second;
    }
	vi inds(n);
	iota(all(inds), 0);
    sort(all(inds), comp);
    int m0 = check(inds);
    for (int mask = 0; mask < (1 << n); mask++){
        if (my_popcount(mask) != n / 2) continue;
        vi ans;
        for (int i = 0; i < n; i++){
            if (mask & (1 << i)) ans.push_back(inds[i]);
        }
        if (check(ans) == m0 / 2){
            for (auto ind: ans) cout << ind + 1 << ' ';
            cout << nl;
            return;
        }
    }
}
