#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 7;

int n;
int l[N], r[N];

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	vector<int> ord(n);
	for (int i = 0; i < n; ++i) {
		ord[i] = i;
	}
	sort(ord.begin(), ord.end(), [&](int i, int j) {
		return r[i] < r[j] || (r[i] == r[j] && l[i] > l[j]);
	});
	vector<int> kek;
	for (int i : ord) {
		if (kek.empty() || l[i] > r[kek.back()]) {
			kek.push_back(i);
		}
	}
	vector<int> good(n);
	for (int i : kek) {
		good[i] = 1;
	}
	vector<int> cnt(n);
	vector<int> id(n, -1);
	for (int i = 0; i < n; ++i) {
		if (!good[i]) {
			for (int j : kek) {
				if (l[i] <= r[j] && r[i] >= r[j]) {
					++cnt[j];
					id[i] = j;
					break;
				}
			}
		}
	}
	sort(kek.begin(), kek.end(), [&](int i, int j) {
		return cnt[i] < cnt[j];
	});
	for (int i = 0; i < (int)kek.size() / 2; ++i) {
		good[kek[i]] = 0;
	}
	int cntgood = (int)kek.size() / 2;
	for (int i = 0; i < n; ++i) {
		if (id[i] != -1 && good[id[i]] && cntgood < n / 2) {
			++cntgood;
			good[i] = 1;
		}
	}
	vector<int> ans;
	for (int i = 0; i < n; ++i) {
		if (good[i]) {
			ans.push_back(i);
		}
	}
	assert((int)ans.size() == n / 2);
	sort(ans.begin(), ans.end());
	for (int i = 0; i < n / 2; ++i) {
		cout << ans[i] + 1 << " ";
	}
	cout << "\n";
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}