#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 2e5 + 7;

int n, q;
vector<int> g[N];
ll X, Y, M;
ll V[N];
ll l[N], r[N];
vector<int> kek;
ll dp[N][2];
ll a[N];
ll k[N];
ll rofl[N];
int par[N];
vector<int> ord;
ll pref[N];
ll prefxor[N], sufxor[N];

void dfs(int v, int p = -1) {
	par[v] = p;
	for (int u : g[v]) {
		if (u != p) {
			dfs(u, v);
		}
	}
	ord.push_back(v);
}

void build(ll d) {
	for (int i = 0; i < n; ++i) {
		a[i] = l[i];
		ll mn = min(d, r[i] - l[i]);
		a[i] += mn;
		d -= mn;
	}
}

ll get(ll d) {
	build(d);
	for (int i = 0; i < n; ++i) {
		dp[i][0] = 0;
		dp[i][1] = a[i];
	}
	for (int v : ord) {
		dp[v][1] = max(dp[v][1], dp[v][0]);
		if (par[v] != -1) {
			dp[par[v]][0] += dp[v][1];
			dp[par[v]][1] += dp[v][0];
		}
	}
	return dp[0][1];
}

ll getcert(ll d) {
	int L = 0, R = n + 1;
	while (R - L > 1) {
		int mid = (L + R) / 2;
		if (pref[mid] <= d) {
			L = mid;
		} else {
			R = mid;
		}
	}
	d -= pref[L];
	ll ret = prefxor[L];
	if (L < n) {
		ret ^= sufxor[L + 1];
		ll a1 = l[L] + d;
		ret ^= (X * (L + 1) + Y * a1 % M * a1) % M;
	}
	return ret;
}

void solve(ll L, ll R, ll Lval, ll Rval, vector<int> vs) {
	if (vs.empty()) {
		return;
	}
	if (Lval == Rval) {
		for (int i : vs) {
			rofl[i] = L;
		}
		return;
	}
	if (Lval + R - L == Rval) {
		for (int i : vs) {
			rofl[i] = L + V[i] - Lval;
			// assert(get(rofl[i]) == V[i]);
		}
		return;
	}
	int mid = (L + R) / 2;
	ll midval = get(mid);
	vector<int> vsl, vsr;
	for (int i : vs) {
		if (V[i] <= midval) {
			vsl.push_back(i);
		} else {
			vsr.push_back(i);
		}
	}
	solve(L, mid, Lval, midval, vsl);
	solve(mid, R, midval, Rval, vsr);
}

void solve() {
	cin >> n >> q;
	cin >> X >> Y >> M;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	for (int i = 0; i < q; ++i) {
		cin >> V[i];
	}
	ll sum = 0;
	for (int i = 0; i < n; ++i) {
		sum += r[i] - l[i];
	}
	pref[0] = 0;
	for (int i = 0; i < n; ++i) {
		pref[i + 1] = pref[i] + r[i] - l[i];
	}
	prefxor[0] = 0;
	for (int i = 0; i < n; ++i) {
		prefxor[i + 1] = prefxor[i] ^ ((X * (i + 1) + Y * r[i] % M * r[i]) % M);
	}
	sufxor[n] = 0;
	for (int i = n - 1; i >= 0; --i) {
		sufxor[i] = sufxor[i + 1] ^ ((X * (i + 1) + Y * l[i] % M * l[i]) % M);
	}
	ord.clear();
	dfs(0);
	vector<int> vs;
	ll mn = get(0);
	ll mx = get(sum);
	for (int i = 0; i < q; ++i) {
		if (V[i] < mn || V[i] > mx) {
			k[i] = -1;
		} else {
			vs.push_back(i);
		}
	}
	solve(0, sum, mn, mx, vs);
	for (int i : vs) {
		k[i] = getcert(rofl[i]);
	}
	for (int i = 0; i < q; ++i) {
		cout << k[i] << " ";
	}
	cout << endl;
	while (true) {
		int id;
		cin >> id;
		if (id == 0) {
			break;
		}
		--id;
		if (k[id] == -1) {
			cout << -1; 
		} else {
			build(rofl[id]);
			for (int i = 0; i < n; ++i) {
				cout << a[i] << " ";
			}
		}
		cout << endl;
	}
}	

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}