#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

vector<vector<int>> gnd;

void gen(vector<int>& r, int i, int n) {
	if (i == n) {
		gnd.push_back(r);
	}
	else {
		if (n - i >= n / 2 - (int) r.size()) {
			gen(r, i + 1, n);
		}
		r.push_back(i);
		gen(r, i + 1, n);
		r.pop_back();
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<vector<int>> v(n);
		set<int> s;
		for (int i = 0; i < n; ++i) {
			s.insert(i);
			int l, r;
			cin >> l >> r;
			v.push_back({l, 1, i});
			v.push_back({ r, -1, i });
		}
		sort(v.begin(), v.end());
		vector<vector<int>> j;
		vector<pair<int, int>> k;
		vector<int> st;
		int idx = 0;
		for (int i = 0; i < 2 * n; ++i) {
			if (v[i][1] == 1) {
				st.push_back(i);
			}
			else {
				if (!st.empty()) {
					j.push_back(st);
					k.push_back({ st.size(), idx++ });
					st.clear();
				}
			}
		}
		sort(k.begin(), k.end());
		for (int i = 0; i < k.size() / 2; ++i) {
			for (int e = 0; e < k[i].first; ++e) {
				s.erase(j[k[i].second][e]);
			}
		}
		int ix = k.size() / 2, inx = 0;
		while (s.size() > n / 2) {
			if (inx < k[ix].first) {
				s.erase(j[k[ix].second][inx++]);
			}
			else {
				++ix;
				inx = 0;
			}
		}
		for (auto i : s) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}
	return 0;
}
