#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

inline void slave1() {
    int n, k;
    std::cin >> n >> k;
    std::set<int> a;
    for (int i = 0; i < k; i++) {
        int x;
        std::cin >> x;
        x--;
        a.insert(x);
    }
    std::vector<int> to(n);
    for (int i = 0; i < n; i++) {
        to[i] = (i + n - 1) % n;
    }
    std::set<int> b;
    std::vector<int> way;
    for (auto x : a) {
        int y = to[x];
        way = {y};
        while (a.count(y) || b.count(y)) {
            y = to[y];
            way.push_back(y);
        }
        for (auto node : way) {
            to[node] = to[y];
        }
        b.insert(y);
    }
    for (auto e : b) {
        std::cout << e + 1 << ' ';
    }
    std::cout << '\n';
}

inline void slave2() {
    int n, k;
    std::cin >> n >> k;
    std::set<int> a;
    for (int i = 0; i < k; i++) {
        int x;
        std::cin >> x;
        x--;
        a.insert(x);
    }
    std::vector<int> to(n);
    for (int i = 0; i < n; i++) {
        to[i] = (i + 1) % n;
    }
    std::set<int> b;
    std::vector<int> way;
    for (auto x : a) {
        int y = to[x];
        way = {y};
        while (a.count(y) || b.count(y)) {
            y = to[y];
            way.push_back(y);
        }
        for (auto node : way) {
            to[node] = to[y];
        }
        b.insert(y);
    }
    for (auto e : b) {
        std::cout << e + 1 << ' ';
    }
    std::cout << '\n';
}

signed main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int type;
    std::cin >> type;
    int t;
    std::cin >> t;
    if (type == 1) {
        while (t-- > 0) {
            slave1();
        }
    } else {
        while (t-- > 0) {
            slave2();
        }
    }
    return 0;
}