#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "algorithm"

#define int long long
#define vec vector
using namespace std;

bool bit(int num, int index) {
    return (num >> index) & 1;
}

void solve() {
    int n;
    cin >> n;
    int best = 0;
    vec<int> p(n);
    for (auto &i: p)cin >> i;
    for (int i = 0; i < 1 << n; ++i) {
        vec<int> a;
        vec<int> b;
        int cnta = 0, cntb = 0;
        int minn = +1e9;
        int maxx = -1e9;
        for (int j = 0; j < n; ++j) {
            if (bit(i, j)) {
                if (maxx < p[j]) {
                    cnta++;
                    maxx = p[j];
                }
                a.emplace_back(p[j]);
            } else {
                if (minn > p[j]) {
                    cntb++;
                    minn = p[j];
                }
                b.emplace_back(p[j]);
            }
        }
        best = max(best, cnta + cntb);
    }
    cout<<best<<'\n';

}

signed main() {
    int t;
    cin >> t;
    while (t--)solve();
    return 0;
}
