#include <iostream>
#include <vector>
#include <random>
#include <chrono>
#include <algorithm>
#include <set>

using namespace std;
typedef long long ll;
typedef long double ld;

ll INF = 2e18, L_INF = 2e9, mod = 1e9+7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define all(x) x.begin(), x.end()
#define forall(aaa, aaaa) for(auto& aaa: aaaa)

void print(vector < vector < ll >>& a) {
    forall(i, a) {
        forall(j, i) cout << max(j, -1ll) << '\t';
        cout << '\n';
    }
    cout << "-----------";
    cout << endl;
}

void print(vector < ll >& a) {
    forall(i, a) cout << i << ' ';
    cout << endl;
}

void stupid_solve(ll n, vector < ll >&a) {
//    ll n;
//    cin >> n;
//    vector < ll > a(n);
//    forall(i, a) cin >> i;
    ll ans = 0;
    for (ll mask = 0; mask < (1ll << n); mask++) {
        ll now = 0, mx = 0, mn = n + 1;
        for (ll i = 0; i < n; i++) {
            if (mask & (1ll << i)) {
                if (a[i] > mx) now++;
                mx = max(mx, a[i]);
            }
            else {
                if (a[i] < mn) now++;
                mn = min(mn, a[i]);
            }
        }
        ans = max(ans, now);
//        cout << ans << ' ' << mask << '\n';
    }
    cout << ans << '\n';
}
ll t;
void solve() {
    ll n;
    cin >> n;
    vector < ll > a(n);
    forall(i, a) cin >> i;
    ll mx = 0;
    if (n <= 16 && t <= 120) stupid_solve(n, a);
    else {
        ll cnt = 0;
        ll mn = n + 1;
//        stupid_solve(n, a);
        bool fl = true;
        for (ll i = 0; i < n - 1; i++) {
            if (a[i] > a[i + 1]) fl = false;
        }
        if (fl) {
            cout << n << '\n';
            return;
        }

        vector < ll > b(n + 2, INF);
        b[0] = -INF;
        forall(i, a) {
            b[lower_bound(all(b), i) - b.begin()] = i;
        }
//        print(b);
        ll k = lower_bound(all(b), n + 1) - b.begin();
        cout << k << '\n';
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1, k;
//    cin >> k;
    cin >> T;
    t = T;
    while (T--) {
//        if (k == 1) solve1();
//        else solve2();
        solve();
        cout << endl;
    }
    return 0;
}