#include <bits/stdc++.h>

using namespace std;
#define int long long

vector<int> bit(int n) {
    vector<int> res;
    while (n > 0) {
        res.emplace_back(n % 2);
        n /= 2;
    }
    return res;
}

int mex(int n) {
    vector<int> b = bit(n);
    for (int i = 0; i < (int) b.size(); i++) {
        if (b[i] == 0)
            return i;
    }
    return (int) b.size();
}

int ultra(int n) {
    vector<int> res = bit(n);
    int m = mex(n) - 1, ans = 0;
    for (int i = 0; i < (int) res.size(); i++) {
        if (res[i] == 0)
            continue;
        int t = (i ^ m);
        ans += (1 << t);
    }
    return ans;
}

int Cnt(int n) {
    vector<int> b = bit(n);
    int res = 0;
    for (auto c: b)
        res += c;
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int M;
    cin >> M;
    int t;
    cin >> t;
    while (t--) {
        int k, n, p;
        cin >> k >> n >> p;
        int m = n, cnt = 0;
        n = (1 << k);
        bool used[(1 << n)];
        fill(used, used + (1 << n), false);
        bool used1[(1 << n)];
        fill(used1, used1 + (1 << n), false);
        bool ok[(1 << n)];
        fill(ok, ok + (1 << n), false);
        for (int a0 = 0; a0 < (1 << n); a0++) {
            if (Cnt(a0) != m || used[a0])
                continue;
            if (((a0 >> 0) & 1) == 0)
                continue;
            int path = 0;
            int cur = a0;
            while (!used[cur]) {
                path++;
                used[cur] = true;
                cur = ultra(cur);
            }
            if (used1[cur]) {
                int copy = a0;
                while (!used1[copy]) {
                    used1[copy] = true;
                    ok[copy] = ok[cur];
                    copy = ultra(copy);
                }
                if (ok[cur])
                    cnt += path;
                continue;
            }
            int copy = a0;
            while (!used1[copy]) {
                used1[copy] = true;
                copy = ultra(copy);
            }
            int st = cur, start = 0;
            bool flag = false;
            while (true) {
                if (cur == st && start == 1)
                    break;
                start = 1;
                if (mex(cur) != mex(st)) {
                    flag = true;
                    break;
                }
                cur = ultra(cur);
            }
            if (!flag && mex(cur) == p) {
                cnt += path;
                cur = a0;
                while (!ok[cur]) {
                    ok[cur] = true;
                    cur = ultra(cur);
                }
            }
        }
        cout << cnt << "\n";
    }
    return 0;
}