#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

void solve() {
    int n, m, k;
    cin >> n >> m >> k;
    vector<pii> a(k);
    int l = m, r = 0;
    int u = n, d = 0;
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
        u = min(u, a[i].first);
        d = max(d, a[i].first);
        l = min(l, a[i].second);
        r = max(r, a[i].second);
    };
//    ll ans = 1LL * (r - l + 1) * (d - u + 1);

    auto check = [](int dist, int m, vector<int> &b) {
        bool ok = false;
        if (b.back() - b[0] + 1 <= dist) {
            ok = true;
        }
        for (int i = 1; i < sz(b); ++i) {
            if (m + b[i - 1] - b[i] + 1 <= dist) {
                ok = true;
                break;
            }
        }
        return ok;
    };

    auto get_cnt = [](int dist, int m, vector<int> &b) {
        int res = INF;
        if (b.back() - b[0] + 1 <= dist) {
            res = 0;
        }
        for (int i = 1; i < sz(b); ++i) {
            if (m + b[i - 1] - b[i] + 1 <= dist) {
                res = min(res, b[i - 1]);
            }
        }
        return res;
    };

    int cnt = 0;

    int w = (r - l + 1);
    {
        vector<int> xs;
        for (auto i : a) {
            xs.emplace_back(i.second);
        }
        sort(all(xs));
        xs.resize(unique(all(xs)) - xs.begin());

        int lo = 0, hi = w;
        while (hi - lo > 1) {
            int mid = lo + (hi - lo) / 2;
            if (check(mid, m, xs)) {
                hi = mid;
            } else {
                lo = mid;
            }
        }
        w = hi;
        cnt += get_cnt(w, m, xs);
    }

    int h = (d - u + 1);
    {
        vector<int> xs;
        for (auto i : a) {
            xs.emplace_back(i.first);
        }
        sort(all(xs));
        xs.resize(unique(all(xs)) - xs.begin());

        int lo = 0, hi = w;
        while (hi - lo > 1) {
            int mid = lo + (hi - lo) / 2;
            if (check(mid, n, xs)) {
                hi = mid;
            } else {
                lo = mid;
            }
        }
        h = hi;
        cnt += get_cnt(h, n, xs);
    }

    ll ans = 1LL * w * h;
    cout << ans << ' ' << cnt << en;
}

int main() {
    int tests = 1;
#ifdef THEEVILBID
    freopen("input.txt", "r", stdin);
    tests = 2;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
