#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

void encode() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k), b;
    vector<int> used(n + 1, 1);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        used[a[i]] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        if (used[i]) {
            b.emplace_back(i);
        }
    }
    for (auto i : b) {
        cout << i << ' ';
    }
    cout << en;
}

void decode() {
    int n, k;
    cin >> n >> k;
    vector<int> a(k), b;
    vector<int> used(n + 1, 1);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
        used[a[i]] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        if (used[i]) {
            b.emplace_back(i);
        }
    }
    for (auto i : b) {
        cout << i << ' ';
    }
    cout << en;
}

int main() {
    int tests = 1;
#ifdef THEEVILBID
    freopen("input.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    int type;
    cin >> type;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        if (type == 1) {
            encode();
        } else {
            decode();
        }
    }
    cout << endl;
    return 0;
}
