#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "unordered_set"
#include "algorithm"

#define int long long
#define all(x) (x).begin(), (x).end()

using namespace std;

void solve() {
    int n; cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    vector<vector<int>> dp(n + 2, vector<int>(n + 2, -1));
    dp[0][n + 1] = 0;
    for (auto el: p) {
        auto dp1 = dp;
        for (int i = 0; i < n + 2; ++i) {
            for (int j = 0; j < n + 2; ++j) {
                if (dp[i][j] == -1) continue;
                if (i < el) {
                    dp1[el][j] = max(dp1[el][j], dp[i][j] + 1);
                }
                if (j > el) {
                    dp1[i][el] = max(dp1[i][el], dp[i][j] + 1);
                }
            }
        }
        dp = dp1;
    }
    int mx = 0;
    for (int i = 0; i < n + 2; ++i) {
        for (int j = 0; j < n + 2; ++j) {
            mx = max(mx, dp[i][j]);
        }
    }
    cout << mx << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        solve();
    }
}