//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

using namespace std;

using ll = long long;

#define len(a) (ll) a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const ll INF = 1e18;

ll n, x, y, m;
vector <vector <ll>> g, dp;
vector <ll> l, r, w;
map <pair <ll, ll>, vector <ll>> ans;
map <ll, ll> sert;

void dfs(ll v, ll p) {
    dp[v][0] = 0;
    dp[v][1] = w[v];
    for (auto to : g[v]) {
        if (to != p) {
            dfs(to, v);
            dp[v][0] += max(dp[to][0], dp[to][1]);
            dp[v][1] += dp[to][0];
        }
    }
}

void func(ll deep = 0) {
    if (deep == n) {
        ll k = 0;
        for (ll i = 1; i <= n; i++)
            k ^= (x * i % m + y * w[i - 1] % m * w[i - 1] % m) % m;
        dfs(0, -1);
        ll cnt = max(dp[0][0], dp[0][1]);
        if (sert.find(cnt) == sert.end()) {
            sert[cnt] = k;
            ans[{cnt, sert[cnt]}] = w;
        }
        return;
    }
    for (ll i = l[deep]; i <= r[deep]; i++) {
        w[deep] = i;
        func(deep + 1);
    }
}

void solve() {
    g.clear(), l.clear(), r.clear(), dp.clear(), w.clear();
    ll q; cin >> n >> q;
    cin >> x >> y >> m;
    g.resize(n);
    for (ll i = 1; i < n; i++) {
        ll a, b; cin >> a >> b; a--, b--;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    l.resize(n), r.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    dp.resize(n, vector <ll> (2, 0));
    w.resize(n);
    func();

    vector <pair <ll, ll>> t(q, {-1, -1});
    for (ll i = 0; i < q; i++) {
        cin >> t[i].first;
        if (sert.find(t[i].first) != sert.end())
            t[i].second = sert[t[i].first];
    }
    for (auto i : t)
        cout << i.second << ' ';
    cout << endl;
    ll ind; cin >> ind;
    while (ind != 0) {
        if (t[ind - 1].second == -1) {
            cout << -1 << endl;
        } else {
            for (auto i : ans[t[ind - 1]])
                cout << i << ' ';
            cout << endl;
        }
        cin >> ind;
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
