#include <iostream>
#include <random>
#include <bits/stdc++.h>
#define int long long

using namespace std;
vector < vector <int> > a;
vector <int> w;
int can = -1;
vector <int> dpY, dpN;
void dfs(int v, int pred)
{
    //cout << v << " ---" << endl;
    dpY[v] = w[v];
    dpN[v] = 0;
    for(int u : a[v])
    {
        if(u == pred)
            continue;
        dfs(u, v);

        dpY[v] += dpN[u];
        dpN[v] += max(dpN[u], dpY[u]);
    }
    //cout << v << " dpY = " << dpY[v] << " dpN = " << dpN[v] << endl;
}

void solve()
{
    int n, q;
    cin >> n  >> q;
    int x, y, m;
    cin >> x >> y >> m;
    a.clear();
    w.clear();
    dpY.clear();
    dpN.clear();
    a.resize(n);
    w.resize(n);
    dpY.resize(n);
    dpN.resize(n);
    bool is_1_subtest = true;

    for(int i = 0; i < n - 1; i++)
    {
        int fi, si;
        cin >> fi >> si;
        --fi, --si;
        a[fi].push_back(si);
        a[si].push_back(fi);
    }
    int k = 0;
    for(int i = 0; i < n; ++i)
    {
        int li, ri;
        cin >> li >> ri;
        if(li != ri)
            is_1_subtest = false;
        w[i] = li;
        k ^= ((x * (i + 1) + y * (li * li)%m) % m);
    }

    //is_1_subtest = false;
    if(is_1_subtest)
        dfs(0, -1);
    can = max(dpN[0], dpY[0]);
    //cout << can;
    int need_q = -1;
    for(int i = 0; i < q; ++i)
    {
        int vi;
        cin >> vi;
        if(is_1_subtest && vi == can) {
            cout << k << endl;
            need_q = i;
        }
        else
            cout << -1 << " ";
    }
    cout << endl;

    while(true)
    {
        int check;
        cin >> check;
        if(check == 0) {
            cout << endl;
            return;
        }
        if(is_1_subtest && check - 1 == need_q )
        {
            for(int i = 0; i < n; ++i)
                cout << w[i] << " ";
            cout << endl;
        }
        else
        {
            cout << -1 << endl;
        }
    }
    cout << endl;


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
