#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

const int MAXQ = 1500;

void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll> v(n);
	for (ll& x : v) cin >> x;
	int Z; cin >> Z;

	sort(all(v));

	vector<vector<bitset<MAXQ + 1>>> dp(n + 1, vector<bitset<MAXQ + 1>>(MAXQ + 1));
	dp[0][0][0] = 1;
	for (int i = 1; i <= n; i++) {
		ll x = v[i - 1];
		for (int a = 0; a <= MAXQ; a++) {
			dp[i][a] = dp[i - 1][a] | (dp[i - 1][a] << x);
			if (a >= x) dp[i][a] |= dp[i - 1][a - x];
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int a = 0; a <= MAXQ; a++) {
			int p = (~dp[i][a])._Find_first();
			if (a == 0) {
				dp[i][a].reset();
				dp[i][a] = ~dp[i][a];
			} else {
				dp[i][a] = dp[i][a - 1];
			}
			int d = (~dp[i][a])._Find_first();

			for (int j = d - 1; j >= p; j--) dp[i][a][j] = 0;
		}
	}

	for (int id = 0; id < q; id++) {
		ll k, a, b;
		cin >> k >> a >> b;
		int p = upper_bound(all(v), k) - v.begin();

//		bool is = true;
//		for (int i = 0; i <= a; i++) {+-
//			for (int j = 0; j <= b; j++) {
//				if (!dp[p][i][j]) {
//					is = false;
//					break;
//				}
//			}
//		}
		if (dp[p][a][b]) cout << "Yes\n";
		else cout << "No\n";
	}
}

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	solve();

}
