#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

#ifdef LOCAL
#define debug(x) cout << #x << ": " << x << endl;
#else
#define debug(x) ;
#endif
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define ff first
#define ss second
#define pb push_back

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

void upd(vi &t, int v, int x){
    v++;
    for (; v < sz(t); v += v & -v) t[v] = max(t[v], x);
}

int get(vi &t, int v){
    v++;
    int res = 0;
    for (; v > 0; v -= v & -v) res = max(res, t[v]);
    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    cin >> n;
    while (n--) solve();
}

void solve(){
    int n;
    cin >> n;
    vi a(n);
    vi t(n + 1);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) a[i]--;
    int mx = 0;
    for (int mask = 0; mask < (1 << n); mask++){
        vi p, q;
        for (int i = 0; i < n; i++){
            if (mask & (1 << i)) p.pb(i);
            else q.pb(i);
        }
        if (p.empty()) continue;
        int r1 = 1, r2 = 0;
        for (int i = 0; i <= n; i++) t[i] = 0;
        for (int j = 0; j < sz(p); j++){
            int res = get(t, a[p[j]]) + 1;
            upd(t, a[p[j]], res);
        }
        r1 = get(t, n - 1);
        for (int i = 0; i <= n; i++) t[i] = 0;
        for (int j = sz(q) - 1; j >= 0; j--){
            int res = get(t, a[q[j]]) + 1;
            upd(t, a[q[j]], res);
        }
        r2 = get(t, n - 1);
        mx = max(mx, r1 + r2);
    }
    cout << mx << endl;
}