#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vi = vector<int>;
using vll = vector<ll>;

#ifdef LOCAL
#define debug(x) cerr << #x << " " << x << endl;
#else
#define debug(x) ;
#endif

#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

void solve();

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while (n--) solve();
}

struct nd {
    ll k, a, b, i;
};

bool cmp(nd a, nd b){
    return a.k < b.k;
}

void solve() {
    int mx = 1024 + 1;
    int n, q;
    cin >> n >> q;
    vll a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    ll z; cin >> z;
    for (int tt = 0; tt < q; tt++){
        vector<vector<int>> cn(mx + 1, vi(mx + 1, 0));
        cn[0][0] = 1;
        ll l, x, y;
        cin >> l >> x >> y;
        for (ll i : a){
            if (i > mx) continue;
            if (i > l) continue;
            for (int j = mx; j >= 0; j--){
                for (int k = mx; k >= 0; k--){
                    if (cn[j][k]) continue;
                    if (j >= i) cn[j][k] += cn[j - i][k];
                    if (k >= i) cn[j][k] += cn[j][k - i];
                    cn[j][k] = min(1, cn[j][k]);
                }
            }
        }
        for (int i = 0; i < mx; i++){
            for (int j = 0; j < mx; j++){
                if (i == 0 && j == 0) continue;
                if (i == 0) cn[i][j] += cn[i][j - 1];
                if (j == 0) cn[i][j] += cn[i - 1][j];
                if (min(i, j) > 0) cn[i][j] += (cn[i - 1][j] + cn[i][j - 1] - cn[i - 1][j - 1]);
            }
        }
        if (cn[x][y] == (x + 1) * (y + 1)){
            cout << "Yes" << endl;
        }
        else cout << "No" << endl;
    }
}