#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <unordered_map>
#include <fstream>
#include <chrono>
#include <algorithm>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int MAXN = 5005;
vector <int> res;

struct query {
    int k, a, b, id;
};

vector <int> ans;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int n, q;
    cin >> n >> q;
    vector <int> task;
    vector <int> tmp(n);
    for (int i = 0 ; i < n; i++) {
        cin >> tmp[i];
    }
    int z;
    cin >> z;
    sort(tmp.begin(), tmp.end());
    int sum = 0;
    for (int i = 0 ; i < n; i++) {
        if (tmp[i] <= (sum + 1)) {
            task.push_back(tmp[i]);
            sum += tmp[i];
        }
    }
    res.assign(MAXN, 0);
    res[1] = 1;
    vector <query> tt;
    tt.resize(q);
    ans.resize(q);
    for (int i = 0 ;  i < q; i++) {
        cin >> tt[i].k >> tt[i].a >> tt[i].b;
        tt[i].a++;
        tt[i].b++;
        tt[i].a = min(tt[i].a, 5000LL);
        tt[i].b = min(tt[i].b, 5000LL);
        tt[i].id = 0;
        tt[i].id = i;
    }
    sort(tt.begin(), tt.end(), [] (query a, query b) {
        return a.k < b.k;
    });
    int pp = 0;
    vector <int> old(MAXN);
    for (int i = 0 ; i < n; i++) {
        int nxt = task[i];
        while (pp < tt.size() && tt[pp].k < nxt) {
            if (res[tt[pp].a] >= tt[pp].b) {
                ans[tt[pp].id] = 1;
            } else {
                ans[tt[pp].id] = 0;
            }
            pp++;
        }
        for (int j = 0 ; j < MAXN; j++) {
            old[j] = res[j];
        }
        for (int j = 1; j < MAXN; j++) {
            for (int k = res[j] + 1; k < MAXN; k++) {
                if (k - task[i] > 0 && (k - task[i]) <= old[j]) {
                    res[j]++;
                } else if (j - task[i] > 0 && res[j - 1] >= k && old[j - task[i]] >= k) {
                    res[j]++;
                } else {
                    break;
                }
            }
        }
    }
    while (pp < tt.size()) {
        if (res[tt[pp].a] >= tt[pp].b) {
            ans[tt[pp].id] = 1;
        } else {
            ans[tt[pp].id] = 0;
        }
        pp++;
    }
    for (int i = 0 ; i < q; i++) {
        if (ans[i] == 1) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}