#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 5005;
const ll INF = 1e18;

bool comp(pair<ll, ll> a, pair<ll, ll> b) {
    if (a.second == b.second) {
        return a.first < b.first;
    }
    return a.second < b.second;
}

void solve() {
    ll n; cin >> n;
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end(), comp);
    ll st = 0;
    ll cur_r = -1;
    for (auto [l, r] : a) {
        if (l > cur_r) {
            cur_r = r;
            st++;
        }
    }
    for (int mask = 1; mask < (1 << n); mask++) {
        vector<ll> has;
        for (int b = 0; b < n; b++) {
            if (((mask >> b) & 1)) {
                has.push_back(b);
            }
        }
        if (has.size() != n / 2) continue;
        ll cur = 0;
        cur_r = -1;
        for (auto i : has) {
            ll l = a[i].first, r = a[i].second;
            if (l > cur_r) {
                cur_r = r;
                cur++;
            }
        }
       //  cout << cur << '\n';
        if (cur == st / 2) {
            for (auto i : has) {
                cout << i + 1 << " ";
            }
            cout << '\n';
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }
}
