#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 35;
const ll INF = 1e18;

void dfs(ll v, ll p, vector<vector<ll>>& g, vector<pair<ll, ll>>& dp, vector<pair<ll, ll>>& a) {
    vector<ll> son;
    for (auto to : g[v]) {
        if (to != p) {
            son.push_back(to);
            dfs(to, v, g, dp, a);
        }
    }
    dp[v] = {0, 0};
    dp[v].second = a[v].first;
    for (auto to : son) {
        dp[v].first += max(dp[to].first, dp[to].second);
        dp[v].second += dp[to].first;
    }
}

void solve() {
    ll n, q; cin >> n >> q;
    ll x, y, m; cin >> x >> y >> m;
    vector<vector<ll>> g(n);
    for (int i = 0; i < n - 1; i++) {
        ll u, v; cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<pair<ll, ll>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
    vector<pair<ll, ll>> dp(n, {0, 0});
    dfs(0, -1, g, dp, a);
    ll ans = max(dp[0].first, dp[0].second);
    cout << ans << endl;
    ll k = 0;
    for (int i = 1; i <= n; i++) {
        k ^= ((x * i % m + (y * a[i - 1].first) % m * a[i - 1].first % m) % m);
    }
    vector<ll> ask(q);
    for (int i = 0; i < q; i++) cin >> ask[i];
    for (int i = 0; i < q; i++) {
        if (ask[i] == ans) {
            cout << k << " ";
        } else {
            cout << -1 << " ";
        }
    }
    cout << endl;
    ll in; cin >> in;
    while (in != 0) {
        in--;
        if (ask[in] == ans) {
            for (int i = 0; i < n; i++) {
                cout << a[i].first << " ";
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> in;
    }

}

int main() {

    ll tst; cin >> tst;
    while (tst--) {
        solve();
    }
}