#include <bits/stdc++.h>
#define int long long
using namespace std;

bool dp[101][301][301];
int mn[301];
int K = 1e18;
int n;

void calc(const vector<int> &w) {
    dp[0][0][0] = true;
    for (int i = 1; i <= n; i++) {
        for (int a = 0; a <= 300; a++) {
            for (int b = 0; b <= 300; b++) {
                dp[i][a][b] = false;
                if (w[i - 1] <= K) {
                    dp[i][a][b] = (a >= w[i - 1] && dp[i - 1][a - w[i - 1]][b]) || (b >= w[i - 1] && dp[i - 1][a][b - w[i - 1]]) || dp[i - 1][a][b];
                } else {
                    dp[i][a][b] = dp[i - 1][a][b];
                }
            }
        }
    }
    for (int a = 0; a <= 300; a++) {
        mn[a] = 0;
        while (dp[n][a][mn[a]]) {
            mn[a]++;
        }
        if (a > 0) {
            mn[a] = min(mn[a], mn[a - 1]);
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q;
    cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    int z;
    cin >> z;
    int sum = 0;
    calc(w);
    for (int i = 1; i <= q; i++) {
        int j, c, d;
        cin >> j >> c >> d;
        int k = j - sum * z;
        int a = c - sum * z;
        int b = d - sum * z;
        if (K != k) {
            K = k;
            calc(w);
        }
        if (mn[a] - 1 >= b) {
            sum += i;
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
    return 0;
}