#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

using std::cin;
using std::cout;
using std::vector;
using std::string;
using ll = long long;
using ld  = long double;
using pl = std::pair<ll, ll>;
using sl = std::pair<ll, vector<pl>>;
#define all(x) x.begin(),x.end()

ll h, w, n;
void sdv(vector<pl>& vc, char wh, ll s)
{
	for (pl& i : vc)
	{
		if (wh == 'l')
		{
			i.second = ((i.second - 1 - s) % w + w) % w + 1;
		}
		if (wh == 'r')
		{
			i.second = ((i.second - 1 + s) % w + w) % w + 1;
		}
		if (wh == 'd')
		{
			i.first = ((i.first - 1 + s) % h + h) % h + 1;
		}
		if (wh == 'u')
		{
			i.first = ((i.first - 1 - s) % h + h) % h + 1;
		}
	}
}

int main()
{
	std::ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> h >> w >> n;
	vector<pl> vc(n);
	for (pl& i : vc)
	{
		cin >> i.first;
		cin >> i.second;
	}
	
	std::map<vector<pl>, ll> mp;
	mp[vc] = 0;
	std::set<sl> st;
	st.insert({ 0,vc });
	ll cmp = 1e18;
	ll sp = 1e18;
	ll k = 0;
	while (st.size())
	{
		++k;
		if (k == 300)break;
		sl v = *st.begin();
		st.erase(st.begin());

		ll lmn = 1e9;
		ll lmx = 0;
		ll rmn = 1e9;
		ll rmx = 0;

		for (pl& i : v.second)
		{
			lmn = std::min(lmn, i.second);
			lmx = std::max(lmx, i.second);
			rmn = std::min(rmn, i.first);
			rmx = std::max(rmx, i.first);
		}

		if (cmp > (lmx - lmn + 1) * (rmx - rmn + 1))
		{
			cmp = (lmx - lmn + 1) * (rmx - rmn + 1);
			sp = v.first;
		}
		if (cmp == (lmx - lmn + 1) * (rmx - rmn + 1) && sp > v.first)
		{
			sp = v.first;
		}

		//вниз
		ll move = 1e9;
		for (pl& i : v.second)
		{
			move = std::min(move, h - i.first);
		}
		++move;
		sdv(v.second, 'd', move);
		if (mp.count(v.second) == 0 || mp[v.second] > v.first)
		{
			mp[v.second] = v.first + move;
			st.insert({ v.first + move,v.second });
		}
		sdv(v.second, 'u', move);

		//вверх
		move = 1e9;
		for (pl& i : v.second)
		{
			move = std::min(move, i.first);
		}
		sdv(v.second, 'u', move);
		if (mp.count(v.second) == 0 || mp[v.second] > v.first)
		{
			mp[v.second] = v.first + move;
			st.insert({ v.first + move,v.second });
		}
		sdv(v.second, 'd', move);

		//влево
		move = 1e9;
		for (pl& i : v.second)
		{
			move = std::min(move, i.second);
		}
		sdv(v.second, 'l', move);
		if (mp.count(v.second) == 0 || mp[v.second] > v.first)
		{
			mp[v.second] = v.first + move;
			st.insert({ v.first + move,v.second });
		}
		sdv(v.second, 'r', move);

		//вправо
		move = 1e9;
		for (pl& i : v.second)
		{
			move = std::min(move, w - i.second);
		}
		++move;
		sdv(v.second, 'r', move);
		if (mp.count(v.second) == 0 || mp[v.second] > v.first)
		{
			mp[v.second] = v.first + move;
			st.insert({ v.first + move,v.second });
		}
		sdv(v.second, 'l', move);
	}

	cout << cmp << ' ' << sp;
	
}