#include <iostream>
#include <iomanip>
#include <cmath>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <random>
#include <map>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

void f() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	for (ll i = 0; i < k; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	for (ll i = 0; i < k; i++) {
		cout << (a[i] + k - 1) % n + 1 << " ";
	}
	cout << endl;
}

void g() {
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	for (ll i = 0; i < k; i++) {
		cin >> a[i];
	}
	sort(a.begin(), a.end());
	for (ll i = 0; i < k; i++) {
		cout << (a[i] - k - 1 + n) % n + 1 << " ";
	}
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	ll t, ttt;
	cin >> ttt >> t;
	if (ttt == 1) {
		while (t--) {
			f();
		}
	}
	else {
		while (t--) {
			g();
		}
	}
}