#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pb push_back
#define sc second
#define fr first
#define all(arr) arr.begin(), arr.end()

struct MP{
    int i;
    int l, r;

    bool operator<(const MP& other) {
        return (l == other.l ? r < other.r : l < other.l);
    }
};

int dp[5001][5001];
vector<MP> mp;
int calc(int v, int m) {
    if (dp[v][m] != -1)
        return dp[v][m];

    int cnt = 0;
    for (int i = v + 1; i < mp.size(); ++i) {
        if (mp[v].r < mp[i].l) {
            int res = calc(i, m - 1);
            if (res != -1)
                dp[v][m] = max(dp[v][m], res + cnt);
        } else {
            ++cnt;
        }
    }
    return dp[v][1] = cnt;
}

vector<int> ans;
void build(int v, int m, int n) {
    ans.pb(mp[v].i + 1);

    for (int i = v + 1; i < mp.size(); ++i) {
        if (m != 1 && mp[v].r < mp[i].l && dp[i][m - 1] >= n) {
            build(i, m - 1, n);
            return;
        } else {
            if (n > 0) {
                ans.pb(mp[i].i + 1);
                --n;
            }
        }
    }
}

void solve() {
    int n;
    cin >> n;

    mp.resize(n);
    for (int i = 0; i < n; ++i) {
        cin  >> mp[i].l >> mp[i].r;
        mp[i].i = i;
    }
    sort(all(mp));

    int m = 1;
    int R = mp[0].r;
    for (int i = 0; i < n; ++i) {
        if (R < mp[i].l) {
            R = mp[i].r;
            ++m;
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int mm = 1; mm <= n; ++mm)
            dp[i][mm] = -1;
    }

    for (int i = 0; i < n; ++i) {
        for (int mm = 1; mm <= n; ++mm)
            calc(i, mm);
    }

    ans.clear();
    for (int i = 0; i < n; ++i) {
        if (dp[i][m / 2] != -1 && m / 2 + dp[i][m] >= n / 2) {
            build(i, m / 2, n / 2 - m / 2);
            break;
        }
    }

    while(ans.size() == 0) {}
    assert(ans.size() <= n / 2);

//    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
        cout << ans[i] << ' ';
    cout << endl;
}

int main() {
//    ios_base::sync_with_stdio(0);
//    cout.tie(0);
//    cin.tie(0);

    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();


    return 0;
}
