#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

int main()
{
    long long n, q;
    cin >> n >> q;
    vector<long long> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    sort(v.begin(), v.end());
    vector<long long> ans;
    long long z;
    cin >> z;
    long long mx = 0;
    bool fl = true;
    for (int i = 0; i < n; i++) {
        ans.push_back(mx);
        if (!fl || v[i] > mx + 1) {
            fl = false;
        } else {
            mx = mx + v[i];
        }
    }
    ans.push_back(mx);
    for (int i = 0; i < q; i++) {
        long long k, a, b;
        cin >> k >> a >> b;
        long long l = -1, r = n, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (v[mid] > k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (ans[r] >= a) {
            cout << "Yes";
        } else {
            cout << "No";
        }
        cout << '\n';
    }
    return 0;
}
