#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define endl '\n'

typedef tree <int64_t, null_type, less <int64_t>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int INF = 1e18;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
//    cout.tie(0);
}

vector <vector <int>> sm;
vector <int> h;
vector <bool> used;

int dfs(int v){
    bool flag = false;
    int g = INF;
    for (int i = 0; i < sm[v].size(); i++){
        int to = sm[v][i];
        if (used[to]) continue;
        flag = true;
        g = min(g, dfs(to) + 1);
    }
    if (!flag){
        h[v] = 0;
        return 0;
    }
    h[v] = g;
    return g;
}

int ch(int v){
    int cnt = 0;
    for (int i = 0; i < sm[v].size(); i++){
        int to = sm[v][i];
        if (h[to] != -1) cnt++;
    }
    return cnt;
}

signed main() {
    //Fast();
    int t;
    cin >> t;
    while (t--){
        int n;
        cin >> n;
        vector <int> l(n), r(n);
        sm.assign(n, vector <int>());
        h.assign(n, -1);
        used.assign(n, false);
        for (int i = 0; i < n; i++)
            cin >> l[i] >> r[i];
        vector <int> p(n, -1);
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++){
                if (i == j || p[j] == i) continue;
                if (l[j] <= l[i] && r[j] >= r[i]){
                    if (p[i] == -1) p[i] = j;
                    else{
                        if (l[p[i]] <= l[j] && r[p[i]] >= r[j]) p[i] = j;
                    }
                }
            }
        }
        int ind = -1;
        for (int i = 0; i < n; i++){
            if (p[i] == -1) ind = i;
            else{
                sm[p[i]].push_back(i);
            }
        }
//        for (auto i:p){
//            cout << i << " ";
//        }
//        cout << endl;
//        cout << ind << endl;
        //cout << 1 << endl;
        dfs(ind);
//        for (auto i:h){
//            cout << i << " ";
//        }
//        cout << endl;
        int cnt = 0;
        for (int i = 0; i < n; i++){
            cnt += (sm[i].empty());
        }
        int k = 0;
        for (int i = 0; i < cnt / 2; i++){
            h.assign(n, -1);
            dfs(ind);
            int o = INF, w = -1;
//            for (auto j:h){
//                cout << j << " ";
//            }
//            cout << endl;
            for (int j = 0; j < n; j++){
                if (h[j] == -1) continue;
                if (ch(j) >= 2){
                    if (h[j] < o){
                        o = h[j], w = j;
                    }
                }
            }
            for (int j = 0; j < sm[w].size(); j++){
                int to = sm[w][j];
                if (h[to] == -1) continue;
                if (h[to] == h[w] - 1){
                    used[to] = true;
                    k += h[w];
                    break;
                }
            }
        }
        vector <int> ans;
        for (int i = 0; i < n; i++){
            if (used[i]) continue;
            if (ch(i) == 0) ans.push_back(i);
        }
        for (int i = 0; i < n / 2 - k; i++){
            for (int j = 0; j < n; j++){
                if (used[j] || h[j] == -1) continue;
                bool flag = false;
                for (int y:ans){
                    if (l[j] <= l[y] && r[j] >= r[y] || l[y] <= l[j] && r[y] >= r[j]){
                        ans.push_back(j);
                        h[j] = -1;
                        flag = true;
                        break;
                    }
                }
                if (flag) break;
            }
        }
        for (auto i:ans){
            cout << i + 1 << " ";
        }
        cout << endl;
    }
    return 0;
}
