#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;

void dfs(ll v, ll t, vector <ll>& dp, vector <vector <ll>>& g)
{
	if (g[v].empty()) return;
	if (t == 0)
	{
		dp[g[v][0]] = dp[v];
		dfs(g[v][0], -1, dp, g);
		dp[g[v][1]] = dp[v];
		dfs(g[v][1], 1, dp, g);
	}
	if (t == -1)
	{
		dp[g[v][0]] = dp[v];
		dfs(g[v][0], -1, dp, g);
		dp[g[v][1]] = dp[v] + 1;
		dfs(g[v][1], 1, dp, g);
	}
	if (t == 1)
	{
		dp[g[v][0]] = dp[v] + 1;
		dfs(g[v][0], -1, dp, g);
		dp[g[v][1]] = dp[v];
		dfs(g[v][1], 1, dp, g);
	}
}
void dfss(ll v, vector <ll>& ans, vector <vector <ll>>& g)
{
	if (g[v].empty()) return;
	dfss(g[v][0], ans, g);
	dfss(g[v][1], ans, g);
	ans[v] = ans[g[v][0]] + ans[g[v][1]];
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	ll n, k, q;
	cin >> n >> k >> q;
	vector <vector <ll>> g(n);
	for (ll i = 0; i < n; i++)
	{
		ll c;
		cin >> c;
		if (c == 2)
		{
			ll u, v;
			cin >> u >> v;
			u--;
			v--;
			g[i].push_back(u);
			g[i].push_back(v);
		}
	}
	vector <ll> dp(n);
	dfs(0, 0, dp, g);
	vector <ll> ans(n);
	for (ll i = 0; i < n; i++)
	{
		if (g[i].empty() && dp[i] <= k)
		{
			ans[i] = 1;
		}
	}
	dfss(0, ans, g);
	while (q--)
	{
		ll v;
		cin >> v;
		v--;
		cout << ans[v] << "\n";
	}

	return 0;
}
/*
7 1 4
2 2 4
0
2 6 5
2 3 7
0
0
0
1
4
3
5
*/