#include <bits/stdc++.h>

using namespace std;
#define ll long long

struct point {
    ll x;
    ll y;

};

pair<ll, ll> getRes(vector<point> orig, ll w) {
    deque<point> horiz(orig.begin(), orig.end());
    sort(horiz.begin(), horiz.end(), [](point a, point b) { return a.x < b.x; });
    horiz.erase(unique(horiz.begin(), horiz.end(),
                       [](auto a, auto b) { return a.x == b.x; }), horiz.end());
    ll minW = horiz.back().x - horiz.front().x;
    ll minL = 0;
    ll curOffset = 0;
    ll moves = 0;
    for (int i = 0; i < horiz.size(); i++) {
        auto front = horiz.front();
        moves += front.x - curOffset;
        front.x += w;
        horiz.pop_front();
        horiz.push_back(front);
        if (minW > horiz.back().x - horiz.front().x) {
            minW = horiz.back().x - horiz.front().x;
            minL = moves;
        }
        curOffset = front.x - w;
    }
    horiz = deque<point>(orig.begin(), orig.end());
    sort(horiz.begin(), horiz.end(), [](point a, point b) { return a.x < b.x; });
    horiz.erase(unique(horiz.begin(), horiz.end(),
                       [](auto a, auto b) { return a.x == b.x; }), horiz.end());
    curOffset = w;
    moves = 1;
    for (int i = 0; i < horiz.size(); i++) {
        auto front = horiz.back();
        moves += curOffset - front.x;
        front.x -= w;
        horiz.pop_back();
        horiz.push_front(front);

        if (minW == horiz.back().x - horiz.front().x && moves < minL) {
            minL = moves;
        }
        curOffset = horiz.front().x + w;
    }
    minL;
    minW++;
    return {minW, minL};
}

void solve() {
    ll h, w, k;
    cin >> h >> w >> k;
    vector<point> orig(k);

    for (auto &o: orig)
        cin >> o.y >> o.x;
    auto hh = getRes(orig, w);
    for (auto &o: orig)
        swap(o.y, o.x);
    auto vv = getRes(orig, h);
    cout << vv.first * hh.first << ' ' << hh.second + vv.second;
}

int main() {
#ifdef VNT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin>>q;
    for (int i = 0; i < q; i++) {
        solve();
        cout << '\n';
    }
}