#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e18;

struct Nugget {
	ll r, c;
	Nugget () {}
};

void solve() {
	ll h, w, k;
	cin >> h >> w >> k;

	vector <Nugget> nuggets(k);
	for (auto &x: nuggets) {
		cin >> x.r >> x.c;
	}
	
	ll ans = INF, moves = INF;
	for (ll move_w = -w; move_w <= w; move_w++) {
		for (ll move_h = -h; move_h <= h; move_h++) {
			ll minc = INF, maxc = -INF, minr = INF, maxr = -INF;
			for (auto &x: nuggets) {
				ll newr = (x.r - 1 + move_h + h) % h + 1;
				ll newc = (x.c - 1 + move_w + w) % w + 1;

				minc = min(minc, newc);
				maxc = max(maxc, newc);

				minr = min(minr, newr);
				maxr = max(maxr, newr);
			}

			ll new_ans = (maxc - minc + 1) * (maxr - minr + 1);
			if (new_ans < ans) {
				ans = new_ans;
				moves = abs(move_w) + abs(move_h);
			} else if (new_ans == ans) {
				moves = min(moves, abs(move_w) + abs(move_h));
			}
		}
	}

	cout << ans << ' ' << moves << '\n';
}	

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	solve();
}