#include <iostream>
#include <set>
#include <random>
#include <algorithm>

using namespace std;

#define int long long

const int MAXN = 2'00'000;

mt19937 rnd;

vector <pair<int, int>> a[MAXN];

void solve(int i){
    auto c = a[i]; int n = c.size();
    //sort(c.begin(), c.end());
    vector <int> st(n, 0);
    vector <int> p(n, -1);
    vector <pair <int, pair<int, int>>> r;
    for (int i = 0; i < n; i ++){
        r.push_back({c[i].first, {1, i}});
        r.push_back({c[i].second, {0, i}});
    }
    sort(r.begin(), r.end());
    set <pair <int, int>> wid;
    for (auto & i : r){
        if (i.second.first == 0){
            wid.erase({c[i.second.second].first, i.second.second});
            if (wid.size()){
                auto o = *(--wid.end());
                p[i.second.second] = o.second;
                st[o.second]++;
                st[i.second.second]++;
            }
        }
        else{
            wid.insert({i.first, i.second.second});
        }
    }
    vector <int> lea;
    for (int i = 0 ; i < n; i ++) if (st[i] == 1) lea.push_back(i);
    set <int> d;
    for (int i = 0; i < n / 2; i ++){
        int v = lea.back(); lea.pop_back();
        d.insert(v);
        v = p[v]; st[v] --;
        if (st[v] == 1) lea.push_back(v);
    }
    for (int i = 0; i < n; i ++){
        if (d.find(i) == d.end()) cout << i + 1 << ' ';
    }
    cout << endl;
 }

signed main() {
    int t; cin >> t;
    int mxn = 0;
    for (int i = 0; i < t; i ++){
        int n; cin >> n;
        a[i].resize(n);
        for (int j = 0; j < n; j ++){
            cin >> a[i][j].first >> a[i][j].second;
        }
        mxn += n;
    }
    if (mxn <= 20 && 0){

    }
    else{
        for (int i = 0 ; i < t; i ++) solve(i);
    }
}
