#include <bits/stdc++.h>
using namespace std;

#define endl "\n"
#define int long long
#define all(a) a.begin(), a.end()
#define uni(a) sort(all(a)); a.erase(unique(all(a)), a.end())
#define pii pair<int, int>
#define X first
#define Y second

using namespace std;

template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = b1;
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = b1;
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& in, vector<T> &a) {
    for (auto &it : a) {
        in << it << ' ';
    }
    return in;
}

void solve() {
    int n, q;
    cin >> n >> q;

    vector<int> w(n);
    cin >> w;
    sort(all(w));
    int z;
    cin >> z;

    const int CNT = 1e5 + 1;
    bitset<CNT> dost;
    dost &= 0;
//    vector<int> dost(1e5 * 100 + 1, 0);
    dost[0] = 1;

    for (int i = 0; i < n; i++) {
        if (w[i] <= 1e5) {
            dost |= (dost << w[i]);
        }
    }

    vector<int> sum(CNT, 0);
    sum[0] = 1;

    for (int i = 1; i < CNT; i++) {
        sum[i] = sum[i - 1] + dost[i];
    }

    while (q--) {
        int k, a, b;
        cin >> k >> a >> b;

        if (sum[a] == a + 1) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
