#include <bits/stdc++.h>

#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
using namespace std;

#define int ll
struct query {
    ll k, a, b, ind;
};

const int maxa = 0, maxb = 100000 + 100; // a <= b

void solve() {
    int n, Q;
    cin >> n >> Q;
    vector<ll> w(n);
    for (auto &el : w) {
        cin >> el;
    }

    sort(all(w));

    vector<query> qs(Q);
    vector<bool> ans(Q, false);

    int Z; cin >> Z;
    for (int i = 0; i < Q; ++i) {
        ll k, a, b;
        cin >> k >> a >> b;
        if (a > b)
            swap(a, b);
        qs[i] = {k, a, b, i};
    }

    sort(all(qs), [&] (const query& q1, const query& q2) {
        return q1.k < q2.k;
    });

    bitset<maxa * (maxb + 1) + maxb + 1> dp;

    int it = 0;
    dp[0] = 1;
    for (int i = 0; i <= n; ++i) {
        while (it < Q && (qs[it].k < w[i] || i == n)) {
            auto [k, a, b, ind] = qs[it];
            ans[ind] = dp[a * (maxb + 1) + b];
            ++it;
        }

        if (i == n)
            break;

        bitset<maxa*(maxb + 1) + maxb + 1> nw;
        if (w[i] <= maxb) {
            nw |= dp<<w[i];
        }

        if (w[i] <= maxa) {
            nw |= dp<<(w[i]*(maxb+1));
        }

        dp |= nw;
    }

    for (auto el : ans) {
        cout << (el ? "Yes" : "No") << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}