#include <bits/stdc++.h>

#define pb push_back
#define st string
#define vec vector
#define all(a) a.begin(), a.end()
#define ff first
#define ss second
#define int long long

//#define endl "\n";

using namespace std;
using vi = vec<int>;
using vvi = vec<vi>;
using pi = pair<int, int>;
using vpi = vec<pi>;

vvi g;

int sert(vi &a, int x, int y, int m) {
    int k = 0;
    for (int i = 0; i < a.size(); i++) {
        int j = i + 1;
        k = (k ^ ((x * j + y * a[i] * a[i]) % m));
    }
    return k;
}

vpi dp;
vi used;

// .ff - take, .ss - no
void dfs(int v, vi &a) {
    used[v] = 1;
    vi ch;
    for (auto u : g[v]) {
        if (!used[u]) {
            ch.pb(u);
            dfs(u, a);
        }
    }
    if (!ch.size()) {
        dp[v].ff = a[v];
        dp[v].ss = 0;
    }
    else {
        int cntt = 0;
        int cntt2 = 0;
        for (auto u : ch) {
            cntt += dp[u].ss;
            cntt2 += max(dp[u].ff, dp[u].ss);
        }
        dp[v].ff = a[v] + cntt;
        dp[v].ss = cntt2;
    }
}

void solve() {
    g = {};
    int n, q; cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        u--; v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    vi a(n);
    for (int i = 0; i < n; i++) {
        int l, r; cin >> l >> r;
        a[i] = l;
    }
    used.assign(n, 0);
    dp.assign(n, {0, 0});
    dfs(0, a);
    int cnt = max(dp[0].ff, dp[0].ss);
    int ser = sert(a, x, y, m);
//    cout << cnt << " " << ser << endl;
    vi ans(q, -1);
    for (int i = 0; i < q; i++) {
        int xx; cin >> xx;
        if (cnt == xx) {
            ans[i] = ser;
        }
    }
    for (auto u : ans) {
        cout << u << " ";
    }
    cout << endl;
    int nw; cin >> nw;
    while (nw) {
        if (ans[nw - 1] != -1) {
            for (auto u : a) {
                cout << u << " ";
            }
            cout << endl;
        }
        else {
            cout << -1 << endl;
        }
        cin >> nw;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
        cout << endl;
    }
}