#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

void solveC() {
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int& i : arr) cin >> i;

	long long sol = 0;

	for (int i = 0; i < (1 << (n + 1)); ++i) {
		long long sh = 0;
		int mn = 1000000, mx = -1000000;
		for (int j = 0; j < n; ++j) {
			if (i & (1 << j)) {
				if (mx < arr[j]) {
					++sh;
					mx = arr[j];
				}
			}
			else {
				if (mn > arr[j]) {
					++sh;
					mn = arr[j];
				}
			}
		}
		sol = max(sol, sh);
	}

	cout << sol << "\n";
}

bool solveh1(int n, int k) {
	if (k != 1) return false;
	int x;
	cin >> x;
	if (x == n)
		cout << 1 << "\n";
	else
		cout << x + 1 << "\n";
	return true;
}

bool solveh2(int n, int k) {
	if (k != 2) return false;
	int x1, x2;
	cin >> x1 >> x2;
	vector<int> arr(5000 + 113);
	arr[x1 - 1] = 1;
	arr[x2 - 1] = 1;
	int sol1, sol2;
	int i = x1 - 1;
	while (true) {
		i = (i + 1) % n;
		if (arr[i] == 0) {
			sol1 = i + 1;
			arr[i] = 1;
			break;
		}
	}

	i = x2 - 1;
	while (true) {
		i = (i + 1) % n;
		if (arr[i] == 0) {
			sol2 = i + 1;
			arr[i] = 1;
			break;
		}
	}

	if (sol1 > sol2) swap(sol1, sol2);
	cout << sol1 << " " << sol2 << "\n";
	return true;
}

bool solveh3(int n, int k) {
	if (k * 2 != n) return false;
	vector<int> arr(n);
	for (int i = 0; i < k; ++i) {
		int x;
		cin >> x;
		arr[x - 1] = 1;
	}

	for (int i = 0; i < n; ++i) {
		if (arr[i] == 0) 
			cout << i + 1 << " ";
	}
	cout << "\n";
	return true;
}


void solveh() {
	int n, k;
	cin >> n >> k;
	if (solveh1(n, k)) return;
	if (solveh2(n, k)) return;
	if (solveh3(n, k)) return;
}

bool solver1(int n, int k) {
	if (k != 1) return false;
	int x;
	cin >> x;
	if (x == 1)
		cout << n << "\n";
	else
		cout << x - 1 << "\n";
	return true;
}

bool solver2(int n, int k) {
	if (k != 2) return false;
	int x1, x2;
	cin >> x1 >> x2;
	vector<int> arr(5000 + 113);
	arr[x1 - 1] = 1;
	arr[x2 - 1] = 1;
	int sol1, sol2;
	int i = x1 - 1;
	while (true) {
		i = (n + i - 1) % n;
		if (arr[i] == 0) {
			sol1 = i + 1;
			arr[i] = 1;
			break;
		}
	}

	i = x2 - 1;
	while (true) {
		i = (n + i - 1) % n;
		if (arr[i] == 0) {
			sol2 = i + 1;
			arr[i] = 1;
			break;
		}
	}
	if (sol1 > sol2) swap(sol1, sol2);
	cout << sol1 << " " << sol2 << "\n";
	return true;
}

void solver() {
	int n, k;
	cin >> n >> k;
	if (solver1(n, k)) return;
	if (solver2(n, k)) return;
	if (solveh3(n, k)) return;
}

int main(){
	int T = 1, a;
	cin >> a >> T;
	while (T--)
		if (a == 1)
			solveh();
		else
			solver();
	return 0x0;
}
