#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(x) begin(x), end(x)
#define ll long long
int k;

pair<int, int> calc(vector<int>& hs, int h) {
	sort(all(hs));
	pair<int, int> ret = { hs.back() - hs[0] + 1, 0};
	for (int i = 0; i < k - 1; i++) {
		int cur = hs[i];
		ret = min(ret, make_pair(h - (hs[i + 1] - cur) + 1, cur));
	}

	for (int i = 1; i < k; i++) {
		int cur = h - hs[i] + 1;
		ret = min(ret, make_pair(hs[i - 1] + cur, cur));
	}
	return ret;
}

int main() {
	int h, w;

	cin >> h >> w >> k;
	vector<int> hh(k), ww(k);

	for (int i = 0; i < k; i++) {
		cin >> hh[i] >> ww[i];
	}

	auto ans = calc(hh, h);
	auto ans2 = calc(ww, w);
	

	cout << ans.first * 1ll * ans2.first << ' ' << ans.second + ans2.second;

	return 0;
}