#include <iostream>
#include <vector>



using namespace std;



vector<vector<int>> r;
int now = 0, last = -1, k;
int n;
vector<int> f;

void inc(int i) {
	while (i < n) {
		f[i]++;
		i |= i + 1;
	}
}

int getr(int r) {
	int ret = 0;
	while (r >= 0) {
		ret += f[r];
		r &= r + 1;
		r--;
	}
	return ret;
}

int get(int l, int r) {

	if (l) return getr(r) - getr(l - 1);
	return getr(r);
}

vector<int> sm;

void dfs(int v) {

	if (r[v].size() == 0) {
		if (now <= k) {
			sm[v]++;
		}
		return;
	}

	if (last == 1) {
		dfs(r[v][0]);
		now++;
		last = 2;
		dfs(r[v][1]);
		now--;
		last = 1;
	}
	else {
		dfs(r[v][1]);
		now++;
		last = 1;
		dfs(r[v][0]);
		now--;
		last = 2;
	}

	sm[v] = sm[r[v][0]] + sm[r[v][1]];

}


int main() {
	int q;
	cin >> n >> k >> q;

	r.resize(n);
	int a, b;
	int t;
	for (int i = 0; i < n; i++) {
		cin >> t;
		if (t) {
			cin >> a >> b;
			a--;
			b--;
			r[i].push_back(a);
			r[i].push_back(b);
		}
	}

	sm.resize(n);
	dfs(0);

	for (int i = 0; i < q; i++) {
		cin >> a;
		a--;
		cout << sm[a] << "\n";
	}


	return 0;
}
