#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = 1e9;
const ll INF_ll = 1e18;
const int mod = 1e9 + 7;

vector<vector<int> > g;
vector<int> c, val;

struct event{
    int x, type, i;
    event(){};
    event(int _x, int _type, int _i){};
};

bool cmp(event &a, event &b) {
    if (a.x < b.x) {
        return 1;
    } else if (a.x > b.x) {
        return 0;
    } else {
        return a.type < b.type;
    }
}

void dfs(int v) {
    if (g[v].size() == 0) {
        return;
    }
    val[g[v][0]] = val[v] + 1;
    for (auto to : g[v]) {
        dfs(to);
    }
}

void solve() {
    int n;
    cin >> n;
    g.resize(n);
    vaL.resize(n);
    c.resize(n);
    vector<pair<int, int> > seg(n);
    vector<event> v;
    for (int i = 0; i < n; i++) {
        cin >> seg[i].first >> seg[i].second;
        v.push_back({seg[i].first, -1, i});
        v.push_back({seg[i].second, 1, i});
    }
    sort(v.begin(), v.end(), cmp);
    vector<int> p(n, -1);
    int cur_p = -1;
    for (int i = 0; i < n; i++) {
        if (v[i].type == -1) {
            if (cur_p != -1) {
                g[cur_p].push_back(v[i].i);
                p[v[i].i] = cur_p;
            }
            cur_p = v[i].i;
        } else {
            cur_p = p[cur_p];
        }
    }
    c.resize(n);
    dfs(0);
    priority_queue<pair<int, int> > q;
    vector<bool> erased(n);
    int m = 0;
    for (int i = 0; i < n; i++) {
        if (g[i].size() == 0) {
            m++;
            q.push({-val[i], i});
            c[i] = 1;
        }
    }
    int n_need = n / 2, m_need = m / 2;
    while (m_need) {
        int cnt = q.top().first, v = q.top().second;
        q.pop();
        erased[v] = 1;
        if (cnt == 0) {
            m_need--;
        } else {
            q.push({val[p[v]], p[v]});
            c[p[v]] = 1;
        }
        n_need--;
    }
    for (int i = 0; i < n; i++) {
        if (n_need && !c[i]) {
            erased[i] = 1;
        }
    }
    for (int i = 0; i < n; i++) {
        if (!erased[i]) {
            cout << i + 1 << ' ';
        }
    }
    cout << endl;
}

int main() {
//    freopen("../input.txt", "r", stdin);
//    freopen("../output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}