#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <random>
#include <deque>
#include <queue>

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 7;
const ll LL_INF = 2e18 + 7;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
	for (auto& i : a) {
		in >> i;
	}
	return in;
}

template<typename T> ostream& operator << (ostream& out, const vector<T>& a) {
	for (auto& i : a) {
		out << i << ' ';
	}
	return out;
}

int main() {
	vector<int> _n(2);
	int k;
	cin >> _n >> k;
	vector<vector<int>> _a(2);
	while (k--) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		_a[0].push_back(x);
		_a[1].push_back(y);
	}
	ll ans = 1;
	int moves_cnt = 0;
	for (int arr = 0; arr < 2; arr++) {
		vector<int>& a = _a[arr];
		int& n = _n[arr];
		sort(a.begin(), a.end());
		a.resize(unique(a.begin(), a.end()) - a.begin());
		reverse(a.begin(), a.end());
		queue<int> q;
		for (auto& i : a) {
			q.push(i);
		}
		//cout << q.front() << ' ' << q.back() << '\n';
		int best_window = INT_INF;
		int best_moves = 0;
		int shift = 0;
		for (int move = 0; move < a.size(); move++) {
			int l = q.back();
			int r = q.front();
			int window = r - l + 1;
			if (window < best_window) {
				best_window = window;
				best_moves = min(move, n - move);
			}
			r += shift;
			shift += n - r;
			q.push(-shift);
			q.pop();
		}
		ans *= best_window;
		moves_cnt += best_moves;
	}
	cout << ans << ' ' << moves_cnt;
}
