#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;
using ll = long long;

void solve();

int main(){
    int t;
    cin >> t;
    while (t--){
        solve();
    }
}

vector<vector<int>> g;
vector<int> l;
vector<int> r;
vector<int> v;
vector<ll> k;
vector<ll> aa;
ll x, y, m;
int n, q;

vector<ll> dp1;
vector<ll> dp0;

void dfs(int vv, int p){
    dp0[vv] = 0;
    dp1[vv] = r[vv];
    for (int u : g[vv]){
        if (u != p){
            dfs(u, vv);
            dp0[vv] += max(dp0[u], dp1[u]);
            dp1[vv] += dp0[u];
        }
    }
}



void dfs_ans(int vv, int p, int type){
    if (type){
        aa[vv] = r[vv];
    } else{
        aa[vv] = 0;
    }
    for (int u : g[vv]){
        if (u != p){
            if (type){
                dfs_ans(u, vv, 0);
            } else{
                if (dp0[u] >= dp1[u]){
                    dfs_ans(u, vv, 0);
                } else{
                    dfs_ans(u, vv, 1);
                }
            }
        }
    }
}

void solve(){
    cin >> n >> q;
    cin >> x >> y >> m;
    g.resize(0);
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dp1.resize(n);
    dp0.resize(n);
    l.resize(n);
    r.resize(n);
    aa.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        assert(l[i] == 0);
        assert(r[i] <= 1);
    }
    dfs(0, 0);
    ll mx = max(dp0[0], dp1[0]);
    if (mx == dp0[0]){
        dfs_ans(0, 0, 0);
    } else{
        dfs_ans(0, 0, 1);
    }
    v.resize(q);
    vector<ll> res(mx + 1);
    int sm = 0;
    ll xr = 0;
    vector<ll> suff(n + 1);
    suff[n] = 0;
    for (int i = n - 1; i >= 0; --i){
        suff[i] = suff[i + 1] ^ ((i + 1) * x % m);
    }
    res[0] = suff[0];
    for (int i = 0; i < n; ++i) {
        if (aa[i] == 1){
            sm++;
            xr ^= (((i + 1) * x % m + y) % m);
            res[sm] = (xr ^ suff[i + 1]);
        } else{
            xr ^= ((i + 1) * x % m);
        }
    }
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
        if (v[i] > mx){
            cout << -1 << ' ';
        } else {
            cout << res[v[i]] << ' ';
        }
    }
    cout << endl;
    int t;
    cin >> t;
    while (t != 0){
        --t;
        if (v[t] > mx){
            cout << -1 << endl;
            cin >> t;
            continue;
        }
        int xxx = v[t];
        for (int i = 0; i < n; ++i) {
            if (xxx > 0 && aa[i] > 0) {
                cout << 1 << ' ';
                --xxx;
            } else{
                cout << 0 << ' ';
            }
        }
        cout << endl;
        cin >> t;
    }
}