#include <iostream>
#include <vector>

using namespace std;

void dfs(int k, int v, const vector <pair<int, int>>& t, vector <int>& qt, int turn, int dir, vector <int>& ans) {
    qt[v] = turn;
    if (qt[v] <= k) {
        ans[v] = 1;
    }
    if (t[v].first != -1) {
        if (dir == 1) {
            dfs(k, t[v].first, t, qt, turn + 1, 0, ans);
            dfs(k, t[v].second, t, qt, turn, 1, ans);
        }   else if (dir == 0) {
                dfs(k, t[v].second, t, qt, turn + 1, 1, ans);
                dfs(k, t[v].first, t, qt, turn, 0, ans);
        }   else {
                dfs(k, t[v].first, t, qt, turn, 0, ans);
                dfs(k, t[v].second, t, qt, turn, 1, ans);
        }
        ans[v] = ans[t[v].first] + ans[t[v].second];
    }
}

int main() {
    int n, k, q;
    cin >> n >> k >> q;
    vector <pair<int, int>> t(n, make_pair(-1, -1));
    vector <int> leaves;
    vector <int> qt(n, -1);
    for (int i = 0; i < n; i++) {
        int quant;
        cin >> quant;
        if (quant == 2) {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            t[i].first = l;
            t[i].second = r;
    }   else {
            leaves.push_back(i);
    }
    }
    vector <int> ans(n, 0);
    dfs(k, 0, t, qt, 0, -1, ans);
    for (int i = 0; i < q; i++) {
        int num;
        cin >> num;
        cout << ans[num - 1] << "\n";
    }
}
