#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll h, w, k;
    cin >> h >> w >> k;
    vector<ll> u;
    vector<ll> v;
    while(k--)
    {
        ll r, c;
        cin >> r >> c;
        u.push_back(r);
        v.push_back(c);
    }
    sort(u.begin(), u.end());
    sort(v.begin(), v.end());
    ll mh = u.back() - u[0] + 1, mhn = 0;
    for (int i = 1; i < u.size(); i++)
    {
        ll x = h - (u[i] - u[i - 1] - 1);
        ll n = min(u[i - 1], h - u[i] + 1);
        if (x < mh)
        {
            mh = x;
            mhn = n;
        }
        else if (x == mh)
        {
            mhn = min(mhn, n);
        }
    }
    ll mw = v.back() - v[0] + 1, mwn = 0;
    for (int i = 1; i < v.size(); i++)
    {
        ll x = w - (v[i] - v[i - 1] - 1);
        ll n = min(v[i - 1], w - v[i] + 1);
        if (x < mw)
        {
            mw = x;
            mwn = n;
        }
        else if (x == mw)
        {
            mwn = min(mwn, n);
        }
    }
    cout << mh*mw << ' ' << mhn + mwn << '\n';
    return 0;
}
