#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
const int INF = 1e9;

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int T;
    cin >> T;
    while(T--)
    {
        int n;
        cin >> n;
        vector<int> p(n);
        for (auto& i : p) cin >> i;
        vector<vector<int>> a(n + 2, vector<int>(n + 2, 0));
        for (auto& e : p)
        {
            for (int j = 1; j <= n + 1; j++)
            {
                if (j == e) continue;
                if (a[e][j] == -1) continue;
                for (int i = 0; i < e; i++) a[e][j] = max(a[e][j], a[i][j] + 1);
            }
            for (int i = 0; i <= n; i++)
            {
                if (i == e) continue;
                if (a[i][e] == -1) continue;
                for (int j = n + 1; j > e; j--) a[i][e] = max(a[i][e], a[i][j] + 1);
            }
            for (int i = 0; i < e; i++) for (int j = n + 1; j > e; j--) a[i][j] = -1;
        }
        int ans = 0;
        for (int i = 1; i <= n; i++) for (int j = 1; j <= n; j++) ans = max(ans, a[i][j]);
        cout << ans << '\n';
    }
}
