#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cstdio>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#include <random>
#include <ctime>
#define endl '\n'
using namespace std;
using ll = long long;
using ld = long double;

struct node {
	int l, r, ind;
};

bool cmp(node a, node b) {
	if (a.l != b.l)
		return a.l < b.l;
	return a.r < b.r;
}

int dp[30][30];
int get(vector <node> x) {
	int n = x.size();
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j <= n; j++) {
			dp[i][j] = -1e9;
			//p[i][j] = { -1, -1 };
		}
		dp[i][1] = 1;
	}
	for (int i = 1; i < n; i++) {
		for (int j = 0; j < i; j++) {
			for (int k = 0; k <= n; k++) {
				if (x[j].r < x[i].l && dp[j][k] + 1 > dp[i][k + 1]) {
					dp[i][k + 1] = dp[j][k] + 1;
					//p[i][k + 1] = { j, k };
				}
				else if (dp[i][k + 1] < dp[j][k]) {
					dp[i][k + 1] = dp[j][k];
					//p[i][k + 1] = { j, k };
				}
				if (dp[i][k] < dp[j][k]) {
					dp[i][k] = dp[j][k];
					//p[i][k] = { j, k };
				}
			}
		}
	}
	int m = 0;
	for (int i = 0; i < n; i++)
		m = max(m, dp[i][n]);
	return m;
}

void solve() {
	int n;
	cin >> n;
	vector <node> x(n);
	for (int i = 0; i < n; i++) {
		cin >> x[i].l >> x[i].r;
		x[i].ind = i;
	}
	sort(x.begin(), x.end(), cmp);
	int k = get(x);
	for (int mask = 0; mask < (1 << n); mask++) {
		vector <node> y;
		for (int i = 0; i < n; i++)
			if ((mask >> i) & 1)
				y.push_back(x[i]);
		if (y.size() == n / 2 && get(y) == k / 2) {
			for (auto& r : y)
				cout << r.ind + 1 << ' ';
			return;
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif 
	int t;
	cin >> t;
	while (t--) {
		solve();
		cout << endl;
	}
}	