#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cstdio>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#include <random>
#include <ctime>
#define endl '\n'
using namespace std;
using ll = long long;
using ld = long double;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif
	int n, q;
	cin >> n >> q;
	vector <ll> x(n);
	for (auto& r : x)
		cin >> r;
	sort(x.begin(), x.end());
	int z;
	cin >> z;
	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;
		int s = upper_bound(x.begin(), x.end(), k) - x.begin();
		vector <pair <ll, ll> > mn;
		for (int msk = 0; msk < (1 << s); msk++) {
			for (int msk2 = 0; msk2 < (1 << s); msk2++) {
				ll A = 0, B = 0;
				for (int i = 0; i < s; i++) {
					if ((msk >> i) & 1) {
						if ((msk2 >> i) & 1)
							A += x[i];
						else
							B += x[i];
					}
				}
				if (A <= a && B <= b)
					mn.push_back({ A, B });
			}
		}
		sort(mn.begin(), mn.end());
		mn.erase(unique(mn.begin(), mn.end()), mn.end());
		cout << ((int)mn.size() == (a + 1) * (b + 1) ? "Yes" : "No") << endl;
	}
}