#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <cstdio>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#include <random>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2e5 + 10;
vector <int> g[N];
ll l[N], r[N];
ll dp[N][2];

void dfs(int v, int p) {
	dp[v][1] = r[v];
	dp[v][0] = 0;
	for (auto& u : g[v]) {
		if (u != p) {
			dfs(u, v);
			dp[v][1] += dp[u][0];
			dp[v][0] += max(dp[u][1], dp[u][0]);
		}
	}
}

void solve() {
	ll n, q, x, y, m;
	cin >> n >> q >> x >> y >> m;
	for (int i = 0; i < n - 1; i++) {
		int s, f;
		cin >> s >> f;
		g[s].push_back(f);
		g[f].push_back(s);
	}
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
	}
	vector <ll> v(q);
	for (int t = 0; t < q; t++) {
		cin >> v[t];
	}
	dfs(1, -1);
	vector <ll> k(q, -1);
	for (int t = 0; t < q; t++) {
		if (max(dp[1][0], dp[1][1]) == v[t]) {
			ll kk = 0;
			for (int i = 1; i <= n; i++)
				kk ^= ((x * i) % m + ((y * r[i]) % m * r[i]) % m) % m;
			cout << kk;
			k[t] = kk;
		}
		else 
			cout << -1;
		cout << ' ';
	}
	cout << endl;
	int z;
	cin >> z;
	while (z != 0) {
		z--;
		if (k[z] == -1)
			cout << -1;
		else
			for (int i = 1; i <= n; i++)
				cout << r[i] << ' ';
		cout << endl;
		cin >> z;
	}
	for (int i = 0; i <= n; i++) {
		g[i].clear();
		l[i] = r[i] = 0;
		dp[i][0] = dp[i][1] = 0;
	}
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}