#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

void solve() {
    int n;
    cin >> n;
    int ans = 0;
    vector <int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }
    vector <int> dp(n, n + 1);
    vector <int> pr(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (dp[j] == n + 1 || p[dp[j]] > p[i]) {
                dp[j] = i;
                if (j != 0) {
                    pr[i] = dp[j - 1];
                }
                break;
            }
        }
    }
    vector <bool> used(n + 1, false);
    int k = 0;
    while (k < n && dp[k] != n + 1) {
        k++;
    }
    k--;
    k = dp[k];
    while (k != -1) {
        used[p[k]] = true;
        k = pr[k];
        ans++;
    }

    vector <int> pp;
    for (auto v : p) {
        if (!used[v]) {
            pp.push_back(v);
        }
    }
    swap(pp, p);
    if (p.empty()) {
        cout << ans << "\n";
        return;
    }
    n = p.size();
    dp.clear();
    pr.clear();
    dp.resize(n, n + 1);
    pr.resize(n, -1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (dp[j] == n + 1 || p[dp[j]] < p[i]) {
                dp[j] = i;
                if (j != 0) {
                    pr[i] = dp[j - 1];
                }
                break;
            }
        }
    }
    k = 0;
    while (k < n && dp[k] != n + 1) {
        k++;
    }
    cout << ans + k << "\n";

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}