#include<bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define fast cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;


const int N = 210;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;


struct s_tree {

    vector<int> maxx;
    int n;
    s_tree(int n1) {
        n = n1;
        maxx.resize(n * 4, 0);
    }

    void upd(int v, int l, int r, int i, int x) {
        if (r - l == 1) {
            maxx[v] = max(maxx[v], x);
            return;
        }
        int m = (l + r) / 2;
        if (i < m) upd(v * 2 + 1, l, m, i, x);
        else upd(v * 2 + 2, m, r, i, x);

        maxx[v] = max(maxx[v * 2 + 1], maxx[v * 2 + 2]);
    }

    int get(int v, int l, int r, int lq, int rq) {
        if (lq <= l && r <= rq) return maxx[v];
        if (l >= rq || r <= lq) return 0;
        int m = (l + r) / 2;
        int s1 = get(v * 2 + 1, l, m, lq, rq);
        int s2 = get(v * 2 + 2, m, r, lq, rq);
        return max(s1, s2);
    }
};

vector<int> a;
int n;

vector<int> dp;

int check(int ban1, int ban2) {
    int m = n + 1;
    s_tree t(m);
    dp.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (i == ban1 || i == ban2) continue;
        //cout << i << '\n';
        dp[i] = t.get(0, 0, m, 0, a[i]) + 1;
        t.upd(0, 0, m, a[i], dp[i]);
        //cout << i << '\n';
    }
    int ans = 0;
    for (int i = 0; i < n; i++) ans = max(ans, dp[i]);
    return ans;
}

set<pair<int, int> > exist;
vector<pair<int, int> > smth;
void solve() {
    int ans = min(n, check(-1, -1) + 1);

    for (int i = 0; i < n; i++) {
        for (auto it = exist.upper_bound({a[i], INF}); it != exist.end(); it = exist.upper_bound(*it)) {
           // cout << it->second << '\n';
            smth.push_back({i, it->second});
            if (smth.size() > 100) break;
        }
        exist.insert({a[i], i});
    }
    for (auto [i1, i2] : smth) {
        ans = max(ans, check(i1, i2) + 2);
    }
    cout << ans << '\n';
}

signed main() {
#ifdef parasha
    freopen("Untitled2.cpp", "r", stdin);
#endif // parasha
    int q;
    cin >> q;
    while (q--) {
        cin >> n;
        a.assign(n, 0);
        for (int &i : a) cin >> i;
        solve();
    }


}
