#include<bits/stdc++.h>

using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define fast cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

const int N = 1e5 + 100;
const int INF = 1e9 + 100;
const int MOD = 1e9 + 7;

vector<vector<int> > gr;
vector<int> cnt;
vector<int> l, r;
vector<int> ind;
int n;

bool check(int i, int j) {
    if (r[i] < l[j] || r[j] < l[i]) return 0;
    return 1;
}
void build_gr() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) continue;
            if (check(i, j)) {
                gr[i].push_back(j);
                //gr[j].push_back(i);
            }
        }
    }
}

vector<int> dp, p;

bool comp(int x, int y) {
    return r[x] < r[y];
}

vector<int> ans;
vector<int> can;

int build_m() {
    ind.clear();
    for (int i = 0; i < n; i++) {
        ind.push_back(i);
    }
    sort(all(ind), comp);
    dp.assign(n, 0);
    p.assign(n, -1);
    for (int i = 0; i < n; i++) {
        if (can[ind[i]] == 0) continue;
        dp[i] = 1;
        p[i] = -1;
        for (int j = 0; j < i; j++) {
            if (can[ind[j]] == 0) continue;
            if (check(ind[i], ind[j]) == 0) {
                if (dp[j] + 1 > dp[i]) {
                    dp[i] = dp[j] + 1;
                    p[i] = j;
                }
            }
        }
    }
    int id = 0;
    for (int i = 0; i < n; i++) {
        if (dp[i] > dp[id]) {
            id = i;
        }
    }
    int res = dp[id];;
    ans.assign(n, 0);
    while (id >= 0) {
        ans[ind[id]] = 1;
        id = p[id];
    }
    return res;


}

vector<int> used;
set<pair<int, int> > exist;
vector<int> num;
set<int> smth;

void do_smth(int v) {
    //cout << v + 1 << '\n';
    for (int u : gr[v]) {
        if (exist.find({num[u], u}) != exist.end()) {
            exist.erase({num[u], u});
            num[u]++;
            exist.insert({num[u], u});
        }
    }
}

void upd(int v, bool flag) {
    vector<int> need;
    if (flag == 1) {
        int kol = 0;
        for (int u : gr[v]) {
            cnt[u]++;
            if (cnt[u] == 1) kol++;
        }
        num[v] = kol;
        exist.insert({kol, v});
    } else {
        for (int u : gr[v]) {
            cnt[u]--;
            if (used[u] == 0 && ans[u] == 0 && cnt[u] == 0) {
                upd(u, 1);
            }
            if (used[u] == 0 && ans[u] == 0 && cnt[u] == 1) {
                do_smth(u);
            }
        }
    }
}


void solve() {
    gr.clear();
    cin >> n;
    gr.resize(n);
    l = r = vector<int>(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    build_gr();
    can.assign(n, 1);
    build_m();
    num.assign(n, 0);
    cnt.assign(n, 0);
    used.assign(n, 0);
    exist.clear();

    for (int v = 0; v < n; v++) {
        if (ans[v] == 0) continue;
        for (int u : gr[v]) cnt[u]++;
    }
    for (int v = 0; v < n; v++) {
        if (ans[v] == 0) continue;
        int kol = 0;
        for (int u : gr[v]) {
            if (cnt[u] == 1) kol++;
        }
        num[v] = kol;
        exist.insert({kol, v});
    }

    int now = 0;
    int need = exist.size() / 2;
    int cur = 0;
    //cout << need << '\n';
    while (exist.size() > need) {
        int v = exist.begin()->second;
       // cout << v + 1 << ' ' << num[v] << '\n';
        used[v] = 1;
        cur++;
        exist.erase(exist.begin());
        upd(v, 0);
    }
    assert(cur <= n / 2);
    smth.clear();
    for (auto [num, v] : exist) {
        smth.insert(v);
    }
    for (int i = 0; i < n; i++) {
        if (used[i] == 0 && cur < n / 2 && smth.find(i) == smth.end()) {
            used[i] = 1;
            cur++;
        }
    }
    can.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (used[i] == 0) {
            can[i] = 1;
            //cout << i + 1 << '\n';
        }
    }
    //cout << buil

    assert(build_m() == need);
    for (int u = 0; u < n; u++) {
        if (used[u] == 0) {
            cout << u + 1 << ' ';
        }
    }
    cout << '\n';
}





signed main() {
#ifdef parasha
    freopen("Untitled2.cpp", "r", stdin);
#endif // parasha
    fast;
    int q;
    cin >> q;
    while (q--) {
        solve();
    }

}
