#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define ll long long
#define int ll

using namespace std;

const int N = 2e5 + 10;

pair<int, int>a[N];
set<int>g[N];
bool used1[N];
int h[N];
int del[N];

bool cmp(int i, int j) {

	if (a[i].second == a[j].second) return a[i].first > a[j].first;
	return a[i].second < a[j].second;
}

bool cmp1(int i, int j) {
	if (a[i].first == a[j].first) return a[i].second > a[j].second;
	return a[i] < a[j];
}

void dfs(int v) {
	used1[v] = 1;
	h[v] = 1;
	for (auto to : g[v]) {
		if (!used1[to]) {
			dfs(to);
			h[v] = max(h[v], h[to] + 1);
		}
	}
}

bool used2[N];

vector<int>ans;
int can[N];

void dfs1(int v) {
	if (g[v].size() == 0) {
		ans.push_back(v + 1);
		del[v] = 1;
	}
	else can[v] = 1;
	for (auto to : g[v]) {
		if (!del[to]) {
			dfs1(to);
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<int>ind(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].first >> a[i].second;
			ind[i] = i;
		}
		sort(ind.begin(), ind.end(), cmp);
		int m = 0;
		int r = -1;
		for (int i = 0; i < n; ++i) {
			if (a[ind[i]].first > r) {
				m += 1;
				r = a[ind[i]].second;
			}
		}
		sort(ind.begin(), ind.end(), cmp1);
		vector<int>par(n);
		for (int i = 0; i < n; ++i) {
			par[i] = i;
		}
		vector<int>st;
		vector<int>roots;
		for (int i = 0; i < n; ++i) {
			while (st.size() > 0 && a[st.back()].second < a[ind[i]].first) {
				st.pop_back();
			}
			if (st.size() == 0) {
				roots.push_back(ind[i]);
				st.push_back(ind[i]);
			}
			else {
				par[ind[i]] = st.back();
				g[st.back()].insert(ind[i]);
				st.push_back(ind[i]);
			}
		}
		int m1 = 0;
		vector<bool>used(n);
		for (int i = 0; i < n; ++i) {
			if (m1 == m / 2) break;
			if (g[i].size() == 0) {
				int v = par[i];
				if (g[v].size() != 1) {
					g[v].erase(i);
					used[i] = 1;
					del[i] = 1;
					++m1;
				}
			}
		}
		if (m1 < m / 2) {
			for (auto x : roots) {
				if (!del[x]) dfs(x);
			}
			set<pair<int, int>>stt;
			for (auto x : roots) {
				stt.insert({ h[x], x });
			}
			for (int i = 0; i < n; ++i) {
				if (g[i].size() > 1) {
					for (auto to : g[i]) {
						stt.insert({ h[to], to });
					}
				}
			}
			while (m1 < m / 2) {
				int x = (*stt.begin()).second;
				stt.erase({ h[x], x });
				int v = par[x];
				if (x == v || g[v].size() > 1) {
					g[v].erase(x);
					del[x] = 1;
					m1 += 1;
				}
			}
		}
		for (auto x : roots) {
			if (!del[x]) dfs1(x);
		}
		for (int i = 0; i < n && ans.size() < n / 2; ++i) {
			if (can[i]) ans.push_back(i + 1);
		}
		for (auto x : ans) {
			cout << x << ' ';
		}
		cout << '\n';
		ans.clear();
		for (int i = 0; i < n; ++i) {
			g[i].clear();
			can[i] = 0;
			a[i] = { 0, 0 };
			used1[i] = 0;
			h[i] = 0;
			del[i] = 0;
		}
	}
}