#include <iostream>
#include <vector>
using namespace std;

const int MAXN = 201;

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    vector<vector<int>> dp(n + 2, vector<int>(n + 2, -MAXN));
    dp[0][n + 1] = 0;
    for (int i = 0; i < n; ++i) {
        vector<vector<int>> ndp(n + 2, vector<int>(n + 2, -MAXN));
        for (int a = 0; a <= n + 1; ++a) for (int b = 0; b <= n + 1; ++b) {
            if (a <= p[i])
                ndp[p[i]][b] = max(ndp[p[i]][b], dp[a][b] + 1);
            else
                ndp[a][b] = max(ndp[a][b], dp[a][b]);
            if (p[i] <= b)
                ndp[a][p[i]] = max(ndp[a][p[i]], dp[a][b] + 1);
            else
                ndp[a][b] = max(ndp[a][b], dp[a][b]);
        }
        dp = ndp;
    }
    int ans = 0;
    for (int a = 1; a <= n; ++a) for (int b = 1; b <= n; ++b)
        ans = max(ans, dp[a][b]);
    cout << ans << '\n';
}

signed main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
