#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

struct Seg {
    int l, r;
};

bool cmp(const pair<Seg, int>& a, const pair<Seg, int>& b) {
    return a.first.l < b.first.l;
}

int calcM(const vector<Seg>& b) {
    int n = (int)b.size();
    vector<int> dp(n);
    dp[0] = 1;
    for (int i = 1; i < n; ++i) {
        for (int prev = i - 1; prev >= 0; --prev) {
            if (b[prev].r < b[i].l) {
                dp[i] = max(dp[i], dp[prev] + 1);
            }
        }
    }
    return *max_element(all(dp));
}

void solve1() {
    int n; cin >> n;
    vector<pair<Seg, int>> a(n);
    vector<Seg> tA;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.l >> a[i].first.r;
        a[i].second = i;
    }
    for (int i = 0; i < n / 2; ++i) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

void solve() {
    int n; cin >> n;
    vector<pair<Seg, int>> a(n);
    vector<Seg> tA;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first.l >> a[i].first.r;
        a[i].second = i;
    }
    sort(all(a), cmp);
    vector<Seg> ta;
    for (int i = 0; i < n; ++i) {
        ta.push_back(a[i].first);
    }
    int m = calcM(ta);
    for (int mask = 0; mask < (1 << n); ++mask) {
        vector<Seg> b;
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i)) {
                b.push_back(a[i].first);
            }
        }
        if ((int)b.size() != n / 2) continue;
        if (calcM(b) == m / 2) {
            for (int i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    cout << a[i].second + 1 << ' ';
                }
            }
            cout << '\n';
            return;
        }
    }
    assert(false);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
