#include <bits/stdc++.h>
#define int long long
#define all(a) a.begin(), a.end()

using namespace std;

struct Query {
    int k, a, b;
};

int myPow(int a, int p) {
    int ans = 1;
    for (int i = 0; i < p; ++i) ans *= a;
    return ans;
}

bool used[200005];

vector<bool> stupidSolve(vector<int> w, vector<Query> qs) {
    int n = (int)w.size(), q = (int)qs.size();
    vector<bool> ans;
    for (auto [k, a, b] : qs) {
        vector<int> v;
        for (int i = 0; i < n; ++i) {
            if (w[i] <= k) v.push_back(w[i]);
        }
        for (int i = 0; i < 200005; ++i) used[i] = false;
        int nn = (int)v.size();
        int mx = myPow(3, nn);
        for (int mask = 0; mask < mx; ++mask) {
            int na = 0, nb = 0, tmp = mask;
            for (int i = 0; i < nn; ++i) {
                if (tmp % 3 == 2) {
                    nb += v[i];
                } else if (tmp % 3 == 1) {
                    na += v[i];
                }
                tmp /= 3;
            }
            if (na > a || nb > b) continue;
            used[na * (b + 1) + nb] = true;
        }
        bool ok = true;
        for (int i = 0; i <= a; ++i) {
            for (int j = 0; j <= b; ++j) {
                if (used[i * (b + 1) + j] == false) {
                    ok = false;
                    break;
                }
            }
        }
        ans.push_back(ok);
    }
    return ans;
}

void run() {
    int n, q; cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    int z; cin >> z;
    vector<Query> qs(q);
    for (int i = 0; i < q; ++i) {
        cin >> qs[i].k >> qs[i].a >> qs[i].b;
    }
    auto ans = stupidSolve(w, qs);
    for (auto i : ans) {
        if (i) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}