#include <bits/stdc++.h>

using namespace std;

#define sz(a) int((a).size())

typedef long long ll;

int k;

vector<vector<int>> gr;
vector<int> p;

vector<vector<bool>> side;

vector<int> turns;
vector<int> cnt;

void dfs(int v) {
    if (gr[v].empty() && turns[v] <= k) {
        cnt[v] = 1;
    }
    for (int i = 0; i < sz(gr[v]); ++i) {
        int to = gr[v][i];
        turns[to] = turns[v] + int(!side[v][i]);
        dfs(to);
        cnt[v] += cnt[to];
    }
}

void solve() {
    int n, q;
    cin >> n >> k >> q;
    gr.resize(n);
    p.assign(n, -1);
    side.assign(n, vector(2, false));
    side[0][0] = side[0][1] = true;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        for (int j = 0; j < t; ++j) {
            int to;
            cin >> to;
            to--;
            gr[i].push_back(to);
            side[to][j] = true;
            p[to] = i;
        }
    }

    turns.assign(n, 0);
    cnt.assign(n, 0);
    dfs(0);

    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << cnt[v] << '\n';
    }

    cerr << "lol\n";
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}