#include <iostream>
#include <algorithm>

using namespace std;

pair<int, int> solve(int* arr, int k, int n)
{
	sort(arr, arr + k);
	int maxd = arr[0] + n - arr[k - 1] - 1, shift = 0, lshift, rshift;
	for (int i = 0; i < k - 1; i++)
	{
		int dist;
		dist = arr[i + 1] - arr[i] - 1;
		lshift = (arr[i] + 1) % n;
		rshift = n - arr[i + 1];
		if (dist > maxd || dist == maxd && (lshift < shift || rshift < shift))
		{
			maxd = dist;
			shift = min(lshift, rshift);
		}
	}
	return pair<int, int>(n - maxd, shift);
}

int main()
{
	int w, h, k;
	cin >> h >> w >> k;

	auto arrx = new int[k];
	auto arry = new int[k];
	for (int i = 0; i < k; i++)
	{
		cin >> arrx[i] >> arry[i];
		arrx[i]--;
		arry[i]--;
	}

	auto x = solve(arrx, k, h);
	auto y = solve(arry, k, w);

	cout << x.first * y.first << " " << x.second + y.second << endl;
	
	return 0;
}
