#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;

const int N = 200005;

int l[N], r[N], flips[N], res[N];
vector<int> qs[N], s[N];

int n, k, q;

void dfs1(int v, int cur, int type) {
  flips[v] = cur;
  if (l[v] != -1) {
    if (type == 2) {
      dfs1(l[v], cur + 1, 1);
    } else {
      dfs1(l[v], cur, 1);
    }
  }
  if (r[v] != -1) {
    if (type == 1) {
      dfs1(r[v], cur + 1, 2);
    } else {
      dfs1(r[v], cur, 2);
    }
  }
}

void dfs2(int v) {
  int cnt = k - flips[v];
  if (l[v] == -1) {
    s[v].push_back(0);
    for (int id : qs[v]) {
      res[id] = upper_bound(all(s[v]), cnt) - s[v].begin();
    }
    return;
  }
  dfs2(l[v]);
  dfs2(r[v]);
  int al = (flips[l[v]] > flips[v]);
  int ar = (flips[r[v]] > flips[v]);
  int i1 = 0, i2 = 0;
  while (i1 < size(s[l[v]]) && i2 < size(s[r[v]])) {
    if (s[l[v]][i1] + al <= s[r[v]][i2] + ar) {
      s[v].emplace_back(al + s[l[v]][i1++]);
    } else {
      s[v].emplace_back(ar + s[r[v]][i2++]);
    }
  }
  while (i1 < size(s[l[v]])) {
    s[v].emplace_back(al + s[l[v]][i1++]);
  }
  while (i2 < size(s[r[v]])) {
    s[v].emplace_back(ar + s[r[v]][i2++]);
  }
  s[l[v]].clear();
  s[r[v]].clear();
  for (int id : qs[v]) {
    res[id] = upper_bound(all(s[v]), cnt) - s[v].begin();
  }
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  memset(l, -1, sizeof(l));
  memset(r, -1, sizeof(r));
  cin >> n >> k >> q;
  for (int i = 0; i < n; ++i) {
    int cnt;
    cin >> cnt;
    if (cnt == 2) {
      cin >> l[i] >> r[i];
      --l[i], --r[i];
    }
  }
  dfs1(0, 0, 0);
  for (int i = 0; i < q; ++i) {
    int v;
    cin >> v;
    --v;
    qs[v].emplace_back(i);
  }
  dfs2(0);
  for (int i = 0; i < q; ++i) {
    cout << res[i] << '\n';
  }
  return 0;
}