#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pikachu push_back
#define sz(a) (int)(a.size())

void debug_out(){
    cerr << endl;
}

template<typename H, typename...T>
void debug_out(H head, T... tail){
    cerr << ' ' << to_string(head);
    debug_out(tail...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

void run();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    run();
}

const ll N = 2e5;
vector<ll> g[N];
ll sm[N];
ll k;

void dfs(ll v, ll t, ll cnt) {
    ll c = 0;
    for (auto u: g[v]) {
        ll w = 0;
        if (t != -1) w = (c ^ t);
        dfs(u, c, cnt + w);
        ++c;
        sm[v] += sm[u];
    }
    if (!sz(g[v]) && cnt <= k) {
        sm[v]++;
    }
}

void run() {
    ll n, q;
    cin >> n >> k >> q;
    for (ll i = 0; i < n; ++i) {
        ll t;
        cin >> t;
        while (t--) {
            ll x;
            cin >> x;
            g[i].pikachu(--x);
        }
    }
    dfs(0, -1, 0);
    while (q--) {
        ll v;
        cin >> v;
        cout << sm[--v] << '\n';
    }

}
