#include<bits/stdc++.h>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

int n, q;

int A = 0, B = 0;

vector<int> w(0);
vector<ii> ask(0);

void solve() {
    bool dp[n + 1][A + 1][B + 1];
    for (int num = 0; num <= n; num++) {
        for (int i = 0; i <= A; i++) {
            for (int j = 0; j <= B; j++) {
                dp[num][i][j] = false;
            }
        }
    }
    dp[0][0][0] = true;
    for (int num = 0; num < n; num++) {
        for (int i = 0; i <= A; i++) {
            for (int j = 0; j <= B; j++) {
                dp[num + 1][i][j] = dp[num][i][j];
                if (i >= w[num]) {
                    dp[num + 1][i][j] |= dp[num][i - w[num]][j];
                }
                if (j >= w[num]) {
                    dp[num + 1][i][j] |= dp[num][i][j - w[num]];
                }
            }
        }
    }
    int first_bad[A + 1];
    for (int i = 0; i <= A; i++) {
        first_bad[i] = B + 1;
        for (int j = 0; j <= B; j++) {
            if (!dp[n][i][j]) {
                first_bad[i] = j;
                break;
            }
        }
    }
    for (auto j : ask) {
       // cout << j.ft << " " << j.sd << " " << first_bad[j.ft] << endl;
        int in = first_bad[j.ft];
        if (in <= j.sd) {
            cout << "No\n";
        } else {
            cout << "Yes\n";
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> q;
    w.resize(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    sort(w.begin(), w.end());
    int zz;
    cin >> zz;
    ask.resize(q);
   // cout << q << endl;
    for (int i = 0; i < q; i++) {
        long long rr44;
        cin >> rr44 >> ask[i].ft >> ask[i].sd;
        //cout << ask[i].ft << " "<< ask[i].sd << endl;
        A = max(A, ask[i].ft);
        B = max(B, ask[i].sd);
    }
    //cout << A << " " << B << endl;
    solve();
    return 0;
}