#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void Alice() {
    int n, k;
    cin >> n >> k;

    vector<int> got(n), put(n);

    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        x -= 1;
        got[x] = true;
    }

    int bal = 0;

    for (int i = 0; i < n; ++i) {
        if (got[i]) {
            bal += 1;
        } else if (bal > 0) {
            put[i] = true;
            bal -= 1;
        }
    }

    for (int i = 0; i < n && bal > 0; ++i) {
        if (!got[i] && !put[i]) {
            put[i] = true;
            bal -= 1;
        }
    }

    assert(bal == 0);

    for (int i = 0; i < n; ++i) {
        if (put[i]) {
            cout << i + 1 << " ";
        }
    }

    cout << '\n';
}

void Bob() {
    int n, k;
    cin >> n >> k;

    vector<int> got(n), put(n);

    for (int i = 0; i < k; ++i) {
        int x;
        cin >> x;
        x -= 1;
        got[x] = true;
    }

    int bal = 0;

    for (int i = n - 1; i >= 0; --i) {
        if (got[i]) {
            bal += 1;
        } else if (bal > 0) {
            put[i] = 1;
            bal -= 1;
        }
    }

    assert(bal >= 0);

    for (int i = n - 1; i >= 0 && bal > 0; --i) {
        if (!got[i] && !put[i]) {
            put[i] = true;
            bal -= 1;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (put[i]) {
            cout << i + 1 << " ";
        }
    }

    cout << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int type, test;
    cin >> type >> test;

    while (test--) {
        if (type == 1) {
            Alice();
        } else {
            Bob();
        }
    }

    return 0;
}
