#include <iostream>
#include <algorithm>
#include <cassert>
#include <vector>
#include <set>
using namespace std;
#define int long long
bool ok(pair<int, int> a, pair<int, int> b) {
    return a.second < b.first || b.second < a.first;
}

int f(vector<pair<int, int>> a) {
    sort(a.begin(), a.end());
    vector<int> dp(a.size(), 0);
    int n = a.size();
    for (int i = 0; i < n; ++i) {
        dp[i] = 1;
        for (int j = 0; j < i; ++j) {
            if (a[j].second < a[i].first) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
    }
    return *max_element(dp.begin(), dp.end());
}

const int inf =  1e9;

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> segsp;
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        segsp.push_back({ { l, r }, i });
    }
    vector<pair<int, int>> segs;
    sort(segsp.begin(), segsp.end());
    for (int i = 0; i < n; ++i) {
        p[i] = segsp[i].second;
        segs.push_back(segsp[i].first);
    }
    int m = f(segs);
    assert(m % 2 == 0);
    vector<pair<int, int>> res;
    vector<int> rs;
    for (int i = 0; i < n; ++i) {
        int pr = -1;
        if (res.size()) pr = f(res);
        res.push_back(segs[i]);
        if (f(res) > m / 2) {
            if (pr != m / 2) {
                assert(0);
            }
            res.pop_back();
        } else {
            rs.push_back(p[i]);
        }
    }
    assert(rs.size() >= n / 2);
    for (int i = 0; i < n / 2; ++i) {
        cout << rs[i] + 1 << ' ';
    }
    cout << '\n';
}

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}