#pragma GCC optimize ("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
//#define int ll

vector<int> cnt, sz, leaf, lcnt;
vector<pair<int, int>> g;

void dfs(int v, int t) {
    if (g[v] == make_pair(-1, -1))
        return;
    cnt[g[v].first] = cnt[v] + (t != 1);
    dfs(g[v].first, 1);
    cnt[g[v].second] = cnt[v] + (t != 2);
    dfs(g[v].second, 2);
}

void get_sz(int v) {
    if (g[v] == make_pair(-1, -1)) {
        sz[v] = 1;
        return;
    }

    get_sz(g[v].first);
    get_sz(g[v].second);

    sz[v] += sz[g[v].first] + sz[g[v].second];
}

void get_leaf(int v, int cur) {
    leaf[v] = cur;

    if (g[v] == make_pair(-1, -1))
        return;

    get_leaf(g[v].first, cur);
    get_leaf(g[v].second, cur + sz[g[v].first]);
}

void get_lcnt(int v) {
    if (g[v] == make_pair(-1, -1)) {
        lcnt.push_back(cnt[v]);
        return;
    }
    get_lcnt(g[v].first);
    get_lcnt(g[v].second);
}

void solve() {
    int n, k, q;
    cin >> n >> k >> q;
    g.assign(n, {-1, -1});
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int u, v;
            cin >> u >> v;
            g[i] = {u - 1, v - 1};
        }
    }

    cnt.assign(n, 0);
    dfs(0, -1);
    for (int i = 1; i < n; ++i)
        --cnt[i];

    sz.assign(n, 0);
    get_sz(0);

    leaf.assign(n, 0);
    get_leaf(0, 0);

    get_lcnt(0);

    vector<int> pr(lcnt.size() + 1);
    for (int i = 1; i < pr.size(); ++i)
        pr[i] = pr[i - 1] + (lcnt[i - 1] <= k);

    while (q--) {
        int i;
        cin >> i;
        --i;

        int l = leaf[i], r = l + sz[i];
        cout << pr[r] - pr[l] << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t=  1;
    //cin >> t;
    while (t--)
        solve();
}
