#pragma GCC optimize ("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

const int MAXC = 1510;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;

    sort(all(a));
    vector<vector<bool>> dp(MAXC, vector<bool>(MAXC));
    dp[0][0] = 1;
    for (int i = 1; i <= n; ++i)
        for (int x = MAXC - 1; x > -1; --x)
            for (int y = MAXC - 1; y > -1; --y)
                dp[x][y] = dp[x][y] || (x >= a[i - 1] && dp[x - a[i - 1]][y]) || (y >= a[i - 1] && dp[x][y - a[i - 1]]);

    for (int x = 0; x < MAXC; ++x)
        for (int y = 0; y < MAXC; ++y)
            dp[x][y] = (x == 0 || dp[x - 1][y]) && (y == 0 || dp[x][y - 1]) && dp[x][y];
    /*
    for (auto i : dp) {
        for (int j = 0; j < 10; ++j) {
            for (int k = 0; k < 10; ++k)
                cout << i[j][k] << " ";
            cout << endl;
        }
        cout << endl;
    }
    */
    int z;
    cin >> z;
    while (q--) {
        int k, x, y;
        cin >> k >> x >> y;
        cout << (dp[x][y] ? "Yes" : "No") << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t=  1;
    //cin >> t;
    while (t--)
        solve();
}
