#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <iostream>
#define f first
#define s second
#define int long long
#define debug(x) cerr << (#x)<<": "<<x<<endl
#define pb push_back
using namespace std;
int min(int a, int b) {
	if (a <= b) return a;
	return b;
}
int max(int a, int b) {
	if (a >= b) return a;
	return b;
}
int n, q;
vector<int> p, w;
set<pair<int, int> > can;
vector<int> spec;
void perebor() {
	if (p.size() == spec.size()) {
		int sum_1 = 0, sum_2 = 0;
		int nn = spec.size();
		for (int i = 0; i < nn; i++) {
			if (!p[i]) continue;
			if (p[i] == 1) {
				sum_1 += w[i];
			}
			else {
				sum_2 += w[i];
			}
		}
		can.insert({ sum_1,sum_2 });
	}
	else {
		for (int i = 0; i < 3; i++) {
			p.pb(i);
			perebor();
			p.pop_back();
		}
	}
}
void solve() {
	cin >> n >> q;
	int z;
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		w.pb(x);
	}
	cin >> z;
	sort(w.begin(), w.end());
	for (int it = 0; it < q; it++) {
		int k, a, b; cin >> k >> a >> b;
		int fl = 1;
		can.clear();
		spec.clear();
		for (int j = 0; j < n; j++) {
			if (w[j] <= k) spec.pb(w[j]);
		}
		perebor();
		for (int j = 0; j <= a; j++) {
			for (int p = 0; p <= b; p++) {
				if (!can.count({ j, p })) {
					fl = 0;
					break;
				}
			}
			if (!fl) break;
		}
		if (fl) {
			cout << "Yes";
		}
		else {
			cout << "No";
		}
		cout << '\n';
	}
}
signed main()
{
	ios_base::sync_with_stdio();
	cout.tie(0);
	cin.tie(0);
	int t = 1;
	//cin>>t;
	while (t--) {
		solve();
	}
}