#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

pair<int, int> get(vector<int> a, int h) {
    sort(a.begin(), a.end());
    pair<int, int> mn = {a.back() - a.front() + 1, 0};
    for (int i = 0; i < a.size() - 1; ++i) {
        int now = h - (a[i + 1] - a[i]) + 1;
        int cnt = min(a[i], h - a[i + 1] + 1);
        mn = min(mn, {now, cnt});
    }
    return mn;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> f(k);
    vector<int> s(k);
    for (int i = 0; i < k; ++i) {
        cin >> f[i];
        cin >> s[i];
    }
    auto res1 = get(f, h);
    auto res2 = get(s, w);
    cout << res1.first * res2.first << " " << res1.second + res2.second << "\n";
}
