#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

void solve1() {
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        vector<int> a;
        map<int, int> cnt;
        for (int i = 0; i < k; ++i) {
            int c;
            cin >> c;
            --c;
            a.push_back(c);
            cnt[c]++;
        }
        vector<int> ans;
        for (int j = 1; j < n; ++j) {
            ++a[0];
            a[0] %= n;
            ++a[1];
            a[1] %= n;
            if (cnt[a[0]] == 0 && cnt[a[1]] == 0) {
                ans.push_back(a[0]);
                ans.push_back(a[1]);
            }
        }
        sort(ans.begin(), ans.end());
        for (auto i: ans) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }
}

void solve2() {
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        vector<int> a;
        map<int, int> cnt;
        for (int i = 0; i < k; ++i) {
            int c;
            cin >> c;
            --c;
            a.push_back(c);
            cnt[c]++;
        }
        vector<int> ans;
        for (int j = 1; j < n; ++j) {
            --a[0];
            a[0] = (a[0] + n) % n;
            --a[1];
            a[1] = (a[1] + n) % n;
            if (cnt[a[0]] == 0 && cnt[a[1]] == 0) {
                ans.push_back(a[0]);
                ans.push_back(a[1]);
            }
        }
        sort(ans.begin(), ans.end());
        for (auto i: ans) {
            cout << i + 1 << " ";
        }
        cout << endl;
    }
}


signed main() {
    int a;
    cin >> a;
    if (a == 1) {
        solve1();
    } else {
        solve2();
    }
}