#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>
using namespace std;
void cypher2(vector<int>& numbers, int n) {
    bool issecond = true;
    for (int i = 1; i < numbers.size(); i++) {
        if (numbers[i] - numbers[i - 1] < 2 || numbers[i] == n) {
            issecond = false;
        }
    }
    if (issecond) {
        for (auto &i : numbers) {
            cout << i % n + 1 << " ";
        }
        cout << endl;
    } else {
        for (auto &i : numbers) {
            cout << i + n / 2 - 1 << " ";
        }
        cout << endl;
    }
}
void cypher() {
    int n, k;
    cin >> n >> k;
    vector<int> nums(k);
    vector<bool> isnum;
    for (int i = 0; i < k; i++) {
        cin >> nums[i];
    }
    bool isfirst = true;
    for (int i = 1; i < nums.size(); i++) {
        if (nums[i] - nums[i - 1] < 2 || nums[i] == n) {
            isfirst = false;
        }
    }
    bool issecond = true;
    for (auto &i : nums) {
        if (i >= n / 2) {
            issecond = false;
        }
    }
    if (isfirst || issecond) {
        cypher2(nums, n);
        return;
    }
    isnum.resize(n + 1);
    for (auto &i : nums) {
        isnum[i] = true;
    }
    int curnum = 0;
    int need = 0;
    vector<int> ans;
    for (int i = 0; i <= 2 * n - 1; i++) {
        if (curnum < k && nums[curnum] == i + 1) {
            need++;
            curnum++;
        } else if (need > 0 && !isnum[i % n + 1]) {
            isnum[i % n + 1] = true;
            ans.push_back(i % n + 1);
            need--;
        }
    }
    sort(ans.begin(), ans.end());
    for (auto &i : ans) {
        cout << i << " ";
    }
    cout << endl;
}
void decypher2(vector<int>& numbers, int n) {
    bool issecond = true;
    for (int i = 1; i < numbers.size(); i++) {
        if (numbers[i] - numbers[i - 1] < 2) {
            issecond = false;
        }
    }
    if (issecond) {
        for (auto &i : numbers) {
            cout << (i - 2 + n) % n + 1 << " ";
        }
        cout << endl;
    } else {
        for (auto &i : numbers) {
            cout << i - n / 2 + 1 << " ";
        }
        cout << endl;
    }
}
void decypher() {
    int n, k;
    cin >> n >> k;
    vector<bool> nums;
    vector<bool> was;
    vector<int> nums2(k);
    bool isbig = false;
    for (int i = 0; i < k; i++) {
        int now;
        cin >> now;
        nums2.push_back(now);
    }
    bool isfirst = true;
    for (int i = 1; i < nums2.size(); i++) {
        if (nums2[i] - nums2[i - 1] < 2 || nums2[i] == 1) {
            isfirst = false;
        }
    }
    bool issecond = true;
    for (auto &i : nums2) {
        if (i < n / 2) {
            issecond = false;
        }
    }
    if (isfirst || issecond) {
        decypher2(nums2, n);
        return;
    }
    nums.resize(n + 1);
    was.resize(n + 1);
    for (auto &i : nums2) {
        nums[i] = true;
    }
    vector<int> ans;
    int credit = 0;
    for (int i = 2 * n - 1; i >= 0; i--) {
        if (credit > 0 && (!was[i % n + 1]) && (!nums[i % n + 1])) {
            ans.push_back(i % n + 1);
            was[i % n + 1] = true;
            credit--;
        }
        if (nums[i % n + 1] && !was[i % n + 1]) {
            credit++;
            was[i % n + 1] = true;
        }
    }
    sort(ans.begin(), ans.end());
    for (auto &i : ans) {
        cout << i << " ";
    }
    cout << endl;
}
int main() {
    int t;
    cin >> t;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        if (t == 1) {
            cypher();
        } else {
            decypher();
        }
    }
}
