#include <bits/stdc++.h>
using namespace std;

#define int long long

signed main() {

    #ifdef GEOMA
        freopen("input", "r", stdin);
        freopen("output", "w", stdout);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif

    int n, q;
    while (cin >> n >> q) {
        vector<int> w(n);
        for (int i = 0; i < n; i++) cin >> w[i];
        int z;
        cin >> z;
        sort(w.begin(), w.end());

        int last_good = -1;
        int prv = 0;
        for (int i = 0; i < n; i++) {
            if (w[i] > prv + 1) {
                break;
            }
            prv += w[i];
            last_good = i;
        }

        while ((int)w.size() != last_good + 1) w.pop_back();
        n = w.size();
        vector<int> pref(n + 1, 0);
        for (int i = 0; i < n; i++) pref[i + 1] = pref[i] + w[i];

        // for (int i : last_good) cout << i << " ";
        // cout << "\n";

        for (int i = 0; i < q; i++) {
            int k, a, b;
            cin >> k >> a >> b;
            bool good = true;
            for (int x = 0; x <= a; x++) {
                for (int y = 0; y <= b; y++) {
                    int curr = upper_bound(w.begin(), w.end(), k) - w.begin() - 1;
                    int u = x, v = y;
                    while (u != 0 || v != 0) {
                        // cout << u << " " << v <<  " " << curr << "\n";
                        if (u < v) swap(u, v);
                        while (w[curr] > u && curr >= 0) curr--;
                        if (curr == -1) break;
                        u -= w[curr--];
                    }
                    if (u != 0 || v != 0) {
                        // cout << x << " " << y << "\n";
                        good = false;
                        break;
                    }
                }
                if (!good) break;
            }
            if (good) cout << "Yes\n";
            else cout << "No\n";
        }
    }
}