#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
#define int long long
#define ll long long
#define ld long double
#define pi pair<int, int>
#define vi vector<int>
const int INF = 1e10;
void slv(vi& p1) {
	int N = p1.size();
	vector<int> p = p1;
	vector<vector<vector<int>>> dp; 
	dp.assign(N + 1, vector<vector<int>>(N + 2, vector<int>(N + 1, -INF)));
	dp[0][0][N + 1] = 0;
	for (int i = 0; i < N; ++i) {
		for (int j = 0; j <= N + 1; ++j) {
			for (int k = 0; k <= N + 1; ++k) {
				if (dp[i][j][k] < 0) continue;
				if (p[i] > j) dp[i + 1][p[i]][k] = max(dp[i + 1][p[i]][k], dp[i][j][k] + 1);
				else dp[i + 1][j][k] = max(dp[i + 1][j][k], dp[i][j][k]);
				if (p[i] < k) {
					dp[i + 1][j][p[i]] = max(dp[i + 1][j][p[i]], dp[i][j][k] + 1);
				}
				else {
					dp[i + 1][j][k] = max(dp[i + 1][j][k], dp[i][j][k]);
				}
			}
		}
		
	}
	int mx = 0;
	for (int i = 0; i <= N + 1; ++i) {
		for (int j = 0; j <= N + 1; ++j) {
			mx = max(mx, dp[N][i][j]);
		}
	}
	cout << mx << "\n";
}
vi seg_tree;
void upd(int v, int l, int r, int pos, int val) {
	if (l > pos || r < pos) return;
	if (l == pos && r == pos) {
		seg_tree[v] = max(seg_tree[v], val);
		return;
	}
	int mid = (l + r) / 2;
	upd(2 * v, l, mid, pos, val);
	upd(2 * v + 1, mid + 1, r, pos, val);
	seg_tree[v] = max(seg_tree[2 * v], seg_tree[2 * v + 1]);
}
int get(int v, int l, int r, int L, int R) {
	if (l > R || L > r) return 0;
	if (l >= L && R >= r) return seg_tree[v];
	int mid = (l + r) / 2;
	return  max(get(2 * v, l, mid, L, R), get(2 * v + 1, mid + 1, r, L, R));
}
void solve() {
	int N = 0; cin >> N;
	vi p; p.assign(N, 0);
	for (int i = 0; i < N; ++i) cin >> p[i];
	vi dp;
	if (is_sorted(p.begin(), p.end())) {
		cout << N << "\n";
		return;
	}
	int it = N - 1;
	int ans = 0;
	while (p[it] == it + 1) {
		it--; ans++;
	}
	ans += 2; int prev_mx = -1;
	for (int j = 0; j < it; ++j) {
		if (p[j] == it + 1) continue;
		if (prev_mx < p[j]) {
			prev_mx = p[j]; ans++;
		}
	}
	cout << ans << "\n";
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}
}
/*
6
1 6 5 2 3 4
*/