//
// Created by roi on 03.04.2023.
//
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2,bmi,bmi2,ssse3,sse4_2,lzcnt,popcnt")
#include<bits/stdc++.h>

typedef long long ll;
using namespace std;
#define int long long
vector<vector<vector<int>>> dp;
const ll INF = 1e15;

vector<ll> tree;

int get_max(int v, int vl, int vr, int l, int r) {
    if (l <= vl && vr <= r) return tree[v];
    if (l >= vr || vl >= r) return -INF;
    int vm = (vl + vr) / 2;
    return max(
            get_max(2 * v + 1, vl, vm, l, r),
            get_max(2 * v + 2, vm, vr, l, r)
    );
}


void setP(int v, int vl, int vr, int ind, int val) {
    if (vr - vl == 1) {
        tree[v] = val;
        return;
    }
    int vm = (vl + vr) / 2;
    if (ind < vm) setP(2 * v + 1, vl, vm, ind, val);
    else setP(2 * v + 2, vm, vr, ind, val);
    tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; i++) cin >> p[i];

    int res = 0;
    int mx = -1, mn = n + 1;
    vector<int> tmp;
    for (int i = 0; i < n; i++) {
        if (p[i] > mx) {
            res++;
            mx = p[i];
        } else {
            tmp.push_back(p[i]);
        }
    }

    n++;
    tree.assign(4 * (n + 1), 0);
    for (int i = 0; i < tmp.size(); i++) {
        int val = get_max(0, 0, n, tmp[i], n);
        setP(0, 0, n, tmp[i], val + 1);
    }
    res += get_max(0, 0, n, 0, n);
    cout << res;
//    cout << n;
//    return;
//    for (int i = 0; i <= n; i++) dp[0][i].assign(n + 2, -INF);
//    dp[0][p[0]][n + 1] = 1;
//    dp[0][0][p[0]] = 1;
//    for (int i = 1; i < n; i++) {
//        for (int j = n + 1; j >= p[i]; j--) {
//            dp[i][j] = dp[i - 1][j];
//        }
//        for (int j = 0; j <= p[i]; j++) {
//            dp[i][j].assign(n + 2, -INF);
//        }
//
//        // lets put it in r
//        int mx = p[i];
//        for (int lmx = 0; lmx < mx; lmx++) {
//            for (int k = 0; k <= n + 1; k++) {
//                dp[i][mx][k] = max(dp[i][mx][k], dp[i - 1][lmx][k] + 1);
//            }
//        }
//
//        // lets put it in c
//        int mn = p[i];
//        for (int j = 0; j <= mn; j++) {
//            for (int k = 0; k <= n + 1; k++) {
//                dp[i][k][j] = max(dp[i][k][j], dp[i - 1][k][j]);
//            }
//        }
//
//        for (int lmn = n + 1; lmn > p[i]; lmn--) {
//            for (int k = 0; k <= n + 1; k++) {
//                dp[i][k][mn] = max(dp[i][k][mn], dp[i - 1][k][lmn] + 1);
//            }
//        }
//    }
//
//    int res = -n - 1;
//    for (int i = 0; i <= n + 1; i++) {
//        res = max(res, *max_element(dp[n - 1][i].begin(), dp[n - 1][i].end()));
//    }
//    cout << res;
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    const int MAXN = 207;
    dp.resize(MAXN, vector<vector<int>>(MAXN, vector<int>(MAXN)));
    int t = 1;
#ifdef LOCAL
    freopen("c.in", "r", stdin);
#endif
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
#ifdef LOCAL
        cout << endl;
#endif
    }
}