//
// ВАСЯ ФЕДОРОВ ЛОХ АХВХАВХАХВАХВХВХА
//
//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("bmi,bmi2,sse,sse2,sse3,sse4,ssse3,mmx,lzcnt,popcnt,tune=native")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define int long long

const int INF = 1e16;


vector<vector<int>> g;
vector<int> a;
vector<vector<int>> dp;
vector<unordered_map<int, int>> nig;


void dfs(int v, int p) {
    for (int u: g[v]) {
        if (u != p) dfs(u, v);
    }

    ll smax = 0;
    for (int u: g[v]) {
        if (u != p) {
            if (dp[u][0] > dp[u][1]) {
                nig[v][u] = 0;
                smax += dp[u][0];
            } else {
                nig[v][u] = 1;
                smax += dp[u][1];
            }
        }
    }
    dp[v][0] = smax;
    dp[v][1] = a[v];
    for (int u: g[v]) {
        if (u != p) {
            dp[v][1] += dp[u][0];
        }
    }
}


vector<bool> used;


void dfs2(int v, int p, int c) {
    if (c == 1) {
        used[v] = true;
    }
    for (int u: g[v]) {
        if (u == p) continue;
        if (c == 1) {
            dfs2(u, v, 0);
        } else {
            dfs2(u, v, nig[v][u]);
        }
    }
}


void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    g.assign(n, vector<int>());
    for (int i = 0; i + 1 < n; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    a.assign(n, 0);
    nig.assign(n, {});
    used.assign(n, 0);
    for (int i = 0; i < n; i++) cin >> a[i] >> a[i];

    dp.assign(n, vector<int>(2, -INF));

    dfs(0, -1);
    int eff = max(dp[0][0], dp[0][1]);
    if (dp[0][0] > dp[0][1]) {
        dfs2(0, -1, 0);
    } else {
        dfs2(0, -1, 1);
    }
    int xx = 0;
//    for (int i = 0; i < n; i++) {
//        xx ^= (((i + 1) * x + ((y * a[i]) % m) * a[i]) % m);
//    }
    vector<int> pref(eff + 1);
    for (int i = 0; i < n; i++) {
        pref[0] ^= ((x * (i + 1)) % m);
    }
    vector<int> tmp;
    for (int i = 0; i < n; i++) {
        if (used[i]) tmp.push_back(i);
    }
    for (int i = 1; i < eff; i++) {
        pref[i] = pref[i - 1];
        pref[i] ^= (((x * (i + 1)) % m));
        pref[i] ^= ((x * (i + 1) + y) % m);
    }

    vector<int> v(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < q; i++) {
        if (v[i] <= eff) {
            cout << pref[eff];
        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    int c = 0;
    while (true) {
        cin >> c;
        if (c == 0) return;
        c--;
        if (v[c] > eff) cout << -1;
        else {
            vector<int> ans(n, 0);
            for (int i = 0; i < v[c]; i++) ans[tmp[i]] = 1;
            for (int i: ans)cout << i << ' ';
        }
        cout << endl;
    }

}

int32_t main() {
    int t = 1;
#ifdef LOCAL
    freopen("d.in", "r", stdin);
#endif
    cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
}