#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

pair <int, int> get1(vector <int> a, int mx) {
    sort(all(a));
    a.erase(unique(all(a)), a.end());

    int n = a.size();
    deque <int> d;
    d.push_back(a[0] - 1);
    for (int i = 1; i < n; i++) {
        d.push_back(a[i] - a[i - 1] - 1);
    }
    d.push_back(mx - a.back());

    int all = 0;
    for (int i : d)
        all += i;

    int cnt = 0;
    int ans = all - d[0] - d.back() + n;
    int ans_cnt = cnt;
    for (int i = 1; i < n; i++) {
        d[0] += d.back();
        cnt += d.back() + 1;
        d.pop_back();
        d.push_front(0);

        if (ans > all - d[0] - d.back() + n) {
            ans = all - d[0] - d.back() + n;
            ans_cnt = cnt;
        }
    }
    return {ans, ans_cnt};
}

pair <int, int> get2(vector <int> a, int mx) {
    for (int& i : a) {
        i = mx - i + 1;
    }
    sort(all(a));
    a.erase(unique(all(a)), a.end());

    int n = a.size();
    deque <int> d;
    d.push_back(a[0] - 1);
    for (int i = 1; i < n; i++) {
        d.push_back(a[i] - a[i - 1] - 1);
    }
    d.push_back(mx - a.back());

    int all = 0;
    for (int i : d)
        all += i;

    int cnt = 0;
    int ans = all - d[0] - d.back() + n;
    int ans_cnt = cnt;
    for (int i = 1; i < n; i++) {
        d[0] += d.back();
        cnt += d.back() + 1;
        d.pop_back();
        d.push_front(0);

        if (ans > all - d[0] - d.back() + n) {
            ans = all - d[0] - d.back() + n;
            ans_cnt = cnt;
        }
    }
    return {ans, ans_cnt};
}

void solve() {
    int h, w, n;
    cin >> h >> w >> n;

    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    pair <int, int> ra1 = get1(a, h), ra2 = get2(a, h);
    pair <int, int> rb1 = get1(b, w), rb2 = get2(b, w);

    pair <int, int> ra = min(ra1, ra2), rb = min(rb1, rb2);
    cout << ra.first * rb.first << " " << ra.second + rb.second << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}