#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const ll LINF = 1e18;
const int MOD = 1e9 + 7;

#define int long long
#define all(a) a.begin(), a.end()

void solve() {
    int n;
    cin >> n;

    vector <int> a(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];

    a[0] = 0;

    vector <int> minAForD(n + 1, n + 1);
    vector <int> prev(n + 1, 0);
    minAForD[0] = 0;
    for (int i = 1; i <= n; i++) {
        int l = 0, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (minAForD[m] == n + 1 || a[minAForD[m]] > a[i]) {
                r = m;
            } else {
                l = m;
            }
        }
        minAForD[l + 1] = i;
        prev[i] = minAForD[l];
    }

    int res = 0;
    vector <bool> ok(n + 1, true);
    for (int i = n; i >= 1; i--) {
        if (minAForD[i] != n + 1) {
            res += i;
            int v = i;
            while (v > 0) {
                ok[v] = false;
                v = prev[v];
            }
            break;
        }
    }

    int prv = LINF;
    for (int i = 1; i <= n; i++) {
        if (!ok[i]) continue;
        if (a[i] < prv) {
            res++;
            prv = a[i];
        }
    }
    cout << res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
//    cin.tie(0);
//    cout.tie(0);

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}