
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <random>
#include <map>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = (int)1e5 + 10;
const int mod = (int)1e9 + 7;

#define all(x) begin(x), end(x)

int nxt(int x, int n) {
	return x % n + 1;
}

int prv(int x, int n) {
	if (x == 1) return n;
	return x - 1;
}

void encode() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i];
	}
	if (k == 1) {
		cout << nxt(a[0], n) << endl;
	} else if (k == 2) {
		if (a[0] % n + 1 == a[1]) {
			cout << nxt(a[1], n) << " " << nxt(nxt(a[1], n), n) << endl;
		} else {
			cout << nxt(a[0], n) << " " << nxt(a[1], n) << endl;
		}
	}
}

void decode() {
	int n, k;
	cin >> n >> k;
	vector<int> a(k);
	for (int i = 0; i < k; i++) {
		cin >> a[i];
	}
	if (k == 1) {
		cout << prv(a[0], n) << endl;
	} else if (k == 2) {
		if (nxt(a[0], n) == a[1]) {
			cout << prv(prv(a[0], n), n) << " " << prv(a[0], n) << endl;
		} else {
			cout << prv(a[0], n) << " " << prv(a[1], n) << endl;
		}
	}
}

void solve() {

}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int ty;
	int t = 1;
	cin >> ty >> t;
	while (t--) {
		if (ty == 1) {
			encode();
		} else {
			decode();
		}
	}
	return 0;
}