#include <iostream>
#include <vector>
#include <iomanip>
#include <assert.h>
#include <map>
#include  <set>
#include  <random>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) begin(x), end(x)

const int maxn = (int)510;
int dp[maxn][maxn];
int ndp[maxn][maxn];
int pepo[maxn][maxn];

#define int ll
void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll> a(n + 1), pr(n + 1), can(n + 1);
	for (int i = 0; i < n; i++) {
		cin >> a[i + 1];
	}
	sort(all(a));
	int z;
	cin >> z;
	vector<vector<int>> t(q);
	vector<string> ans(q);
	for (int i = 0; i < q; i++) {
		ll k, A, B;
		cin >> k >> A >> B;
		t[i] = { k, A, B, i };
	}
	sort(all(t));
	int j = 0;
	dp[0][0] = 1;
	for (int i = 1; i <= n; i++) {
		ll add = a[i];
		for (int x = maxn - 1; x >= 0; x--) {
			for (int y = maxn - 1; y >= 0; y--) {
				if (x + add < maxn) {
					ndp[x + add][y] |= dp[x][y];
				}
				if (y + add < maxn) {
					ndp[x][y + add] |= dp[x][y];
				}
				ndp[x][y] |= dp[x][y];
			}
		}
		swap(dp, ndp);
		while (j < q && t[j][0] >= add && (i == n || t[j][0] < a[i + 1])) {
			int A = t[j][1];
			int B = t[j][2];
			bool ok = 1;
			for (int x = 0; x <= A; x++) {
				for (int y = 0; y <= B; y++) {
					ok &= dp[x][y];
				}
			}
			if (ok) {
				ans[t[j][3]] = "Yes\n";
			} else {
				ans[t[j][3]] = "No\n";
			}
			j += 1;
		}
	}
	for (auto& x : ans) {
		cout << x;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--) {
		solve();
	}
	return 0;
}