#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const int sz = 200100;

vector <int> g[sz];
ll a[sz];
ll dp[sz][2];
ll u[sz];

void dfs(int u, int pr = -1) {
	dp[u][0] = 0;
	dp[u][1] = a[u];
	for (int i : g[u]) {
		if (i == pr) continue;
		dfs(i, u);
		dp[u][1] += dp[i][0];
		dp[u][0] += max(dp[i][0], dp[i][1]);
	}
}

void solve() {
	int n, q;
	cin >> n >> q;
	ll x, y, m;
	cin >> x >> y >> m;
	for (int i = 1; i <= n; ++i) {
		g[i].resize(0);
	}
	for (int i = 1; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 1; i <= n; ++i) {
		cin >> a[i] >> a[i];
	}
	dfs(1);
	ll ans = max(dp[1][0], dp[1][1]);
	ll k = 0;
	for (int i = 1; i <= n; ++i) {
		k ^= (x * i % m + y * a[i] % m * a[i] % m) % m;
	}
	vector <ll> v;
	for (int i = 1; i <= q; ++i) {
		cin >> u[i];
		if (u[i] == ans) {
			v.push_back(k);
		}
		else {
			v.push_back(-1);
		}
	}
	for (ll i : v) cout << i << ' ';
	cout << endl;
	int i;
	cin >> i;
	while (i != 0) {
		if (u[i] != ans) {
			cout << -1 << endl;
			cin >> i;
			continue;
		}
		for (int i = 1; i <= n; ++i) {
			cout << a[i] << ' ';
		}
		cout << endl;
		cin >> i;
	}
}

int main() {
	//freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}