#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

using namespace std;

#define int ll

const int N = 2e5 + 5;

vc<int> g[N];
int dp[N][2];
int L[N], R[N];

void dfs(int v, int p = -1) {
    dp[v][0] = dp[v][1] = 0;
    int sm = 0;
    for (auto u: g[v]) {
        if (u == p) continue;
        dfs(u, v);
        dp[v][0] += dp[u][1];
        dp[v][1] += dp[u][1];
        sm += dp[u][0];
    }
    dp[v][1] = max(dp[v][1], sm + L[v]);
}

int32_t main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;
        int x, y, m;
        cin >> x >> y >> m;
        for (int v = 1; v <= n; ++v) g[v].clear();
        for (int i = 1; i < n; ++i) {
            int a, b;
            cin >> a >> b;
            g[a].push_back(b);
            g[b].push_back(a);
        }
        for (int v = 1; v <= n; ++v) cin >> L[v] >> R[v];
        int s = 0;
        for (int v = 1; v <= n; ++v) {
            s ^= (x * v + y * (L[v] * L[v] % m)) % m;
        }
        dfs(1);
        int ans1 = max(dp[1][0], dp[1][1]);
        for (int v = 1; v <= n; ++v) {
            L[v] = R[v];
        }
        dfs(1);
        int ans2 = max(dp[1][0], dp[1][1]);
        vc<int> di(q);
        for (int i = 0; i < q; ++i) {
            cin >> di[i];
            if (ans1 <= di[i] && di[i] <= ans2) {
                cout << s++ << ' ';
            } else {
                cout << -1 << ' ';
            }
        }
        cout << endl;
        int t;
        while (cin >> t) {
            if (!t) break;
            assert(false);
        }
    }
}