#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int nx, ny, n;
    cin >> nx >> ny >> n;
    vector<int> x(n), y(n);
    vector<pii > a(n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> y[i], x[i]--, y[i]--;
        a[i] = {x[i], y[i]};
    }
    sort(all(x)), sort(all(y));
    if (n == 1) {
        cout << "1 0";
        return;
    }
    int ans = inf, mn = inf;
    for (int kx = -nx + 1; kx < nx; ++kx) {
        for (int ky = -ny + 1; ky < ny; ++ky) {
            int lx = inf, rx = -inf, ly = inf, ry = -inf;
            for (int i = 0; i < n; ++i) {
                int vx = (x[i] + kx + nx) % nx;
                int vy = (y[i] + ky + ny) % ny;
                lx = min(lx, vx), rx = max(rx, vx);
                ly = min(ly, vy), ry = max(ry, vy);
            }
            int add = abs(kx) + abs(ky);
            int res = (rx - lx + 1) * (ry - ly + 1);
            if (res < ans || (res == ans && add < mn)) ans = res, mn = add;
        }
    }
    cout<<ans<<' '<<mn;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
/*
3 4 3
1 1
3 4
1 4
 */
/*
1 10 3
1 5
1 7
1 2
 */