#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n2, N;
vector<pii > t;

void build() {
    N = 1;
    while (N <= n2) N *= 2;
    t.clear();
    t.resize(2 * N, {0, -1});
}

void upd(int i, int x, int ind) {
    i += N;
    t[i] = {x, ind};
    while (i) {
        i /= 2;
        t[i] = max(t[i * 2], t[i * 2 + 1]);
    }
}

pii get(int lq, int rq, int v = 1, int l = 0, int r = N) {
    if (rq <= l || r <= lq)return {0, -1};
    if (lq <= l && r <= rq)return t[v];
    int m = (l + r) / 2;
    return max(get(lq, rq, v * 2, l, m), get(lq, rq, v * 2 + 1, m, r));
}

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int>> a(n);
    map<int, vector<int>> w;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        w[l].push_back(i);
        w[r].push_back(i);
        a[i] = {r, l, i};
    }
    int T = 0;
    for (auto &[x, mas]: w) {
        for (int i: mas) {
            auto &[r, l, u] = a[i];
            if (l == x) l = T;
            if (r == x) r = T;
        }
        T++;
    }
    sort(all(a));
    vector<int> ind;
    for (auto [r, l, i]: a)
        ind.push_back(i + 1);
    n2 = T;
    build();
    vector<int> dp(n), p(n, -1);
    for (int i = 0; i < n; ++i) {
        auto [r, l, I] = a[i];
        auto [val, j] = get(0, l);
        dp[i] = val + 1, p[i] = j;
        upd(r, dp[i], i);
    }
    vector<int> way;
    int s = 0;
    for (int i = 0; i < n; ++i) {
        if (dp[i] > dp[s]) s = i;
    }
    while (s != -1) {
        way.push_back(s);
        s = p[s];
    }
    reverse(all(way));
    int m = sz(way);
    int h = m / 2;
    vector<int> ans;
    vector<int> used(n);
    if (way[h] >= n / 2) {
        for (int i = 0; i < h; ++i) {
            ans.push_back(way[i]);
            used[way[i]] = 1;
        }
        for (int i = 0; i < way[h] && sz(ans) < n / 2; ++i) {
            if (!used[i])ans.push_back(i);
        }
    } else {
        for (int i = h; i < m; ++i) {
            ans.push_back(way[i]);
            used[way[i]] = 1;
        }
        for (int i = way[h]; i < n && sz(ans) < n / 2; ++i) {
            if (!used[i])ans.push_back(i);
        }
    }
    for (int an: ans) cout << ind[an] << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}