#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ll long long
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int zzz;
    cin >> zzz;
    vector<tuple<int, int, int>> z(q);
    int nl = 0, nr = 0;
    for (auto &[k, l, r]: z) {
        cin >> k >> l >> r;
        if (l > r)swap(l, r);
        nl = max(nl, l);
        nr = max(nr, r);
    }
    sort(all(a));
    nl++, nr++;
    vector<vector<int>> pos(nl, vector<int>(nr));
    pos[0][0] = 1;
    for (int i = 0; i < n; ++i) {
        for (int l = nl - 1; l >= 0; --l) {
            for (int r = nr - 1; r >= 0; --r) {
                if (!pos[l][r]) continue;
                if (l + a[i] < nl) pos[l + a[i]][r] = 1;
                if (r + a[i] < nr) pos[l][r + a[i]] = 1;
            }
        }
    }
    for (auto [k, l, r]: z) {
        int ok = 1;
        for (int i = 0; ok && i <= l; ++i) {
            for (int j = 0; ok && j <= r; ++j) {
                ok &= pos[i][j];
            }
        }
        if (ok) cout << "Yes\n";
        else cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
    return 0;
}
/*
8 5
17 1 3 2 100 5 6 1
0
6 15 3
9 4 4
5 15 3
17 34 1
16 33 2
 */