#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ui unsigned int
#define ld long double
#define mp make_pair
#define ff first
#define ss second
#define pii pair<int, int>
#define pil pair<int, long long>
#define pli pair<long long, int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define uset unordered_set
#define umap unordered_map

const int N = 2e5 + 5;
vector<int> l(N), r(N);
vector<int> turn(N);
vector<int> from(N);
int n;

void dfs(int v) {
    if (l[v] == -1)
        return;
    from[l[v]] = 0;
    from[r[v]] = 1;
    if (from[v] != -1) {
        turn[l[v]] = turn[v] + from[v];
        turn[r[v]] = turn[v] + 1 - from[v];
    }
    dfs(l[v]);
    dfs(r[v]);
}

int slow(int v, int k) {
    if (l[v] == -1)
        return turn[v] <= k;
    int ans = turn[v] <= k;
    ans += slow(l[v], k);
    ans += slow(r[v], k);
    return ans;
}

inline void solve() {
    cin >> n;
    int k, q;
    cin >> k >> q;
    for (int i = 0; i < n; i++) {
        l[i] = -1;
        r[i] = -1;
    }
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 2) {
            cin >> l[i] >> r[i];
            l[i]--;
            r[i]--;
        }
    }
    from[0] = -1;
    dfs(0);
    while (q--) {
        int u;
        cin >> u;
        u--;
        cout << slow(u, k) << '\n';
        /*if (turn[u] <= k)
            cout << 1 << '\n';
        else
            cout << 0 << '\n';*/
        /*if (u == 0)
            cout << 2 << '\n';
        else if (turn[u] == 0)
            cout << 1 << '\n';
        else
            cout << 0 << '\n';*/
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
#ifdef DEBUG
    cin >> tt;
#endif
    while (tt--) {
#ifdef DEBUG
        cout << "Test case#\n";
#endif
        solve();
    }
    return 0;
}