#include "iostream"
#include "vector"
#include "string"
#include "set"
#include "map"
#include "algorithm"
#include "cmath"


using namespace std;
typedef long long ll;
#define all(a) a.begin(), a.end()

void solve1();

void solve2();

bool crash = 0;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int x;
    cin >> x;
    ll t = 1;
    cin >> t;
    while (t--) {
        if (x == 1)
            solve1();
        else
            solve2();
        cout << endl;
        if (crash)
            return 1;
    }
}

int get(vector<int> &v, int n) {
    int k = v.size();
    set<int> p;
    for (int x = 0; x < k; x++) {
        for (int y = 0; y < k; y++) {
            p.insert(((v[x] - v[y]) % n + n) % n);
        }
    }
    int m = 0;
    for (int i: p) {
        if (i == m)
            m++;
    }
    return m;
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int &i: v)
        cin >> i;
    int x = get(v, n);
    for (int &i: v) {
        i = (i - 1 + x) % n + 1;
    }
    sort(all(v));
    for (int i: v)
        cout << i << ' ';
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int &i: v)
        cin >> i;
    int x = get(v, n);
    for (int &i: v) {
        i = ((i - 1 - x) % n + n) % n + 1;
    }
    sort(all(v));
    for (int i: v)
        cout << i << ' ';
}