#include "iostream"
#include "vector"
#include "string"
#include "set"
#include "map"
#include "algorithm"
#include "cmath"


using namespace std;
typedef long long ll;
#define all(a) a.begin(), a.end()

void solve1();

void solve2();

bool crash = 0;

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int x;
    cin >> x;
    ll t = 1;
    cin >> t;
    while (t--) {
        if (x == 1)
            solve1();
        else
            solve2();
        cout << endl;
        if (crash)
            return 1;
    }
}

void solve1() {
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int &i: v)
        cin >> i;
    crash = 1;

    for (int x = 1;; x++) {
        set<int> s;
        for (int a: v) {
            a--;
            a = (a + x) % n + 1;
            s.insert(a);
        }
        if (s.size() != k)
            continue;
        for (int i: v) {
            s.erase(i);
        }
        if (s.size() != k)
            continue;
        for (int &a: v) {
            a--;
            a = (a + x) % n + 1;
        }
        crash = 0;
        break;
    }
    sort(all(v));
    for (int i: v)
        cout << i << ' ';
}

void solve2() {
    int n, k;
    cin >> n >> k;
    vector<int> v(k);
    for (int &i: v)
        cin >> i;
    crash = 1;
    for (int x = 1;; x++) {
        set<int> s;
        for (int a: v) {
            a--;
            a = (a - x + n) % n + 1;
            s.insert(a);
        }
        if (s.size() != k)
            continue;
        for (int i: v) {
            s.erase(i);
        }
        if (s.size() != k)
            continue;
        for (int &a: v) {
            a--;
            a = (a - x + n) % n + 1;
        }
        crash = 0;
        break;
    }
    sort(all(v));
    for (int i: v)
        cout << i << ' ';
}