#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())

void solve() {
    ll n;
    cin >> n;
    vector<tuple<ll, ll, ll>> a;
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        a.push_back({r, l, i});
    }
    sort(a.begin(), a.end());
    ll cnt = 0;
    ll last_r = 0;
    for (int i = 0; i < n; ++i) {
        if (get<1>(a[i]) > last_r) {
            ++cnt;
            last_r = get<0>(a[i]);
        }
    }
    ll cnt_fst = cnt;
    vector<bool> here(n, true), used(n);
    while (true) {
        cnt = 0;
        ll pre_last = 0;
        last_r = 0;
        fill(used.begin(), used.end(), false);
        for (int i = 0; i < n; ++i) {
            if (here[i] && get<1>(a[i]) > last_r) {
                ++cnt;
                pre_last = last_r;
                last_r = get<0>(a[i]);
                used[i] = true;
            }
        }
        if (cnt == cnt_fst / 2) {
            break;
        }
        for (int i = 0; i < n; ++i) {
            if (used[i]) {
                here[i] = false;
                break;
            }
        }
    }
    ll count = accumulate(here.begin(), here.end(), 0ll);
    for (int i = 0; i < n; ++i) {
        if (here[i] && !used[i] && count > n / 2) {
            here[i] = false;
            --count;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (here[i]) {
            cout << get<2>(a[i]) + 1 << ' ';
        }
    }
}
vector<ll> solve(ll n, vector<pair<ll, ll>> b) {
    vector<tuple<ll, ll, ll>> a;
    for (int i = 0; i < n; ++i) {
        auto [l, r] = b[i];
        a.push_back({r, l, i});
    }
    sort(a.begin(), a.end());
    ll cnt = 0;
    ll last_r = 0;
    for (int i = 0; i < n; ++i) {
        if (get<1>(a[i]) > last_r) {
            ++cnt;
            last_r = get<0>(a[i]);
        }
    }
    ll cnt_fst = cnt;
    vector<bool> here(n, true), used(n);
    while (true) {
        cnt = 0;
        ll pre_last = 0;
        last_r = 0;
        fill(used.begin(), used.end(), false);
        for (int i = 0; i < n; ++i) {
            if (here[i] && get<1>(a[i]) > last_r) {
                ++cnt;
                pre_last = last_r;
                last_r = get<0>(a[i]);
                used[i] = true;
            }
        }
        if (cnt == cnt_fst / 2) {
            break;
        }
//        for (int i = 0; i < n; ++i) {
//            if (here[i] && get<1>(a[i]) > pre_last) {
//                here[i] = false;
//            }
//        }
        for (int i = 0; i < n; ++i) {
            if (used[i]) {
                here[i] = false;
                break;
            }
        }
    }
    ll count = accumulate(here.begin(), here.end(), 0ll);
    for (int i = 0; i < n; ++i) {
        if (here[i] && !used[i] && count > n / 2) {
            here[i] = false;
            --count;
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; ++i) {
        if (here[i]) {
            ans.push_back(get<2>(a[i]) + 1);
        }
    }
    return ans;
}

void stress() {
    mt19937 rnd(1234);
    while (true) {
        ll n = rnd() % 10 + 1;
        if (n & 1) {
            ++n;
        }
        vector<pair<ll, ll>> a(n), h(n);
        for (int i = 0; i < n; ++i) {
            ll l = rnd() % 10 + 1, r = l + rnd() % 100 + 1;
            a[i] = {l, r};
            h[i] = {r, l};
        }
        sort(h.begin(), h.end());
        ll cnt_fst = 0;
        ll last_r = 0;
        for (int i = 0; i < n; ++i) {
            if (h[i].second > last_r) {
                ++cnt_fst;
                last_r = h[i].first;
            }
        }
        if (cnt_fst & 1) {
            continue;
        }
        auto x = solve(n, a);
        vector<pair<ll, ll>> b;
        for (int i : x) {
            b.push_back({a[i - 1].second, a[i - 1].first});
        }
        sort(b.begin(), b.end());
        ll cnt = 0;
        last_r = 0;
        for (int i = 0; i < sz(b); ++i) {
            if (b[i].second > last_r) {
                ++cnt;
                last_r = b[i].first;
            }
        }
        if (sz(x) != n / 2 || cnt != cnt_fst / 2) {
            cout << n << '\n';
            for (int i = 0; i < n; ++i) {
                cout << a[i].first << ' ' << a[i].second << '\n';
            }
            break;
        }
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int times = 1;
    cin >> times;
    while (times--) {
        solve(), cout << '\n';
    }
#ifdef LOCAL
    cout << "-------\n";
    stress();
#endif
    return 0;
}
