#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())

void solve() {
    ll n;
    cin >> n;
    vector<tuple<ll, ll, ll>> a;
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        a.push_back({r, l, i});
    }
    sort(a.begin(), a.end());
    ll cnt = 0;
    ll last_r = 0;
    vector<bool> used(n);
    for (int i = 0; i < n; ++i) {
        if (get<1>(a[i]) > last_r) {
            ++cnt;
            used[i] = true;
            last_r = get<0>(a[i]);
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; ++i) {
        if (used[i] && sz(ans) < n / 2) {
            ans.push_back(get<2>(a[i]));
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && sz(ans) < n / 2) {
            ans.push_back(get<2>(a[i]));
        }
    }
    for (int i : ans) {
        cout << i << ' ';
    }
}

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int times = 1;
    cin >> times;
    while (times--) {
        solve(), cout << '\n';
#ifdef LOCAL
        cout << "-------\n";
#endif
    }
    return 0;
}
