#include <bits/stdc++.h>

using namespace std;

#define ssize(a) static_cast<ptrdiff_t>(size(a));
#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename T>
void chmin(T& a, const T& b) {
  if (b < a) a = b;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}

void solve();

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

void solve() {
  i64 h, w, k;
  cin >> h >> w >> k;
  vector<pair<i64, i64>> a(k);
  for (auto& e : a) cin >> e.first >> e.second;
  
  vector<i64> r(k), c(k);
  for (int i = 0; i < k; ++i) {
    tie(r[i], c[i]) = a[i];
  }
  sort(ALL(r));
  sort(ALL(c));
  auto FindMinDelta = [k](vector<i64>& x, i64 dim) -> pair<i64, i64> {
    pair<i64, i64> best = {x.back() - x.front(), 0};
    for (int i = 0; i < k - 1; ++i) {
      pair<i64, i64> cur = {x[i] - x[i + 1] + dim, x[i]};
      chmin(best, cur);
    }
    return best;
  };
  pair<i64, i64> best_dr = FindMinDelta(r, h);
  for (auto& e : r) e = h - e + 1;
  reverse(ALL(r));
  chmin(best_dr, FindMinDelta(r, h));
  pair<i64, i64> best_dc = FindMinDelta(c, w);
  for (auto& e : c) e = w - e + 1;
  reverse(ALL(c));
  chmin(best_dc, FindMinDelta(c, w));
  cout << (best_dr.first + 1) * (best_dc.first + 1) << " " << best_dr.second + best_dc.second << "\n";
}
