#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;

pair<int, int> solve(int h, vector<int> &r) {
    sort(all(r));
    int k = r.size();
    pair<int, int> best = make_pair(r.back() - r[0], 0);
    for (int i = 1; i < k; i++)
        best = min(best, make_pair(r[i - 1] - r[i] + h, min(r[i - 1] + 1, h - r[i - 1] - 1)));
    best.first++;
    return best;
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> r(k), c(k);
    for (int i = 0; i < k; i++) {
        cin >> r[i] >> c[i];
        r[i]--; c[i]--;
    }
    auto res1 = solve(h, r), res2 = solve(w, c);
    cout << (ll) res1.first * res2.first << ' ' << res1.second + res2.second << '\n';
}
