#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define PB push_back

using namespace std;
int h, n, p;
vector <int> seg;

void upd(int now, int l, int r, int ind, int val) {
    if (l > ind || ind >= r) {
        return;
    }
    if (l + 1 == r) {
        seg[now] = val;
        return;
    }
    int x = (l + r) / 2;
    upd(now * 2 + 1, l, x, ind, val);
    upd(now * 2 + 2, x, r, ind, val);
    seg[now] = max(seg[now * 2 + 1], seg[now * 2 + 2]);
}

int get(int now, int l, int r, int lq, int rq) {
    if (lq <= l && r <= rq) {
        return seg[now];
    }
    if (lq >= r || l >= rq) {
        return 0;
    }
    int x = (l + r) / 2;
    return max(get(now * 2 + 1, l, x, lq, rq), get(now * 2 + 2, x, r, lq, rq));
}

void solve() {
    cin >> n;
    vector <int> mas(n), dp(n);
    p = 2;
    while (p < n) {
        p *= 2;
    }
    seg.resize(2 * p);
    for (int i = 0; i < n; i++) cin >> mas[i];
    dp[0] = 1;
    h = 1;
    upd(0, 0, 0, mas[0] - 1, dp[0]);
    for (int i = 1; i < n; i++) {
        if (mas[i] != 1) {
            dp[i] = 1 + get(0, 0, p, 0, mas[i] - 1);
        }
        else {
            dp[i] = 1;
        }
        upd(0, 0, p, mas[i] - 1, dp[i]);
        h = max(h, dp[i]);
    }
    seg.resize(0);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
}