#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

void solve() {
    int n;
    cin >> n;
    vector<tuple<int, int, int>> e;
    vector<pii> b(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        e.emplace_back(l, 0, i);
        e.emplace_back(r, 1, i);
        b[i] = {l, r};
    }
    sort(all(e));
    vi d(n, 1), p(n, -1);
    int mx = -1;
    for (auto x: e) {
        if (get<1>(x) == 1) {
            if (mx == -1 || d[get<2>(x)] >= d[mx])
                mx = get<2>(x);
        }
        else {
            if (mx != -1) {
                d[get<2>(x)] = d[mx] + 1;
                p[get<2>(x)] = mx;
            }
        }
    }
    vi a;
    vector<bool> s(n, false);
    while (mx != -1) {
        a.push_back(mx);
        s[mx] = true;
        mx = p[mx];
    }
    reverse(all(a));
    int m = (int)a.size();
    vi g1, g2;
    for (int i = 0; i < n; ++i) {
        if (b[i].second < b[a[m / 2]].first)
            g1.push_back(i);
        else
            g2.push_back(i);
    }
    if (g1.size() < g2.size())
        swap(g1, g2);
    n = n / 2 - (int)g2.size();
    while (!g1.empty()) {
        if (s[g1.back()] || n == 0)
            cout << g1.back() + 1 << ' ';
        else
            --n;
        g1.pop_back();
    }
    cout << '\n';
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--)
        solve();
}
