#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int A = 5010;

int main() {
    fast;
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    sort(all(w));
    vector<vector<ll>> s(n + 1, vector<ll>(A + 1, -1));
    s[0][0] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= A; ++j) {
            if (w[i - 1] > s[i - 1][j] + 1)
                s[i][j] = s[i - 1][j];
            else
                s[i][j] = s[i - 1][j] + w[i - 1];
        }
        for (int j = 0; j + w[i - 1] <= A; ++j)
            s[i][j + w[i - 1]] = max(s[i][j + w[i - 1]], s[i - 1][j]);
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = 1; j <= A; ++j)
            s[i][j] = min(s[i][j], s[i][j - 1]);
    }
    int z;
    cin >> z;
    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;
        int i = upper_bound(all(w), k) - w.begin();
        if (s[i][a] >= b)
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}
