#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> all_vectors;

void perebor(int n, int k, int last, vector<int> &now) {
    if (now.size() == k) {
        all_vectors.push_back(now);
        return;
    }
    if (now.size() + n - last < k) {
        return;
    }
    for (int i = last + 1; i <= n; i++) {
        now.push_back(i);
        perebor(n, k, i, now);
        now.pop_back();
    }
}

bool check(vector<int> &a, vector<int> &b) {
    int i, j = 0;
    for (i = 0; i < a.size(); i++) {
        while (j < b.size() && b[j] < a[i]) {
            j++;
        }
        if (j < b.size() && b[j] == a[i]) {
            return true;
        }
    }
    return false;
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int type, t, key, o, i, n, k;
    cin >> type >> t;
    vector<vector<int>> ans(t);
    for (o = 0; o < t; o++) {
        cin >> n >> k;
        all_vectors.clear();
        vector<int> arr(k);
        for (i = 0; i < k; i++) {
            cin >> arr[i];
        }
        vector<int> now;
        perebor(n, k, 0, now);
        for (i = 0; i < all_vectors.size(); i++) {
            if (check(all_vectors[i], now)) {
                ans[o] = all_vectors[i];
                break;
            }
        }
    }
    for (o = 0; o < t; o++) {
        for (i = 0; i < ans[o].size(); i++) {
            cout << ans[o][i] << ' ';
        }
        cout << '\n';
    }
    return 0;
}