#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<int> glub;

void get_glub(int v, int p, vector<vector<int>> &g) {
    glub[v] = 1;
    for (int u : g[v]) {
        if (u != p) {
            get_glub(u, v, g);
            glub[v] += glub[u];
        }
    }
}

bool cmp(int a, int b) {
    return glub[a] > glub[b];
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, i, u, v, j, m = 0;
        cin >> n;
        glub.resize(n);
        vector<int> p(n, -1);
        vector<vector<int>> arr(n);
        vector<vector<int>> g(n);
        for (i = 0; i < n; i++) {
            cin >> u >> v;
            arr[i] = {v - u, u, v};
        }
        sort(arr.begin(), arr.end());
        for (i = 0; i < n; i++) {
            int mi = 1e18;
            for (j = i + 1; j < n; j++) {
                if (arr[j][0] < mi && arr[j][1] <= arr[i][1] && arr[j][2] >= arr[i][2]) {
                    mi = arr[j][0], p[i] = j;
                }
            }
            if (p[i] == -1) {
                continue;
            }
            g[p[i]].push_back(i);
        }
        for (i = 0; i < n; i++) {
            if (g[i].empty()) {
                m++;
            }
        }
        int cnt_not_even = n / 2 - m / 2;
        vector<int> del;
        m /= 2;
        for (i = 0; i < n; i++) {
            if (g[i].empty() && m) {
                m--;
                del.push_back(i);
            } else if (!g[i].empty() && cnt_not_even) {
                cnt_not_even--;
                del.push_back(i);
            }
        }
        vector<bool> used(n, false);
        for (int u : del) {
            used[u] = true;
        }
        for (i = 0; i < n; i++) {
            if (!used[i]) {
                cout << i + 1 << ' ';
            }
        }
        cout << '\n';
    }
    return 0;
}