#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<int>> g;
vector<int> dp0, dp1, a;

void dfs(int u, int p) {
    for (int v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
    }
    dp1[u] = a[u], dp0[u] = 0;
    for (int v : g[u]) {
        if (v == p) continue;
        dp1[u] += dp0[v];
        dp0[u] += dp1[v];
    }
    dp1[u] = max(dp0[u], dp1[u]);
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    g.assign(n, {}), dp0.assign(n, 0), dp1.assign(n, 0);
    a.assign(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v), g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> a[i];
    }
    vector<int> w(q);
    for (int i = 0; i < q; ++i) {
        cin >> w[i];
    }
    int S = 0;
    for (int i = 0; i < n; ++i) {
        S = (S ^ ((x * (i + 1) + y * a[i] * a[i]) % m));
    }
    dfs(0, -1);
    for (int i = 0; i < n; ++i) {
        dp1[0] = max(dp1[0], dp1[i]);
        dp1[0] = max(dp1[0], dp0[i]);
    }
    for (int i : w) {
        if (dp1[0] == i) {
            cout << S << " ";
        }
        else cout << -1 << " ";
    }
    cout << endl;
    int r = 1;
    while (r != 0) {
        cin >> r;
        if (r == 0) break;
        if (dp1[0] == w[r - 1]) {
            for (int i : a) cout << i << " ";
            cout << endl;
        }
        else cout << -1 << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
}
