#include <bits/stdc++.h>

#define f first
#define s second

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int INF = 2e9;
const ll LL_INF = 2e18;
const ld EPS = 1e-7;

ll h, w, k;
vector < ll > x, y;

void gen_test(int seed) {
    mt19937 rnd(seed);

    h = 1;
    w = 10;
    k = 4;
    x.resize(k);
    y.resize(k);
    set < int > st;
    for (int i = 0; i < w; ++i)
        st.insert(i);
    for (int i = 0; i < k; ++i) {
        x[i] = 0;
        y[i] = rnd() % w;
        while (st.find(y[i]) == st.end())
            y[i] = rnd() % w;
        st.erase(y[i]);
    }
    sort(y.begin(), y.end());
}

pair < ll, ll > solve() {
    cin >> h >> w >> k;

    x.resize(k);
    y.resize(k);

    for (int i = 0; i < k; ++i) {
        cin >> x[i] >> y[i];
        --x[i];
        --y[i];
    }

    if (k == 1) {
        cout << "1 0";
        return {1, 0};
    }

    deque < ll > lr, ud;
    for (int i = 0; i < k; ++i) {
        lr.push_back(y[i]);
        ud.push_back(x[i]);
    }

    sort(lr.begin(), lr.end());
    sort(ud.begin(), ud.end());
    lr.resize(unique(lr.begin(), lr.end()) - lr.begin());
    ud.resize(unique(ud.begin(), ud.end()) - ud.begin());
    deque < ll > lr1 = lr, ud1 = ud;

    // сначала пробуем влево, потом вправо, выбираем выгодный

    ll cnt1 = 0, cnt = LL_INF, s = LL_INF;
    while (lr.size() > 1) {
        if (s > (((lr.back() - lr.front()) % w + w) % w + 1)) {
            s = (((lr.back() - lr.front()) % w + w) % w + 1);
            cnt = cnt1;
        }
        else if (s == (((lr.back() - lr.front()) % w + w) % w + 1))
            cnt = min(cnt, cnt1);

        ll l1 = lr.front(), l2 = lr.at(1);
        ll r1 = lr.back(), r2 = lr.at(lr.size() - 2);

//        for (ll elem: lr)
//            cout << elem << ' ';
//        cout << " lr\n";
//        cout << l1 << ' ' << l2 << ' ' << r2 << ' ' << r1 << "\n";
//        cout << ((w - (l2 - l1)) % w + w) % w << ' ' << ((r1 - l1 + w) % w + w) % w << "\n";

        if (((w - (l2 - l1)) % w + w) % w < ((r1 - l1 + w) % w + w) % w) {
            cnt1 += (((l1 - cnt1) % w + w) % w + 1);
            lr.push_back(lr.front());
            lr.pop_front();
        }
        else
            break;
    }
    if (s > (((lr.back() - lr.front()) % w + w) % w + 1)) {
        s = (((lr.back() - lr.front()) % w + w) % w + 1);
        cnt = cnt1;
    }
    else if (s == (((lr.back() - lr.front()) % w + w) % w + 1))
        cnt = min(cnt, cnt1);

    lr = lr1;
    ll cnt2 = 0;
    while (lr.size() > 1) {

        if (s > (((lr.back() - lr.front()) % w + w) % w + 1)) {
            s = (((lr.back() - lr.front()) % w + w) % w + 1);
            cnt = cnt2;
        }
        else if (s == (((lr.back() - lr.front()) % w + w) % w + 1))
            cnt = min(cnt, cnt2);

        ll l1 = lr.front(), l2 = lr.at(1);
        ll r1 = lr.back(), r2 = lr.at(lr.size() - 2);

//        for (ll elem: lr)
//            cout << elem << ' ';
//        cout << " lr\n";
//        cout << l1 << ' ' << l2 << ' ' << r2 << ' ' << r1 << "\n";
//        cout << ((w - (l2 - l1)) % w + w) % w << ' ' << ((r1 - l1 + w) % w + w) % w << "\n";



        if (((w - (r1 - r2)) % w + w) % w < (((r1 - l1 + w) % w) + w) % w) {
            cnt2 += (((w - (r1 + cnt2)) % w) + w) % w + 1;
            lr.push_front(lr.back());
            lr.pop_back();
        }
        else
            break;
    }
    if (s > (((lr.back() - lr.front()) % w + w) % w + 1)) {
        s = (((lr.back() - lr.front()) % w + w) % w + 1);
        cnt = cnt1;
    }
    else if (s == (((lr.back() - lr.front()) % w + w) % w + 1))
        cnt = min(cnt, cnt2);

//    if (s != ((lr.back() - lr.front()) % w + w) % w + 1) {
//        cout << "WTH\n";
//        cout << "TEST:\n" << h << ' ' << w << ' ' << k << "\n";
//        for (int i = 0; i < k; ++i)
//            cout << x[i] + 1 << ' ' << y[i] + 1 << "\n";
//
//        cout << s << ' ' << ((lr.back() - lr.front()) % w + w) % w + 1 << "\n";
//
//        exit(0);
//    }

    cout << s << ' ' << cnt << "\n";
    return {s, cnt};
}

pair < ll, ll > solve_right() {
    vector < ll > x1 = x, y1 = y;
    ll cnt1 = 0, cnt = 0;
    ll s = LL_INF;

    ll mx = 0, mn = INF;
    for (int i = 0; i < k; ++i) {
        mx = max(mx, y[i]);
        mn = min(mn, y[i]);
    }
    s = mx - mn + 1;

    for (int i = 0; i < k; ++i)
        y[i] = (y[i] + 1) % w;
    ++cnt1;
    mx = 0, mn = LL_INF;
    for (int i = 0; i < k; ++i) {
        mx = max(mx, y[i]);
        mn = min(mn, y[i]);
    }
    if (s > mx - mn + 1) {
        s = mx - mn + 1;
        cnt = cnt1;
    }
    else if (s == mx - mn + 1)
        cnt = min(cnt, cnt1);

    while (y != y1) {
        for (int i = 0; i < k; ++i)
            y[i] = (y[i] + 1) % w;
        ++cnt1;
        ll mx1 = 0, mn1 = INF;
        for (int i = 0; i < k; ++i) {
            mx1 = max(mx1, y[i]);
            mn1 = min(mn1, y[i]);
        }
        if (s > mx1 - mn1 + 1) {
            s = mx1 - mn1 + 1;
            cnt = cnt1;
        }
        else if (s == mx1 - mn1 + 1)
            cnt = min(cnt, cnt1);
    }

    ll cnt2 = 0;
    for (int i = 0; i < k; ++i)
        y[i] = (y[i] - 1 + w) % w;
    ++cnt2;
    mx = 0, mn = INF;
    for (int i = 0; i < k; ++i) {
        mx = max(mx, y[i]);
        mn = min(mn, y[i]);
    }
    if (s > mx - mn + 1) {
        s = mx - mn + 1;
        cnt = cnt2;
    }
    else if (s == mx - mn + 1)
        cnt = min(cnt, cnt2);
    while (y != y1) {
        for (int i = 0; i < k; ++i)
            y[i] = (y[i] - 1 + w) % w;
        ++cnt2;
        ll mx1 = 0, mn1 = INF;
        for (int i = 0; i < k; ++i) {
            mx1 = max(mx1, y[i]);
            mn1 = min(mn1, y[i]);
        }
        if (s > mx1 - mn1 + 1) {
            s = mx1 - mn1 + 1;
            cnt = cnt2;
        }
        else if (s == mx1 - mn1 + 1)
            cnt = min(cnt, cnt2);
    }
    x = x1;
    y = y1;

    return {s, cnt};
}

int main() {
//    freopen("../input.txt", "r", stdin);
    ios::sync_with_stdio(false), cin.tie(nullptr);
//    cout.tie(nullptr);
//
//    for (int test = 1;; ++test) {
//        gen_test(test);
//        cout << "TEST " << test << ' ';
//        pair < ll, ll > ans_r = solve_right();
//        pair < ll, ll > ans = solve();
//        if (ans_r != ans) {
//            cout << "FAILED\nTEST:\n" << h << ' ' << w << ' ' << k << "\n";
//            for (int i = 0; i < k; ++i)
//                cout << x[i] + 1 << ' ' << y[i] + 1 << "\n";
//            cout << "RIGHT\n" << ans_r.f << ' ' << ans_r.s << "\n";
//            cout << "WRONG\n" << ans.f << ' ' << ans.s << "\n";
//            return 0;
//        }
//        cout << "PASSED\n";
//    }

    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
}

