#include <bits/stdc++.h>
#define ff first
#define ss second
#define endl '\n'
#define all(x) x.begin(), x.end()

typedef long long ll;
using namespace std;


struct seg {
    int x, t, id;

    seg() {
        x = 0;
        t = 0;
        id = 0;
    }
};

bool cmp(seg a, seg b) {
    if (a.x != b.x) return a.x < b.x;

    return a.t > b.t;
}


void solve() {
    int n;
    cin >> n;

    vector<seg> e(2 * n);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;

        e[2 * i].x = l;
        e[2 * i].t = 0;
        e[2 * i].id = i;

        e[2 * i + 1].x = r + 1;
        e[2 * i + 1].t = 1;
        e[2 * i + 1].id = i;
    }
    sort(all(e), cmp);

    int m = 0;
    vector<int> i;
    vector<bool> u(n);
    vector<int> a;
    vector<int> ans;
    for (auto s : e) {
        if (!s.t) i.push_back(s.id);
        else if (i.back() == s.id) {
            m++;
            a.push_back(s.id);
            u[s.id] = 1;
        }
    }
    for (int i = 0; i < n && ans.size() < n / 2 - m / 2; i++) {
        if (!u[i]) ans.push_back(i + 1);
    }
    for (int i = 0; i < m / 2; i++) {
        ans.push_back(a[i] + 1);
    }
    for (auto x : ans) cout << x << " ";
    cout << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
