#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector <int> p(n);
	for (int i = 0; i < n; i++)
		cin >> p[i];
	vector <vector <vector <int>>> dp(n, vector <vector <int>>(n + 1, vector <int>(n + 2, -1e9)));
	dp[0][p[0]][n + 1] = 1;
	dp[0][0][p[0]] = 1;
	for (int i = 1; i < n; i++) {
		for (int j = 0; j <= n; j++) {
			for (int t = 0; t <= n + 1; t++) {
				dp[i][max(j, p[i])][t] = max(dp[i][max(j, p[i])][t], dp[i - 1][j][t] + (p[i] > j));
				dp[i][j][min(t, p[i])] = max(dp[i][j][min(t, p[i])], dp[i - 1][j][t] + (p[i] < t));
			}
		}
	}
	int ans = 0;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			ans = max(ans, dp[n - 1][i][j]);
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}