#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <random>
#include <unordered_map>

using namespace std;

const int MAXN = (1 << 18);
vector <int> g[MAXN];
int t[MAXN];
int w[MAXN];
int n, k, q;

void dfs(int v, int c = 0, int pt = -1) {
	if (t[v] != pt && pt != -1)
		c++;
	w[v] = 0;
	if (c <= k && (int)g[v].size() == 0)
		w[v] = 1;
	for (auto to : g[v]) {
		dfs(to, c, t[v]);
		w[v] += w[to];
	}
	if (t[v] != pt && pt != -1)
		c--;
}

void solve() {
	cin >> n >> k >> q;
	t[0] = -1;
	for (int i = 0; i < n; i++) {
		int sz;
		cin >> sz;
		if (sz == 0)
			continue;
		int l, r;
		cin >> l >> r;
		l--; r--;
		g[i].push_back(l);
		g[i].push_back(r);
		t[l] = 0;
		t[r] = 1;
	}
	dfs(0);
	for (int i = 0; i < q; i++) {
		int v;
		cin >> v;
		v--;
		cout << w[v] << "\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}