#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

const int MX = 20;

map<vector<int>, vector<int>> trans1, trans2;
map<vector<int>, vector<int>> trans3, trans4;
set<vector<int>> st;

vector<vector<int>> hv;

void gen(vector<int> a) {
    if (a.size() == 4) return;
    if (a.size() == 3) {
        hv.push_back(a);
    }
    for (int i = (a.empty() ? 1 : a.back() + 1); i < 8; ++i) {
        a.push_back(i);
        gen(a);
        a.pop_back();
    }
}

void clc() {
    for (auto a: hv) {
        vector<int> usd(100, false);
        for (auto el: a) usd[el] = true;
        vector<int> rem;
        for (int i = 1; i <= 7; ++i) {
            if (!usd[i]) {
                rem.push_back(i);
            }
        }
        bool f = false;
        for (int mask = 0; mask < (1 << 4); ++mask) {
            vector<int> cur;
            for (int i = 0; i < 4; ++i) {
                if ((mask >> i) & 1) {
                    cur.push_back(rem[i]);
                }
            }
            if (cur.size() == 3 && !st.count(cur)) {
                st.insert(cur);
                f = true;
                trans1[a] = cur, trans2[cur] = a;
                break;
            }
        }
    }
}

int32_t main() {
    gen({});
    reverse(all(hv));
    clc();
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
//    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

void solve1() {
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        for (auto &i: a) {
            cin >> i;
        }
        if (a.size() <= 2) {
            if (a[1] - a[0] == 1 || a[0] == 1 && a[1] == n) {
                vector<int> ns;
                map<int, int> usd;
                for (auto &el: a) {
                    usd[el] = 1;
                    --el;
                    int ans = (el + n - 2) % n + 1;
                    ns.push_back(ans);
                }
                sort(all(ns));
                for (auto &el: ns) {
                    cout << el << ' ';
                }
                cout << endl;
            } else {
                vector<int> ns;
                for (auto &el: a) {
                    --el;
                    int ans = (el + n - 1) % n + 1;
                    ns.push_back(ans);
                }
                sort(all(ns));
                for (auto &el: ns) cout << el << ' ';
                cout << endl;
            }
        } else if (k * 2 == n) {
            vector<int> usd(n + 1, false);
            for (auto &el: a) usd[el] = 1;
            for (int i = 1; i <= n; ++i) {
                if (!usd[i]) {
                    cout << i << ' ';
                }
            }
            cout << endl;
        } else if (a.back() == 7) {
            for (auto &el : trans1[a]) {
                cout << el << ' ';
            }
            cout << endl;
        } else {
            if (*max_element(all(trans1[a])) <= n) {
                for (auto &el: trans1[a]) {
                    cout << el << ' ';
                }
                cout << endl;
            } else {
                assert(false);
            }
        }
    }
}

void solve2() {
    int m;
    cin >> m;
    while (m--) {
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        for (auto &i: a) {
            cin >> i;
        }
        if (a.size() <= 2) {
            if (a[1] - a[0] == 1 || a[0] == 1 && a[1] == n) {
                vector<int> ns;
                for (auto &el: a) {
                    --el;
                    int ans = (el + 2) % n + 1;
                    ns.push_back(ans);
                }
                sort(all(ns));
                for (auto el: ns) cout << el << ' ';
                cout << endl;
            } else {
                vector<int> ns;
                for (auto &el: a) {
                    --el;
                    int ans = (el + 1) % n + 1;
                    ns.push_back(ans);
                }
                sort(all(ns));
                for (auto &el: ns) cout << el << ' ';
                cout << endl;
            }
        } else if (k * 2 == n) {
            vector<int> usd(n + 1, false);
            for (auto &el: a) usd[el] = 1;
            for (int i = 1; i <= n; ++i) {
                if (!usd[i]) {
                    cout << i << ' ';
                }
            }
            cout << endl;
        } else {
            assert(*max_element(all(trans2[a])) <= n);
            for (auto &el: trans2[a]) {
                cout << el << ' ';
            }
            cout << endl;

        }
    }
}

void solve() {
    int t;
    cin >> t;
    if (t == 1) {
        solve1();
    } else {
        solve2();
    }
}