#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

struct Fenw {
    vector<int> t;

    Fenw(int n) {
        t.resize(n + 1, 0);
    }

    int get(int len) {
        int ans = 0;
        for (; len > 0 ;len -= len & -len) ans = max(ans, t[len]);
        return ans;
    }

    void upd(int i, int nv) {
        for (; i < t.size(); i += i & -i) t[i] = max(t[i], nv);
    }
};

int get(const vector<int> &a, int n) {
    Fenw fenw(n);
    for (auto &el : a) {
        fenw.upd(el, fenw.get(el - 1) + 1);
    }
    return fenw.get(n);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    if (is_sorted(all(a))) {
        cout << n << "\n";
        return;
    }
    int mx = get(a, n);
    vector<int> pref(n + 1, 0);
    cout << max(2, mx + 2) << "\n";
}