#include<bits/stdc++.h>

#include <random>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

vector<int> krd;

int get(int x) {
    return lower_bound(all(krd), x) - krd.begin() + 1;
}

struct Fenw {
    vector<int> t;

    Fenw(int n) {
        t.resize(n + 1);
    }

    int get(int len) {
        int mx = 0;
        for (; len > 0 ;len -= len & -len) mx = max(mx, t[len]);
        return mx;
    }

    void upd(int i, int nv) {
        for (; i < t.size(); i += i & -i) {
            t[i] = max(t[i], nv);
        }
    }
};

int get(vector<pair<int, int>> a) {
    int mx = 0;
    for (auto &[l, r] : a) {
        mx = max({mx, l, r});
        swap(l, r);
    }
    sort(all(a));
    Fenw fenw(mx);
    for (auto &[r,l] : a) {
        fenw.upd(r, fenw.get(l - 1) + 1);
    }
    return *max_element(all(fenw.t));
}

void solve() {
    krd.clear();
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto &[l, r]: a) {
        cin >> l >> r;
        krd.push_back(l), krd.push_back(r);
    }
    sort(all(krd)), krd.resize(unique(all(krd)) - krd.begin());
    for (auto &[l, r]: a) {
        l = get(l), r = get(r);
    }
    int m = get(a) / 2;
    vector<tuple<int, int, int>> b(n);
    for (int i = 0; i < n; ++i) {
        b.emplace_back(a[i].Y, a[i].X, i);
    }
    sort(all(b)); //dp[lst_r][cnt][pref];
    vector<int> t(n);
    iota(all(t), 0);
    for (int j = 0;; ++j) {
        vector<pair<int, int>> nw;
        vector<int> cur;

        for (int i = 0; i < n / 2; ++i) {
            cur.push_back(t[i] + 1);
            nw.emplace_back(a[t[i]].X, a[t[i]].Y);
        }
        if (get(nw) == m && nw.size() == n / 2) {
            for (auto &el: cur) {
                cout << el << ' ';
            }
            cout << "\n";
            return;
        }
        shuffle(all(t), std::mt19937(std::random_device()()));
    }
}