#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937_64 gen(time(nullptr));

int n, k, q;
vector<pair<int, int>> tree;
vector<int> lst_val;

void dfs_ms(int v, int deep = -1, int napravl = 0){
    if(tree[v].first == -1){
        if(deep <= k){
            lst_val[v] = 1;
        }else{
            lst_val[v] = 0;
        }
    }else{
        dfs_ms(tree[v].first, deep + (napravl != -1), -1);
        dfs_ms(tree[v].second, deep + (napravl != 1), 1);
        lst_val[v] = lst_val[tree[v].first] + lst_val[tree[v].second];
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> k >> q;
    tree.assign(n, {-1, -1});
    lst_val.assign(n, -1);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if(t != 0){
            int l, r;
            cin >> l >> r;
            --l, --r;
            tree[i] = {l, r};
        }
    }
    dfs_ms(0);
    for (int i = 0; i < q; ++i) {
        int g;
        cin >> g;
        --g;
        cout << lst_val[g] << endl;
    }

    return 0;
}
