#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#define int long long
using namespace std;
int md, mx; 
vector <vector <int> > mn;

int n, k, p;

int find_mh(vector <int>& a) {
	int mh = 0;
	int uk = 0;
	while (uk < a.size() && a[uk] == mh) {
		mh++;
		uk++;
	}
	return mh;
}

vector <int> nxt(vector <int> &a) {
	int mh = find_mh(a);
	vector <int> ans;
	for (int i = 0; i < a.size(); ++i) {
		ans.push_back(a[i] ^ (mh - 1));
	}
	sort(ans.begin(), ans.end());
	return ans;
	

}

void gen(vector <int> c, int uk) {
	if (uk == mx + 1) {
		if (c.size() == n) {
			mn.push_back(c);
		}
		return;
	}

	if (mx - uk + 1 + c.size() < n) {
		return;
	}
	if (c.size() + 1 <= n) {
		c.push_back(uk);
		gen(c, uk + 1);
		c.pop_back();
	}
	gen(c, uk + 1);
}

map <vector <int>, int> usd;
map <vector <int>, int> pr;

void dfs(vector <int> c) {
	vector <int> nx = nxt(c);

	if (usd[nx] == 0) {
		usd[c] = 1;
		dfs(nx);
	}
	if (usd[nx] == 2) {
		usd[c] = 2;
		pr[c] = pr[nx];
	}
	if (usd[nx] == 1) {
		usd[c] = 1;
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> md;
	int t;
	cin >> t;
	for (int q = 0; q < t; ++q) {
		cin >> k >> n >> p;
		mn.clear();
		usd.clear();
		pr.clear();
		mx = (1 << k) - 1;
		vector <int> c = { 0};
		gen(c, 1);
		for (int i = 0; i < mn.size(); ++i) {
			if (nxt(mn[i]) == mn[i]) {
				usd[mn[i]] = 2;
				pr[mn[i]] = find_mh(mn[i]);
			}
		}
		int ans = 0;
		for (int i = 0; i < mn.size(); ++i) {
			if (!usd[mn[i]]) {
				dfs(mn[i]);
			}
			if (pr[mn[i]] == p && usd[mn[i]] == 2) {
				ans += 1;
			}

		}
		cout << ans % md << '\n';


	}
}