#include<iostream>
#include<vector>
#include<algorithm>

#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

using namespace std;
typedef long long ll;

ll n,m,k;
const ll INF=1e9;

void solve()
{
	cin>>n;
	vector<ll> p(n),nvp(n+2,-1),pred(n);
	//nvp.clear();
	for(int i=0;i<n;i++)
	{
		cin>>p[i];
	}
	for(int i=0;i<n;i++)
	{
		ll l=-1,r=nvp.size(),m;
		while(r-l>1)
		{
			m=(r+l)/2;
			if(nvp[m] !=-1 && p[nvp[m]]<p[i])
			{
				l=m;
			}
			else
			{
				r=m;
			}
		}
		nvp[r]=i;
		if(r==0)
		{
			pred[i]=-1;
		}
		else
		{
			pred[i]=nvp[l];
		}
	}
	ll sz=0;
	while(nvp[sz]!=-1)
	{
		sz++;
	}
	if(sz==n)
	{
		cout<<n<<'\n';
		return;
	}
	vector<ll> nvpv (sz);
	nvpv.clear();
	ll j=nvp[sz-1];
	while(j!=-1)
	{
		nvpv.push_back(j);
		j=pred[j];
	}
	reverse(nvpv.begin(),nvpv.end());
	ll mx=0;
	j=0;
	for(int i=0;i<sz;i++)
	{
		debug(nvpv[i])
	}
	for(int i=0;i<n;i++)
	{
		if(j<sz && p[nvpv[j]]==p[i])
		{
			j++;
			continue;
		}
		mx=max(mx,p[i]);
		if(p[i]<mx)
		{
			cout<<sz+2<<'\n';
			debug(sz)
			return;
		}
	}
	cout<<sz+1<<'\n';
}

int main()
{
	ll t;
	cin>>t;
	while(t--)
	{
		solve();
	}
}
