#include<iostream>
#include<map>
#include<vector>
#include<algorithm>

using namespace std;

typedef long long ll;

#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#define label(x) cerr<<(x);
#else
#define debug(x) ;
#define label(x) ;
#endif

ll n,q,k,m;

const ll INF=1e9;
//const int A=100001,B=1;
//const int A=301,B=301;
const int A=1501,B=1501;
int mk[A+1][B+1];
int mx[A+1][B+1];

int main()
{
	ll z;
	cin>>n>>q;
	vector<ll> w(n);
	for(int i=0;i<n;i++)
	{
		cin>>w[i];
	}
	for(int i=0;i<A;i++)
	{
		for(int j=0;j<B;j++)
		{
			mk[i][j]=INF;
		}
	}
	cin>>z;
	sort(w.begin(),w.end());
	vector<pair<int,int>> prs;
	prs.reserve(A*B);
	mk[0][0]=0;
	prs.push_back({0,0});
	for(int i=0;i<n;i++)
	{
		ll sz=prs.size();
		for(int j=0;j<sz;j++)
		{
			int x=prs[j].first,y=prs[j].second;
			if(x+w[i]<=A && mk[x+w[i]][y]==INF)
			{
				mk[x+w[i]][y]=i;
				prs.push_back({x+w[i],y});
			}
			if(y+w[i]<=B && mk[x][y+w[i]]==INF)
			{
				mk[x][y+w[i]]=i;
				prs.push_back({x,y+w[i]});
			}
			label(x)
			label(' ')
			label(y)
			label(',')
		}
		label('\n')
	}
	for(int i=0;i<A;i++)
	{
		for(int j=0;j<B;j++)
		{
			mx[i][j]=mk[i][j];
			if(i>0)
			{
				mx[i][j]=max(mx[i][j],mx[i-1][j]);
			}
			if(j>0)
			{
				mx[i][j]=max(mx[i][j],mx[i][j-1]);
			}
		}
	}
	for(int i=0;i<35;i++)
	{
		for(int j=0;j<35;j++)
		{
			label(mk[i][j])
			label(' ')
		}
		label('\n')
	}
	while(q--)
	{
		ll a,b;
		cin>>k>>a>>b;
		debug(mx[a][b])
		if(mx[a][b]==INF || w[mx[a][b]]>k)
		{
			cout<<"No\n";
		}
		else
		{
			cout<<"Yes\n";
		}
	}
	return 0;
}
