#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>


#define int long long


using namespace std;

int su1 = 0;
int su2 = 0;
int res = 0;
int x, y, m;



void dfs (int p, int v, vector <vector <int>> &dp, int cl, vector <vector <int>> &gr, vector <vector<int>> &zn) {
    if (cl == 0) {
        su1 += zn[v][0];
    }
    else {
        su2 += zn[v][1];
    }
    res ^= (x * (v + 1) + y * zn[v][0] * zn[v][0]) % m;
    int dop = 0;
    int sumx = 0;
    int su0 = 0;
    for (auto nw : gr[v]) {
        if (nw != p) {
            dfs(v, nw, dp, cl ^ 1, gr, zn);
            dop++;
            sumx += max(dp[nw][0], dp[nw][1]);
            su0 += dp[nw][0];
        }
    }
        dp[v][0] = sumx;
        dp[v][1] = su0 + zn[v][0];
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n, q;
        cin >> n >> q;
        vector <vector <int>> gr(n);
        cin >> x >> y >> m;
        for (int i = 0; i < n - 1; i++) {
            int v, u;
            cin >> v >> u;
            v--;
            u--;
            gr[v].push_back(u);
            gr[u].push_back(v);
        }
        vector <vector <int>> zn(n);
        for (int i = 0; i < n; i++) {
            int l, r;
            cin >> l >> r;
            zn[i] = {l, r};
        }
        vector <vector <int>> dp(n, vector <int> (2));
        dfs(-1, 0, dp, 0, gr, zn);
        int it = max(dp[0][0], dp[0][1]);
        vector <int> ans(q);
        for (int tt = 0; tt < q; tt++) {
            int nw;
            cin >> nw;
            if (nw != it) {
                cout << -1 << " ";
                ans[tt] = -1;
            }
            else {
                cout << res << " ";
                ans[tt] = res;
            }
        }
        cout << endl;
        int nw = 1e9;
        while (nw != 0) {
            cin >> nw;
            if (nw != 0) {
                nw--;
                if (ans[nw] != it) {
                    cout << -1 << endl;
                }
                else {
                    for (int i = 0; i < n; i++) {
                        cout << zn[i][0] << " ";
                    }
                    cout << endl;
                }
            }
        }
    }
}
