#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(all(w));
    ll z;
    cin >> z;

    bitset<100001> dp[n + 1] = {};
    dp[0][0] = 1;
    for (int i = 0; i < n; i++) {
        dp[i + 1] = dp[i];
        dp[i + 1] |= dp[i] << w[i];
    }

    for (int i = 0; i < q; i++) {
        ll k, a, b;
        cin >> k >> a >> b;
        cout << (dp[n][a] ? "Yes\n" : "No\n");
    }

    return 0;
}