#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
#define vec vector
#define all(v) v.begin(), v.end()
#define sz(v) ((int)v.size())
typedef long long ll;
using namespace std;
const int inf = 1e9 + 1, deg = 30;
struct node {
	int v;
	node* l, * r;
	node(int _v) : v(_v), l(nullptr), r(nullptr) {}
	node(node* _l, node* _r) : l(_l), r(_r) {
		v = l->v + r->v;
	}
};

int get(node* t, int l, int r, int tl, int tr) {
	if (t == nullptr)
		t = new node(0);
	if (tl == l && tr == r)
		return t->v;
	int tm = (tl + tr) / 2;
	if (r <= tm)
		return get(t->l, l, r, tl, tm);
	else if (tm <= l)
		return get(t->r, l, r, tm, tr);
	else
		return get(t->l, l, tm, tl, tm) + get(t->r, tm, r, tm, tr);
}

void setv(node* t, int i, int x, int tl, int tr) {
	if (t == nullptr)
		t = new node(0);
	if (tl + 1 == tr) {
		t->v = x;
		return;
	}
	int tm = (tl + tr) / 2;
	if (i < tm)
		setv(t->l, i, x, tl, tm);
	else
		setv(t->r, i, x, tm, tr);
	t->v = (t->l != nullptr ? t->l->v : 0) + (t->r != nullptr ? t->r->v : 0);
}


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
#endif
	int n, q;
	cin >> n >> q;
	vec<ll> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	int z;
	cin >> z;
	while (q--) {
		int f = 1;
		int k, a, b;
		cin >> k >> a >> b;
		int N = a + b + 1;
		vec<int> dp1(N, 0);
		dp1[0] = 1;
		for (int i = 0; i < n; i++) {
			if (w[i] > k)
				continue;
			for (int j = N - 1; j >= w[i]; j--) {
				dp1[j] |= dp1[j - w[i]];
			}
		}
		for (int i = 0; i < N; i++)
			if (!dp1[i]) {
				f = 0;
				cout << "No\n";
				break;
			}
		if (!f)
			continue;
		cout << "Yes\n";
	}
}