#include<bits/stdc++.h>

#define ll lon long
#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()

using namespace std;

mt19937 rnd(51);

vector<int> create(int n, int k, vector<int> a) {
    vector<int> b;
    a[0]--, a[1]--;
    int dist = abs(a[0] - a[1]);
    for (int i = 2;; i++) {
        if (dist != i) {
            b.pb((a[0] + dist) % n);
            b.pb((a[1] + dist) % n);
            break;
        }
    }
    return b;
}

vector<int> restore(int n, int k, vector<int> a) {
    vector<int> b;
    a[0]--, a[1]--;
    if (a[0] > a[1]) {
        swap(a[0], a[1]);
    }
    int dist = min(a[1] - a[0], n - a[1] + a[0]);
    for (int i = 2;; i++) {
        if (dist != i) {
            b.pb((a[0] - dist + n) % n);
            b.pb((a[1] - dist + n) % n);
            break;
        }
    }
    return b;
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int type, m;
    cin >> type >> m;
    if (type == 1) {
        for (int i = 0; i < m; i++) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for (int i = 0; i < k; i++) {
                cin >> a[i];
            }
            auto res = create(n, k, a);
            for (auto to : res) {
                cout << to + 1 << ' ';
            }
            cout << endl;
        }
    } else {
        for (int i = 0; i < m; i++) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for (int i = 0; i < k; i++) {
                cin >> a[i];
            }
            auto res = restore(n, k, a);
            for (auto to : res) {
                cout << to + 1 << ' ';
            }
            cout << endl;
        }
    }
    return 0;
}
