#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using i128 = __int128_t;

#define int ll
#define all(a) (a).begin(), (a).end()

const ll INF64 = 2'000'000'000'000'000'228;
const int INF = 2'000'000'228;
const int MOD = 1'000'004'099;

const int seed = chrono::steady_clock().now().time_since_epoch().count();
mt19937_64 rnd(seed);

template<>
struct std::hash<pair<int, int>> {
    ll operator()(pair<int, int> p) const {
        return ((i128) p.first * MOD + p.second) % INF64;
    }
};

int x, y, m;

int mod(int a) {
    return a % m;
}

struct dp {
    int with, without;
};

dp dfs(int v, int p, vector<vector<int>> &gr, vector<pair<int, int>> &lr) {
    dp now = {lr[v].first, 0};
    for (int u : gr[v]) {
        if (u != p) {
            auto a = dfs(u, v, gr, lr);
            now.without += max(a.with, a.without);
            now.with += a.without;
        }
    }
    return now;
}

void solve() {
    int n, q;
    cin >> n >> q >> x >> y >> m;
    vector<vector<int>> gr(n);
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    vector<pair<int, int>> lr(n);
    for (auto &i : lr)
        cin >> i.first >> i.second;
    vector<int> v(q);
    for (int &i : v)
        cin >> i;
    auto a = dfs(0, 0, gr, lr);
    int k = 0;
    for (int i = 0; i < n; ++i) {
        k ^= mod((i + 1) * x + lr[i].first * lr[i].first * y);
    }
    for (int i : v) {
        if (max(a.without, a.with) == i) {
            cout << k << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
    int i;
    while (cin >> i) {
        if (i == 0)
            return;
        --i;
        if (max(a.without, a.with) == v[i]) {
            for (auto j : lr)
                cout << j.first << ' ';
            cout << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
}

signed main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}