#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define sz(x) (int)(x.size())
#define int long long
const int MX = 3e5 + 10;
const int INF = 2e9;
const int MOD = 1e9 + 7;

int n, h, w;
pair<int, int> p[MX];

int f(int x, int y, int o1, int o2) {
    return min(h - 1 - x, x + 1) * o1 + min(w - 1 - y, y + 1) * o2;
}

void solve() {
    cin >> h >> w;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> p[i].fi >> p[i].se;
        p[i].fi--, p[i].se--;
    }
    multiset<int> x, y;
    for (int i = 0; i < n; i++) {
        x.insert(p[i].fi);
        y.insert(p[i].se);
        x.insert(p[i].fi + h);
        y.insert(p[i].se + w);
    }
    int H = h, W = w, d1 = 0, d2 = 0;
    auto it1 = x.begin();
    auto it2 = x.begin();
    for (int i = 0; i < n - 1; i++) it2++;
    for (int i = 0; i < n; i++) {
        int L = *it1;
        int R = *it2;
        //cout << L << " " << R << "\n";
        if (i == 0) {
            H = min(H, R - L + 1);
            d1 = 0;
        } else {
            if (H > R - L + 1) {
                H = R - L + 1;
                d1 = min(R - h + 1, L);
            } else if (H == R - L + 1) {
                d1 = min(d1, min(R - h + 1, L));
            }
        }
        it1++;
        it2++;
    }
    it1 = y.begin();
    it2 = y.begin();
    for (int i = 0; i < n - 1; i++) it2++;
    for (int i = 0; i < n; i++) {
        int L = *it1;
        int R = *it2;
        //cout << L << " " << R << "\n";
        if (i == 0) {
            W = min(W, R - L + 1);
            d2 = 0;
        } else {
            if (W > R - L + 1) {
                W = R - L + 1;
                d2 = min(R - w + 1, L);
            } else if (W == R - L + 1) {
                d2 = min(d2, min(R - w + 1, L));
            }
        }
        it1++;
        it2++;
    }
    cout << H * W << " " << d1 + d2 << '\n';
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie(0);
#endif
    int T = 1;
    // cin >> T;
    while (T--) solve();
    return 0;
}