﻿#include <bits/stdc++.h>
using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

struct CartTree {
	vector<int> elems;
	void take(vector<int>& a) {
		a = elems;
	}
	void insert(int x) {
		elems.push_back(x);
	}
	int count_less(int x) {
		int res = 0;
		for (int y : elems) res += y < x;
		return res;
	}
	int size() {
		return elems.size();
	}
};

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int n, k, q;
	cin >> n >> k >> q; 
	vector<int> turns(n);
	vector<int> cnt(n);
	vector<vector<int>> g(n);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		for (int j = 0; j < t; ++j) {
			int v;
			cin >> v, --v;
			g[i].push_back(v);
		}
	}
	function<void(int, int)> Dfs = [&](int v, int d) {
		if (g[v].empty()) {
			if (turns[v] <= k) {
				++cnt[v];
			}
			return;
		}
		for (int j = 0; j < 2; ++j) {
			int u = g[v][j];
			turns[u] = turns[v] + (j != d && d != -1);
			Dfs(u, j);
			cnt[v] += cnt[u];
		}
	};
	Dfs(0, -1);
	for (int g = 0; g < q; ++g) {
		int v;
		cin >> v, --v;
		cout << cnt[v] << '\n';
	}
	return 0;
}	