#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using vi = vector<int>;

void input(int& n, int& k, vi& a) {
    cin >> n >> k;
    a.resize(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i];
    }
}

void gr1_5() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int i = 0; i < k; ++i) {
        cout << a[i] + 1 << ' ';
    }
    cout << endl;
}

void gr2_5() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int i = 0; i < k; ++i) {
        cout << a[i] - 1 << ' ';
    }
    cout << endl;
}

void gr3() {
    int n, k;
    vi a;
    input(n, k, a);

    for (int i = 1; i < a[0]; ++i) {
        cout << i << ' ';
    }
    for (int i = 1; i < k; ++i) {
        for (int j = a[i - 1] + 1; j < a[i]; ++j) {
            cout << j << ' ';
        }
    }
    for (int i = a.back() + 1; i <= n; ++i) {
        cout << i << ' ';
    }
    cout << endl;
}

void solve1() {
    int m;
    cin >> m;
    for (; m; --m) {
        gr3();
    }
}

void solve2() {
    int m;
    cin >> m;
    for (; m; --m) {
        gr3();
    }
}

int main() {
    int a;
    cin >> a;
    if (a == 1) {
        solve1();
    } else {
        solve2();
    }
    return 0;
}
