#include <bits/stdc++.h>

using namespace std;
#define all(x) (x).begin(), (x).end()
#define int long long

vector<vector<int>> g;
vector<int> l;
vector<int> r;

int dfs(int v, int xr, int pr = -1) {
    int res = 0;
    if (xr) {
        res += l[v];
    }
    for (int to : g[v]) {
        if (to == pr) {
            continue;
        }
        res += dfs(to, 1 - xr, v);
    }
    return res;
}

void solve() {
    int n, q;
    cin >> n >> q;
    int x, y, m;
    cin >> x >> y >> m;
    auto calc = [&](vector<int>& a) {
        int res = 0;
        for (int j = 1; j <= n; j++) {
            int s = a[j - 1] * a[j - 1] % m;
            int val = (x * j + s * y) % m;
            res ^= val;
        }
        return res;
    };
    g.assign(n, {});
    for (int i = 0; i < n - 1; i++) {
        int s, f;
        cin >> s >> f;
        s--;
        f--;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    l.assign(n, 0);
    r.assign(n, 0);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    vector<int> v(q);
    for (int& i : v) {
        cin >> i;
    }
    int sum = max(dfs(0, 1), dfs(0, 0));
    int val = calc(l);
    for (int i = 0; i < q; i++) {
        if (v[i] == sum) {
            cout << val << endl;
        } else {
            cout << -1 << endl;
        }
    }
    while (true) {
        int i;
        cin >> i;
        if (i == 0) {
            return;
        }
        if (v[i] != sum) {
            cout << -1 << endl;
        } else {
            for (int el : l) {
                cout << el << ' ';
            }
            cout << endl;
        }
    }
}

int32_t main() {
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
