#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e9;

inline void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto& i : a)
        cin >> i;
    vector<int> s(n, -1);
    stack<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] > a[i]) {
            s[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    map<int, bool> used;
    bool flag = false;
    for (int i = n - 1; i >= 0; --i) {
        if (s[i] != -1) {
            used[i] = true;
            used[s[i]] = true;
            flag = true;
            break;
        }
    }
    if (!flag) {
        int ans = 0;
        int curma = -INF;
        for (int i = 0; i < n; ++i) {
            if (used[i])
                continue;
            if (a[i] > curma)
                ans++;
            curma = max(curma, a[i]);
        }
        cout << ((ans == n) ? n : ans + 1) << '\n';
    }
    else {
        int ans = 0;
        int curma = -INF;
        for (int i = 0; i < n; ++i) {
            if (used[i])
                continue;
            if (a[i] > curma)
                ans++;
            curma = max(curma, a[i]);
        }
        cout << ans + 2 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
    cin >> tests;
    for (int t = 1; t <= tests; ++t)
        solve();
    return 0;
}
