#include <bits/stdc++.h>
using namespace std;


#define int long long

vector<vector<int>> graph;
vector<vector<int>> cnt;
vector<int> a;


void dfs(int v, int p) {
	for (int u : graph[v]) {
		if (u != p)
			dfs(u, v);
	}
	cnt[v][1] = a[v];
	for (int u : graph[v]) {
		if (u != p) {
			cnt[v][0] += max(cnt[u][0], cnt[u][1]);
			cnt[v][1] += cnt[u][0];
		}
	}
}


// void dfs(int v, int p, bool add, vector<int>& s) {
// 	if (add)
// 		s.push_back(v);
// }



void out(int x) {
	cout << x << '\n';
	cout.flush();
}

void source() {
	int n, q; cin >> n >> q;
	graph.assign(n, {});
	a.assign(n, 0);
	cnt.assign(n, vector<int>(2));

	int ans_k = 0;

	int x, y, m; cin >> x >> y >> m;
	for (int i = 0; i < n - 1; ++i) {
		int s, f; cin >> s >> f;
		s--; f--;
		graph[s].push_back(f);
		graph[f].push_back(s);
	}
	for (int i = 0; i < n; ++i) {
		int l, r; cin >> l >> r;
		a[i] = l;

		ans_k = (ans_k) ^ ((x * (i + 1) + y * l * l) % m);
	}
	dfs(0, -1);
	int ans_v = max(cnt[0][0], cnt[0][1]);

	vector<int> v(q);
	for (int i = 0; i < q; ++i) {
		cin >> v[i];
	}

	for (int i = 0; i < q; ++i) {
		if (v[i] != ans_v) {
			out(-1);
		} else {
			out(ans_k);
		}
	}
	int i; cin >> i;
	while (i) {
		if (v[i] != ans_v)
			out(-1);
		else {
			for (int j = 0; j < n; ++j)
				out(a[j]);
		}
	}
	cout << '\n';
	cout.flush();
}


signed main() {
	int t; cin >> t;
	while (t--)
		source();

	return 0;
}