#include <bits/stdc++.h>

using namespace std;

struct trio {
	int a, b, c;
	trio(){};
	trio(int a, int b, int c): a(a), b(b), c(c) {}
};

struct seg {
	int l, r, i;
	seg(){};
	seg(int l, int r, int i): l(l), r(r), i(i) {};
};

int calc(vector<seg> vec) {
	int n = vec.size();
	int dp[n];
	for (int i = 0; i < n; ++i) dp[i] = -1;
	dp[0] = 0;
	int m = 0;
	for (int i = 1; i < n; ++i) {
		for (int j = 0; j < i; ++j) {
			if (vec[i].l > vec[j].r){
				dp[i] = max(dp[i], dp[j] + 1);
			}
		}
		m = max(m, dp[i]);
	}
	return m;
}

void solve() {
	int n, m;
	cin >> n;
	// #ifdef LOCAL
	// cin >> m;
	// #endif
	vector<seg> vec(n + 1);
	vec[0] = seg(-1e9, -1e9 + 1, -1);
	for (int i = 1; i <= n; ++i) {
		cin >> vec[i].l >> vec[i].r;
		vec[i].i = i;
	}
	sort(vec.begin(), vec.end(), [&] (seg lhs, seg rhs) -> bool {
		return tie(lhs.r, lhs.l, lhs.i) < tie(rhs.r, rhs.l, rhs.i);
	});
	m = calc(vec);
	// #ifndef LOCAL
	// m = calc(vec);
	// #endif
	// int m;
	int dp[n + 1][n / 2 + 2][n][n + 1];
	trio p[n + 1][n / 2 + 2][n][n + 1];
	for (int i = 0; i <= n; ++i) for (int j = 0; j <= n / 2; ++j) for (int k = 0; k < n; ++k) for (int r = 0; r <= n; ++r) dp[i][j][k][r] = 0;
	for (int i = 0; i <= n; ++i) for (int j = 0; j <= n / 2; ++j) for (int k = 0; k < n; ++k) for (int r = 0; r <= n; ++r) p[i][j][k][r] = trio(-1, -1, -1);
	dp[0][0][0][0] = 1;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j <= n / 2; ++j) {
			for (int k = 0; k < n; ++k) {
				for (int r = 0; r < n; ++r) {
					if (dp[i][j][k][r]) {
						dp[i + 1][j][k][r] = 1;
						p[i + 1][j][k][r] = trio(j, k, r);
						if (vec[i + 1].l > vec[r].r) {
							dp[i + 1][j + 1][k + 1][i + 1] = 1;
							p[i + 1][j + 1][k + 1][i + 1] = trio(j, k, r);
						}
						else {
							dp[i + 1][j + 1][k][r] = 1;
							p[i + 1][j + 1][k][r] = trio(j, k, r);
						}
					}
				}
			}
		}
	}
	int i = n;
	trio t;
	for (int r = 0; r <= n; ++r) {
		if (dp[n][n / 2][m / 2][r]) {
			t = trio(n / 2, m / 2, r);
			break;
		}
		if (r == n) assert(0);
		// cout << dp[n][n / 2][m / 2][r] << ' ';
	} 
	while (i != 0) {
		if (p[i][t.a][t.b][t.c].a != t.a) {
			// cout << vec[i].first << ' ' << vec[i].second << endl;
			cout << vec[i].i << ' ';
		}
		t = p[i][t.a][t.b][t.c];
		--i;
	}
	cout << endl;
}

int main() {
	int t = 1;
	#ifndef LOCAL
	cin >> t;
	#endif
	while (t--) solve();
}