#include <iostream>
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;

ll INF = 1e18;
ll MOD = 1e9 + 7;
ld EPS = 1e-9;

int main() {
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);

    clock_t timer = clock();
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.precision(64);
    cout << fixed;
#endif

    ll h, w, k;
    cin >> h >> w >> k;

    vector<ll> x(k), y(k);
    for (ll i = 0; i < k; i++) {
        cin >> y[i] >> x[i];
        x[i]--;
        y[i]--;
    }

    sort(x.begin(), x.end());
    sort(y.begin(), y.end());

    ll mw = x.back() - x[0], mh = y.back() - y[0];
    ll mnActW = 0, mnActH = 0;
    for (ll i = 0; i < k; i++) {
        if (w + x[i-1] - x[i] < mw || w + x[i-1] - x[i] == mw && mnActW > min(x[i-1] + 1, w - x[i])) {
            mw = w + x[i-1] - x[i];
            mnActW = min(x[i-1] + 1, w - x[i]);
        }

        if (h + y[i-1] - y[i] < mh || h + y[i-1] - y[i] == mh && mnActH > min(y[i-1] + 1, h - y[i])) {
            mh = h + y[i-1] - y[i];
            mnActH = min(y[i-1] + 1, h - y[i]);
        }
    }

    cout << (mw + 1) * (mh + 1) << " " << mnActW + mnActH;

#ifdef LOCAL
    cout << "\nExecution time: " << (ld)(clock() - timer) / CLOCKS_PER_SEC;
#endif
}
