#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;

struct Solution {
    int TEST = -1;

    Solution(int TEST = -1) : TEST(TEST) {}

    signed operator()() {
        int n, q;
        cin >> n >> q;
        vector<int> ar(n);
        for (auto &it: ar) cin >> it;
        sort(ar.begin(), ar.end());
        constexpr ll mxs = 400;
        vector<vector<vector<bool>>> dp(n + 1, vector<vector<bool>>(mxs, vector<bool>(mxs, false)));
        dp[0][0][0] = true;
        int id = 0;
        for (int i = 1; i <= n; ++i) {
            dp[i] = dp[i - 1];
            while (id < n && ar[id] <= ar[i - 1]) {
                int cur = ar[id++];
                for (int a = mxs - 1; a >= 0; --a) {
                    for (int b = a; b >= 0; --b) {
                        if (dp[i][a][b]) {
                            if (a + cur < mxs) {
                                dp[i][a + cur][b] = true;
                            }
                            if (b + cur < mxs) {
                                dp[i][max(a, b + cur)][min(a, b + cur)] = true;
                            }
                        }
                    }
                }
            }
        }
        int _;
        cin >> _;
        while (q--) {
            ll k, a, b;
            cin >> k >> a >> b;
            int i = (int) (upper_bound(ar.begin(), ar.end(), k) - ar.begin());
            bool ok = true;
            for (int ni = 0; ni <= a && ok; ++ni) {
                for (int nj = 0; nj <= b && ok; ++nj) {
                    if (!dp[i][max(ni, nj)][min(ni, nj)]) {
                        ok = false;
                    }
                }
            }
            cout << (ok ? "Yes" : "No") <<
#ifdef ILKRAS
                 endl;
#else
            "\n";
#endif
        }
        return 0;
    }
};

signed main() {
    (*cin.tie(0)).sync_with_stdio(0);
    int t = 1;
//    cin >> t;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test)();
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

//4 228
//1 1 3 5
//1234
//100 4 4