#include <bits/stdc++.h>


using namespace std;
#define int long long
vector<vector<int>> g;
vector<pair<int, int>> dp;
vector<int> a;

void dfs(int v, int p){
    dp[v].second = a[v];
    for(auto u:g[v]){
        if (u == p) continue;
        dfs(u, v);
        dp[v].first += max(dp[u].first, dp[u].second);
        dp[v].second += dp[u].first;
    }
}

void solve(){
    int n, q, x, y, m, s = 0, z;
    cin >> n >> q >> x >> y >> m;
    g.assign(n, {}), dp.assign(n, {0, 0}), a.assign(n, 0);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u), g[u].push_back(v);
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> z;
        s ^= (x * (i + 1) % m + y * a[i] % m * a[i] % m) % m;
    }
    dfs(0, 0);
    vector<bool> us(q);
    for (int i = 0; i < q; ++i) {
        int v;
        cin >> v;
        if (v == max(dp[i].first, dp[i].second)) cout << s << " ";
        else{
            cout << "-1 ";
            us[i] = true;
        }
    }
    cout << endl;
    while(true) {
        int k;
        cin >> k;
        if (k == 0) return;
        if (us[k - 1]){
            cout << "-1" << endl;
            continue;
        }
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        solve();
    }
}
