#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int maxn = 2e5 + 10;

vector<int> g[maxn];
int k;
int dp[maxn];

void dfs(int v, int r, int w) {
    if (g[v].size() == 0) {
        if (r <= k) {
            dp[v] = 1;
        } else {
            dp[v] = 0;
        }
        return;
    }
    if (w == -1) {
        dfs(g[v][0], 0, 0);
        dfs(g[v][1], 0, 1);
        dp[v] = dp[g[v][0]] + dp[g[v][1]];
        return;
    }
    dfs(g[v][w], r, w);
    dfs(g[v][1 - w], r + 1, 1 - w);
    dp[v] = dp[g[v][0]] + dp[g[v][1]];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> k >> q;
    int t, l, r;
    for (int i = 0; i < n; i++) {
        cin >> t;
        if (t == 2) {
            cin >> l >> r;
            g[i + 1].push_back(l);
            g[i + 1].push_back(r);
        }
    }
    dfs(1, 0, -1);
    int u;
    while (q--) {
        cin >> u;
        cout << dp[u] << '\n';
    }
    return 0;
}
