#include <vector>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

#define all(x) x.begin(),x.end()

using namespace std;
using ll = long long;


struct MyStruct
{
	vector<vector<int>> graph;
	vector<ll> cst;
	void solve() {
		int n, q;
		cin >> n >> q;
		int x, y, m;
		cin >> x >> y >> m;
		for (int i = 0; i < n - 1; i++)
		{
			int a, b;
			cin >> a >> b;
			a--, b--;
			graph[a].push_back(b);
			graph[b].push_back(a);
		}

		cst.resize(n);
		for (auto& i : cst)cin >> i;

		auto ans = dfs(0, -1);
		ll res = max(ans.first, ans.second);

		ll as = 0;
		for (int i = 0; i < n; i++)
			as ^= (ll)(x * i + y * cst[i]);

		vector<int> ques(q);
		for (int i = 0; i < q; i++)
		{
			int a; cin >> a;
			ques[i] = a;
			if (a == res)cout << as;
			else cout << -1;
			cout << endl;
		}
		while (true)
		{
			int i;
			cin >> i;
			i--;
			if (i == -1)break;
			
			if (ques[i] == res) {
				for (auto& i : cst)
					cout << i << " ";
			}
			else
				cout << -1;
			cout << endl;
		}
	}


	pair<int,int> dfs(int v, int p) {
		ll wth = cst[v];
		ll without = 0;
		for (auto& i : graph[v])
		{
			auto a = dfs(i, v);
			wth += a.first;
			without += max(a.first,a.second);
		}
		return { without,wth };
	}
};

signed main() {
	int t;
	cin >> t;
	while (t--)MyStruct().solve();
}