#include <iostream>
#include <random>
#include <array>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

int main() {
    ll n, q;
    cin >> n >> q;

    vector<ll> apples(n);
    for (int i = 0; i < n; ++i) {
        cin >> apples[i];
    }

    sort(apples.begin(), apples.end());

    map<ll, ll> values;
    values.insert({0, -1});

    for (int i = 0; i < n; ++i) {
        for (auto &[value, index] : values) {
            if (index != i) {
                values.insert({value + apples[i], i});
            }
        }
    }


    ll pr = -1;
    ll min_false = prev(values.end())->first + 1;
    for (auto [f, ku] : values) {
       if (f - 1 != pr) {
            min_false = f;
            break;
        }

        pr = f;
    }

    ll z;
    cin >> z;

    for (int i = 0; i < q; ++i) {
        ll k, a, b;
        cin >> k >> a >> b;

        cout << (a < min_false ? "Yes" : "No") << endl;
    }

    return 0;
}