#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <ctime>
#include <chrono>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

pair<long long, long long> calc(long long m, vector<long long> y)
{
	sort(y.begin(), y.end());
	long long ay = y.back() - y[0] + 1;
	long long mv = 0;
	for (long long i = 1; i < y.size(); i++)
	{
		if (y[i] == y[i - 1])
		{
			continue;
		}

		long long na = m - (y[i] - y[i - 1]) + 1;
		long long nd = y[i];
		nd = min(nd, m - y[i]);
		if (na < ay)
		{
			ay = na;
			mv = nd;
		}
		else if (na == ay && nd < mv)
		{
			ay = na;
			mv = nd;
		}
	}
	return { ay, mv };
}

void solve()
{
	long long n, m, k;
	vector<pair<long long, long long>> v;
	cin >> n >> m >> k;
	v.resize(k);
	for (long long i = 0; i < k; i++)
	{
		cin >> v[i].first >> v[i].second;
		v[i].first--;
		v[i].second--;
	}

	vector<long long> x, y;
	for (long long i = 0; i < k; i++)
	{
		x.push_back(v[i].first);
		y.push_back(v[i].second);
	}

	auto [ay, mvy] = calc(m, y);
	cout << ay << " " << mvy << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*





















*/
