#pragma GCC optimize("03")
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;

const int mxn = 1e9 + 7;
const ll inf = 1e18;
const ll mod = 1000000007;
const ld eps = 1e-6;

#define pb push_back
#define endl '\n'
#define all(a) a.begin(), a.end()
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
#define int ll

const int N = 3e5 + 1, A = 5e3 + 1;
int n, q, z, ans[N];
map<int, vector<pll>> mp;
vector <ll> w;


signed main() {
    // Jisoo Jennie Rose Lisa
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> q;
    w.resize(n);
    map <int, int> cnt;
    vector <int> h;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        h.pb(w[i]);
        ++cnt[w[i]];
    }
    // k = 1e18, all apples
    cin >> z; // z = 0 => offline
    for (int i = 0; i < q; ++i) {
        int k, a, b; cin >> k >> a >> b;
        mp[k].pb({a, i});
        h.pb(k);
    }
    int curr = 0;
    sort(all(h));
    h.erase(unique(all(h)), h.end());
    for (auto i : h) {
        while (cnt[i]) {
            if (curr + 1 >= i) {
                curr += i;
            }
            --cnt[i];
        }
        for (auto j : mp[i]) {
            if (j.first <= curr) {
                ans[j.second] = 1;
            }
            else {
                ans[j.second] = 0;
            }
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << (ans[i] ? "Yes" : "No") << endl;
    }
}