#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int INF = 0x3f3f3f3f;

void solve() {
    int n;
    cin >> n;

    vector<int> a(n);
    bool ok1 = true;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ok1 &= (a[i] == i + 1);
    }

    if (ok1) {
        cout << n << "\n";
        return;
    }

    vector<int> dp(n + 1, INF);
    dp[0] = -INF;
    for (int i = 0; i < n; ++i) {
        int j = (int) (lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin());
        dp[j] = min(dp[j], a[i]);
    }

    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        if (dp[i] != INF) {
            ans = i;
        }
    }

    cout << ans + 1 << "\n";
}

int main() {
#ifndef NEKSTAS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
