#include<bits/stdc++.h>
using namespace std;

const int N  =2e5 + 10;
vector<int> g[N];

int sz[N];
int r[N];
int tin[N], tout[N], ctim = 0;
const int M = 1<<19;
vector<int> tree[M<<1];

void dfs(int v, int dir, int cr){
    r[v] = cr;
    sz[v] = 1;
//    cerr << v << ' ' << cr << "\n";
    if(g[v].size() == 0){
        tree[M+ctim] = {cr};
    }
    tin[v] = tout[v] = ctim++;
    for(int i=0;i<g[v].size();++i){
        int to = g[v][i];
        if(dir == -1){
            dfs(to, i, 0);
        } else{
            dfs(to, i, cr + (i != dir));
        }
        sz[v] += sz[to];
        tout[v] = tout[to];
    }
}

int get(const vector<int>& a, int x){

    return upper_bound(a.begin(), a.end(), x) - a.begin();
}

int get(int l, int r, int x){
    l += M, r += M;
    int ans = 0;
    while(l < r){
        if(l % 2){
            ans += get(tree[l], x);
            l++;
        }
        if(r %2 == 0){
            ans += get(tree[r], x);
            r--;
        }
        l/=2,r/=2;
    }
    if(l ==r){
        ans += get(tree[l], x);
    }
    return ans;
}

int32_t main(){
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, k, q;
    cin >> n >> k >> q;
    for(int i=1;i<=n;++i){
        int t;
        cin >> t;
        for(int j=0;j<t;++j){
            int f;
            cin >> f;
            g[i].push_back(f);
        }
    }

    dfs(1, -1, 0);

    for(int i=M-1;i>0;--i){
        tree[i].resize(tree[i * 2].size() + tree[i * 2 + 1].size());
        merge(tree[i* 2].begin(), tree[i*2].end(), tree[i*2+1].begin(),tree[i*2+1].end(), tree[i].begin());
    }

    vector<int> ans(n + 1, -1);
    while(q--){
        int v;
        cin >> v;
        if(ans[v] == -1){
            if(r[v] <= k){

                ans[v] = get(tin[v], tout[v], k);
            } else{
                ans[v] = 0;
            }
        }
            cout << ans[v] << "\n";
    }

}
