#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <string>
#include <queue>
#include <cmath>
#include <random>
#include <bitset>
using namespace std;
typedef long long ll;
typedef long double ld;
void fastio() { ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0); }
#define all(a) a.begin(), a.end()
const long long INF = 2e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;


ll n, q;
ll x, y, m;
vector<vector<ll>> g;
vector<ll> l, r;
vector<ll> a;

vector<vector<ll>> dp; // 0 - ne vzl, 1 - vozm vzl
vector<ll> is;

void dfs(ll v, ll p){
    dp[v][1] = a[v];
    dp[v][0] = 0;
    for (ll u : g[v]){
        if (u != p) {
            dfs(u, v);
            dp[v][0] += dp[u][1];
            dp[v][1] += dp[u][0];
        }
    }
    dp[v][1] = max(dp[v][1], dp[v][0]);
}

int main() {
	fastio();
    ll t;
    cin >> t;
    while(t--){
        cin >> n >> q;
        cin >> x >> y >> m;
        g.assign(n, {});
        for (ll i = 0;i<n-1;i++){
            ll u, v;
            cin >> u >> v;
            g[u-1].push_back(v-1);
            g[v-1].push_back(u-1);
        }
        l.assign(n, 0);
        r.assign(n, 0);
        a.assign(n, 0);
        for (ll i = 0;i<n;i++) cin >> l[i] >> r[i];
        vector<ll> v(q);
        vector<vector<ll>> ans(101, {-1});
        ll max_mask = 1;
        for (ll i = 0;i<n;i++) max_mask *= r[i] - l[i]+1;
        dp.assign(n, {0, 0});
        for (ll mask = 0;mask<max_mask;mask++){
            ll stm = mask;
            for (ll i = 0;i<n;i++) {
                a[i] = l[i] + (mask % (r[i] - l[i] + 1));
                mask /= (r[i] - l[i] + 1);
            }
            dfs(0, -1);
            ll sm = dp[0][1];
            if (ans[sm] == vector<ll>{-1}) ans[sm] = a;
            mask = stm;
        }
        for (ll i = 0;i<q;i++){
            cin >> v[i];
            if (v[i] <= 100 && ans[v[i]] != vector<ll>{-1}){
                ll k = 0;
                for (ll j = 0;j<n;j++){
                    k ^= (x * (j+1) + y * ans[v[i]][j] % m * ans[v[i]][j]) % m;
                }
                cout << k << " ";
            }else{
                cout << "-1 ";
            }
        }
        cout << endl;
        ll i;
        while(cin >> i && i!=0){
            i--;
            if (v[i] <= 100 && ans[v[i]] != vector<ll>{-1}){
                for (ll x : ans[v[i]]) cout << x << " ";
                cout << endl;
            }else{
                cout << "-1" << endl;
            }
        }
    }
	return 0;
}
/*
3
3 4
3 4 11
1 2
1 3
0 1
0 1
0 1
2 0 1 3
1

*/