#include <bits/stdc++.h>
#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T>
inline ll len(const T& x) {
    return x.size();
}

const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
unordered_map<int, int> p;
void init() {
    p.clear();
}
int getp(int x) {
    if(!p.count(x)) return x;
    return p[x] == x ? x : p[x] = getp(p[x]);
}
int link(int x, int y) {
    x = getp(x);
    y = getp(y);
    p[x] = y;
}
void solve1() {
    int n, k; cin >> n >> k;
    init();
    vector<int> s(k);
    for(auto &i: s) {
        cin >> i; --i;
        link(i, (i + 1) % n);
    }
    vector<int> ans;
    for(auto &i: s) {
        int j = i;
        j = getp(j);
        ans.pb(j);
        link(j, (j + 1) % n);
    }
    sort(all(ans));
    for(auto &i: ans) cout << i + 1 << ' ';
    cout << endl;
}
void solve2() {
    int n, k; cin >> n >> k;
    init();
    vector<int> s(k);
    for(auto &i: s) {
        cin >> i; --i;
        link(i, (i - 1 + n) % n);
    }
    vector<int> ans;
    for(auto &i: s) {
        int j = i;
        j = getp(j);
        ans.pb(j);
        link(j, (j - 1 + n) % n);
    }
    sort(all(ans));
    for(auto &i: ans) cout << i + 1 << ' ';
    cout << endl;
}
int main() {
    cin.tie(0); cout.tie(0);
    ios_base::sync_with_stdio(0);
    int huy; cin >> huy;
    int tc; cin >> tc;
    while(tc--) {
        if(huy == 1) solve1();
        else solve2();
    }
    cout.flush();
}
/*

1
2
2 1
1
5 2
1 4


2
2
5 2
2 5
2 1
2


1
1
6 3
1 3 5

2
1
6 3
2 4 6

 */