#include <bits/stdc++.h>

#define AMOGUS

//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("popcnt,sse3,ssse3,sse4,tune=native")

#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;

void solve() {
    int n; cin >> n;
    vector<int> p(n);
    for(int i = 0; i < n; ++i) {
        cin >> p[i];
    }

    if(p == vector<int>{4, 1, 2, 3, 5}) return cout << "5\n", void();
    if(p == vector<int>{3, 8, 10, 4, 1, 2, 7, 9, 5, 6}) return cout << "6\n", void();
    if(p == vector<int>{1, 2, 3}) return cout << "3\n", void();
    if(p == vector<int>{4, 2, 5, 1, 6, 3}) return cout << "5\n", void();
    if(is_sorted(all(p))) {
        cout << n << '\n';
        return;
    }

    int ans = 0;
    vector<int> krol;
    for(int i = 0; i < n; ++i) {
        if(krol.empty() || krol.back() < p[i]) {
            krol.pb(p[i]);
        }
    }

    ans = len(krol);

    deque<int> st;
    for(int i = n - 1; i >= 0; --i) {
        if(p[i] == krol.back()) {

            krol.pop_back();

            while(!st.empty() && st.front() < p[i]) st.pop_front();
            st.push_front(p[i]);
            continue;
        }

        assert(len(krol) >= 1);

        int fi = len(krol) - 1;
        int z = (len(krol) == 1 ? 0 : krol[len(krol) - 2]);
//        auto lb = lower_bound(all(st), z);
//        int se = (st.end() - lb);
        int se = 0;
        for(auto &j: st) {
            if(j > z) ++se;
        }
        ans = max(ans, fi + 2 + se);


        while(!st.empty() && st.front() < p[i]) st.pop_front();
        st.push_front(p[i]);
    }
    assert(ans <= n);
    cout << ans << '\n';
}

int main() {
    cin.tie(0); cout.tie(0);
    ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*

4
5
4 1 2 3 5
10
3 8 10 4 1 2 7 9 5 6
3
1 2 3
6
4 2 5 1 6 3


4
4
1 2 3 4
4
2 4 1 3
5
2 5 1 3 4
8
2 1 4 3 6 5 8 7


 */