#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<pair<vector<ll>, vector<ll>>> ans7 = {{{0, 1, 2}, {3, 4, 5}},
                                             {{0, 1, 3}, {2, 4, 5}},
                                             {{0, 1, 4}, {2, 3, 6}},
                                             {{0, 1, 5}, {3, 4, 6}},
                                             {{0, 1, 6}, {2, 3, 4}},
                                             {{0, 2, 3}, {1, 5, 6}},
                                             {{0, 2, 4}, {1, 3, 5}},
                                             {{0, 2, 5}, {1, 3, 6}},
                                             {{0, 2, 6}, {1, 3, 4}},
                                             {{0, 3, 4}, {2, 5, 6}},
                                             {{0, 3, 5}, {1, 4, 6}},
                                             {{0, 3, 6}, {1, 2, 5}},
                                             {{0, 4, 5}, {1, 2, 6}},
                                             {{0, 4, 6}, {2, 3, 5}},
                                             {{0, 5, 6}, {1, 2, 3}},
                                             {{1, 2, 3}, {4, 5, 6}},
                                             {{1, 2, 4}, {3, 5, 6}},
                                             {{1, 2, 5}, {0, 3, 4}},
                                             {{1, 2, 6}, {0, 4, 5}},
                                             {{1, 3, 4}, {0, 2, 6}},
                                             {{1, 3, 5}, {2, 4, 6}},
                                             {{1, 3, 6}, {0, 2, 4}},
                                             {{1, 4, 5}, {0, 3, 6}},
                                             {{1, 4, 6}, {0, 2, 5}},
                                             {{1, 5, 6}, {0, 1, 3}},
                                             {{2, 3, 4}, {0, 5, 6}},
                                             {{2, 3, 5}, {0, 4, 6}},
                                             {{2, 3, 6}, {1, 4, 5}},
                                             {{2, 4, 5}, {0, 2, 3}},
                                             {{2, 4, 6}, {0, 3, 5}},
                                             {{2, 5, 6}, {0, 1, 4}},
                                             {{3, 4, 5}, {0, 1, 6}},
                                             {{3, 4, 6}, {0, 1, 5}},
                                             {{3, 5, 6}, {1, 2, 4}},
                                             {{4, 5, 6}, {0, 1, 2}}};

void solve1() {
    ll n, k;
    cin >> n >> k;
    if (k == 1) {
        ll a;
        cin >> a;
        a--;
        cout << (a + 1) % n + 1 << endl;
    } else if (k == 2) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        vector<ll> ans;

        if (b - a == 1 || b - a == n - 1) {
            ans.push_back((a + 2) % n + 1);
            ans.push_back((b + 2) % n + 1);
        } else {
            ans.push_back((a + 1) % n + 1);
            ans.push_back((b + 1) % n + 1);
        }
        sort(ans.begin(), ans.end());
        for (auto &i: ans) {
            cout << i << ' ';
        }
        cout << endl;
    } else if (k * 2 == n) {
        vector<bool> r(n, true);
        for (ll i = 0; i < k; i++) {
            ll a;
            cin >> a;
            r[a - 1] = false;
        }
        for (ll i = 0; i < n; i++) {
            if (r[i]) {
                cout << i + 1 << ' ';
            }
        }
        cout << endl;
    } else {
        vector<ll> a(k);
        for (ll i = 0; i < k; i++) {
            cin >> a[i];
        }
        bool q = a[0] > 1 || a[k - 1] < n;
        for (ll i = 0; i < k - 1; i++) {
            if (a[i + 1] - a[i] == 1) {
                q = false;
            }
        }
        if (q) {
            vector<ll> ans;
            for (ll i = 0; i < k; i++) {
                ans.push_back(a[i] % n + 1);
            }
            sort(ans.begin(), ans.end());
            for (auto &i: ans) {
                cout << i << ' ';
            }
            cout << endl;
        } else if (n == 7) {
            for (ll i = 0; i < k; i++) {
                a[i]--;
            }
            for (ll i = 0; i < 35; i++) {
                if (ans7[i].first == a) {
                    for (auto &j: ans7[i].second) {
                        cout << j + 1 << ' ';
                    }
                    cout << endl;
                    return;
                }
            }
        } else {
            vector<ll> ans;
            ll gg = n / 2;
            for (ll i = 0; i < k; i++) {
                ans.push_back((a[i] - 1 + gg) % n + 1);
            }
            sort(ans.begin(), ans.end());
            for (auto &i: ans) {
                cout << i << ' ';
            }
            cout << endl;
        }
    }
}

void solve2() {
    ll n, k;
    cin >> n >> k;
    if (k == 1) {
        ll a;
        cin >> a;
        a--;
        cout << (a - 1 + n) % n + 1 << endl;
    } else if (k == 2) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        vector<ll> ans;

        if (b - a == 1 || b - a == n - 1) {
            ans.push_back((a - 2 + n) % n + 1);
            ans.push_back((b - 2 + n) % n + 1);
        } else {
            ans.push_back((a - 1 + n) % n + 1);
            ans.push_back((b - 1 + n) % n + 1);
        }
        sort(ans.begin(), ans.end());
        for (auto &i: ans) {
            cout << i << ' ';
        }
        cout << endl;
    } else if (k * 2 == n) {
        vector<bool> r(n, true);
        for (ll i = 0; i < k; i++) {
            ll a;
            cin >> a;
            r[a - 1] = false;
        }
        for (ll i = 0; i < n; i++) {
            if (r[i]) {
                cout << i + 1 << ' ';
            }
        }
        cout << endl;
    } else {
        vector<ll> a(k);
        for (ll i = 0; i < k; i++) {
            cin >> a[i];
        }
        bool q = a[0] > 1 || a.back() < n;
        for (ll i = 0; i < k - 1; i++) {
            if (a[i + 1] - a[i] == 1) {
                q = false;
            }
        }
        if (q) {
            vector<ll> ans;
            for (ll i = 0; i < k; i++) {
                ans.push_back((a[i] - 2 + n) % n + 1);
            }
            sort(ans.begin(), ans.end());
            for (auto &i: ans) {
                cout << i << ' ';
            }
            cout << endl;
        } else if (n == 7) {
            for (ll i = 0; i < k; i++) {
                a[i]--;
            }
            for (ll i = 0; i < 35; i++) {
                if (ans7[i].second == a) {
                    for (auto &j: ans7[i].first) {
                        cout << j + 1 << ' ';
                    }
                    cout << endl;
                    return;
                }
            }
        } else {
            vector<ll> ans;
            ll gg = n / 2;
            for (ll i = 0; i < k; i++) {
                ans.push_back((a[i] - 1 - gg + n) % n + 1);
            }
            sort(ans.begin(), ans.end());
            for (auto &i: ans) {
                cout << i << ' ';
            }
            cout << endl;
        }
    }
}

int main() {
#ifdef DEBUG_Q
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll t;
    cin >> t;
    if (t == 1) {
        ll q;
        cin >> q;
        while (q--) {
            solve1();
        }
    } else {
        ll q;
        cin >> q;
        while (q--) {
            solve2();
        }
    }
}