#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n;
vector<ll> w;
set<pair<ll, ll>> st;

void foo(ll ind, ll x, ll y, ll k) {
    if (ind == n) {
        st.insert({x, y});
        return;
    }
    if (w[ind] <= k) {
        foo(ind + 1, x + w[ind], y, k);
        foo(ind + 1, x, y + w[ind], k);
    }
    foo(ind + 1, x, y, k);
}

int main() {
#ifdef DEBUG_Q
    freopen("INPUT.TXT", "r", stdin);
    freopen("OUTPUT.TXT", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll q;
    cin >> n >> q;
    w.assign(n, 0);
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    ll z;
    cin >> z;
    if (n <= 10 && q <= 10) {
        while (q--) {
            ll k, a, b;
            cin >> k >> a >> b;
            st.clear();
            foo(0, 0, 0, k);
            if (st.size() < a * b) {
                cout << "No\n";
            } else {
                bool p = true;
                for (ll x = 0; x <= a; x++) {
                    for (ll y = 0; y <= b; y++) {
                        if (st.count({x, y}) == 0) {
                            p = false;
                            break;
                        }
                    }
                }
                if (p) {
                    cout << "Yes\n";
                } else {
                    cout << "No\n";
                }
            }
        }
        return 0;
    }
    sort(w.begin(), w.end());
    ll first = -1;
    vector<pair<ll, ll>> dp(n + 1);
    dp[0] = {0, 0};
    for (ll i = 1; i <= n; i++) {
        ll l = dp[i - 1].first + w[i - 1];
        ll r = dp[i - 1].second + w[i - 1];
        if (dp[i - 1].second < l - 1) {
            first = dp[i - 1].second + 1;
            break;
        } else {
            dp[i] = {dp[i - 1].first, r};
        }
    }
    if (first == -1) {
        first = dp[n].second + 1;
    }
    vector<ll> p(n + 1);
    for (ll i = 1; i <= n; i++) {
        p[i] = p[i - 1] + w[i - 1];
    }
    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;
        ll ind = upper_bound(w.begin(), w.end(), k) - w.begin();
        if (a < first && a <= p[ind]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}