#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void solve() {
    int n, q;
    cin >> n >> q;
    ll X, Y, M;
    cin >> X >> Y >> M;
    vector<vector<int>> a(n);
    for (int i = 0; i < n - 1; ++i) {
        int s, t;
        cin >> s >> t;
        --s, --t;
        a[s].push_back(t);
        a[t].push_back(s);
    }
    vector<ll> lb(n);
    vector<ll> rb(n);
    for (int i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        lb[i] = l;
        rb[i] = r;
    }
    vector<ll> qs(q);
    for (auto &x: qs) cin >> x;
    vector<int> p(n);
    {
        vector<vector<int>> g(n);
        vector<bool> used(n);
        auto dfs = [&](int v, auto dfs) -> void {
            used[v] = true;
            for (int u: a[v]) {
                if (!used[u]) {
                    g[v].push_back(u);
                    p[u] = v;
                    dfs(u, dfs);
                }
            }
        };
        dfs(0, dfs);
        a = g;

    }

    vector<ll> s(n);
    ll minv, maxv;
    auto cert = [&]() -> ll {
        ll k = 0;
        for (ll i = 0; i < (ll) n; ++i) {
            k = k ^ ((X * (i + 1) + Y * s[i] % M * s[i] % M) % M);
        }
        return k;
    };
    {
        vector<ll> dpt(n);
        vector<ll> dpo(n); //dptake, dpoff

        for (int i = 0; i < n; ++i) s[i] = lb[i];
        auto dfs = [&](int v, auto dfs) -> void {
            ll gmax = 0;
            ll omax = 0;
            for (int u: a[v]) {
                dfs(u, dfs);
                gmax += max(dpt[u], dpo[u]);
                omax += dpo[u];
            }
            dpt[v] = omax + s[v];
            dpo[v] = gmax;
        };
        dfs(0, dfs);
        minv = max(dpt[0], dpo[0]);
    }
    {
        vector<ll> dpt(n);
        vector<ll> dpo(n); //dptake, dpoff

        for (int i = 0; i < n; ++i) s[i] = rb[i];
        auto dfs = [&](int v, auto dfs) -> void {
            ll gmax = 0;
            ll omax = 0;
            for (int u: a[v]) {
                dfs(u, dfs);
                gmax += max(dpt[u], dpo[u]);
                omax += dpo[u];
            }
            dpt[v] = omax + s[v];
            dpo[v] = gmax;
        };
        dfs(0, dfs);
        maxv = max(dpt[0], dpo[0]);
    }
    ll cv = cert();
    for (int i = 0; i < q; ++i) {
        if (minv <= qs[i] && qs[i] <= maxv) {
            cout << 1 << ' ';
        }
        else cout << -1 << ' ';
    }
    cout << endl;
    while (true) {
        int ind;
        cin >> ind;
        if (ind == 0) break;
        --ind;
        if (qs[ind] == 177) {
            for (int i = 0; i < n; ++i) {
                cout << s[i] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
    }
    return;
}

int main() {
    int t;
    cin >> t;
    while (t--) solve();
}