#include <bits/stdc++.h>

using namespace std;

const int maxn = 1e5 + 1329;

vector<int> g[maxn];

void solve() {
    int n; cin >> n;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }
    set<pair<int, int>> s;
    vector<int> deg(n, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            deg[i] += 1 - (i == j || r[i] < l[j] || r[j] < l[i]);
        }
        s.emplace(deg[i], i);
    }
    for (int st = 0; st < n / 2; ++st) {
        int i = (*s.begin()).second; s.erase(s.begin());
        for (int j = 0; j < n; ++j) {
            if (i == j || r[i] < l[j] || r[j] < l[i]) continue;
            if (s.count(make_pair(deg[j], j))) {
                s.erase(make_pair(deg[j], j));
                deg[j] -= 1;
                s.emplace(deg[j], j);
            }
        }
    }
    for (auto [d, i] : s) {
        cout << i + 1 << ' ';
    } cout << '\n';
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}