#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<int> p(n);
        for (int i = 0; i < n; ++i) cin >> p[i];
        vector<int> dp(n + 1, 1e9);
        dp[1] = p[0];
        for (int i = 1; i < n; ++i) {
            int x = p[i];
            int l = -1, r = n + 1;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (dp[m] < x) l = m;
                else r = m;
            }
            dp[l+1] = min(dp[l+1], x);
        }
        int ans = 0;
        for (int i = 1; i <= n; ++i){
            if (dp[i] != 1e9) ans = i;
        }
        if (ans >= n - 1){
            cout << n << '\n';
        }else{
            cout << ans + 2 << '\n';
        }
    }
}