#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        if (n <= 16){
            vector<int> p(n);
            int ans = -1e9;
            for (int i = 0; i < n; ++i) cin >> p[i];
            for (int mask = 1; mask < ((1 << n) - 1); ++mask){
                int cur = 2;
                vector<int> q, r;
                for (int i = 0; i < n; ++i){
                    if ((mask & (1 << i)) == 0){
                        q.push_back(p[i]);
                    }else{
                        r.push_back(p[i]);
                    }
                }
                int m = q[0];
                for (int i : q){
                    if (i > m){
                        ++cur;
                        m = i;
                    }
                }

                m = r[0];
                for (int i : r){
                    if (i < m){
                        ++cur;
                        m = i;
                    }
                }
                ans = max(ans, cur);
            }
            cout << ans << '\n';
        }else {
            vector<int> p(n);
            for (int i = 0; i < n; ++i) cin >> p[i];
            vector<int> dp(n + 1, 1e9);
            dp[1] = p[0];
            for (int i = 1; i < n; ++i) {
                int x = p[i];
                int l = -1, r = n + 1;
                while (l + 1 < r) {
                    int m = (l + r) / 2;
                    if (dp[m] < x) l = m;
                    else r = m;
                }
                dp[l + 1] = min(dp[l + 1], x);
            }
            int ans = 0;
            for (int i = 1; i <= n; ++i) {
                if (dp[i] != 1e9) ans = i;
            }
            if (ans >= n - 1) {
                cout << n << '\n';
            } else {
                cout << ans + 2 << '\n';
            }
        }
    }
}