#include <bits\stdc++.h>

using namespace std;
using ll = long long;

vector<pair<pair<int, int>, int>> del(vector<pair<pair<int, int>, int>> &p, int i) {
    vector<pair<pair<int, int>, int>> q;
    for (int j = 0; j < (int) p.size(); ++j) {
        if (i != j) q.push_back(p[j]);
    }
    return q;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first.first >> p[i].first.second;
        p[i].second = i + 1;
    }
    sort(p.begin(), p.end());
    vector<int> result;

    vector<int> dp(n);
    dp[0] = 1;
    for (int i = 1; i < (int) p.size(); ++i) {
        dp[i] = 1;
        for (int j = 0; j < i; ++j) {
            if (p[j].first.second < p[i].first.first) {
                if (dp[i] < dp[j] + 1) {
                    dp[i] = dp[j] + 1;
                }
            }
        }
    }
    int M = 1;
    for (int i = 0; i < n; ++i) {
        M = max(M, dp[i]);
    }

    while ((int) result.size() < n / 2) {
        sort(p.begin(), p.end());
        vector<int> dp((int) p.size());
        vector<int> res((int) p.size(), -1);
        dp[0] = 1;
        for (int i = 1; i < (int) p.size(); ++i) {
            dp[i] = 1;
            for (int j = 0; j < i; ++j) {
                if (p[j].first.second < p[i].first.first) {
                    if (dp[i] < dp[j] + 1) {
                        dp[i] = dp[j] + 1;
                        res[i] = j;
                    }
                }
            }
        }
        int max = 0;
        int ind = 0;
        for (int i = 0; i < (int) p.size(); ++i) {
            if (dp[i] > max) {
                max = dp[i];
                ind = i;
            }
        }
        vector<int> g;
        vector<bool> ans((int) p.size());
        while (res[ind] != -1) {
            g.push_back(ind);
            ans[ind] = true;
            ind = res[ind];
        }
        g.push_back(ind);
        ans[ind] = true;
        int m = (int) g.size();
//        cout << '\n' << '\n';
//        for (auto c : p){
//            cout << c.second << " ";
//        }
//        cout << '\n';
//        for (auto c : g){
//            cout << p[c].second << " ";
//        }
//        cout << '\n';
        if (m > M / 2) {
            result.push_back(p[g[0]].second);
            p = del(p, g[0]);
        } else {
            for (int i = 0; i < (int) p.size(); ++i) {
                if (!ans[i]) {
                    result.push_back(p[i].second);
                    p = del(p, i);
                    break;
                }
            }
        }
    }

    for (auto c : p) cout << c.second << " ";
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}