#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

using ll = long long;

ll n, w, k;
vector<pair<ll, ll>> a;


void solve1() {
	cout << "1 0\n";
}

void solve3 () {
	vector<pair<ll, ll>> t = a;
	sort(t.begin(), t.end());
	pair<ll, ll> answer = { t.back().second - t[0].second + 1, 0 };
	for (int i = 0; i < k - 1; ++i) {
		pair<ll, ll> cur = { w - (t[i + 1].second - t[i].second) + 1, t[i].second };
		answer = min(answer, cur);
	}
	for (int i = 1; i < k; ++i) {
		pair<ll, ll> cur = { t[i - 1].second + (w - t[i].second + 1), w - t[i].second + 1 };
		answer = min(answer, cur);
	}
	cout << answer.first << " " << answer.second << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n >> w >> k;
	a.resize(k);
	for (int i = 0; i < k; ++i) {
		cin >> a[i].first >> a[i].second;
	}
	solve3();
}
