#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll n, q, z;
	cin >> n >> q;
	vector<ll> v(n, 0), ans(q, 0);
	vector<vector<ll>> ask(q, vector<ll>(4));// k, a, b, ind
	for (int i = 0; i < n; i++)
		cin >> v[i];
	sort(v.begin(), v.end());
	ll sp = 100;
	ll maxs = 2 * sp + 11;
	vector<vector<bool>> dp(maxs, vector<bool>(maxs, 0)), dp1;
	dp[0][0] = 1;
	dp1 = dp;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < maxs; j++)
		{
			for (int l = 0; l < maxs; l++)
			{
				if (j + v[i] < maxs && j + l >= v[i]-1)
					dp1[j + v[i]][l] = max(dp[j][l], dp[j + v[i]][l]);
				if (l + v[i] < maxs &&  j + l >= v[i]-1)
					dp1[j][l + v[i]] = max(dp[j][l], dp[j][l + v[i]]);
			}
		}
		dp = dp1;
	}
	cin >> z;
	for (int i = 0; i < q; i++)
	{
		ll k, a, b;
		cin >> k >> a >> b;
		if (a > maxs || b > maxs || !dp[a][b])
			cout << "No\n";
		else
			cout << "Yes\n";
	}
}