#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <random>
#include <chrono>

#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <tuple>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e18);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<ll> p;
ll n, ans;

void fn(const ll i, const ll record, const ll antirecord, const ll sum) {
	if (i == n) {
		ans = max(ans, sum);
		return;
	}
	if (ans >= sum + (n - i))
		return;

	if (p[i] > record)
		fn(i + 1, p[i], antirecord, sum + 1);
	else
		fn(i + 1, record, antirecord, sum);

	if (p[i] < antirecord)
		fn(i + 1, record, p[i], sum + 1);
	else
		fn(i + 1, record, antirecord, sum);
}


void solve(istream& cin, ostream& cout) {
	cin >> n;
	p.resize(n);
	for (auto& t : p)
		cin >> t;
	ans = min(2ll , n);

	fn(0, -INF, INF, 0);

	cout << ans << '\n';
}