#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, q, z;
	cin >> n >> q;
	vector<ll> w(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	cin >> z;
	vector<vector<bool>> dp(n + 1, vector<bool>(1e5 + 1, 0));
	dp[0][0] = 1;
	for (int i = 1; i <= n; ++i) {
		for (int j = 0; j <= 1e5; ++j) {
			dp[i][j] = dp[i - 1][j];
			if (j - w[i - 1] >= 0) {
				dp[i][j] = dp[i - 1][j - w[i - 1]] || dp[i][j];
			}
		}
	}
	for (int i = 1; i <= 1e5; ++i) {
		dp[n][i] = dp[n][i] && dp[n][i - 1];
	}
	while (q--) {
		ll k, a, b;
		cin >> k >> a >> b;
		if (dp[n][a]) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
	return 0;
}