#include <bits/stdc++.h>

using namespace std;

#define fast ios::sync_with_stdio(false);cin.tie(0);
typedef long long ll;

int get_m(vector<pair<int, int>> otr) {
    vector<pair<int, int>> events;
    int n = otr.size();
    vector<int> vx(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        events.push_back({otr[i-1].first, i});
        events.push_back({otr[i-1].second, -i});
    }
    int mx = 0;
    sort(events.begin(), events.end());
    for (auto [x, idx] : events) {
        if (idx < 0) {
            mx = max(vx[-idx], mx);
        } else {
            vx[idx] = mx + 1;
        }
    }
    return *max_element(vx.begin(), vx.end());
}

void sol() {
    int n;
    cin >> n;
    vector<pair<int, int>> otr(n);
    for (int i = 0; i < n; i++) {
        cin >> otr[i].first >> otr[i].second;
    }
    int m0 = get_m(otr);
    for (int mask = 0; mask < (1 << n); mask++) {
        int count = 0;
        vector<pair<int, int>> curr;
        for (int j = 0; j < n; j++) {
            if (mask & (1 << j)) {
                count++;
                curr.push_back(otr[j]);
            }
        }
        if (count != n/2)
            continue;
        if (get_m(curr) == m0/2) {
            get_m(curr);
            for (int j = 0; j < n; j++) {
                if (mask & (1 << j)) {
                    cout << j + 1 << ' ';
                }
            }
            cout << '\n';
            return;
        }
    }
}

int main() {
    fast;
    int t;
    cin >> t;
    while (t--)
        sol();
}
