#include <bits/stdc++.h>

using namespace std;

#define fast ios::sync_with_stdio(false);cin.tie(0);
typedef long long ll;
vector<bool> used;
vector<vector<int>> g;
vector<int> t_s;

struct SegT {

    struct Node {
        int val = 0, idx = -1;
    };

    Node merge(Node a, Node b) {
        if (a.val > b.val)
            return a;
        return b;
    }

    vector<Node> tree;


    SegT (int n) {
        tree.resize(4 * n);
    }

    void set(int i, int l, int r, int qi, int x, int c) {
        if (!(l <= qi && qi < r)) {
            return;
        }
        if (l + 1 == r) {
            if (tree[i].val < x) {
                tree[i] = {max(tree[i].val, x), c};
            }
            return;
        }
        int m = (r + l) / 2;
        set(2 * i + 1, l, m, qi, x, c);
        set(2 * i + 2, m, r, qi, x, c);
        tree[i] = merge(tree[2 * i + 1], tree[2 * i + 2]);
    }

    Node get(int i, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql) {
            return Node();
        }
        if (ql <= l && r <= qr) {
            return tree[i];
        }
        int m = (r + l) / 2;
        return merge(get(2 * i + 1, l, m, ql, qr), get(2 * i + 2, m, r, ql, qr));
    }
};

void top_sort(int v) {
    used[v] = true;
    for (auto u : g[v]) {
        if (!used[u])
            top_sort(u);
    }
    t_s.push_back(v);
}

vector<int> t_s1;
vector<vector<int>> gf;

void top_sort1(int v) {
    used[v] = true;
    for (auto u : gf[v]) {
        if (!used[u])
            top_sort1(u);
    }
    t_s1.push_back(v);
}

bool cmp(pair<int, int> a, pair<int, int> b) {
    return a.second < b.second;
}

bool cmp1(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.second < b.first.second;
}


int get_m(vector<pair<int, int>> otr) {
    g.clear();
    t_s.clear();
    used.clear();
    int n = otr.size();

    g.resize(n);
    used.resize(n);
    {
        vector<pair<int, int>> events;
        for (int i = 0; i< n; i++) {
            for (int j = 0; j < n; j++) {
                if (otr[i].first > otr[j].second) {
                    g[j].push_back(i);
                }
            }
        }
    }

    for (int i = 0; i < n; i++) {
        if (!used[i])
            top_sort(i);
    }
    reverse(t_s.begin(), t_s.end());
    vector<int> dp(n), dp1(n);
    vector<int> p(n, -1);
    for (auto v: t_s) {
        for (auto u: g[v]) {
            if (v != u && dp[v] + 1 > dp[u]) {
                dp[u] = dp[v] + 1;
                p[u] = v;
            }
        }
    }
    return *max_element(dp.begin(), dp.end()) + 1;
}

void sol(vector<pair<int, int>> otr) {
    t_s1.clear();
    t_s.clear();
    gf.clear();
    used.clear();
    g.clear();
    int n = otr.size();
    vector<int> z;
    for (auto [l, r] : otr) {
        z.push_back(l);
        z.push_back(r);
    }
    sort(z.begin(), z.end());
    z.erase(unique(z.begin(), z.end()), z.end());
    for (auto & [l, r] : otr) {
        l = lower_bound(z.begin(), z.end(), l) - z.begin();
        r = lower_bound(z.begin(), z.end(), r) - z.begin();

    }
    map<pair<int, int>, int> cnt;

    used.resize(n);
    g.resize(n);
    gf.resize(n);
    {
        {

        }
        for (int i = 0; i < n; i++) {
            if (!used[i])
                top_sort(i);
        }
        reverse(t_s.begin(), t_s.end());
        vector<int> dp(n), dp1(n);
        vector<int> p(n, -1);
        SegT tr(z.size());
        vector<pair<pair<int, int>, int>> otr1;
        for (int i = 0; i < otr.size(); i++) {
            otr1.push_back({otr[i], i});
        }
        sort(otr.begin(), otr.end(), cmp);
        sort(otr1.begin(), otr1.end(), cmp1);
        for (int v = 0; v < n; v++) {
            auto d = tr.get(0, 0, z.size(), 0, otr[v].first);
            dp[v] = d.val + 1;
            p[v] = d.idx;
            tr.set(0, 0, z.size(), otr[v].second, dp[v], v);
        }
        for (auto & i : dp) i--;

        fill(used.begin(), used.end(), false);
        /*for (int i = 0; i < n; i++) {
            if (!used[i])
                top_sort1(i);
        }
        reverse(t_s1.begin(), t_s1.end());
        for (auto v : t_s1) {
            dp[v] = dp1[v];
            for (auto u : gf[v]) {
                dp1[u] = max(dp1[u], dp1[v]);
            }
        }*/
        vector<bool> bad(n);
        int m0 = *max_element(dp.begin(), dp.end()) + 1;
        if (m0 % 2 != 0) {
            return;
        }
        for (int i = 0; i < n; i++) {
            if (dp[i] + 1 > m0 / 2) {
                bad[i] = true;
            }
        }
        for (int i = 0; i < n; i++) {
            if (dp[i] == m0 / 2 - 1) {
                int st = i;
                vector<int> ans;
                vector<bool> was(n);
                while (st != -1) {
                    was[st] = true;
                    ans.push_back(st);
                    st = p[st];
                }
                for (int j = 0; j < n; j++) {
                    if (ans.size() < n / 2 && !was[j] && !bad[j]) {
                        ans.push_back(j);
                    }
                }
                if (ans.size() == n/2) {
                    for (auto j: ans) cout << otr1[j].second + 1 << ' ';
                    cout << '\n';
                    return;
                }
            }
        }
    }
    {

        t_s1.clear();
        t_s.clear();
        gf.clear();
        used.clear();
        g.clear();
        used.resize(n);
        g.resize(n);
        gf.resize(n);
        {

        }
        for (int i = 0; i < n; i++) {
            if (!used[i])
                top_sort(i);
        }
        reverse(t_s.begin(), t_s.end());
        vector<int> dp(n), dp1(n);
        vector<int> p(n, -1);
        sort(otr.begin(), otr.end(), cmp);
        vector<pair<pair<int, int>, int>> otr1;
        for (int i = 0; i < otr.size(); i++) {
            otr1.push_back({otr[i], i});
        }
        sort(otr1.begin(), otr1.end(), cmp1);
        SegT tr(z.size());
        for (int v = 0; v < n; v++) {
            auto d = tr.get(0, 0, z.size(), otr[v].second + 1, z.size());
            dp[v] = d.val + 1;
            p[v] = d.idx;
            tr.set(0, 0, z.size(), otr[v].first, dp[v], v);
        }
        for (auto & i : dp) i--;

        fill(used.begin(), used.end(), false);
        /*for (int i = 0; i < n; i++) {
            if (!used[i])
                top_sort1(i);
        }
        reverse(t_s1.begin(), t_s1.end());
        for (auto v : t_s1) {
            dp[v] = dp1[v];
            for (auto u : gf[v]) {
                dp1[u] = max(dp1[u], dp1[v]);
            }
        }*/
        vector<bool> bad(n);
        int m0 = *max_element(dp.begin(), dp.end()) + 1;
        if (m0 % 2 != 0) {
            return;
        }
        for (int i = 0; i < n; i++) {
            if (dp[i] + 1 > m0 / 2) {
                bad[i] = true;
            }
        }
        for (int i = 0; i < n; i++) {
            if (dp[i] == m0 / 2 - 1) {
                int st = i;
                vector<int> ans;
                vector<bool> was(n);
                while (st != -1) {
                    was[st] = true;
                    ans.push_back(st);
                    st = p[st];
                }
                for (int j = 0; j < n; j++) {
                    if (ans.size() < n / 2 && !was[j] && !bad[j]) {
                        ans.push_back(j);
                    }
                }

                vector<pair<int, int>> tx;
                for (int j : ans) {
                    tx.push_back(otr[j]);
                }
                for (auto j: ans) cout << otr1[j].second + 1 << ' ';
                cout << '\n';
                return;
            }
        }
    }
}

mt19937 rnd(228);

int main() {
    fast;
    int t;
    cin >> t;
    while (t--) {
        vector<pair<int, int>> otr;
        int n;
        cin >> n;
        for (int i = 0; i< n; i++) {
            int l, r;
            cin >> l >> r;
            otr.push_back({l, r});
        }
        sol(otr);
    }
}