#include <iostream>
#include <vector>
#include <random>
#include <chrono>

using namespace std;
typedef long long ll;
typedef long double ld;

ll INF = 2e18, L_INF = 2e9, mod = 1e9+7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define all(x) x.begin(), x.end()
#define forall(aaa, aaaa) for(auto& aaa: aaaa)

void solve() {
    ll h, w, k;
    cin >> h >> w >> k;
    vector < ll > x(k), y(k);
    for (ll i = 0; i < k; i++) {
        cin >> y[i] >> x[i];
        x[i]--; y[i]--;
    }

    ll resx = INF, cntx = INF;
    for (ll move = 0; move < w; move++) {
        ll mx = 0, mn = w - 1, now;
        forall(i, x) {
            now = i + move;
            if (now >= w) now -= w;
            mx = max(mx, now);
            mn = min(mn, now);
        }
        if (mx - mn + 1 < resx) {
            resx = mx - mn + 1;
            cntx = min(move, w - move);
        }
        else if (mx - mn + 1 == resx) {
            cntx = min(cntx, min(move, w - move));
        }
    }

//    cout << resx << ' ' << cntx << '\n';

    ll resy = INF, cnty = INF;
    for (ll move = 0; move < h; move++) {
        ll mx = 0, mn = h - 1, now;
        forall(i, y) {
            now = i + move;
            if (now >= h) now -= h;
            mx = max(mx, now);
            mn = min(mn, now);
        }
        if (mx - mn + 1 < resy) {
            resy = mx - mn + 1;
            cnty = min(move, h - move);
        }
        else if (mx - mn + 1 == resy) {
            cnty = min(cnty, min(move, h - move));
        }
    }

//    cout << resy << ' ' << cnty << '\n';
    cout << resx * resy << ' ' << cntx + cnty << '\n';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
