#include <bits/stdc++.h>

using namespace std;
#define int long long

const int N = 2 * (int) 1e5 + 10;

vector<int> g[N];
int l[N], r[N], dp[N];
vector<int> a;

pair<int, int> dfs(int v) {
    if ((int) g[v].empty()) {
        a.emplace_back(dp[v]);
        l[v] = (int) a.size() - 1, r[v] = (int) a.size() - 1;
        return {l[v], r[v]};
    }
    for (auto u: g[v])
        dfs(u);
    l[v] = l[g[v][0]];
    r[v] = r[g[v][1]];
    return {l[v], r[v]};
}

void calc(int v, int last) {
    if ((int) g[v].empty())
        return;
    if (last == 1)
        dp[g[v][0]] = dp[v] + 1;
    if (last == 0)
        dp[g[v][1]] = dp[v] + 1;
    calc(g[v][0], 0);
    calc(g[v][1], 1);
}

int t[4 * N];

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = a[tl];
        return;
    }
    int mid = (tl + tr) / 2;
    build(v * 2, tl, mid);
    build(v * 2 + 1, mid + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get_sum(int v, int tl, int tr, int ql, int qr) {
    if (tl > qr || tr < ql)
        return 0;
    if (tl >= ql && tr <= qr)
        return t[v];
    int mid = (tl + tr) / 2;
    return get_sum(v * 2, tl, mid, ql, qr) + get_sum(v * 2 + 1, mid + 1, tr, ql, qr);
}
int k;

int cnt(int v){
    if(g[v].empty())
        return (dp[v] <= k);
    int res = 0;
    for(auto u : g[v])
        res += cnt(u);
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, q;
    cin >> n >> k >> q;
    for(int i = 0; i < n; i++){
        int sz;
        cin >> sz;
        g[i].resize(sz);
        for(int j = 0; j < sz; j++)
            cin >> g[i][j], g[i][j]--;
    }
    dp[0] = 0;
    calc(0, -1);
    while(q--){
        int u;
        cin >> u;
        cout << cnt(u - 1) << "\n";
    }
    return 0;
}