#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

#define int ll

struct Solution {

    Solution() {}

    int n, q;
    int m, x, y;
    vector<vector<int>> g;
    vector<int> koef;
    vector<ll> l, r;
    vector<ll> a;
    vector<ll> qs;
    map<ll, vector<ll>> ans;
    vector<vector<ll>> dp;

    void calc_dp(int v, int p) {
        for (auto u : g[v]) {
            if (u != p) {
                calc_dp(u, v);
            }
        }

        ll sum_0 = 0;
        for (auto u : g[v]) {
            if (u != p) {
                sum_0 += dp[u][0];
            }
        }
        dp[v][1] = sum_0 + a[v];

        ll sum_any = 0;
        for (auto u : g[v]) {
            if (u != p) {
                sum_any += max(dp[u][0], dp[u][1]);
            }
        }
        dp[v][0] = sum_any;
    }

    void operator()() {
        cin >> n >> q;
        cin >> x >> y >> m;

        g.resize(n);
        a.resize(n);
        l.resize(n);
        r.resize(n);
        koef.resize(n);
        dp.resize(n, vector<ll> (2, 0));
        for (int i = 0; i < n - 1; ++i) {
            int v, u;
            cin >> v >> u;
            --v; --u;
            g[v].emplace_back(u);
            g[u].emplace_back(v);
        }
        for (int i = 0; i < n; ++i) {
            cin >> l[i] >> r[i];
        }
        qs.resize(q);
        for (int i = 0; i < q; ++i) {
            cin >> qs[i];
        }

        for (int i = 0; i < n; ++i) {
            a[i] = l[i];
        }
        int val = 0;
        for (int i = 0; i < n; ++i) {
            int cur = ((1LL * x * (i + 1)) + (1LL * a[i] * y)) % m;
            val ^= cur;
        }

        calc_dp(0, -1);
        ll profit = max(dp[0][0], dp[0][1]);
        ans[profit] = a;
        for (auto i : qs) {
            if (ans[i].empty()) {
                cout << -1 << ' ';
            } else {
                cout << val << ' ';
            }
        }
        cout << endl;

        int id;
        while (true) {
            cin >> id;
            if (id == 0) {
                return;
            }
            --id;
            if (ans[qs[id]].empty()) {
                cout << -1;
            } else {
                for (auto el : ans[qs[id]]) {
                    cout << el << ' ';
                }
            }
            cout << endl;
        }
    }
};

int32_t main() {
    int tests = 1;
#ifdef THEEVILBIRD
    freopen("input-d.txt", "r", stdin);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        Solution()();
    }
    return 0;
}
