#include <iostream>
#include "vector"
#include "set"
#include "deque"
#include "unordered_set"
#include "algorithm"

#define int long long
#define all(x) (x).begin(), (x).end()

using namespace std;

void solve1() {
    int n, k; cin >> n >> k;
    vector<bool> used(n + 1, false);
    for (int i = 0; i < k; ++i) {
        int x; cin >> x;
        used[x] = true;
    }
    vector<int> outp;
    for (int i = 1; i <= n; ++i) {
        if (not used[i]) outp.push_back(i);
    }
    for (auto el: outp) {
        cout << el << " ";
    }
    cout << endl;
}

void solve2() {
    int n, k; cin >> n >> k;
    vector<bool> used(n + 1, false);
    for (int i = 0; i < k; ++i) {
        int x; cin >> x;
        used[x] = true;
    }
    vector<int> outp;
    for (int i = 1; i <= n; ++i) {
        if (not used[i]) outp.push_back(i);
    }
    for (auto el: outp) {
        cout << el << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int casee; cin >> casee;
    int test; cin >> test;
    while (test--) {
        if (casee == 1) {
            solve1();
        } else {
            solve2();
        }
    }
}