#include <iostream>
#include <bits/stdc++.h>

#define int long long

using namespace std;
vector <int> a;
int n;


int solve(int ind, int now, int maxp, int minq)
{
    if(ind == n)
        return now;

    int ans = -1;
    // P
    if(maxp > a[ind])
        ans = max(ans, solve(ind + 1, now, maxp, minq));
    else
        ans = max(ans, solve(ind + 1, now + 1, a[ind], minq));

    // Q
    if(minq < a[ind])
        ans = max(ans, solve(ind + 1, now, maxp, minq));
    else
        ans = max(ans, solve(ind + 1, now + 1, maxp, a[ind]));

    return ans;

}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    //a = {1,2,3,4,5,6,7,8};
    //n = a.size();
    while(t--)
    {
        cin >> n;
        a.clear();
        a.resize(n);
        for(int i = 0; i < n; ++i) {
            cin >> a[i];
            --a[i];
        }
        //next_permutation(a.begin(), a.end());

        vector < vector < int > > dp1;
        dp1.clear();
        dp1.resize(n, vector <int> (n, 0));
        vector < vector < int > > dp2;
        dp2.clear();
        dp2.resize(n, vector <int> (n, 0));

        for(int i = 0; i < n; ++i)
        {
            int now = a[i];
            for(int mxp = 0; mxp < n; ++mxp)
            {
                for(int mnq  = 0; mnq < n; ++mnq)
                {
                    if(mxp >= now || mnq <= now)
                        dp2[mxp][mnq] = dp1[mxp][mnq];
                    else
                    {
                        dp2[mxp][mnq] = 0;
                        continue;
                    }

                    if(now <= mxp)
                        dp2[mxp][mnq] = max(dp2[mxp][mnq], dp1[max((int)0, now - 1)][mnq] + 1);
                    if(now >= mnq)
                        dp2[mxp][mnq] = max(dp2[mxp][mnq], dp1[mxp][min(n - 1, now + 1)] + 1);
                }
            }
            //cout << i << "| " << dp2[n - 1][0] << endl;
            swap(dp1, dp2);
        }
        /*if(dp1[n - 1][0] != solve(0,0,0, n))
        {
            for(int x : a)
                cout << x << " ";
            cout << endl;
            cout << dp1[n - 1][0] << " " << solve(0,0,0, n) << endl;
            return 0;
        }*/
        cout << dp1[n - 1][0] << endl; //<< " " << solve(0,0,0,n - 1) << endl;
    }

}
