#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
using ll = long long;

struct qr {

	qr() {}

	qr(ll k, ll a, ll b) : k(k), a(a), b(b) {}

	ll k, a, b;

};

const int MAXQ = 5000;
int n, q;
vector<ll> v;
vector<qr> qrs;

void stupid() {
	for (int id = 0; id < q; id++) {
		int p = qrs[id].k;
		ll A = qrs[id].a, B = qrs[id].b;
		if (p == -1) {
			if (A == 0 && B == 0) cout << "Yes\n";
			else cout << "No\n";
			continue;
		}
		p++;

		set<pair<ll, ll>> can;
		for (int mask = 0; mask < (1 << p); mask++) {
			ll a = 0;
			vector<ll> t;
			for (int i = 0; i < p; i++) {
				if ((mask >> i) & 1) a += v[i];
				else t.push_back(v[i]);
			}

			if (t.empty()) {
				can.insert({a, 0});
				continue;
			}

			for (int mask2 = 0; mask2 < (1 << t.size()); mask2++) {
				ll b = 0;
				for (int i = 0; i < t.size(); i++) {
					if ((mask2 >> i) & 1) b += t[i];
				}
				can.insert({a, b});
			}
		}

		set<pair<ll, ll>> ans;
		for (auto [a, b]: can) {
			if (a == 0 && b == 0) ans.insert({a, b});
			else if (a == 0) {
				if (ans.find({a, b - 1}) != ans.end()) ans.insert({a, b});
			} else if (b == 0) {
				if (ans.find({a - 1, b}) != ans.end()) ans.insert({a, b});
			} else {
				if (ans.find({a, b - 1}) != ans.end() && ans.find({a - 1, b}) != ans.end()) {
					ans.insert({a, b});
				}
			}
		}

		if (ans.find({A, B}) != ans.end()) cout << "Yes\n";
		else cout << "No\n";
	}
}

void solve0() {
	vector<ll> ans(n + 1);
	ans[0] = 0;
	for (int i = 1; i <= n; i++) {
		ll x = v[i - 1];
		if (ans[i - 1] >= x - 1) ans[i] = ans[i - 1] + x;
		else ans[i] = ans[i - 1];
	}
	for (int i = 0; i < q; i++) {
		if (ans[qrs[i].k + 1] >= qrs[i].a) cout << "Yes\n";
		else cout << "No\n";
	}
}

void solve() {
	vector<vector<int>> dp(n + 1, vector<int>(MAXQ + 1, -1));
	dp[0][0] = 0;
	for (int i = 1; i <= n; i++) {
		ll x = v[i - 1];
		for (int a = 0; a <= MAXQ; a++) {
			if (dp[i - 1][a] >= x - 1) dp[i][a] = dp[i - 1][a] + x;
			if (a >= x && dp[i - 1][a - x] != -1) dp[i][a] = max(dp[i][a], dp[i - 1][a - x]);
		}
	}

	for (int id = 0; id < q; id++) {
		int p = qrs[id].k + 1, a = qrs[id].a, b = qrs[id].b;

		if (dp[p][a] >= b) cout << "Yes\n";
		else cout << "No\n";
	}
}

int main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
#endif

	cin >> n >> q;
	v.resize(n);
	for (ll& x : v) cin >> x;
	int Z; cin >> Z;
	sort(all(v));

	bool b0 = true;

	qrs.resize(q);
	for (int i = 0; i < q; i++) {
		cin >> qrs[i].k >> qrs[i].a >> qrs[i].b;
		qrs[i].k = upper_bound(all(v), qrs[i].k) - v.begin() - 1;
		if (qrs[i].b != 0) b0 = false;
	}

	if (b0) solve0();
//	else if (n <= 10 && q <= 10) stupid();
	else solve();

}
