#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <random>
#include <string>
#include <map>
#include <unordered_map>
#include <fstream>
#include <bitset>

using namespace std;

typedef long long ll;

const ll INF = 1e18;


//umap optimizer
//#include <ext/pb_ds/assoc_container.cpp>
//using namespace __gnu_pbds;
//unordered_map gp_hash_table

ll check(vector<pair<ll, ll>>& vec) {
	ll r = INF;
	ll ans = 0;
	for (ll i = vec.size() - 1; i >= 0; i--) {
		if (vec[i].second < r) {
			r = vec[i].first;
			ans++;
		}
	}
	return ans;
}

ll check(multiset<pair<ll, ll>>& vec) {
	ll l = 0;
	ll ans = 0;
	for (auto p : vec) {
		if (p.first > l) {
			l = p.second;
			ans++;
		}
	}
	return ans;
}

vector<ll> get(vector<pair<ll, ll>>& vec) {
	ll r = INF;
	vector<ll> ans;
	for (ll i = vec.size() - 1; i >= 0; i--) {
		if (vec[i].second < r) {
			r = vec[i].first;
			ans.push_back(i);
		}
	}
	return ans;
}

mt19937 rnd;

void RE() {
	ll k = 0;
	ll k2 = 1 / k;
	cout << k2;
}

void TL() {
	for (ll i = 0; i < 1e18; i++) {
		cout << 1;
	}
}

int main() {
	ll t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<pair<pair<ll, ll>, ll>> rvec;
		for (ll i = 0; i < n; i++) {
			ll a, b; cin >> a >> b;
			rvec.push_back({ { a, b }, i });
		}
		sort(rvec.begin(), rvec.end());
		vector<pair<ll, ll>> vec;
		vector<ll> nidsd(n);
		ll ifds = 0;
		for (auto p : rvec) {
			vec.push_back(p.first);
			nidsd[ifds] = p.second;
		    ifds++;
		}
		ll m = check(vec);

		for (ll i = 0; i < 1e7; i++) {
			vector<pair<ll, ll>> v;
			vector<ll> ids;
			ll cnt = 0;
			for (ll j = 0; j < n; j++) {
				if ((i > 1 && rnd() % 2 == 1) || (i == 1 && j < n / 2) || (i == 0 && j >= n / 2)) {
					v.push_back(vec[j]);
					ids.push_back(j);
					cnt++;
					if (cnt == n / 2) break;
				}
			}
			if (cnt != n / 2) continue;
			ll nm = check(v);
			if (nm == m / 2) {
				for (auto p : ids) cout << nidsd[p] + 1 << " "; cout << endl;
				break;
			} else if (nm < m / 2) {
				//RE();
				vector<bool> used(n);
				vector<bool> prime(n);
				vector<ll> can = get(vec);
				for (auto p : ids) used[p] = true;
				for (auto p : can) prime[p] = true;
				multiset<pair<ll, ll>> vv;
				for (auto e : v) vv.insert(e);
				while (true) {
					ll id = 0;
					while (id < ids.size() && prime[ids[id]]) id++;
					ll nid = 0;
					while (nid < can.size() && used[can[nid]]) nid++;
					vv.erase(vv.find(vec[ids[id]]));
					ids[id] = can[nid];
					used[can[nid]] = true;
					vv.insert(vec[ids[id]]);
					ll rnm = check(vv);
					if (rnm == m / 2) break;
				}
				for (auto p : ids) cout << nidsd[p] + 1 << " "; cout << endl;
				break;
			}
		}
	}
}