#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define sz(x) int(size(x))
#define all(x) begin(x), end(x)
using ll = long long;
using vi = vector<int>;
using pii = pair<int, int>;

const int MUL = int(mt19937(42)() % INT_MAX);

int mul(int a, int b, int mod) {
    return 1LL * a * b % mod;
}

int modpow(int b, int e, int mod) {
    int ans = 1;
    while (e > 0) {
        if (e & 1) { ans = mul(ans, b, mod); }
        b = mul(b, b, mod);
        e >>= 1;
    }
    return ans;
}

vi encode(int n, const vi &a) {
    vi ans(sz(a));
    transform(all(a), begin(ans), [&](int x) {
        return n - x + 1;
    });
    return ans;
}

vi decode(int n, const vi &a) {
    return encode(n, a);
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int type;
    cin >> type;

    int q;
    cin >> q;
    while (q--) {
        int n, k;
        cin >> n >> k;

        vi a(k);
        for (auto &el: a) cin >> el;
        for (auto el: (type == 1? encode(n, a): decode(n, a))) {
            cout << el << ' ';
        }
        cout << '\n';
    }
}