#include <bits/stdc++.h>

using namespace std;

#define rep(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define all(x) begin(x), end(x)
#define sz(x) (int)size(x)
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

void solve() {
    int n;
    cin >> n;

    vector<array<int, 3>> segs(n);
    for (int i = 0; auto &[l, r, p]: segs) {
        cin >> l >> r;
        p = i++;
    }

    sort(all(segs), [](const array<int, 3>& a, const array<int, 3>& b) {
        return tuple(a[0], -a[1], a[2]) < tuple(b[0], -b[1], b[2]);
    });

    set<array<int, 3>> small;
    vi safe;
    for (auto [l, r, p]: segs) {
        while (!small.empty() && r <= (*small.rbegin())[1]) {
            safe.push_back((*small.rbegin())[2]);
            small.erase(*small.rbegin());
        }
        small.insert({l, r, p});
    }

    vector<array<int, 3>> small_segs = {all(small)};
    vi ans(n / 2);

    int del = min(sz(small_segs), n / 2);
    rep(i, 0, del) {
        ans[i] = small_segs[i][2];
    }
    rep(i, del, n / 2) {
        ans[i] = safe[i - sz(small_segs) / 2];
    }

    for (auto el: ans) cout << el + 1 << ' ';
    cout << '\n';
}

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}