#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <fstream>

typedef long long ll;
void solve() {
	int n;
	std::cin >> n;
	std::vector<int> a(n);
	for (int& i : a) {
		std::cin >> i;
	}
	int ans = 0;
	for (int mask = 0; mask < (1 << n); ++mask) {
		int p_max = -1, q_min = n + 1, now_ans = 0;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				if (a[i] > p_max) {
					p_max = a[i];
					++now_ans;
				}
			}
			else {
				if (a[i] < q_min) {
					q_min = a[i];
					++now_ans;
				}
			}
		}
		ans = std::max(ans, now_ans);
	}
	std::cout << ans << '\n';
}
int main() {
	int t;
	std::cin >> t;
	while (t--) {
		solve();
	}
}