#include <iostream>
#include <vector>
#include <map>
#include <string>
#include <set>
#include <unordered_map>
#include <fstream>
#include <chrono>
#include <algorithm>
#include <random>

using namespace std;

#define ll long long
#define ld long double
#define pii pair<int, int>
#define int ll

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

vector <vector <int>> g;
vector <int> dp0;
vector <int> dp1;
// vector <int> res0;
// vector <int> res1;
vector <pii> task;
int x, y, m;

void dfs(int v, int p) {
    for (int n: g[v]) {
        if (n != p) {
            dfs(n, v);
            dp0[v] += max(dp0[n], dp1[n]);
            dp1[v] += dp0[n];
        }
    }
    dp1[v] += task[v].first;
}

void solve() {
    int n, q;
    cin >> n >> q;
    dp0.assign(n, 0);
    dp1.assign(n, 0);
    // res0.assign(n, 0);
    // res1.assign(n, 0);
    cin >> x >> y >> m;
    g.assign(n, {});
    int t1, t2;
    for (int i = 1; i < n; i++) {
        cin >> t1 >> t2;
        t1--;
        t2--;
        g[t1].push_back(t2);
        g[t2].push_back(t1);
    }
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i].first >> task[i].second;
    }
    vector <int> ask;
    ask.resize(q);
    for (int i = 0 ; i < q; i++) {
        cin >> ask[i];
    }
    dfs(0, -1);
    int sert = 0;
    for (int i = 0 ; i < n; i++) {
        sert ^= ((x * (i + 1) + y * task[i].first * task[i].first) % m);
    }
    int corr = -1;
    for (int i = 0 ; i < q; i++) {
        if (ask[i] == max(dp0[0], dp1[0])) {
            cout << sert << " ";
            corr = i;
        } else {
            cout << "-1 ";
        }
    }
    cout << endl;
    int t;
    while (true) {
        cin >> t;
        if(t == 0) {
            return;
        }
        t--;
        if (t == corr) {
            for (auto j: task) {
                cout << j.first << " ";
            }
            cout << endl;
        } else {
            cout << "-1" << endl;
        }
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
    #endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}