#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <cmath>
#include <cassert>
#include <fstream>
#include <unordered_map>
#include <random>

using namespace std;

#define re return
#define ll long long
#define fori(n) for(ll i = 0; i < n; ++i)
#define forj(n) for(ll j = 0; j < n; ++j)
#define all(x) x.begin(), x.end()

int _not__lg(ll n) {
	int cnt = 0;
	while (n /= 2)cnt++;
	re cnt;
}

#ifdef LOCAL_BOBER
#define __lg(n) _not__lg(n)
#define ffast_io ios::sync_with_stdio(false);\
				 cout.tie(nullptr);
#define asdasdasd ifstream fl("sample.io")
#define cin fl
#else
#define ffast_io ios::sync_with_stdio(false);\
				  cin.tie(nullptr); cout.tie(nullptr);
#define asdasdasd 42
#endif

template <class T> istream& operator>>(istream& u, vector<T>& v) { for (auto& i : v) u >> i; re u; }
template <class T> T gcd(T a, T b) { if (a == 0) re b; re gcd(b % a, a); }

void solve1(ll n, ll k, vector<ll>& v) {
	cout << v[0] % n + 1 << endl;
}

void unsolve1(ll n, ll k, vector<ll>& v) {
	cout << (v[0] - 2 + n) % n + 1 << endl;
}

void solve2(ll n, ll k, vector<ll>& v) {
	vector<bool> was(n);
	fori(k)
		was[v[i] - 1] = 1;
	fori(n)
		if (!was[i])cout << i + 1 << " ";
	cout << endl;
}

vector<ll> solve3(ll n, ll k, vector<ll>& v) {
	sort(all(v));

	if (v[0] == v[1] - 1) {
		re{ (v[0] + 1) % n + 1, (v[1] + 1) % n + 1 };
	}
	else if (v[0] == 1 && v[1] == n) {
		re{ (v[0] + 1) % n + 1, (v[1] + 1) % n + 1 };
	}else {
		re{ v[0] % n + 1 , v[1] % n + 1 };
	}
}

vector<ll> unsolve3(ll n, ll k, vector<ll> v) {
	sort(all(v));

	if (v[0] == v[1] - 1) {
		re{ (v[0] - 3 + n) % n + 1 , (v[1] - 3 + n) % n + 1 };
	}
	else if (v[0] == 1 && v[1] == n) {
		re{ (v[0] - 3 + n) % n + 1 , (v[1] - 3 + n) % n + 1 };
	}
	else {
		re{ (v[0] - 2 + n) % n + 1 , (v[1] - 2 + n) % n + 1 };
	}
}

void solve4(ll n, ll k, vector<ll>& v) {
	ll m = (1ll << (v[0] - 1)) + (1ll << (v[1] - 1)) + (1ll << (v[2] - 1));

	if (m == 7) cout << 5 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 11) cout << 3 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 13) cout << 2 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 14) cout << 1 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 19) cout << 4 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 21) cout << 2 << ' ' << 4 << ' ' << 7 << endl;
	if (m == 22) cout << 1 << ' ' << 4 << ' ' << 7 << endl;
	if (m == 25) cout << 2 << ' ' << 3 << ' ' << 7 << endl;
	if (m == 26) cout << 1 << ' ' << 3 << ' ' << 7 << endl;
	if (m == 28) cout << 1 << ' ' << 2 << ' ' << 7 << endl;
	if (m == 35) cout << 4 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 37) cout << 2 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 38) cout << 1 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 41) cout << 3 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 42) cout << 1 << ' ' << 3 << ' ' << 5 << endl;
	if (m == 44) cout << 1 << ' ' << 2 << ' ' << 5 << endl;
	if (m == 49) cout << 3 << ' ' << 4 << ' ' << 7 << endl;
	if (m == 50) cout << 1 << ' ' << 3 << ' ' << 4 << endl;
	if (m == 52) cout << 1 << ' ' << 2 << ' ' << 4 << endl;
	if (m == 56) cout << 1 << ' ' << 2 << ' ' << 3 << endl;
	if (m == 67) cout << 4 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 69) cout << 2 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 70) cout << 1 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 73) cout << 3 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 74) cout << 1 << ' ' << 3 << ' ' << 6 << endl;
	if (m == 76) cout << 1 << ' ' << 2 << ' ' << 6 << endl;
	if (m == 81) cout << 3 << ' ' << 4 << ' ' << 6 << endl;
	if (m == 82) cout << 1 << ' ' << 4 << ' ' << 6 << endl;
	if (m == 84) cout << 2 << ' ' << 4 << ' ' << 6 << endl;
	if (m == 88) cout << 2 << ' ' << 3 << ' ' << 6 << endl;
	if (m == 97) cout << 3 << ' ' << 4 << ' ' << 5 << endl;
	if (m == 98) cout << 1 << ' ' << 4 << ' ' << 5 << endl;
	if (m == 100) cout << 2 << ' ' << 4 << ' ' << 5 << endl;
	if (m == 104) cout << 2 << ' ' << 3 << ' ' << 5 << endl;
	if (m == 112) cout << 2 << ' ' << 3 << ' ' << 4 << endl;
}

void unsolve4(ll n, ll k, vector<ll>& v) {
	ll m = (1ll << (v[0] - 1)) + (1ll << (v[1] - 1)) + (1ll << (v[2] - 1));

	if (m == 112) cout << 1 << ' ' << 2 << ' ' << 3 << endl;
	if (m == 100) cout << 1 << ' ' << 2 << ' ' << 4 << endl;
	if (m == 98) cout << 1 << ' ' << 3 << ' ' << 4 << endl;
	if (m == 97) cout << 2 << ' ' << 3 << ' ' << 4 << endl;
	if (m == 104) cout << 1 << ' ' << 2 << ' ' << 5 << endl;
	if (m == 74) cout << 1 << ' ' << 3 << ' ' << 5 << endl;
	if (m == 73) cout << 2 << ' ' << 3 << ' ' << 5 << endl;
	if (m == 70) cout << 1 << ' ' << 4 << ' ' << 5 << endl;
	if (m == 69) cout << 2 << ' ' << 4 << ' ' << 5 << endl;
	if (m == 67) cout << 3 << ' ' << 4 << ' ' << 5 << endl;
	if (m == 88) cout << 1 << ' ' << 2 << ' ' << 6 << endl;
	if (m == 82) cout << 1 << ' ' << 3 << ' ' << 6 << endl;
	if (m == 81) cout << 2 << ' ' << 3 << ' ' << 6 << endl;
	if (m == 84) cout << 1 << ' ' << 4 << ' ' << 6 << endl;
	if (m == 21) cout << 2 << ' ' << 4 << ' ' << 6 << endl;
	if (m == 19) cout << 3 << ' ' << 4 << ' ' << 6 << endl;
	if (m == 76) cout << 1 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 13) cout << 2 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 11) cout << 3 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 7) cout << 4 << ' ' << 5 << ' ' << 6 << endl;
	if (m == 56) cout << 1 << ' ' << 2 << ' ' << 7 << endl;
	if (m == 50) cout << 1 << ' ' << 3 << ' ' << 7 << endl;
	if (m == 49) cout << 2 << ' ' << 3 << ' ' << 7 << endl;
	if (m == 52) cout << 1 << ' ' << 4 << ' ' << 7 << endl;
	if (m == 37) cout << 2 << ' ' << 4 << ' ' << 7 << endl;
	if (m == 35) cout << 3 << ' ' << 4 << ' ' << 7 << endl;
	if (m == 44) cout << 1 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 41) cout << 2 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 42) cout << 3 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 38) cout << 4 << ' ' << 5 << ' ' << 7 << endl;
	if (m == 28) cout << 1 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 25) cout << 2 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 26) cout << 3 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 22) cout << 4 << ' ' << 6 << ' ' << 7 << endl;
	if (m == 14) cout << 5 << ' ' << 6 << ' ' << 7 << endl;
}

int cnt_bit(ll n) {
	ll ans = 0;
	while (n) {
		ans += n % 2;
		n /= 2;
	}
	re ans;
}

string bin(ll n) {
	string s = "";
	fori(7){
		s += to_string(n % 2);
		n /= 2;
	}
	re s;
}

string get_bit(string s) {
	string q = "";
	fori(7) {
		if (s[i] == '1') {
			if (q.size() > 0)q += " << ' ' << ";
			q += to_string(i + 1);
		}
	}
	re q;
}

void solve5(ll n, ll k, vector<ll>& v) {
	fori(k)
		cout << v[i] + 1 << " ";
	cout << endl;
}

void unsolve5(ll n, ll k, vector<ll>& v) {
	fori(k)
		cout << v[i] - 1 << ' ';
	cout << endl;
}

void solve6(ll n, ll k, vector<ll>& v) {
	assert(1 == 0);
	//ll rz = v.back() - v[0] + 1;
	//fori(k)
	//	cout << (v[i] + rz - 1) % n + 1 << ' ';
	//cout << endl;
}

void unsolve6(ll n, ll k, vector<ll>& v) {
	assert(1 == 0);
	/*sort(all(v));
	ll rz = v.back() - v[0] + 1;
	for (int i = 1; i < k; i++) {
		rz = min(v[i - 1] + n - v[i] + 1, rz);
	}

	vector<ll> ans;
	fori(k)
		ans.push_back((v[i] - rz - 1 + n) % n + 1);

	sort(all(ans));
	for (auto i : ans)cout << i << " ";
	cout << endl;*/
}

int main() {
	ffast_io; asdasdasd;

	int a; cin >> a;
	if (a == 1) {
		int t; cin >> t;
		while (t--) {
			int n, k; cin >> n >> k;
			vector<ll> v(k);
			cin >> v;

			bool ok = (v.back() < n);
			for (int i = 1; i < k; i++) {
				if (v[i] - v[i - 1] < 2)ok = false;
			}

			if (k == 1)solve1(n, k, v);
			else if (k * 2 == n)solve2(n, k, v);
			else if (k == 2) {
				vector<ll> tv = solve3(n, k, v);
				sort(all(tv));
				cout << tv[0] << " " << tv[1] << endl;
			}
			else if (n <= 7)solve4(n, k, v);
			if((v.back() - v[0] + 1)* 2 <= n)solve6(n, k, v);
			else solve5(n, k, v);
		}
	}
	else {
		int t; cin >> t;
		while (t--) {
			int n, k; cin >> n >> k;
			vector<ll> v(k);
			cin >> v;

			bool ok = (v[0] > 1);
			for (int i = 1; i < k; i++) {
				if (v[i] - v[i - 1] < 2)ok = false;
			}

			ll rz = v.back() - v[0] + 1;
			for (int i = 1; i < k; i++) {
				rz = min(v[i - 1] + n - v[i] + 1, rz);
			}

			if (k == 1)unsolve1(n, k, v);
			else if (k * 2 == n)solve2(n, k, v);
			else if (k == 2) {
				vector<ll> tv = unsolve3(n, k, v);
				sort(all(tv));
				cout << tv[0] << " " << tv[1] << endl;
			}
			else if (n <= 7)unsolve4(n, k, v);
			else if (rz * 2 <= n)unsolve6(n, k, v);
			else unsolve5(n, k, v);
		}
	}
}