#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

#define re return
#define ll long long
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define all(x) x.begin(), x.end()

template<class T> istream& operator>>(istream& u, vector<T>& v) { for (auto& i : v) u >> i; re u; }
template<class T, class U> istream& operator>>(istream& u, pair<T, U>& v) { re u >> v.first >> v.second; }

struct info {
	ll l, r, i;
};

void solve1(ll n, ll m, vector<info>& v) {
	fori(n / 2) cout << i + 1 << " ";
	cout << endl;
}

vector<info>& tv;
bool ok = false;
void rec(ll pos, ll m, ll mx, ll st, vector<info>& v) {
	if (st == 0) {
		ll q = 0;
		ll prev = -1e9;
		fori(tv.size()) {
			if (tv[i].l > prev) {
				prev = tv[i].r;
				q++;
			}
		}

		if (q * 2 == m) {
			fori(tv.size()) {
				cout << tv[i].i + 1 << " ";
			}
			cout << "\n";
			ok = true;
		}
	}

	tv.push_back(v[pos]);
	rec(pos + 1, m, mx, st - 1, v);
	tv.pop_back();

	if (st == mx - pos || ok) re;

	rec(pos + 1, m, mx, st, v);
}

void solve2(ll n, ll m, vector<info>& v) {
	ok = false;
	rec(0, m, n, n / 2, v)
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<info> v(n);
		fori(n) {
			cin >> v[i].l >> v[i].r;
			v[i].i = i;
		}
		cin >> v;
		sort(all(v), [](info& a, info& b) {
			re a.r < b.r;
		});

		ll m = 0;
		ll prev = -1e9;
		fori(n) {
			if (v[i].l > prev) {
				prev = v[i].r;
				m++;
			}
		}

		if (m == n)solve1(n, m, v);
		else if (n <= 30)solve2(n, m, v);
	}
}