#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const ll N = 5005;
const ll INF = 1e18;

void solve() {
    ll n, q; cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(w.begin(), w.end());
    ll z; cin >> z;

    vector<vector<ll>> dp(n + 1, vector<ll> (N, -INF));
    dp[0][0] = 0;
    for (int i = 1; i <= n; i++) {
        for (int a = 0; a < N; a++) {
            dp[i][a] = dp[i - 1][a];
            if (a >= w[i - 1]) {
                dp[i][a] = max(dp[i][a], dp[i - 1][a - w[i - 1]]);
            }
            if (1 + dp[i - 1][a] >= w[i - 1]) {
                dp[i][a] = max(dp[i][a], dp[i - 1][a] + w[i - 1]);
            }
            //cout << i << " " << a << "   " << dp[i][a] << '\n';
        }
    }
    vector<vector<ll>> pref(n + 1, vector<ll> (N, 0));
    for (int i = 1; i <= n; i++) {
        pref[i][0] = dp[i][0];
        for (int a = 1; a < N; a++) {
            pref[i][a] = min(pref[i][a - 1], dp[i][a]);
            // cout << i << " " << a << "  " << pref[i][a] << '\n';
        }
    }

    while (q--) {
        ll k, a, b; cin >> k >> a >> b;
        if (k < w[0]) {
            cout << "No" << '\n';
            continue;
        }
        ll idx = upper_bound(w.begin(), w.end(), k) - w.begin() - 1;
        if (pref[idx + 1][a] >= b) {
            cout << "Yes" << '\n';
        } else {
            cout << "No" << '\n';
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    solve();
}
