#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
using namespace std;
using ll = int64_t;
const int N = 2e5;
vector<int> g[N];
ll dp[N][2], val[N];
void calc(int v, int p) {
    ll sm1 = 0, sm2 = val[v];
    for (int to : g[v]) if (to != p) {
        calc(to, p);
        sm1 += max(dp[to][0], dp[to][1]);
        sm2 += dp[to][0];
    }
    dp[v][0] = sm1, dp[v][1] = sm2;
}
void tokarenko_trick() {
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; ++i) g[i].clear();
    ll x, y, m, k = 0;
    cin >> x >> y >> m;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].emplace_back(b);
        g[b].emplace_back(a);
    }
    for (int i = 0; i < n; ++i) {
        cin >> val[i] >> val[i];
        k ^= (x * i + x + y * val[i] % m * val[i]) % m;
    }
    calc(0, 0);
    ll ans = max(dp[0][0], dp[0][1]);
    ll out[q];
    for (int i = 0; i < q; ++i) {
        ll v;
        cin >> v;
        if (v == ans) {
            cout << (out[i] = k) << endl;
        } else {
            cout << (out[i] = -1) << endl;
        }
    }
    while (true) {
        int i;
        cin >> i;
        if (i == 0) break;
        if (out[i] == -1) {
            cout << -1 << endl;
        } else {
            for (int i = 0; i < n; ++i) cout << val[i] << ' ';
            cout << endl;
        }
    }
}


signed main() {
    int tt = 1;
    cin >> tt;
    while (tt--) tokarenko_trick();
    return 0;
}