#include <bits/stdc++.h>
using namespace std;

struct Query {
    long long k, a, b;
    int idx;
    Query() {}
    Query(long long _k, long long _a, long long _b, int _idx) {
        k = _k, a = _a, b = _b, idx = _idx;
    }
    bool operator<(const Query& other) const {
        return k < other.k;
    }
    ~Query() {}
};

void solve() {
    int n, qNum;
    cin >> n >> qNum;
    vector<long long> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int useless;
    cin >> useless;
    sort(w.begin(), w.end());
    vector<Query> q(qNum);
    for (int i = 0; i < qNum; ++i) {
        cin >> q[i].k >> q[i].a >> q[i].b;
        q[i].idx = i;
    }
    sort(q.begin(), q.end());
    vector<char> ans(qNum, false);
    long long pref = 0;
    int last = 0;
    bool stop = false;
    for (const auto& [k, a, b, idx] : q) {
        while (!stop && last < n && w[last] <= k) {
            if (w[last] <= pref + 1) {
                pref += w[last];
            } else {
                stop = true;
                break;
            }
            ++last;
        }
        if (a <= pref) {
            ans[idx] = true;
        }
    }
    for (int i = 0; i < qNum; ++i) {
        if (ans[i]) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
