#include <iostream>
#include <iomanip>
#include <cmath>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <ctime>
#include <random>
#include <map>
#include <set>

using namespace std;

typedef long long ll;

mt19937 gen(time(0));

ll Cnt(ll x) {
	ll ans = 0;
	while (x != 0) {
		ans += (x % 2);
		x /= 2;
	}
	return ans;
}

void f() { // next
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	ll cnt = 0, next = 0;
	for (ll i = 0; i < k; i++) {
		cin >> a[i];
		cnt += (1ll << a[i]);
	}
	sort(a.begin(), a.end());
	while (next < (1ll << n) && !((next & cnt) == 0 && Cnt(next) != k)) {
		next++;
	}
	if (next == (1ll << n)) {
		next = (1ll << k) - 1;
	}
	for (ll i = 0; i < n; i++) {
		if (next & (1ll << i)) {
			cout << i + 1 << " ";
		}
	}
	cout << endl;
}

void g() { // prev
	ll n, k;
	cin >> n >> k;
	vector<ll> a(k);
	ll cnt = 0, prev = 0;
	for (ll i = 0; i < k; i++) {
		cin >> a[i];
		cnt += (1ll << a[i]);
	}
	sort(a.begin(), a.end());
	while (prev > 0 && !((prev & cnt) == 0 && Cnt(prev) != k)) {
		prev--;
	}
	if (prev == 0) {
		prev = (((1ll << k) - 1) << (n - k));
	}
	for (ll i = 0; i < n; i++) {
		if (prev & (1ll << i)) {
			cout << i + 1 << " ";
		}
	}
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	ll t, ttt;
	cin >> ttt >> t;
	if (ttt == 1) {
		while (t--) {
			f();
		}
	}
	else {
		while (t--) {
			g();
		}
	}
}