#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define pb push_back

vector<vector<int>> adj;
vector<int> p;

int get_root(int v) {
    if (p[v] == -1)
        return v;
    return get_root(p[v]);
}

vector<int> dp;
int n, k, q;
int dfs(int v, int cnt=0, int lr=-1) {
    if (cnt > k)
        return 0;
    if (adj[v].size() == 0) {
        return dp[v] = 1;
    }

    if (lr == 1) {
        dp[v] += dfs(adj[v][0], cnt + 1, 0);
    } else {
        dp[v] += dfs(adj[v][0], cnt, 0);
    }
    if (lr == 0) {
        dp[v] += dfs(adj[v][1], cnt + 1, 1);
    } else {
        dp[v] += dfs(adj[v][1], cnt, 1);
    }
    return dp[v];
}

int main() {
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);

    cin >> n >> k >> q;
    adj.resize(n);
    p.resize(n, -1);
    int root = 0;
    for (int i = 0; i < n; ++i) {
        int t; cin >> t;
        if (t == 2) {
            int l, r;
            cin >> l >> r;
            --l, --r;
            p[l] = i;
            p[r] = i;
            adj[i].pb(l);
            adj[i].pb(r);
        } else {
            root = i;
        }
    }
    root = 0;

//    cout << root << endl;
    dp.resize(n, 0);
    dfs(root);

//    for (int i = 0; i < n; ++i)
//        cout << dp[i] << ' ';

    while (q--) {
        int u; cin >> u; --u;
        cout << dp[u] << endl;
    }


    return 0;
}
