#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
using ll = long long;
using ld = long double;
#define ff first
#define ss second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define forn(i, n) for (int i = 0; i < (int)n; i++)

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

const int INFi = 1e9;
const ll INFl = 1e18;
#define int long long

void solve();

int tp;
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/roi/Desktop/kek/read.txt", "r", stdin);
#endif
    int tc = 1;
    cin >> tc;
    forn(i, tc) {
        solve();
    }
    return 0;
}

struct seg {
    int n;
    vector<int> tr;
    seg(int _n) {
        n = _n;
        tr.resize(4 * n, -INFl);
    }

    seg() = default;

    void upd(int x, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            inmax(tr[x], val);
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) {
            upd(2 * x + 1, l, m, pos, val);
        } else {
            upd(2 * x + 2, m, r, pos, val);
        }
        tr[x] = max(tr[2 * x + 1], tr[2 * x + 2]);
    }

    void upd(int pos, int val) {
        upd(0, 0, n, pos, val);
    }

    int get(int x, int l, int r, int ql, int qr) {
        if (qr <= l || r <= ql || qr <= ql)
            return -INFl;
        if (ql <= l && r <= qr) {
            return tr[x];
        }
        int m = (l + r) / 2;
        return max(get(2 * x + 1, l, m, ql, qr), get(2 * x + 2, m, r, ql, qr));
    }

    int get(int ql, int qr) {
        return get(0, 0, n, ql, qr);
    }
};

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    forn(i, n) cin >> a[i];
    vector<vector<int>> dp(n + 2, vector<int> (n + 2, -INFl));
    vector<seg> x(n + 2);
    vector<seg> y(n + 2);
    forn(i, n + 2) {
        x[i] = seg(n + 2);
        y[i] = seg(n + 2);
    }
    auto upd = [&](int dx, int dy, int val) {
        inmax(dp[dx][dy], val);
        x[dx].upd(dy, dp[dx][dy]);
        y[dy].upd(dx, dp[dx][dy]);
    };
    upd(0, n + 1, 0);
    forn(i, n) {
        for (int j = 0; j <= n + 1; ++j) {
            inmax(dp[a[i]][j], y[j].get(0, a[i]) + 1);
        }
        for (int j = 0; j <= n + 1; ++j) {
            inmax(dp[j][a[i]], x[j].get(a[i] + 1, n + 2) + 1);
        }
        for (int j = 0; j <= n + 1; ++j) {
            upd(a[i], j, dp[a[i]][j]);
            upd(j, a[i], dp[j][a[i]]);
        }
    }
    int ans = -INFl;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j)
            inmax(ans, dp[i][j]);
    }
    cout << ans << '\n';
}