#include <iostream>
#include<cmath>
#include<algorithm>
#include<string>
#include<random>
#include<vector>

using namespace std;

vector<int> nvp(vector<int>& v)
{
	vector<int> v1;
	vector<int> v2;
	vector<int> v3;

	int ans = 0;

	int it = 0;

	while (it < v.size())
	{
		v2.clear();
		v3.clear();

		while (it < v.size() && (v2.empty() || v2.back() < v[it]))
		{
			v2.push_back(v[it]);
			++it;
		}
		
		for (int i = 0; i < v2.size(); ++i)
		{
			if (ans < lower_bound(v1.begin(), v1.end(), v2[i]) - v1.begin() + v2.size() - i)
			{
				ans = lower_bound(v1.begin(), v1.end(), v2[i]) - v1.begin() + v2.size() - i;
				v3 = v2;
				reverse(v3.begin(), v3.end());
				v3.resize(v2.size() - i);
				reverse(v3.begin(), v3.end());
			}
		}

		if(!v3.empty())
			v1.resize(lower_bound(v1.begin(), v1.end(), v3[0]) - v1.begin());

		for (int i = 0; i < v3.size(); ++i)
		{
			v1.push_back(v3[i]);
		}

	}

	return v1;
}

int main()
{
	int t;

	cin >> t;

	for (int q = 0; q < t; ++q)
	{
		int n;
		cin >> n;
		vector<int> v(n);

		for (int i = 0; i < n; ++i)
		{
			cin >> v[i];
		}

		vector<int> g;

		g = nvp(v);


		cout << min((int)g.size() + 1, n) << '\n';


	}

}