#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#define INF 1e9


int n, k, q;

vector<vector<int>> gr;

vector<int> p;
vector<int> ans;

vector<int> napr;

void bfs(int v, int par)
{
	if (v != 0)
	{
		if (par == 0)
		{
			p[v] = 0;
		}
		else {
			if (napr[par] != napr[v])
			{
				p[v] = p[par] + 1;
			}
			else {
				p[v] = p[par];
			}
		}
	}

	for (auto u : gr[v])
	{
		if (u != par)
		{
			bfs(u, v);
		}
	}
}

void bfs2(int v, int par)
{
	if (gr[v].size() == 0 && p[v] <= k)
	{
		ans[v] = 1;
	}
	for (auto u : gr[v])
	{
		if (u != par)
		{
			bfs2(u, par);
			ans[v] += ans[u];
		}
	}
}

int main()
{
	

	cin >> n >> k >> q;

	gr.resize(n);
	p.resize(n, 0);
	ans.resize(n, 0);
	napr.resize(n, 0);

	for (int i = 0; i < n; ++i)
	{

		int t;
		cin >> t;
		if (t != 0)
		{
			int l, r;
			cin >> l >> r;
			--l;
			--r;
			napr[l] = -1;
			napr[r] = 1;
			gr[i].push_back(l);
			gr[i].push_back(r);
		}
	}

	bfs(0, 0);
	bfs2(0, 0);

	//for (int i = 0; i < n; ++i)
	//{
	//	cout << p[i] << " ";
	//}
	//cout << '\n';

	for (int i = 0; i < q; ++i)
	{
		int buf;
		cin >> buf;
		--buf;
		cout << ans[buf] << '\n';
	}



}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
