#include <bits/stdc++.h>

#define ll long long
using namespace std;
#pragma optimize GCC ("Ofast", "avx2")
const size_t nMax = 2e5 + 228;

void precalc() {

}

vector<int> g[nMax];
vector<tuple<int, int, int>> ev;
set<int> av;
bool printed[nMax];
int leftT;
int leftM;

void dfs(int v) {
    if (g[v].empty()) {
        if (leftM == leftT&&leftM) {
            cout << get<2>(ev[v]) << ' ';
            leftT--;
            leftM--;
        } else if (leftM < leftT) {
            if (!av.empty()) {
                cout << get<2>(ev[v]) << ' ';
                cout << get<2>(ev[*av.begin()]) << ' ';
                av.erase(av.begin());
                leftT -= 2;
                leftM--;
            }
        } else if(leftM>leftT)
            assert(0);
        return;
    }
    if(v!=0)
    av.insert(v);
    for (auto u: g[v]) {
        dfs(u);
    }
    if (av.count(v) && leftT > leftM) {
        leftT--;
        cout << get<2>(ev[v]) << ' ';
    }
    av.erase(v);
}

int getM(vector<tuple<int, int, int>> ev) {
    sort(ev.begin(), ev.end(),
         [](auto a, auto b) { return get<1>(a) < get<1>(b); });
    int m = 0;
    int minR = 0;
    for (auto [l, r, id]: ev) {
        if (l > minR) {
            m++;
            minR = r;
        }
    }
    return m;
}

void solve() {
    int n;
    cin >> n;
    ev.clear();
    ev.resize(n);
    int j = 1;
    for (auto &[l, r, i]: ev) {
        cin >> l >> r;
        i = j++;
    }
    auto m = getM(ev);
    ev.emplace_back(INT_MIN, INT_MAX, 0);
    sort(ev.begin(), ev.end(),
         [](auto a, auto b) {
             return get<0>(a) < get<0>(b) ||
                    get<0>(a) == get<0>(b) &&
                    get<1>(a) > get<1>(b);
         });
    vector<int> st = {0};
    for (int i = 1; i < ev.size(); i++) {
        while (get<0>(ev[i]) > get<1>(ev[st.back()]))
            st.pop_back();
        g[st.back()].push_back(i);
        st.push_back(i);
    }
    memset(printed, 0, sizeof printed);
    leftT = n / 2;
    leftM = m / 2;
    dfs(0);
}

int main() {
#ifdef VNT
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    precalc();
    int q = 1;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
        cout << endl;
    }
    return 0;
}
