#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;
const long long INF=(long long)(1e9+7);

int h,w,k;
map <pair<int,int>,int> table;

vector <int> Sr,Sc;
vector <int> isK;
int main() {
    cin >> h >> w >> k;
    Sr.push_back(0);
    Sc.push_back(0);
    int II=0;
    for (int i=0;i<k;i++) {
        int r,c;
        cin >> r >> c;
        Sr.push_back(--r);
        Sc.push_back(--c);
        II=r;
        Sc.push_back(c+1);
        Sc.push_back(c-1);
        Sc.push_back(c+w);
        Sc.push_back(c-w+1);
        Sc.push_back(c+w+1);
        Sc.push_back(c-w);
        table[{r,c}]=i+1;
    }
    isK.resize(k+1,0);

    sort(Sr.begin(),Sr.end());
    Sr.resize(unique(Sr.begin(),Sr.end())-Sr.begin());
    sort(Sc.begin(),Sc.end());
    Sc.resize(unique(Sc.begin(),Sc.end())-Sc.begin());

    long long minAns=INF*INF;
    long long secAns=-1;
    int sj=-1;
    int nowA=0;
    for (int j=0;j<Sc.size();j++) {
        if (Sc[j]>=0 && Sc[j]<w) {
            if (sj==-1) {
                sj=j;
                if (table[{II,Sc[sj]%w}]!=0 && (++isK[table[{II,Sc[sj]%w}]])==1) nowA++;
            }
            while (sj<Sc.size()-1 && nowA!=k) {
                sj++;
                if (table[{II,Sc[sj]%w}]!=0 && (++isK[table[{II,Sc[sj]%w}]])==1) nowA++;
            }
            if (nowA==k) {
                long long newAns=Sc[sj]-Sc[j]+1;
                long long newsecAns=min(Sc[j],w-Sc[j]);
                if (Sc[sj]<w) newsecAns=0;
                if (newAns<minAns) {
                    minAns=newAns;
                    secAns=newsecAns;
                } else if (newAns==minAns) {
                    secAns=min(secAns,newsecAns);
                }
            }

            if (table[{II,Sc[j]%w}]!=0 && (--isK[table[{II,Sc[j]%w}]])==0) nowA--;
        }
    }
    cout << minAns << " " << secAns << "\n";
}
