#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <math.h>

using namespace std;

#define int long long
#define endl '\n'
#define all(v) v.begin(), v.end()
using ll = long long;
using ld = long double;

mt19937 rnd(777);

const int N = 1e6 + 9;
const ll INF = 1e18 + 9;

int dp[N][2];
int l[N], r[N];

vector<int> g[N];

void dfs(int v, int p) {
	dp[v][0] = 0;
	dp[v][1] = r[v];
	for (auto u : g[v]) {
		if (u == p)
			continue;
		dfs(u, v);
		dp[v][0] += dp[u][1];
		dp[v][1] += dp[u][0];
	}
	dp[v][1] = max(dp[v][1], dp[v][0]);
}

int k[N];

void solve() {
	int n, q;
	cin >> n >> q;

	for (int i = 0; i <= n; i++) {
		g[i].clear();
	}
	int x, y, m;
	cin >> x >> y >> m;
	for (int i = 0; i < n - 1; i++) {
		int v, u;
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	int k0 = 0;
	int f = 1;
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
		if (l[i] != r[i])
			f = 0;
		k0 ^= (i * x + y * r[i] * r[i]) % m;
	}
	dfs(1, 0);

	if (f) {
		for (int i = 1; i <= q; i++) {
			int v;
			cin >> v;
			if (v != dp[1][1])
				k[i] = -1;
			else
				k[i] = k0;
			cout << k[i] << " ";
		}
		cout << endl;
		while (true) {
			int i;
			cin >> i;
			if (!i)
				break;
			if (k[i] == -1) {
				cout << -1 << endl;
			}
			else {
				for (int i = 1; i <= n; i++)
					cout << r[i] << " ";
				cout << endl;
			}

		}
		return;
	}



}


signed main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//cin.tie(0);
	//ios_base::sync_with_stdio(0);
#endif

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}