// 11b top
//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;
//#define int long long
const long long MX = 1e9;
vector<int> a;

int countMX(int pos, int x) {
    int ans = 0, pr = -1;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] > x)
            continue;
        if (pr < a[i]) {
            ans++;
            pr = a[i];
        }
    }
    return ans;
}

int countMN(int pos, int x) {
    int ans = 0, pr = (int) a.size() + 1;
    for (int i = 1; i <= pos; ++i) {
        if (a[i] < x)
            continue;
        if (pr > a[i]) {
            ans++;
            pr = a[i];
        }
    }
    return ans;
}

vector<int> nvp, obrnvp;

int getmx_obrnvp(int pos, int x) {
    int ans = 0;
    for (int i = pos; i < (int) a.size(); ++i) {
        if (a[i] <= x)
            ans = max(ans, obrnvp[i]);
    }
    return ans;
}

int getmx_nvp(int pos, int x) {
    int ans = 0;
    for (int i = pos; i < (int) a.size(); ++i) {
        if (a[i] >= x)
            ans = max(ans, nvp[i]);
    }
    return ans;
}

int solve(int n, vector<int> b) {
    a.clear();
    a = b;
    vector<int> my_back(b.size());
    for (int i = 0; i <= n; ++i) {
        my_back[a[i]] = i;
    }
    int ans = 0;
    bool fl1 = 1, fl2 = 1;
    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i + 1])
            fl1 = 0;
        if (a[i] < a[i + 1])
            fl2 = 0;
    }
    if (fl1 || fl2) {
//        cout << n << "\n";
        return n;
    }
    if (a.back() == n) {
        ans = max(ans, countMX(n, n) + 1);
    }
    if (a.back() == 1) {
        ans = max(ans, countMN(n, 1) + 1);
    }
    nvp.clear();
    nvp.resize(n + 1);
    obrnvp.clear();
    obrnvp.resize(n + 1);
    vector<int> dp(n + 1, MX);
    dp[0] = -MX;
    for (int i = n; i >= 1; --i) {
        int x = lower_bound(dp.begin(), dp.end(), a[i]) - dp.begin();
        dp[x] = a[i];
        obrnvp[i] = x;
    }
    dp.clear();
    dp.resize(n + 1, MX);
    dp[0] = -MX;
    for (int i = n; i >= 1; --i) {
        int x = lower_bound(dp.begin(), dp.end(), -a[i]) - dp.begin();
        dp[x] = -a[i];
        nvp[i] = x;
    }
    if(n > 10000) {
        return nvp[1];
    }
    vector<int> rem_count_mx(n + 1, 0);
    for (int i = 0; i <= n; ++i)
        rem_count_mx[i] = countMX(i, a[i]);
    vector<int> rem_count_mn(n + 1, 0);
    for (int i = 0; i <= n; ++i)
        rem_count_mn[i] = countMN(i, a[i]);
    vector<int> help_nvp(n + 2), help_obr_nvp(n + 2);
    for (int i = 1; i < n; ++i) {
        {
            int mn = (int) a.size() + 1, pos1 = 0;
            int j = 0;
            for (j = 1; j <= i - 1; ++j) {
                if (a[j] >= a[i] + 1 && mn > a[j]) {
                    mn = a[j];
                    pos1 = j;
                }
            }
            int pr = -1;
            vector<int> id;
            int prrrr = max(a[i], a[pos1] - 1);
            for (j = 1; j <= i; ++j) {
                if (a[j] > prrrr)
                    continue;
                if (pr < a[j]) {
                    pr = a[j];
                    id.push_back(j);
                }
            }
            for(j = n; j>=0;--j){
                help_nvp[j] = 0;
                if(j < n)
                    help_nvp[j] = help_nvp[j + 1];
                if(a[j] >= a[i] + 1)
                    help_nvp[j] = max(help_nvp[j], nvp[j]);
                help_obr_nvp[j] = 0;
                if(j < n)
                    help_obr_nvp[j] = help_obr_nvp[j + 1];
                if(a[j] <= a[i] - 1)
                    help_obr_nvp[j] = max(help_obr_nvp[j], obrnvp[j]);
            }
            prrrr++;
            for (j = i + 1; j <= n; ++j) {
                if (a[j - 1] >= a[i] + 1 && mn > a[j - 1]) {
                    mn = a[j - 1];
                    pos1 = j - 1;
                }
                for (; prrrr <= max(a[i], a[pos1] - 1); ++prrrr) {
                    int posss = my_back[prrrr];
                    while (!id.empty() && id.back() > posss)
                        id.pop_back();
                    if (posss <= i)
                        id.push_back(posss);
                }
                if (a[j] < a[i]) {
                    int t1 = rem_count_mn[pos1];
                    int t2 = id.size();
                    ans = max(ans, t1 + t2 + help_nvp[j + 1] + obrnvp[j]);
                }
            }
        }
        {
            int j = 0;
            int mx = 0, pos1 = 0;
            for (j = 1; j <= i - 1; ++j) {
                if (a[j] <= a[i] - 1 && mx < a[j]) {
                    mx = a[j];
                    pos1 = j;
                }
            }
            int pr = (int) a.size() + 1, prrrr = a[pos1] + 1;
            vector<int> id;
            for (j = 1; j <= i; ++j) {
                if (a[j] < prrrr)
                    continue;
                if (pr > a[j]) {
                    pr = a[j];
                    id.push_back(j);
                }
            }
            prrrr--;
            for (j = i + 1; j <= n; ++j) {
                if (a[j - 1] <= a[i] - 1 && mx < a[j - 1]) {
                    mx = a[j - 1];
                    pos1 = j - 1;
                }
                for (; prrrr >= a[pos1] + 1; --prrrr) {
                    int posss = my_back[prrrr];
                    while (!id.empty() && id.back() > posss)
                        id.pop_back();
                    if (posss <= i)
                        id.push_back(posss);
                }
                if (a[j] > a[i]) {
                    int t1 = rem_count_mx[pos1];
                    int t2 = id.size();
                    ans = max(ans, t1 + t2 + help_obr_nvp[j + 1] + nvp[j]);
                }
            }
        }
    }
    return ans;
}

int solvestupid(int n, vector<int> b) {
    a.clear();
    a = b;
    unordered_map<long long, int> pr_dp;
    pr_dp[0] = 0;
    for (int i = 1; i <= n; ++i) {
        unordered_map<long long, int> dp;
        for (auto [v, ans]: pr_dp) {
            int pos_mx = v / MX;
            int pos_mn = v % MX;
            if (a[i] > a[pos_mx] || pos_mx == 0) {
                dp[i * MX + pos_mn] = max(dp[i * MX + pos_mn], ans + 1);
            } else {
                dp[pos_mx * MX + pos_mn] = ans;
            }
            if (a[i] < a[pos_mn] || pos_mn == 0) {
                dp[pos_mx * MX + i] = max(dp[pos_mx * MX + i], ans + 1);
            } else {
                dp[pos_mx * MX + pos_mn] = ans;
            }
        }
        pr_dp = move(dp);
    }
    int mx = 0;
    for (auto [v, ans]: pr_dp) {
        int pos_mx = v / MX, pos_mn = v % MX;
        if (pos_mx && pos_mn)
            mx = max(mx, ans);
    }
    return mx;
}

random_device rd;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
//        n = rd() % 5 + 2;
        vector<int> b(n + 1, 0);
        for(int i = 1;i<=n;++i)
            cin >> b[i];
        cout << solve(n, b) << "\n";
        continue;
        for (int i = 1; i <= n; ++i)
            b[i] = i;
        shuffle(b.begin() + 1, b.end(), rd);
        int rr = solvestupid(n, b);
        int ll = solve(n, b);
        if (ll != rr) {

            int r = solvestupid(n, b);
            int l = solve(n, b);
            cout << n << endl;
            for (int i = 1; i <= n; ++i)
                cout << b[i] << " ";
            break;
        }
        cout << "--------------------" << endl;
    }
}