#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll MAXA = 300;

void solve() {
	int n, q;
	cin >> n >> q;

	vector <ll> w(n);
	for (ll &x: w)
		cin >> x;

	ll z;
	cin >> z;

	ll v = 0;
	for (int i = 1; i <= q; i++) {
		ll j, c, d;
		cin >> j >> c >> d;

		ll k = j - v * z;
		ll a = c - v * z;
		ll b = d - v * z;

		set <pair <int, int>> seen;
		for (int mask1 = 0; mask1 < (1 << n); mask1++) {
			for (int mask2 = 0; mask2 < (1 << n); mask2++) {
				if (mask1 & mask2)
					continue;

				ll x = 0, y = 0;
				for (int j = 0; j < n; j++) {
					if (w[j] > k)
						continue;

					if (mask1 & (1 << j)) {
						x += w[j];
					} else if (mask2 & (1 << j)) {
						y += w[j];
					}
				}

				if (x <= a && y <= b) {
					seen.insert({x, y});
				}
			}
		}
		
		ll expected = (a + 1) * (b + 1);
		if (seen.size() != expected) {
			cout << "No\n";
		} else {
			cout << "Yes\n";
		}
	}

}

signed main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);

	solve();
}