#include <bits/stdc++.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define all(v) (v).begin(), (v).end()
#define fi first
#define se second
#define int long long

using namespace std;
using ll = long long;
using pii = pair <int, int>;

void dfs(int v, vector < vector <int> >& g, vector <int>& a, vector < vector <int> >& dp, int p = -1){
    dp[v][1] = a[v];
    for(auto u : g[v]){
        if(u == p){ continue;}
        dfs(u, g, a, dp, v);
        dp[v][1] += dp[u][0];
        dp[v][0] += max(dp[u][0], dp[u][1]);
    }
    return;
}

void solve(){
    int n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    vector < vector <int> > g(n);
    for(int i = 0; i < n; ++i){
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
        g[u].push_back(v);
    }
    vector <int> a(n);
    for(auto&w : a){
        cin >> w;
    }
    for(auto&w : a){
        cin >> w;
    }
    vector <int> v(q);
    for(auto& w : v){
        cin >> w;
    }

    vector < vector <int> > dp(n, vector <int>(2, 0));

    dfs(0, g, a, dp);

    int mx = max(dp[0][0], dp[0][1]);

    ll ans = 0;
    for(int i = 0; i < n; ++i){
        ans = (ans ^ (((x * (i + 1ll))%m + (y * (a[i] * a[i])%m)%m)%m));
    }

    for(auto w : v){
        if(w == mx){
            cout << ans << endl;
        }
        else{
            cout << -1 << endl;
        }
    }
    int i = 1;
    while(cin >> i){
        if(i == 0){
            //cout << endl;
            break;
        }
        --i;
        if(v[i] == mx){
            cout << -1 << endl;
        }
        else{
            for(auto w : a){
                cout << w << ' ';
            }
            cout << endl;
        }
    }
    //cout << endl;
    return;
}

signed main(){
    ibase;
    int t;
    cin >> t;
    while(t --> 0){
        solve();
    }
}
/**
1
6
1 6
1 3
1 3
4 6
1 2
4 5

**/

