#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int inf = 1e9;

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 2, vector<int> (2, -inf)));
    int ans = 0;
    dp[0][0][0] = 0;
    dp[0][n + 1][1] = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n + 1; j++) {
            int mx = max(j, p[i - 1]);
            int mn = min(j, p[i - 1]);

            // upd max
            if (j < p[i - 1]) {
                dp[i][mx][0] = max(dp[i - 1][j][0] + 1, dp[i][mx][0]);
            } else {
                dp[i][j][0] = max(dp[i - 1][j][0], dp[i][j][0]);
            }
            // upd min
            if (j > p[i - 1]) {
                dp[i][mn][1] = max(dp[i - 1][j][1] + 1, dp[i][mn][1]);
            } else {
                dp[i][j][1] = max(dp[i - 1][j][1], dp[i][j][1]);
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 0; j <= n + 1; j++) {
            for (int k = 0; k < 2; k++) {
                ans = max(ans, dp[i][j][k]);
            }
        }
    }
    cout << ans << '\n';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) solve();
}
