#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int maxa = 301;

int dp[maxa][maxa][maxa];

void solve() {
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        if (w[i] >= (ll)maxa) {
            w[i] = 0;
        }
    }
    sort(w.begin(), w.end());
    dp[0][0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int sum1 = 0; sum1 < maxa; sum1++) {
            for (int sum2 = 0; sum2 < maxa; sum2++) {
                dp[i][sum1][sum2] = dp[i - 1][sum1][sum2];
                if (sum1 >= w[i - 1]) {
                    dp[i][sum1][sum2] |= dp[i - 1][sum1 - w[i - 1]][sum2];
                }
                if (sum2 >= w[i - 1]) {
                    dp[i][sum1][sum2] |= dp[i - 1][sum1][sum2 - w[i - 1]];
                }
            }
        }
    }
    //cout << "kek\n";
    int z;
    cin >> z;
    for (int i = 0; i < q; i++) {
        int k, a, b;
        cin >> k >> a >> b;
        k = upper_bound(w.begin(), w.end(), (ll)k) - w.begin();
        //cout << k << ' ' << a << ' ' << b << '\n';
        bool res = true;
        for (int a1 = 0; a1 <= a; a1++) {
            for (int b1 = 0; b1 <= b; b1++) {
                if (!dp[k][a1][b1]) res = false;
            }
        }
        if (res) {
            cout << "Yes\n";
        } else {
            cout << "No\n";
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    t = 1;
    for (int i = 0; i < t; i++) solve();
}
