#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define ff first
#define sc second
#define all(a) (a).begin(), (a).end()

vector<vector<int>> genc(int n, int k) {
    if (k == 0) return {{0}};
    if (k == n) {
        vector<vector<int>> ans = {{0}};
        f (i, 1, n + 1) ans[0].push_back(i);
        return ans;
    }
    vector<vector<int>> ans;
    for (int last = k; last <= n; last++) {
        auto res = genc(last - 1, k - 1);
        for (auto &u : res) {
            u.push_back(last);
            ans.push_back(u);
        }
    }
    return ans;
}

int mex(vector<int> &a) {
    vector<int> used(a.size(), 0);
    f (i, 0, a.size()) {
        if (a[i] < a.size()) used[a[i]] = 1;
    }
    f (i, 0, a.size()) {
        if (!used[i]) return i;
    }
    return a.size();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int mod; cin >> mod;
    int tt; cin >> tt;
    while (tt--) {
        int k, n, p; cin >> k >> n >> p;
        auto result = genc((1 << k) - 1, n - 1);
        set<vector<int>> win, lose, used;
        int ans = 0;
        for (int i = 0; i < result.size(); i++) {
            int was_mex = -1;
            vector<int> nw = result[i];
            vector<vector<int>> path;
            int nw_mex = mex(nw);
            while (used.find(nw) == used.end() && nw_mex != was_mex) {
                path.push_back(nw);
                used.insert(nw);
                for (int j = 0; j < nw.size(); j++) {
                    nw[j] = (nw[j] ^ (nw_mex - 1));
                }
                sort(all(nw));
                was_mex = nw_mex;
                nw_mex = mex(nw);
            }
            if (nw_mex == was_mex) {
                //ans += (nw_mex == p ? path.size()  : 0);
                for (auto &u : path) {
                    if (nw_mex == p) win.insert(u);
                    else lose.insert(u);
                }
            } else {
                auto wit = win.find(nw), lit = lose.find(nw);
                if (wit == win.end() && lit == lose.end()) {
                    for (auto &u : path) {
                        lose.insert(u);
                    }
                } else if (wit != win.end()) {
                    for (auto &u : path) {
                        win.insert(u);
                    }
                } else {
                    for (auto &u : path) {
                        lose.insert(u);
                    }
                }
            }
        }
        cout << win.size() << '\n';
    }

    return 0;
}