// 7f priv
// vot by prizera

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) (a).begin(), (a).end()
#define sz(a) (int) a.size()
#define f(i, l, r) for (int i = (l); i < (r); i++)
#define pb push_back
#define sc second
#define ff first
#define pii pair<int, int>
#define int long long

mt19937 rnd(time(NULL));

void solve() {
    int n, q; cin >> n >> q;
    vector<int> a(n);
    for (auto &u : a) cin >> u;
    int z; cin >> z;
    vector<int> costs(n, 0);
    for (int i = 0; i < n; i++) {
        costs[i] = (ll)rnd() % 1000000000000;
    }

    vector<int> dp(5001, -1);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        vector<int> dp2 = dp;
        for (int j = 0; j <= 5000; j++) {
            if (j + a[i] <= 5000 && dp[j] > -1 && (dp[j + a[i]] == -1 || dp[j + a[i]] > dp[j] + costs[i])) {
                dp2[j + a[i]] = dp[j] + costs[i];
            }
        }
        swap(dp2, dp);
    }

    vector<vector<bool>> can(5001, vector<bool>(5001, 0));
    can[0][0] = true;
    for (int i = 1; i <= 5000; i++) {
        can[i][0] = (dp[i] > -1);
        can[0][i] = can[i][0];
    }
    for (int i = 1; i <= 5000; i++) {
        for (int j = 1; j <= 5000; j++) {
            can[i][j] = (can[i][j - 1] && can[i - 1][j] && (dp[i + j] > -1 && dp[i] > -1 && dp[j] > -1 && dp[i + j] == dp[i] + dp[j]));
        }
    }

    while (q--) {
        int k, A, B; cin >> k >> A >> B;
        cout << (can[A][B] ? "Yes" : "No") << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}