#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int mod;
const int mod1 = 998244353;
const int p = 31;
vector<unordered_map<ll, int> > used;
vector<ll> p_pow;
int first_time = 0, t = 0;

set<int> ss;

int mex(vector<int> &a) {
    for (auto x : a) {
        ss.erase(x);
    }
    int ans = *ss.begin();
    for (auto x : a) {
        ss.insert(x);
    }
    return ans;
}

ll get_hash(vector<int> &a) {
    ll ans = 0;
    for (int i = 0; i < a.size(); i++) {
        ans += p_pow[a[i]];
    }
    return ans;
}

bool check(vector<int> &a, int p, int prev) {
    if (t >= 1000) {
        return 0;
    }
    int m = mex(a);
    if (m != prev) {
        first_time = t;
    }
    ll hash = get_hash(a);
    if (used[m][hash]) {
        if (first_time <= used[m][hash] && m == p) {
            return 1;
        } else {
            return 0;
        }
    }
    used[m][hash] = t;
    t++;
    for (int i = 0; i < a.size(); i++) {
        a[i] ^= (m - 1);
    }
    return check(a, p, m);
}

void solve() {
    int k, n, p;
    cin >> k >> n >> p;
    k = (1 << k);
    int ans = 0;
    p_pow.resize(k + 3);
    used.resize(k + 2);
    p_pow[0] = 1;
    for (int i = 1; i <= k + 2; i++) {
        p_pow[i] = p_pow[i - 1] * p;
        p_pow[i] %= mod1;
    }
    for (int i = 0; i <= k; i++) {
        ss.insert(i);
    }
    for (int i = 1; i < (1 << k); i += 2) {
        vector<int> a;
        for (int j = 0; j < k; j++) {
            if ((1 << j) & i) {
                a.push_back(j);
            }
        }
        if (a.size() != n) continue;
        if (check(a, p, -1)) {
            ans++;
        }
        t = 0, first_time = 0;
        for (int i = 0; i < used.size(); i++) {
            used[i].clear();
        }
    }
    cout << ans << endl;
}

int main() {
    cin >> mod;
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
