#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

vector<int> l, r, val;

void dfs(int v, int k, int prev) {
    if (l[v] == -1) {
        val[v] = 1;
        return;
    }
    if (prev == -1) {
        dfs(l[v], k, 0);
        dfs(r[v], k, 1);
    } else if (k == 0) {
        if (prev == 0) {
            dfs(l[v], k, 0);
        } else {
            dfs(r[v], k, 1);
        }
    } else {
        if (prev == 0) {
            dfs(l[v], k, 0);
            dfs(r[v], k - 1, 1);
        } else {
            dfs(r[v], k, 1);
            dfs(l[v], k - 1, 0);
        }
    }
    val[v] = val[l[v]] + val[r[v]];
}

int main() {
    int n, k, q;
    cin >> n >> k >> q;
    l.resize(n, -1), r.resize(n, -1), val.resize(n);
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 2) {
            int a, b;
            cin >> a >> b;
            a--, b--;
            l[i] = a, r[i] = b;
        }
    }
    dfs(0, k, -1);
    for (int i = 0; i < q; i++) {
        int v;
        cin >> v;
        v--;
        cout << val[v] << endl;
    }
    return 0;
}
