//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4.1")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;
using ll = long long;

void solve();


signed main(){
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int n;
    cin >> n;
    int q;
    cin >> q;
    vector<ll> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    int maxa = 100000;
    int maxb = 0;
    vector<vector<bool>> dp(maxa + 1, vector<bool>(maxb + 1, false));
    dp[0][0] = true;
    for (int i = 0; i < n; ++i) {
        for (int a_ = maxa; a_ >= 0; --a_){
            for (int b_ = maxb; b_ >= 0; --b_) {
                if (a_ >= v[i]){
                    dp[a_][b_] = dp[a_][b_] || dp[a_ - v[i]][b_];
                }
                if (b_ >= v[i]){
                    dp[a_][b_] = dp[a_][b_] || dp[a_][b_ - v[i]];
                }
            }
        }
    }
//    for (int i = 0; i <= maxa; ++i) {
//        for (int j = 0; j <= maxb; ++j) {
//            cout << dp[i][j] << ' ';
//        }
//        cout << endl;
//    }
    for (int i = 0; i <= maxa; ++i) {
        for (int j = 0; j <= maxb; ++j) {
            if (i > 0){
                dp[i][j] = dp[i][j] && dp[i - 1][j];
            }
            if (j > 0){
                dp[i][j] = dp[i][j] && dp[i][j - 1];
            }
        }
    }
//    cout << endl << endl;
//    for (int i = 0; i <= maxa; ++i) {
//        for (int j = 0; j <= maxb; ++j) {
//            cout << dp[i][j] << ' ';
//        }
//        cout << endl;
//    }
    int z;
    cin >> z;
    for (int i = 0; i < q; ++i) {
        ll k, a, b;
        cin >> k >> a >> b;

        if (dp[a][b]){
            cout << "Yes" << '\n';
        } else{
            cout << "No" << '\n';
        }
    }
    cout << endl;
}
