#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long
#define int ll

using namespace std;

const int N = 2e5 + 10;
vector<int>a[N];
int c[N];
bool used[N];
int cnt[N];

void dfs(int v) {
	used[v] = 1;
	for (auto to : a[v]) {
		if (!used[to]) {
			if (c[v] == c[to] || c[v] == -1) {
				cnt[to] = cnt[v];
			}
			else {
				cnt[to] = cnt[v] + 1;
			}
			dfs(to);
		}
	}
}

bool can[N];
bool used1[N];
int ans[N];

void dfs1(int v) {
	used1[v] = 1;
	if (can[v] == 1) {
		ans[v] = 1;
	}
	for (auto to : a[v]) {
		if (!used1[to]) {
			dfs1(to);
			ans[v] += ans[to];
		}
	}
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--) {
		int n;
		cin >> n;
		vector<pair<int, int>>a(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i].first >> a[i].second;
		}
		for (int i = 0; i < n / 2; ++i) {
			cout << i + 1 << ' ';
		}
		cout << '\n';
	}
}
