#pragma GCC optimize("O3")
#pragma GCC optimize("avx2")
#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.begin(), x.end()
typedef long long ll;

struct Seg {
    ll l, r, id;
    Seg(ll l, ll r, ll id) : l(l), r(r), id(id) {}
    Seg() {}
};

bool comp(Seg a, Seg b) {
    return a.r < b.r;
}

ll mx(vector<Seg> a) {
    ll n = a.size();
    vector<ll> t(n), r(n);
    for (ll i = 0; i < n; i++) r[i] = a[i].r;
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        ll it = lower_bound(all(r), a[i].l) - r.begin() - 1;
        if (it >= 0) t[i] = t[it] + 1;
        if (i > 0) t[i] = max(t[i], t[i - 1]);
        ans = max(ans, t[i]);
    }
    return ans;
}

signed main() {
    ll tt; cin >> tt;
    while (tt--) {
        ll n; cin >> n;
        vector<Seg> a(n), b;
        for (ll i = 0; i < n; i++) {
            cin >> a[i].l >> a[i].r;
            a[i].id = i;
        }
        sort(all(a), comp);

        ll t1 = 1;
        for (ll i = 1; i < n; i++) {
            if (a[i].l <= a[i - 1].r) {
                t1 = 0;
                break;
            }
        }

        if (n <= 30) {
            ll m = mx(a);
            for (ll mask = 0; mask < (1 << n); mask++) {
                b.assign(0, Seg());
                ll cnt = 0;
                for (ll pos = 0; pos < n; pos++) {
                    if ((mask >> pos) & 1) {
                        b.pb(a[pos]);
                        cnt++;
                    }
                }
                if (cnt != n / 2) continue;
                if (mx(b) == m / 2) {
                    for (ll pos = 0; pos < n; pos++) {
                        if ((mask >> pos) & 1) {
                            cout << a[pos].id + 1 << " ";
                        }
                    }
                    break;
                }
            }
        } else if (t1 == 1) {
            for (ll i = 0; i < n / 2; i++) cout << i + 1 << " ";
        } else {

        }
        cout << "\n";
    }
    return 0;
}
