#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<vector<int>> g;
vector<pair<int, int>> diret;
vector<int> sz;
vector<int> cnt;

vector<map<int, int>> dp;

int k;

void dfs0(int v, int p = -1, int dir = -1, int kek = 0) {
    cnt[v] = kek;
    int f = diret[v].first;
    int s = diret[v].second;
    if (f == -1) {
        sz[v] = 1;
        return;
    }
    if (dir == -1) {
        dfs0(f, v, 0, kek);
        dfs0(s, v, 1, kek);
    }
    else if (dir == 0) {
        dfs0(f, v, 0, kek);
        dfs0(s, v, 1, kek + 1);
    } else {
        dfs0(f, v, 0, kek + 1);
        dfs0(s, v, 1, kek);
    }
    sz[v] += sz[f];
    sz[v] += sz[s];
}
vector<int> answ;

pair<int, int> fg(int v, int p = -1, int dir = -1, int kek = 0) {
    cnt[v] = kek;
    int f = diret[v].first;
    int s = diret[v].second;
    if (f == -1) {
        dp.emplace_back();
        if (kek < k)
            dp[(int) dp.size() - 1][kek] = 1;
        sz[v] = 1;
        answ[v] = (kek < k);
        return {(int) dp.size() - 1, kek < k};
    }
    if (dir == -1) {
        pair<int, int> le = fg(f, v, 0, kek);
        pair<int, int> ri = fg(s, v, 1, kek);
        int posl = le.first;
        int posr = ri.first;
        int a = le.second + ri.second;
        answ[v] = a;
        if (dp[posl].size() >= dp[posr].size()) {
            for (auto el : dp[posr]) {
                dp[posl][el.first] += el.second;
            }
            return {posl, le.second + ri.second};
        } else {

            for (auto el : dp[posl]) {
                dp[posr][el.first] += el.second;
            }
            return {posr, le.second + ri.second};
        }
    }
    else if (dir == 0) {
        pair<int, int> le = fg(f, v, 0, kek);
        pair<int, int> ri = fg(s, v, 1, kek + 1);
        int posl = le.first;
        int posr = ri.first;
        int a = le.second + ri.second;
        answ[v] = a;
        if (dp[posl].size() >= dp[posr].size()) {
            for (auto el : dp[posr]) {
                dp[posl][el.first] += el.second;
            }
            return {posl, le.second + ri.second};
        } else {
            for (auto el : dp[posl]) {
                dp[posr][el.first] += el.second;
            }
            return {posr, le.second + ri.second};
        }
    } else {
        pair<int, int> le = fg(f, v, 0, kek + 1);
        pair<int, int > ri = fg(s, v, 1, kek);
        int posl = le.first;
        int posr = ri.first;
        int a = le.second + ri.second;
        answ[v] = a;
        if (dp[posl].size() >= dp[posr].size()) {
            for (auto el : dp[posr]) {
                dp[posl][el.first] += el.second;
            }
            return {posl, le.second + ri.second};
        } else {
            for (auto el : dp[posl]) {
                dp[posr][el.first] += el.second;
            }
            return {posr, le.second + ri.second};
        }
    }
}


signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, q;
    cin >> n >> k >> q;
    g.resize(n);
    sz.resize(n);
    cnt.resize(n);
    answ.resize(n);
    diret.resize(n, {-1, -1});
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        if (t == 2) {
            int a, b;
            cin >> a >> b;
            a--; b--;
            g[i].push_back(a);
            g[a].push_back(i);
            g[i].push_back(b);
            g[b].push_back(i);
            diret[i] = {a, b};
        }
    }
    k++;
    fg(0);
    while (q--) {
        int v;
        cin >> v;
        v--;
        cout << answ[v] << "\n";
    }
    return 0;

}
