#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

struct seg {
    int l, r, id;
};

bool operator<(const seg &a, const seg &b) {
    if (a.r == b.r)
        return a.l > b.l;
    return a.r < b.r;
}

bool in(const seg& a, const seg& b) {
    return a.l >= b.l && a.r <= b.r;
}

int n1, m1;
vector <vector <int>> g;
vector <bool> used;

void dfs(int v) {
    cout << v << " " << n1 << " " << m1 << endl;
    if (n1 == 0 && m1 == 0)
        return;
    if (g[v].empty()) {
        if (m1 != 0) {
            used[v] = true;
            m1--;
        } else if (n1 != 0) {
            used[v] = true;
            n1--;
        }
        return;
    }
    if (n1 != 0) {
        used[v] = true;
        n1--;
    }
    for (auto to: g[v])
        dfs(to);
    if (n1 != 0 && !used[v]) {
        used[v] = true;
        n1--;
    }
}

void solve() {
    int n;
    cin >> n;
    vector <seg> a(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        a[i] = {l, r, i};
    }
    sort(all(a));
    int m = 0;
    int last = 0;
    for (auto el: a) {
        if (el.l > last) {
            last = el.r;
            m++;
        }
    }
    n1=  n / 2, m1 = m / 2;
    vector <seg> ans;
    for (auto cur: a) {
        vector <seg> tmp = ans;
        if (ans.size() == n1)
            tmp.pop_back();
        tmp.push_back(cur);
        int m2 = 0;
        last = 0;
        for (auto el: tmp) {
            if (el.l > last) {
                last = el.r;
                m2++;
            }
        }
        if (m2 > m1) continue;
        else if (ans.size() < n1) {
            ans = tmp;
        }
        else if (m2 == m1) {
            for (auto el: ans)
                cout << el.id + 1 << " ";
            cout << "\n";
            return;
        }
        else
            ans = tmp;
    }
    for (auto el: ans)
        cout << el.id + 1 << " ";
    cout << "\n";
}

int main() {
    int t;
    cin >> t;
    while (t--)
        solve();
}
