#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(a) a.begin(), a.end()

const int SZ = 300;

int main() {
    int n, q;
    cin >> n >> q;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    int z;
    cin >> z;
    vector <vector <vector <bool>>> dp(n + 1, vector <vector <bool>>(SZ + 1, vector<bool>(SZ + 1)));
    dp[0][0][0] = true;
    for (int k = 1; k <= n; ++k) {
        for (int i = 0; i <= SZ; ++i) {
            for (int j = 0; j <= SZ; ++j) {
                //cout << k << " " << i << " " << j << endl;
                dp[k][i][j] = dp[k - 1][i][j];
                if (i >= w[k - 1])
                    dp[k][i][j] = dp[k][i][j] || dp[k - 1][i - w[k - 1]][j];
                if (j >= w[k - 1])
                    dp[k][i][j] = dp[k][i][j] || dp[k - 1][i][j - w[k - 1]];
            }
        }
    }
    vector <vector <bool>> can(SZ + 1, vector <bool>(SZ + 1));
    for (int i = 0; i <= SZ; ++i) {
        for (int j = 0; j <= SZ; ++j) {
            can[i][j] = dp[n][i][j];
            if (i > 0)
                can[i][j] = can[i][j] && can[i - 1][j];
            if (j > 0)
                can[i][j] = can[i][j] && can[i][j - 1];
        }
    }
    for (int i = 0; i < q; ++i) {
        int k, a, b;
        cin >> k >> a >> b;
        if (can[a][b])
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}
