#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 1e18;

int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    set<tuple<ll, ll, ll>> sh, sw;
    ll h, w, k;
    cin >> h >> w >> k;
    sh.insert({0, h, h});
    sw.insert({0, w, w});

    for (ll i = 0; i < k; ++i) {
        ll x, y;
        cin >> x >> y;
        x--, y--;
        if (!sh.empty()) {
            auto it = sh.lower_bound({x + 1, 0, 0});
            if (it != sh.begin()) {
                it--;
                auto [l, r, sz] = *it;
                if (l <= x && x < r) {
                    sh.erase(it);
                    if (x - l > 0) sh.insert({l, x, x - l});
                    if (r - x - 1 > 0) sh.insert({x + 1, r, r - x - 1});
                }
            }
        }

        if (!sw.empty()) {
            auto it2 = sw.lower_bound({y + 1, 0, 0});
            if (it2 != sw.begin()) {
                it2--;
                auto [l2, r2, sz2] = *it2;
                if (l2 <= y && y < r2) {
                    sw.erase(it2);
                    if (y - l2 > 0) sw.insert({l2, y, y - l2});
                    if (r2 - y - 1 > 0) sw.insert({y + 1, r2, r2 - y - 1});
                }
            }
        }
    }



    ll besth = 0;
    ll beststeph = 0;
    for (auto [l, r, sz] : sh) {
//        cerr << l << " " << r << " " << sz << "\n";
        ll step = min(l, h - r);
        if (sz > besth || (sz == besth && step < beststeph)) {
            besth = sz;
            beststeph = step;
        }
    }
    if (!sh.empty()) {
        auto hfirst = *sh.begin();
        auto hlast = *(--sh.end());
        if (hfirst != hlast && get<0>(hfirst) == 0 && get<1>(hlast) == h) {
            if (get<2>(hfirst) + get<2>(hlast) >= besth) {
                besth = get<2>(hfirst) + get<2>(hlast);
                beststeph = 0;
            }
        }
    }
//    cerr << "\n";

    ll bestw = 0;
    ll beststepw = 0;
    for (auto [l, r, sz] : sw) {
//        cerr << l << " " << r << " " << sz << "\n";
        ll step = min(l, w - r);
        if (sz > bestw || (sz == bestw && step < beststepw)) {
            bestw = sz;
            beststepw = step;
        }
    }

    if (!sw.empty()) {
        auto wfirst = *sw.begin();
        auto wlast = *(--sw.end());
        if (wfirst != wlast && get<0>(wfirst) == 0 && get<1>(wlast) == w) {
            if (get<2>(wfirst) + get<2>(wlast) >= bestw) {
                bestw = get<2>(wfirst) + get<2>(wlast);
                beststepw = 0;
            }
        }
    }
//    cerr << "\n";
//    cerr << besth << " " << beststeph << "\n";
//    cerr << bestw << " " << beststepw << "\n";
    cout << (h - besth) * (w - bestw) << " " << beststeph + beststepw << "\n";


    return 0;
}
