#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 1e18;

vector<ll> q, r;
vector<ll> a;
ll n;
ll ans = 0;

void count() {
    ll mx = -INF;
    ll mn = INF;
    ll cnt = 0;
    for (ll i = 0; i < q.size(); ++i) {
        if (q[i] > mx) {
            cnt++;
            mx = q[i];
        }
    }
    for (ll i = 0; i < r.size(); ++i) {
        if (r[i] < mn) {
            cnt++;
            mn = r[i];
        }
    }
    ans = max(ans, cnt);
}

void rec(int k) {
    if (k == n) {
        count();
        return;
    }
    q.push_back(a[k]);
    rec(k + 1);
    q.pop_back();
    r.push_back(a[k]);
    rec(k + 1);
    r.pop_back();
}


int main() {
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t;
    cin >> t;
    while (t--) {
        cin >> n;
        a.resize(n);
        for (ll i = 0; i < n; ++i) {
            cin >> a[i];
        }
        ans = 0;
        rec(0);
        cout << ans << "\n";
    }


    return 0;
}