#include <bits/stdc++.h>
#define FOR_(i, s, n) for(int i = s; i < n; ++i)
#define FOR(i, n) FOR_(i, 0, n)
#define FORR(x, a) for(auto &x : a)
#define IN(a) FORR(x, a) cin >> x;
#define OUT(a) FORR(x, a) cout << x << " "; cout << "\n";
#define FAST ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

using namespace std;
using ll = long long;

const int N = 105, M = 100005, NSLOW = 59049;
int can[N][M];

void slow(int n, int q, int z){
    ll w[n], v = 0;
    IN(w);
    sort(w, w + n);
    cin >> z;
    set<pair<ll, ll>> vp[n + 1];
    FOR(cnt, n + 1){
        FOR(i, NSLOW){
            ll a = 0, b = 0, ii = i;
            FOR(j, cnt){
                int t = ii % 3;
                ii /= 3;
                if (t == 0) a += w[j];
                if (t == 1) b += w[j];
            }
            vp[cnt].insert({a, b});
        }
    }
    FOR(qq, q){
        ll j, c, d;
        cin >> j >> c >> d;
        ll k = j - v * z, a = c - v * z, b = d - v * z;
        if (a > NSLOW || b > NSLOW) { cout << "No\n"; continue; }
        int pos = upper_bound(w, w + n, k) - w;
        if (pos == n + 1) --pos;
        bool good = true;
        FOR(i, a + 1){
            if (!good) break;
            FOR(j, b + 1){
                good &= (vp[pos].count({i, j}) == 1);
                if (!good) break;
            }
        }
        cout << (good ? "Yes\n" : "No\n");
        if (good) v += qq + 1;
    }
}


int main(){
    FAST
    int n, q, z;
    cin >> n >> q;
    if (n <= 10 && q <= 10){ slow(n, q, z); return 0; }
    ll w[n], v = 0;
    IN(w);
    sort(w, w + n);
    cin >> z;
    can[0][0] = 1;
    FOR(cnt, n){
        ll wi = w[cnt];
        FOR(i, N) if (can[cnt][i]) {
            can[cnt + 1][i] = 1;
            if (i + wi < N) can[cnt + 1][i + wi] = 1;
        }
    }
    FOR(cnt, n + 1){
        FOR_(i, 1, N) can[cnt][i] += can[cnt][i - 1];
    }
    FOR(qq, q){
        ll j, c, d;
        cin >> j >> c >> d;
        ll k = j - v * z, a = c - v * z, b = d - v * z;
        int pos = upper_bound(w, w + n, k) - w;
        if (pos == n + 1) --pos;
        bool good = (a + 1 == can[pos][a]);
        cout << (good ? "Yes\n" : "No\n");
        if (good) v += qq + 1;
    }
    return 0;
}
