#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    int n, q, d = 300; cin >> n >> q;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    vector <vector <vector <bool> > > dp(100, vector <vector <bool> >(d + 1, vector <bool>(d + 1, false)));
    if (w[0] <= d) {
        dp[0][w[0]][0] = true;
        dp[0][0][w[0]] = true;
    }
    for (int i = 0; i < n; ++i) {
        dp[i][0][0] = true;
    }
    for (int i = 1; i < n; ++i) {
        for (int m1 = 0; m1 <= d; ++m1) {
            for (int m2 = 0; m2 <= d; ++m2) {
                if (m1 >= w[i] && dp[i - 1][m1 - w[i]][m2]) {
                    dp[i][m1][m2] = true;
                }
                if (m2 >= w[i] && dp[i - 1][m1][m2 - w[i]]) {
                    dp[i][m1][m2] = true;
                }
            }
        }
    }
    int z; cin >> z;
    for (int i = 0; i < q; ++i) {
        int k, a, b; cin >> k >> a >> b;
        bool ok = true;
        for (int x = 0; x <= a; ++x) {
            for (int y = 0; y <= b; ++y) {
                if (!dp[n - 1][x][y]) {
                    ok = false;
                    break;
                }
            }
        }
        if (ok) cout << "Yes\n";
        else cout << "No\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    // int t; cin >> t;
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}