#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <iomanip>
#include <random>

using namespace std;

#define int long long

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<vector<int>> dp(n + 2, vector<int>(n + 2, -1));
    dp[0][n + 1] = 0;
    for (int i = 0; i < n; ++i) {
        int x = v[i];
        for (int y = 0; y < n + 2; ++y) {
            if (y == x) continue;
            int cur_mx = -1;
            for (int j = 0; j < x; ++j) {
                cur_mx = max(cur_mx, dp[j][y]);
            }
            if (cur_mx == -1) continue;
            dp[x][y] = cur_mx + 1;
        }
        for (int y = 0; y < n + 2; ++y) {
            if (y == x) continue;
            int cur_mx = -1;
            for (int j = x + 1; j < n + 2; ++j) {
                cur_mx = max(cur_mx, dp[y][j]);
            }
            if (cur_mx == -1) continue;
            dp[y][x] = cur_mx + 1;
        }
    }
    int ans = 0;
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= n; ++j) {
            ans = max(ans, dp[i][j]);
        }
    }
    cout << ans;
}

signed main() {
#ifdef BENTSA
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}
