#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <set>
#include <vector>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
typedef long long ll;

const int K = 1e5 + 10;
vector<ll> x, y;

ll f(ll x1, ll x2, ll n) {
	return min(min(x1 - 1, n - (x1 - 1)), min(n - x2, n - (n - x2)));
}

inline void solve() {
	int h, w, k;
	cin >> h >> w >> k;
	vector<ll> _x, _y;
	for (int i = 0; i < k; i++) {
		ll cx, cy;
		cin >> cy >> cx;
		_x.push_back(cx);
		_y.push_back(cy);
	}
	sort(all(_x));
	sort(all(_y));
	x.push_back(_x[0]);
	for (int i = 1; i < k; i++) {
		if (_x[i] != _x[i - 1]) {
			x.push_back(_x[i]);
		}
	}
	y.push_back(_y[0]);
	for (int i = 1; i < k; i++) {
		if (_y[i] != _y[i - 1]) {
			y.push_back(_y[i]);
		}
	}
	ll dx = x.back() - x[0] + 1;
	ll vx = 0;
	for (int i = 0; i < (int)x.size() - 1; i++) {
		ll d = x[i] + w - x[i + 1] + 1;
		if (d < dx) {
			dx = d;
			vx = f(x[i + 1], x[i], w);
		}
		else if (d == dx) {
			vx = min(vx, f(x[i + 1], x[i], w));
		}
	}
	ll dy = y.back() - y[0] + 1;
	ll vy = 0;
	for (int i = 0; i < (int)y.size() - 1; i++) {
		ll d = y[i] + h - y[i + 1] + 1;
		if (d < dy) {
			dy = d;
			vy = f(y[i + 1], y[i], h);
		}
		else if (d == dy) {
			vy = min(vy, f(y[i + 1], y[i], h));
		}
	}
	cout << dx * dy << ' ' << vx + vy;
}

int main() {
#ifdef OPIUMCAT
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}