#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <set>
#include <vector>
#include <ctime>
#include <map>
using namespace std;
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
typedef long long ll;

map<int, int> sz, p, val, val2;

inline void init(int v) {
	if (!p.count(v)) {
		p[v] = v;
		sz[v] = 1;
		val[v] = val2[v] = v;
	}
}

inline int get(int v) {
	init(v);
	if (p[v] == v) {
		return v;
	}
	return p[v] = get(p[v]);
}

inline void unite(int v, int u) {
	v = get(v);
	u = get(u);
	if (sz[v] < sz[u]) {
		swap(v, u);
	}
	p[u] = v;
	sz[v] += sz[u];
	val[v] = min(val[v], val[u]);
	val2[v] = max(val2[v], val2[u]);
}

inline void solve() {
	int A, t;
	cin >> A >> t;
	if (A == 1) {
		while (t--) {
			p.clear(), sz.clear(), val.clear(), val2.clear();
			int n, k;
			cin >> n >> k;
			set<int> q, w;
			for (int i = 0; i < k; i++) {
				int a;
				cin >> a;
				q.insert(a);
			}
			if (k * 2 == n) {
				for (int i = 1; i <= n; i++) {
					if (!q.count(i)) {
						cout << i << ' ';
					}
				}
				cout << endl;
				continue;
			}
			int x = n;
			for (auto i = q.rbegin(); i != q.rend(); i++) {
				if (x > * i) {
					x = *i;
				}
				while (q.count(x) || w.count(x)) {
					int y = (x == 1 ? n : x - 1);
					if (y == x - 1 && (q.count(y) || w.count(y))) {
						unite(x, y);
						y = val[get(y)];
					}
					x = y;
				}
				w.insert(x);
				x = (x == 1 ? n : x - 1);
			}
			for (int i : w) {
				cout << i << ' ';
			}
			cout << endl;
		}
	}
	else {
		while (t--) {
			p.clear(), sz.clear(), val.clear(), val2.clear();
			int n, k;
			cin >> n >> k;
			set<int> w, q, r;
			for (int i = 0; i < k; i++) {
				int x;
				cin >> x;
				w.insert(x);
			}
			if (k * 2 == n) {
				for (int i = 1; i <= n; i++) {
					if (!w.count(i)) {
						cout << i << ' ';
					}
				}
				cout << endl;
				continue;
			}
			int x = 1;
			for (auto i = w.begin(); i != w.end(); i++) {
				if (x < *i) {
					x = *i;
				}
				while (w.count(x) || q.count(x)) {
					int y = (x == n ? 1 : x + 1);
					if (y == x + 1 && (w.count(y) || q.count(y))) {
						unite(x, y);
						y = val2[get(y)];
					}
					x = y;
				}
				q.insert(x);
				x = (x == n ? 1 : x + 1);
			}
			for (int i : q) {
				cout << i << ' ';
			}
			cout << endl;
		}
	}
}

int main() {
#ifdef OPIUMCAT
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}