#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define endl "\n"
#define mp(a, b) make_pair(a, b)
#define eb emplace_back
#define sz(v) (int)(v.size())



int h, w, k;
vec<int> ys, xs;



void input() {
    cin >> h >> w >> k;

    for (int i = 0; i < k; ++i) {
        int x, y;
        cin >> y >> x;
        xs.eb(x);
        ys.eb(y);
    }

    sort(all(xs));
    xs.resize(unique(all(xs)) - xs.begin());

    sort(all(ys));
    ys.resize(unique(all(ys)) - ys.begin());

}



pii solve(const vec<int>& a, int bigSize) {
    int n = sz(a);
    int siz = a.back() - a.front() + 1;
    int moves = 0;

    vec<int> ve;
    for (auto& it : a)
        ve.eb(it), ve.eb(bigSize - it + 1);

    // moving left
    for (auto& d : ve) {
        vec<int> b = a;
        for (int i = 0; i < n; ++i) {
            b[i] = a[i] + d;
            if (b[i] <= 0) b[i] += bigSize;
            if (b[i] > bigSize) b[i] -= bigSize;
            //cout << b[i] << " ";
        }
        //cout << endl;
        sort(all(b));
        int sizz = b.back() - b.front() + 1;
        int move = abs(d);

        if (sizz < siz || (sizz == siz && move < moves)) {
            siz = sizz, moves = move;
        }
    }

    return mp( siz, moves );
}


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();

    auto one = solve(ys, h);
    auto two = solve(xs, w);
//    cout << "one : " << one.first << " " << one.second << endl;
//    cout << "two : " << two.first << " " << two.second << endl;

    ll area = one.first * two.first;
    int moves = one.second + two.second;

    cout << area << " " << moves;

}