#pragma GCC optimize("O3, bmi, bmi2, popcnt, lzcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

#ifdef LOCAL
#define FAST_IO ;
#else
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define eb emplace_back
#define sz(v) (int)(v.size())
#define mp(a, b) make_pair(a, b)



const int N = 101, MAXW = 5000;



int n, q;
int arr[N];
bitset<MAXW> dp[N][MAXW];


void countDp() {
    dp[0][0][0] = true;
    for (int i = 1; i <= n; ++i) {
        for (int w1 = 0; w1 < MAXW; ++w1) {
            dp[i][w1] = dp[i - 1][w1];
            if (w1 >= arr[i])
                dp[i][w1] |= dp[i - 1][w1 - arr[i]];
            dp[i][w1] |= (dp[i - 1][w1] << arr[i]);
        }
    }

    for (int i = 0; i <= n; ++i)
        for (int w1 = 0; w1 < MAXW; ++w1)
            dp[i][w1].flip();
}

int first[N][MAXW];

void findFirst() {
    for (int ind = 1; ind <= n; ++ind) {
        for (int x = 0; x < MAXW; ++x) {
            int j = dp[ind][x]._Find_first();
            first[ind][x] = j;
        }
    }
}


bool check(int a, int b, int k) {
    int ind = upper_bound(arr + 1, arr + n + 1, k) - arr - 1;
    return first[ind][a] > b;
}


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    cin >> n >> q;
    for (int i = 1; i <= n; ++i)
        cin >> arr[i];
    sort(arr + 1, arr + n + 1);
    int z; cin >> z;

    countDp();
    findFirst();

    while (q--) {
        int k, a, b; cin >> k >> a >> b;
        cout << (check(a, b, k) ? "YES" : "NO") << endl;
    }

}