#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;

const ll inf = ll(1e18);

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int h, w, k;
  cin >> h >> w >> k;
  vector<int> x(k), y(k);
  for (int i = 0; i < k; ++i) {
    cin >> y[i] >> x[i];
    --x[i], --y[i];
  }
  sort(all(x));
  sort(all(y));
  x.push_back(x[0] + w);
  y.push_back(y[0] + h);
  ll ansX = inf;
  int opsX = 0;
  for (int i = 0; i < k; ++i) {
    ll curAns = x[i] + w - x[i + 1] + 1;
    int curOps = i == k - 1 ? 0 : w - x[i + 1];
    if (curAns < ansX || (curAns == ansX && curOps < opsX)) {
      ansX = curAns;
      opsX = curOps;
    }
  }
  x.pop_back();
  reverse(all(x));
  for (int i = 0; i < k; ++i) {
    x[i] = w - 1 - x[i];
  }
  x.push_back(x[0] + w);
  for (int i = 0; i < k; ++i) {
    ll curAns = x[i] + w - x[i + 1] + 1;
    int curOps = i == k - 1 ? 0 : w - x[i + 1];
    if (curAns < ansX || (curAns == ansX && curOps < opsX)) {
      ansX = curAns;
      opsX = curOps;
    }
  }
  ll ansY = inf;
  int opsY = 0;
  for (int i = 0; i < k; ++i) {
    ll curAns = y[i] + h - y[i + 1] + 1;
    int curOps = i == k - 1 ? 0 : h - y[i + 1];
    if (curAns < ansY || (curAns == ansY && curOps < opsY)) {
      ansY = curAns;
      opsY = curOps;
    }
  }
  y.pop_back();
  reverse(all(y));
  for (int i = 0; i < k; ++i) {
    y[i] = h - 1 - y[i];
  }
  y.push_back(y[0] + h);
  for (int i = 0; i < k; ++i) {
    ll curAns = y[i] + h - y[i + 1] + 1;
    int curOps = i == k - 1 ? 0 : h - y[i + 1];
    if (curAns < ansY || (curAns == ansY && curOps < opsY)) {
      ansY = curAns;
      opsY = curOps;
    }
  }
  cout << ansX * ansY << ' ' << opsX + opsY << '\n';
  return 0;
}