#include<bits/stdc++.h>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

bool cmp (pair<ii, int> a, pair<ii, int> b) {
    if (a.ft.ft < b.ft.ft)
        return true;
    if (a.ft.ft > b.ft.ft)
        return false;
    return a.ft.sd > b.ft.sd;
}

int get_ans1 (vector<ii>& v) {
    int n = v.size();
    int dp[n + 1];
    dp[0] = 0;
    int last = -1;
    for (int i = 0; i < n; i++) {
        dp[i + 1] = max(dp[i], 1);
        for (int j = last + 1; j < i; j++) {
            if (v[j].sd < v[i].ft) {
                last = j;
            } else {
                break;
            }
        }
        dp[i + 1] = max(dp[last + 1] + 1, dp[i + 1]);
    }
    return dp[n];
}
int get_ans (vector<ii> &v1) {
    int n = v1.size();
    vector<bool> bad(n, false);
    int minr[n + 1];
    minr[n] = 1e9 + 5;
    for (int i = n - 1; i >= 0; i--) {
        minr[i] = min(minr[i + 1], v1[i].second);
    }
    vector<ii> v;
    for (int i = 0; i < n; i++) {
        int r1 = v1[i].sd;
        if (minr[i + 1] <= r1) {
            bad[i] = true;
        } else {
            v.pb(v1[i]);
        }
    }
    return get_ans1(v);
}

vector<vector<int>> all(0);

void gen (vector<int> w, int in, int m) {
    if (m == 0) {
        all.push_back(w);
        return;
    }
    if (w.size() - in < m) {
        return;
    }
    gen(w, in + 1, m);
    w[in] = 1;
    gen(w, in + 1, m - 1);
}
void solve() {
    int n;
    cin >> n;
    vector<pair<ii, int>> w1(n);
    for (int i = 0; i < n; i++) {
        cin >> w1[i].ft.ft >> w1[i].ft.sd;
        w1[i].sd = i;
    }
    sort(w1.begin(), w1.end(), cmp);
    vector<ii> w(n);
    for (int i = 0; i < n; i++) {
        w[i] = w1[i].ft;
    }
    all.resize(0);
    vector<int> help(n, 0);
    int M = get_ans(w);
   // cout << M << endl;
    //return;
    gen(help, 0, n / 2);
    for (auto j : all) {
        vector<ii> try1;
        for (int i = 0; i < n; i++) {
            if (j[i] == 1) {
                try1.pb(w[i]);
            }
        }
        int rr = get_ans(try1);
        if (rr * 2 == M) {
            /*for (int i = 0; i < n; i++) {
                cout << j[i] << " ";
            }
            cout << endl;
            for (auto k : try1) {
                cout << k.ft << " " << k.sd << endl;
            }
            cout << endl;*/
            for (int i = 0; i < n; i++) {
                if (j[i] == 1) {
                    cout << w1[i].sd + 1 << " ";
                }
            }
            cout << endl;
            return;
        }
    }

}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();

    return 0;
}