#include <iostream>
#include <algorithm>

using namespace std;

const int maxn = 200000 + 1;
int h[maxn];
int res[maxn];
int k;
void dfs(int v, vector<vector<int>> &g, int w) {
    if (g[v].empty() && h[v] <= k) res[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
        if (i != w) {
            h[g[v][i]] = h[v] + 1;
        } else {
            h[g[v][i]] = h[v];
        }
        dfs(g[v][i], g, i);
    }
    for (int u : g[v]) {
        res[v] += res[u];
    }
}

int main() {
    int n, q;
    cin >> n >> k >> q;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 2) {
            int u, v;
            cin >> u >> v;
            --u; --v;
            g[i].push_back(u);
            g[i].push_back(v);
        }
    }
    ++k;
    dfs(0, g, -1);
    while (q--) {
        int x;
        cin >> x;
        cout << res[x - 1] << '\n';
    }
    return 0;
}
