#include <iostream>
#include <vector>
#include <bitset>

using namespace std;

#define int long long

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    bitset<(int) 1e6 + 1> dp;
    dp[0] = true;
    for (int i = 0; i < n; ++i) {
        dp |= dp << w[i];
    }
    vector<bool> res(dp.size());
    res[0] = true;
    for (int i = 1; i <= 1e6; ++i) {
        res[i] = res[i - 1] & dp[i];
    }
    int z;
    cin >> z;
    int v = 0;
    for (int i = 1; i <= q; ++i) {
        int j, c, d;
        cin >> j >> c >> d;
        int k = j - v * z;
        int a = c - v * z;
        int b = d - v * z;
        if (res[a]) {
            cout << "Yes\n";
            v += i;
        } else {
            cout << "No\n";
        }
    }
}