#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll N = 200000;

vector<ll> g[N];
ll f[N], d[N];
vector<ll> a;
ll ti[N], to[N];

void dfs0(ll v = 0, ll w = -1) {
    ti[v] = ll(a.size());
    f[v] = v ? (g[w][1] == v) : -1;
    d[v] = v ? (d[w] + ll(f[w] != f[v])) : 0;
    if (g[v].empty()) a.push_back(d[v]);
    else for (ll u: g[v]) dfs0(u, v);
    to[v] = ll(a.size());
}

ll query(ll l, ll r, ll x) {
    ll ans = 0;
    for (ll i = l; i < r; i++) if (a[i] <= x) ans++;
    return ans;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    ll n, k, q;
    cin >> n >> k >> q;
    for (ll v = 0; v < n; v++) {
        ll c;
        cin >> c;
        g[v].resize(c);
        for (ll &u: g[v]) cin >> u, u--;
    }
    dfs0();
    for (ll v = 1; v < n; v++) d[v]--;
    for (ll &e: a) e--;
    while (q--) {
        ll v;
        cin >> v, v--;
        ll ans = query(ti[v], to[v], k);
        cout << ans << '\n';
    }
}
