#include <bits/stdc++.h>
#define int long long

using namespace std;

struct st {
    int kol, l = -1, r = -1;
};

int n, k;
vector<st> tree(1);

int upd(int i, int l, int r, int x) {
    if (l > x || r <= x)
        return tree[i].kol;
    if (r - l == 1)
        return tree[i].kol = 0;
    int mid = (l + r) / 2;
    if (tree[i].l == -1) {
        tree[i].l = tree.size();
        tree.push_back({mid - l, -1, -1});
    }
    if (tree[i].r == -1) {
        tree[i].r = tree.size();
        tree.push_back({r - mid, -1, -1});
    }
    return tree[i].kol = upd(tree[i].l, l, (l + r) / 2, x) + upd(tree[i].r, (l + r) / 2, r, x);
}

int get(int i, int l, int r, int x, int y) {
    if (tree[i].kol == 0 || l >= y || r <= x)
        return n + 1;
    if (r - l == 1)
        return l;
    int mid = (l + r) / 2;
    if (tree[i].l == -1) {
        tree[i].l = tree.size();
        tree.push_back({mid - l, -1, -1});
    }
    int now = get(tree[i].l, l, (l + r) / 2, x, y);
    if (now != n + 1)
        return now;
    if (tree[i].r == -1) {
        tree[i].r = tree.size();
        tree.push_back({r - mid, -1, -1});
    }
    now = get(tree[i].r, (l + r) / 2, r, x, y);
    return now;
}

int getr(int i, int l, int r, int x, int y) {
    if (tree[i].kol == 0 || l >= y || r <= x)
        return 0;
    if (r - l == 1)
        return l;
    int mid = (l + r) / 2;
    if (tree[i].r == -1) {
        tree[i].r = tree.size();
        tree.push_back({r - mid, -1, -1});
    }
    int now = getr(tree[i].r, (l + r) / 2, r, x, y);
    if (now != 0)
        return now;
    if (tree[i].l == -1) {
        tree[i].l = tree.size();
        tree.push_back({mid - l, -1, -1});
    }
    now = getr(tree[i].l, l, (l + r) / 2, x, y);
    return now;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    int q;
    cin >> q;
    if (t == 1) {
        while (q--) {
            cin >> n >> k;
            vector<int> a;
            vector<int> ret;
            int K = k;
            upd(0, 0, n + 1, 0);
            while (k--) {
                int x;
                cin >> x;
                a.push_back(x);
                upd(0, 0, n + 1, x);
            }
            for (int i = 0; i < K; i++) {
//                for (int j = a[i] + 1; j <= 2 * n; j++) {
//                    if (j == n + 1)
//                        j = 1;
//                    if (!used[j]) {
//                        used[j] = true;
//                        ret.push_back(j);
//                        break;
//                    }
//                }
                int j = get(0, 0, n + 1, a[i] + 1, n + 1);
                if (j == n + 1)
                    j = get(0, 0, n + 1, 1, a[i]);
                ret.push_back(j);
                upd(0, 0, n + 1, j);
            }
            sort(ret.begin(), ret.end());
            for (auto x : ret)
                cout << x << ' ';
            cout << endl;
        }
    }
    else {
        while (q--) {
            int n, k;
            cin >> n >> k;
            tree = {};
            tree.resize(1);
            upd(0, 0, n + 1, 0);
            int K = k;
            vector<int> ret;
            vector<int> a;
            while (k--) {
                int x;
                cin >> x;
                upd(0, 0, n + 1, x);
                a.push_back(x);
            }
            for (int i = 0; i < K; i++) {
//                for (int j = a[i] - 1; j >= -1; j--) {
//                    if (j == 0)
//                        j = n;
//                    if (!used[j]) {
//                        used[j] = true;
//                        ret.push_back(j);
//                        break;
//                    }
//                }
                int j = getr(0, 0, n + 1, 1, a[i]);
                if (j == 0)
                    j = getr(0, 0, n + 1, a[i + 1], n + 1);
                ret.push_back(j);
                upd(0, 0, n + 1, j);
            }
            sort(ret.begin(), ret.end());
            for (auto x : ret)
                cout << x << ' ';
            cout << endl;
        }
    }
}