#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
const ll infll = 1000000000000000000 + 1;
template<typename T>
bool chmax(T &a, T b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
void solve_case() {
    int n, q;
    cin >> n >> q;
    ll x, y, m;
    cin >> x >> y >> m;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    vector<ll> v(q);
    for (int i = 0; i < q; i++) cin >> v[i];
    vector<int> lst;
    for (int i = 1; i < n; i++) {
        lst.push_back(i);
    }
    function<int(int, int)> calc = [&](int i, int va) {
        return ((1ll * x * (i + 1) % m) + 1ll * y * (1ll * va * va % m) % m) % m;
    };
    ll Ly = 0, Ry = 0;
    for (int i = 1; i < n; i++) {
        Ly += l[i], Ry += r[i];
    }
    vector<ll> pref(lst.size() + 1);
    for (int i = 0; i < lst.size(); i++) pref[i + 1] = pref[i] + r[lst[i]] - l[lst[i]];
    int all_hash = 0;
    for (int i = 0; i < n; i++) {
        all_hash ^= calc(i, l[i]);
    }
    vector<int> pref_hash(lst.size() + 1);
    for (int i = 0; i < lst.size(); i++) {
        pref_hash[i + 1] = pref_hash[i] ^ calc(lst[i], l[lst[i]]) ^ calc(lst[i], r[lst[i]]);
    }
    vector<int> www(q);
    for (int i = 0; i < q; i++) {
        if (l[0] <= v[i] && v[i] <= r[0] && v[i] >= Ly) {
            www[i] = (all_hash ^ calc(0, v[i]) ^ calc(0, l[i]));
            cout << (all_hash ^ calc(0, v[i]) ^ calc(0, l[i])) << " ";
        } else if (v[i] < Ly || v[i] > Ry){
            cout << -1 << " ";
        } else {
            ll cur = v[i] - Ly;
            int pos = upper_bound(pref.begin(), pref.end(), cur) - pref.begin() - 1;
            int myhash = all_hash ^ pref_hash[pos];
            int need = cur - pref[pos];
            if (pos != lst.size()) myhash ^= calc(lst[pos], l[lst[pos]]) ^ calc(lst[pos], l[lst[pos]] + need);
            cout << myhash << " ";
        }
    }
    cout << endl;
    int id;
    while (cin >> id) {
        id--;
        if (id == -1) break;
        if (l[0] <= v[id] && v[id] <= r[0] && v[id] >= Ly) {
            cout << v[id] << " ";
            for (int i = 1; i < n; i++) cout << l[i] << " ";
            int vvv = calc(0, v[id]);
            for (int i = 1; i < n; i++) vvv ^= calc(i, l[i]);
            assert(vvv == www[id]);
            cout << endl;
            continue;
        }
        if (v[id] < Ly || v[id] > Ry){
            cout << -1 << " ";
            cout << endl;
            continue;
        }
        ll cur = v[id] - Ly;
        int pos = upper_bound(pref.begin(), pref.end(), cur) - pref.begin() - 1;
        vector<int> ans = l;
        for (int i = 0; i < pos; i++) ans[lst[i]] = r[lst[i]];
        int vvv = 0;
        for (int i = 0; i < n; i++) vvv ^= calc(i, ans[i]);
        cerr << vvv << endl;
        if (pos != lst.size()) ans[lst[pos]] = l[lst[pos]] + cur - pref[pos];
        for (int i : ans) cout << i << " ";
        cout << endl;
    }
}
int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    //freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
}