#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>
#define ll long long
#define vc vector
#define mp(a,b) make_pair(a,b)
#define pb push_back
#define pip pair <int,int>
#define all(s) s.begin(), s.end()
vc <pip> s;
int n, m;
int check(vc <pip> & q){
    int nn = 1000;
    vc <vc <int>> g(nn);
    vc <pip> dp(nn+1, mp(0,-1));
    for (int i = 0; i < q.size(); i++){
        int a = q[i].first;
        g[a].pb(i);
    }
    for (int l = 0; l < nn; l++){
        dp[l+1] = max(mp(dp[l].first, -1), dp[l+1]);
        for (int j = 0; j < g[l].size(); j++){
            int v = g[l][j];
            int r = q[v].second + 1;
            dp[r] = max(dp[r], mp(dp[l].first + 1, v));
        }
    }
    return dp[nn].first;
}
bool g(int mask){
    vc <pip> w;
    for (int i = 0; i < n; i++){
        if (mask%2) w.pb(s[i]);
        mask /= 2;
    }
    return check(w) == check(s)/2 && w.size() >= n/2;
}
void ans(int mask){
    for (int i = 0; i < n; i++){
        if (mask%2) cout << i+1 << ' ';
        mask /= 2;
    }
    cout << "\n";
}
void solve(){
    int k, a, b, c, nn;
    cin >> n;
    s.resize(n);
    for (int i = 0; i < n; i++) cin >> s[i].first >> s[i].second;
    ordered_set crd;
    for (int i = 0; i < n; i++) crd.insert(s[i].first), crd.insert(s[i].second);
    for (int i = 0; i < n; i++) {
        s[i].first = crd.order_of_key(s[i].first);
        s[i].second = crd.order_of_key(s[i].second);
    }
    if (n <= 20){
        for (int mask = 0; mask < (1<<n); mask++)if (g(mask)){ ans(mask); return;}
    }
}
int main() {
    int tt = 1;
    //cin >> tt;
    while (tt--) solve();
    return 0;
}
