#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#endif

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(2e18) + 13;

template<typename T> inline bool smin(T&a, T b) {
  if (b < a) {
    a = b;
    return true;
  }
  return false;
}
template<typename T> inline bool smax(T&a, T b) {
  if (a < b) {
    a = b;
    return true;
  }
  return false;
}

int mod;
int add(int a, int b) {
  return a + b >= mod ? a + b - mod : a + b;
}
int sub(int a, int b) {
  return a - b < 0 ? a - b + mod : a - b;
}
int mul(int a, int b) {
  return 1ll * a * b % mod;
}
int binpow(int a, int p) {
  int ans = 1;
  while (p) {
    if (p & 1) ans = mul(ans, a);
    a = mul(a, a);
    p >>= 1;
  }
  return ans;
}

constexpr int N = 1e5 + 3;
ull rn[N];

ull Hash(const vector<int> & a) {
  ull ans = 0;
  for (int i = 0; i < a.size(); ++i)
    if (a[i])
      ans ^= rn[i];
  return ans;
}

char l[1 << 10];

int is(vector<int> a) {
  ull prev = Hash(a);
  vector<int> b;
  for (int iter = 0; iter < 100; ++iter) {
    b.clear();
    int mex = 0;
    for (int i : a) l[i] = 1;
    for (; l[mex]; ++mex);
    for (int i : a) l[i] = 0;
    --mex;
    for (int x : a) b.push_back(x ^ mex);
    a.swap(b);
    ull new_hash = Hash(a);
    if (new_hash == prev) {
      return mex + 1;
    }
  }
  return -1;
}

void Solve() {

  int k, n, p;
  cin >> k >> n >> p;
  int pw = 1 << k; --pw;
  vector<int> a;
  a.reserve(pw);
  int ans = 0;
  for (int m = 0, mx = 1 << pw; m < mx; ++m) {
    if (__builtin_popcount(m) != n-1) continue;
    a.clear();
    a.push_back(0);
    for (int i = 1; i <= pw; ++i)
      if (m >> i & 1)
        a.push_back(i);
    if (is(a) == p)
      ans = add(ans, 1);
  }
  cout << ans << endl;

}

mt19937_64 rng(73);

int32_t main() {
  ios_base::sync_with_stdio(0); cin.tie(0);

  for (int i = 0; i < N; ++i) rn[i] = rng();
  cin >> mod;
  int T;
  cin >> T;
  while (T--) {
    Solve();
  }

  return 0;
}
