//
// ВАСЯ ФЕДОРОВ ЛОХ АХВХАВХАХВАХВХВХА
//
//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC target("bmi,bmi2,sse,sse2,sse3,sse4,ssse3,mmx,lzcnt,popcnt,tune=native")
#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

#define int long long
using namespace std;
typedef long long ll;


struct qr {
    int a, b, k, ind;

    qr() = default;
};


void solve() {
    const int LIM = 302;
    int n, q;
    cin >> n >> q;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    sort(w.begin(), w.end());
    vector<vector<bool>> last(LIM, vector<bool>(LIM, false));
    vector<qr> qs;
    int z;
    cin >> z;
    for (int i = 0; i < q; i++) {
        int a, b, k;
        cin >> k >> a >> b;
        qs.push_back(qr{a, b, k, i});
    }
    sort(qs.begin(), qs.end(), [](qr a, qr b) {
        return a.k < b.k;
    });
    int ind = 0;

    vector<bool> ans(q, false);
    while (ind < q && qs[ind].k < w[0]) {
        if (qs[ind].a == 0 && qs[ind].b == 0) ans[qs[ind].ind] = true;
        ind++;
    }

    if (w[0] >= LIM) {
        for (int i = 0; i < q; i++) cout << "No\n";
        return;
    }
    last[0][0] = true;
    last[w[0]][0] = true;
    last[0][w[0]] = true;
    vector<vector<bool>> pref(LIM, vector<bool>(LIM, 0));
    pref[0][0] = last[0][0];
    for (int i = 0; i < LIM; i++) {
        for (int j = 0; j < LIM; j++) {
            if (!last[i][j]) break;
            if (i == 0 && j == 0) continue;
            if (i > 0) {
                if (!pref[i - 1][j]) break;
                pref[i][j] = true;
            } else {
                pref[i][j] = true;
            }
        }
    }

    for (int i = 1; i < n; i++) {
        while (ind < q && qs[ind].k < w[i]) {
            ans[qs[ind].ind] = pref[qs[ind].a][qs[ind].b];
            ind++;
        }
        auto cur = last;
        for (int x = 0; x + w[i] < LIM; x++) {
            for (int y = 0; y < LIM; y++) {
                if (last[x][y]) cur[x + w[i]][y] = true;
            }
        }

        for (int x = 0; x < LIM; x++) {
            for (int y = 0; y + w[i] < LIM; y++) {
                if (last[x][y]) cur[x][y + w[i]] = true;
            }
        }
        last = cur;

        for (int ii = 0; ii < LIM; ii++) {
            fill(pref[ii].begin(), pref[ii].end(), false);
            pref[0][0] = last[0][0];
            for (int j = 0; j < LIM; j++) {
                if (!last[ii][j]) break;
                if (ii == 0 && j == 0) continue;
                if (ii > 0) {
                    if (!pref[ii - 1][j]) break;
                    pref[ii][j] = true;
                } else {
                    pref[ii][j] = true;
                }
            }
        }
    }

    while (ind < q) {
        ans[qs[ind].ind] = true;
        for (int x = 0; x <= qs[ind].a; x++) {
            for (int y = 0; y <= qs[ind].b; y++) {
                if (!last[x][y]) {
                    ans[qs[ind].ind] = false;
                    break;
                }
            }
        }
        ind++;
    }
    for (int i = 0; i < q; i++) {
        if (ans[i]) {
            cout << "Yes";
        } else {
            cout << "No";
        }
        cout << '\n';
    }
}


int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
#ifdef LOCAL
    freopen("c.in", "r", stdin);
    cin >> t;
#endif
    while (t--) {
        solve();
        cout << '\n';
#ifdef LOCAL
        cout << endl;
#endif
    }
}