#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const int sz = 300300;
const int szz = 3000;
const ll k = 100100;

ll w[sz];
bool dp[sz];

int main() {
	//freopen("in.txt", "r", stdin);
	//freopen("out.txt", "w", stdout);
	int n, q;
	cin >> n >> q;
	for (int i = 1; i <= n; ++i) {
		cin >> w[i];
		if (w[i] >= k) w[i] = 0;
	}
	ll z;
	cin >> z;
	dp[0] = 1;
	fill(dp + 1, dp + k * 2 + 1, 0);
	for (int i = 1; i <= n; ++i) {
		if (w[i] == 0) continue;
		for (int j = k - w[i]; j >= 0; --j) {
			if (dp[j]) dp[j + w[i]] = 1;
		}
	}
	int it = 0;
	while (it < k && dp[it]) ++it;
	for (int i = 0; i < q; ++i) {
		ll tk, a, b;
		cin >> tk >> a >> b;
		if (a <= it) {
			cout << "Yes\n";
		}
		else {
			cout << "No\n";
		}
	}
}