#include <iostream>
#include <vector>
#include <algorithm>

#define all(x) x.begin(), x.end()

using namespace std;
typedef long long ll;

template<typename T>

bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
/*
 *
 */

pair<ll, ll> get_range(vector<ll>& a, ll mx) {
    sort(all(a));
    ll res = a.back() - a[0] + 1;
    ll cnt = 0;
    for (int i = 0; i + 1 < a.size(); ++i) {
        if (a[i] == a[i + 1])
            continue;
        cout << mx - (a[i + 1] - a[i] - 1) << endl;
        if (mini(res, mx - (a[i + 1] - a[i] - 1))) {
            cnt = min(a[i], mx - a[i + 1] + 1);
        }
    }
    return {res, cnt};
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#ifdef DUDE
    freopen("input.in", "r", stdin);
#endif
    ll h, w, n;
    cin >> h >> w >> n;
    vector<ll> xs(n), ys(n);
    for (int i = 0; i < n; ++i) {
        cin >> ys[i] >> xs[i];
    }
    auto width = get_range(xs, w);
    auto height = get_range(ys, h);
    cout << width.first * height.first << ' ' << width.second + height.second;

}
