#pragma GCC optimaze("O3,ofast")


#include <bits/stdc++.h>

using namespace std;

#define all(a) a.begin(), a.end()

typedef long long ll;
typedef string str;
mt19937 rnd(157);

vector<int> coder(vector<int> &a, int n, int k) {
    unordered_set<int> used;
    for(int i = 0; i < k; i++) {
        used.insert(a[i]);
    }
    int i = k - 1;
    vector<int> ans;
    int j = 0;
    int cnt = 0;
    while(i >= 0 || cnt > 0) {
        if(cnt == 0) {
            j = a[i];
            i--;
            cnt++;
        }
        if(used.find(j) != used.end()) {
            if(j == 1) {
                j = n;
            } else {
                j--;
            }
            continue;
        }
        ans.push_back(j);
        used.insert(j);
        cnt--;
    }
    sort(all(ans));
    return ans;
}

vector<int> decoder(vector<int> &a, int n, int k) {
    unordered_set<int> used;
    for(int i = 0; i < k; i++) {
        used.insert(a[i]);
    }
    int i = 0;
    vector<int> ans;
    int j = a[0];
    int cnt = 0;
    while(i <= k - 1 || cnt > 0) {
        if(cnt == 0) {
            j = a[i];
            i++;
            cnt++;
        }
        if(used.find(j) != used.end()) {
            if(j == n) {
                j = 1;
            } else {
                j++;
            }
            continue;
        }
        ans.push_back(j);
        used.insert(j);
        cnt--;
    }
    sort(all(ans));
    return ans;
}



signed main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0);
    int zap;
    cin >> zap;
    if(zap == 1) {
        int m;
        cin >> m;
#pragma GCC ivdep
        for(int _ = 0; _ < m; _++) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for(int i = 0; i < k; i++) {
                cin >> a[i];
            }
            auto ans = coder(a, n, k);
            for(auto el : ans) {
                cout << el << ' ';
            }
            cout << '\n';
        }
    } else {
        int m;
        cin >> m;
#pragma GCC ivdep
        for(int _ = 0; _ < m; _++) {
            int n, k;
            cin >> n >> k;
            vector<int> a(k);
            for(int i = 0; i < k; i++) {
                cin >> a[i];
            }
            auto ans = decoder(a, n, k);
            for(auto el : ans) {
                cout << el << ' ';
            }
            cout << '\n';
        }
    }
    cout << endl;
}