#include <iostream>
#include <bits/stdc++.h>


using namespace std;

#define ll long long
#define F first
#define S second
mt19937 rnd(100);

ll x, y, m;
vector<vector<ll>> g;
vector<ll> l, r;


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    ll _;
    cin >> _;
    while (_--) {
        ll n, q, u, v;
        cin >> n >> q >> x >> y >> m;

        g.clear();
        g.resize(n);
        for (int i = 0; i < n - 1; ++i) {
            cin >> u >> v;
            g[u - 1].push_back(v - 1);
            g[v - 1].push_back(u - 1);
        }

        ll l1 = 0, r1 = 0;
        l.resize(n), r.resize(n);
        for (int i = 0; i < n; ++i)
            cin >> l[i] >> r[i];
        for (int i = 1; i < n; ++i)
            l1 += l[i], r1 += r[i];
        ll miV = max(l1, l[0]);
        ll maV = max(r1, r[0]);

        ll help1 = 0;
        vector<ll> Rpref(n), Lsuf(n + 1), distS(n);
        for (int i = 1; i < n; ++i)
            help1 ^= (x * (i + 1) + y * ((l[i] * l[i]) % m)) % m;
        for (int i = 1; i < n; ++i) {
            Rpref[i] = Rpref[i - 1] ^ ((x * (i + 1) + y * ((r[i] * r[i]) % m)) % m);
            Lsuf[n - i] = Lsuf[n - i + 1] ^ ((x * (n - i + 1) + y * ((l[n - i] * l[n - i]) % m)) % m);
            distS[i] = distS[i - 1] + (r[i] - l[i]);
        }

        vector<ll> ans(q), vs(q);
        for (int i = 0; i < q; ++i) {
            cin >> v;
            vs[i] = v;
            if (v >= miV && v <= maV) {
                if (v >= l[0] && v <= r[0]) // Корень
                    ans[v] = help1 ^ ((x + y * ((v * v) % m)) % m);
                else { // Листья
                    v -= l1;
                    ll L = 0, R = n, M; // Бинарим до какого листа мы жадно дойдем.
                    while (R - L > 1) {
                        M = (R + L) / 2;
                        if (distS[M] <= v)
                            L = M;
                        else
                            R = M;
                    }
                    v -= distS[L];
                    ans[i] = Rpref[L] ^ Lsuf[L + 1] ^ ((x * (L + 1) + y * (((l[L] + v) * (l[L] + v)) % m)) % m);
                }
            } else
                ans[i] = -1;
            cout << ans[i] << endl;
        }

        cin >> v;
        while (v) {
            v--;
            if (ans[v] == -1) {
                cout << -1 << endl;
            } else {
                v = vs[v];
                if (v >= l[0] && v <= r[0]) {
                    cout << v << ' ';
                    for (int i = 1; i < n; ++i)
                        cout << l[i] << ' ';
                    cout << endl;
                } else {
                    v -= l1;
                    ll L = 0, R = n, M; // Бинарим до какого листа мы жадно дойдем.
                    while (R - L > 1) {
                        M = (R + L) / 2;
                        if (distS[M] <= v)
                            L = M;
                        else
                            R = M;
                    }
                    for (int i = 0; i < L; ++i)
                        cout << r[i + 1] << ' ';
                    v -= distS[L];
                    if (L + 1 < n) {
                        cout << l[L + 1] + v << ' ';
                        for (int i = L + 2; i < n; ++i)
                            cout << l[i] << ' ';
                    }
                    cout << endl;
                }
            }
            cin >> v;
        }

    }

    return 0;
}
/*
Ежик.
 берем либо корень, либо все остальное.

Мин. v это мин(сумма в листьях, корень)
макс v это макс(сумма в листьях, корень)
*/
/*
1
5 4
1 100 1000000007

1 2
1 3
1 4
1 5

0 5
0 5
0 5
0 5
0 5

10
11
20
25

1
2
3
4
0

*/