#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct event {
    int l, r, i;

    bool operator<(event b) {
        return pair<int, int>{l, r} < pair<int, int>{b.l, b.r};
    }
};


void solve() {
    int n;
    cin >> n;

    vector<event> had(n);
    for (int i = 0; i < n; i++) {
        cin >> had[i].l >> had[i].r;
        had[i].i = i;
    }
    std::sort(had.begin(), had.end());
    vector<vector<int>> group(n);
    for (int i = 0; i < n; i++) {
        group[i].push_back(i);
    }
    vector<event> stek;
    for (int i = 0; i < n; i++) {
        if (!stek.empty() && stek.back().r >= had[i].r) {
            for (auto el : group[stek.back().i]){
                group[had[i].i].push_back(el);
            }
            group[stek.back().i].clear();
            stek.pop_back();
        }
    }
    int min_l = -1;
    int m = 0;
    int pred = -1;
    set<pair<ll, ll>> mine;
    for (auto el: stek) {
        if (el.l > min_l) {

            m++;
            min_l = el.r;
            pred = el.i;
        }
        else{
            group[pred].push_back(el.i);
        }
    }
    vector<vector<ll>> dp(n, vector<ll>())

}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
