#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long ll;

const int mx_b = 5000;

void solve() {
	int n, q;
	cin >> n >> q;
	vector<ll>arr(n);
	for (auto& i : arr)
		cin >> i;
	int z; cin >> z;
	sort(arr.begin(), arr.end());
	vector<vector<pair<int, pair<ll, ll>>>>reqs(n);
	vector<bool>ans(q);
	for (int i = 0; i < q; i++) {
		ll k, a, b;
		cin >> k >> a >> b;
		if (a == 0 && b == 0) {
			ans[i] = true;
			continue;
		}
		int more = upper_bound(arr.begin(), arr.end(), k) - arr.begin();
		if (more == 0)
			continue;
		reqs[more - 1].push_back({ i, {a, b} });
	}
	ll max_value = 0;
	for (int i = 1; i <= n; i++) {
		if (arr[i - 1] <= max_value + 1)
			max_value += arr[i - 1];
		for (auto& el : reqs[i - 1]) {
			ans[el.first] = max_value >= el.second.first;
		}
	}
	for (auto i : ans)
		if (i)
			cout << "Yes\n";
		else
			cout << "No\n";
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}