#include <bits/stdc++.h>

std::pair<int, int> solve(int k, std::vector<int> vec) {
    int n = vec.size();

    std::sort(vec.begin(), vec.end());
    vec.erase(std::unique(vec.begin(), vec.end()), vec.end());

    std::pair<int, int> ans(vec.back() - vec.front() + 1, 0);

    for (int i = 0; i < k; i++) {
        for (auto& i : vec) {
            i++;
            i %= k;
        }
        auto [it1, it2] = std::minmax_element(vec.begin(), vec.end());
        ans = std::min(ans, {*it2 - *it1 + 1, std::min(i + 1, (k - (i + 1)) % k)});
    }

    return ans;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int h, w, n;
    std::cin >> w >> h >> n;
    std::vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
    }

    auto [w1, c1] = solve(w, a);
    auto [w2, c2] = solve(h, b);

    std::cout << int64_t(w1) * w2 << " " << c1 + c2 << "\n";

    return 0;
}
