#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <iomanip>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

const int32_t MAXN = 2E5;

int rt[MAXN], lt[MAXN], ans[MAXN];
bool last_l[MAXN];

int get_ans(int x, int cnt)
{
	if (cnt < 0)
	{
		return 0;
	}

	if (lt[x] == -1)
	{
		return ans[x] = 1;
	}

	if (last_l[x])
	{
		return ans[x] = get_ans(lt[x], cnt) + get_ans(rt[x], cnt - 1);
	}
	else
		return ans[x] = get_ans(lt[x], cnt - 1) + get_ans(rt[x], cnt);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(13);

	int n, k, q;
	cin >> n >> k >> q;
	fill(rt, rt + n, -1);
	fill(lt, lt + n, -1);
	for (int i = 0; i < n; i++)
	{
		int t;
		cin >> t;
		if (t == 2)
		{
			int l, r;
			cin >> l >> r;
			lt[i] = l - 1;
			last_l[l - 1] = true;
			rt[i] = r - 1;
		}
	}
	ans[0] = get_ans(lt[0], k) + get_ans(rt[0], k);

	while (q--)
	{
		int u;
		cin >> u;
		cout << ans[u - 1] << endl;
	}
}