#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ui unsigned int
#define ld long double
#define mp make_pair
#define ff first
#define ss second
#define pii pair<int, int>
#define pil pair<int, long long>
#define pli pair<long long, int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define uset unordered_set
#define umap unordered_map

const int N = 501;
vector<int> g[N];
vector<int> tg[N];
vector<int> pout(N);
bool used[N];
int possible[N];

inline void solve() {
    int n;
    cin >> n;
    vector<pii > a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].ff >> a[i].ss;
    for (int i = 0; i < n; i++)
        for (int j = i + 1; j < n; j++) {
            if (a[i].ff < a[j].ff && a[j].ss < a[i].ss) {
                g[i].pb(j);
                tg[j].pb(i);
                pout[i]++;
            }
            if (a[j].ff < a[i].ff && a[i].ss < a[j].ss) {
                g[j].pb(i);
                tg[i].pb(j);
                pout[j]++;
            }
        }
    for (int i = 0; i < n; i++)
        possible[i] = tg[i].size();
    int m = 0;
    for (int v = 0; v < n; v++)
        if (pout[v] == 0)
            m++;
    vector<int> ans;
    vector<pii> leaf;
    for (int i = 0; i < n; i++)
        if (pout[i] == 0)
            leaf.pb({possible[i], i});
    vector<int> other;
    while (ans.size() < m / 2) {
        sort(all(leaf));
        int v = leaf.back().ss;
        leaf.ppb();
        used[v] = true;
        ans.pb(v);
        for (int u : tg[v]) {
            if (!used[u])
                other.pb(u);
            used[u] = true;
            possible[u] = 0;
        }
        leaf.clear();
        for (v = 0; v < n; v++)
            if (!used[v]) {
                possible[v] = 1;
                for (int u : tg[v])
                    possible[v] += !used[u];
            }
        for (v = 0; v < n; v++)
            if (!used[v] && pout[v] == 0)
                leaf.pb({possible[v], v});
    }
    for (int v : other)
        if (ans.size() < n / 2)
            ans.pb(v);
    for (int i : ans)
        cout << i + 1 << ' ';
    cout << '\n';
    for (int i = 0; i < n; i++) {
        g[i].clear();
        tg[i].clear();
        used[i] = false;
        pout[i] = 0;
        possible[i] = 0;
    }/**/
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
#ifdef DEBUG
        cout << "Test case#\n";
#endif
        solve();
    }
    return 0;
}