#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ui unsigned int
#define ld long double
#define mp make_pair
#define ff first
#define ss second
#define pii pair<int, int>
#define pil pair<int, long long>
#define pli pair<long long, int>
#define pll pair<long long, long long>
#define pb push_back
#define ppb pop_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define uset unordered_set
#define umap unordered_map

const int N = 2e5;
vector<pll > a;
vector<int> g[N];
ll dp[2][N];

void dfs(int v, int p = -1) {
    dp[1][v] = a[v].ff;
    dp[0][v] = 0;
    if (g[v].size() == 1 && g[v][0] == p)
        return;
    for (int u: g[v])
        if (u != p)
            dfs(u, v);
    for (int u: g[v])
        if (u != p) {
            dp[0][v] += max(dp[1][u], dp[0][u]);
            dp[1][v] += dp[0][u];
        }
}

inline void solve() {
    int n, q;
    cin >> n >> q;
    a.resize(n);
    ll x, y, m;
    cin >> x >> y >> m;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    for (int i = 0; i < n; i++)
        cin >> a[i].ff >> a[i].ss;
    dfs(0);
    ll ans = max(dp[1][0], dp[0][0]);
    ll k = 0;
    for (ll i = 0; i < n; i++) {
        ll res = (a[i].ff * a[i].ff) % m;
        res *= y;
        res %= m;
        res += x * (i + 1);
        res %= m;
        k ^= res;
    }
    ll v[q];
    for (int i = 0; i < q; i++)
        cin >> v[i];
    for (int i = 0; i < q; i++) {
        if (ans == v[i])
            cout << k << ' ';
        else
            cout << -1 << ' ';
    }
    cout << endl;
    int i;
    cin >> i;
    while (i > 0) {
        i--;
        if (v[i] == ans) {
            for (int j = 0; j < n; j++)
                cout << a[j].ff << ' ';
        } else
            cout << -1;
        cout << endl;
        cin >> i;
    }
    for (i = 0; i < n; i++) {
        dp[0][i] = 0;
        dp[1][i] = 0;
        g[i].clear();
    }
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) {
#ifdef DEBUG
        cout << "Test case#" << endl;
#endif
        solve();
    }
    return 0;
}