#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include "random"

using namespace std;
typedef long long ll;

#define all(a) a.begin(), a.end()

void solve();

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }

}

void solve() {
    ll n, q;
    cin >> n >> q;
    vector<ll> v(n);
    for (ll &i: v)
        cin >> i;
    sort(all(v));
    ll z;
    cin >> z;
    ll u = 0;
    while (q--) {
        ll k, a, b;
        cin >> k >> a >> b;
        k -= u * z;
        a -= u * z;
        b -= u * z;
        vector<ll> v1;
        for (ll i: v) {
            if (i <= k)
                v1.push_back(i);
        }
        set<pair<ll, ll>> ans;
        for (ll f = 0; f < (1 << v1.size()); f++) {
            for (ll s = 0; s < (1 << v1.size()); s++) {
                if ((s & f) != 0)
                    continue;
                ll s1 = 0, s2 = 0;
                for (ll j = 0; j < v1.size(); j++) {
                    if ((f >> j) & 1)
                        s1 += v[j];
                    if ((s >> j) & 1)
                        s2 += v[j];
                }
                if (s1 <= a && s2 <= b)
                    ans.insert({s1, s2});
            }
        }
        if (ans.size() == (a + 1) * (b + 1)) {
            cout << "Yes\n";
            u++;
        } else
            cout << "No\n";
    }


}