#include <bits/stdc++.h>
using namespace std;

void solve() {
    int h, w, k;
    cin >> h >> w >> k;
    vector<int> x(k), y(k);
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
        x[i]--, y[i]--;
    }
    sort(x.begin(), x.end());
    sort(y.begin(), y.end());
    pair<int, int> ans1 = {INT_MAX, INT_MAX};
    pair<int, int> ans2 = {INT_MAX, INT_MAX};
    int last = -1;
    for (int i = 0; i < k; i++) {
        int max_r = 0;
        if (last != -1) {
            max_r = max(max_r, (last - x[i] + h) % h);
        }
        if (i != k - 1) {
            max_r = max(max_r, x[k - 1] - x[i]);
        }
        ans1 = min(ans1, {max_r + 1, max(0, min(x[i] - (h - 1 - max_r), h - x[i]))});
        if (i + 1 < k && x[i] != x[i + 1]) {
            last = x[i];
        }
    }
    last = -1;
    for (int i = 0; i < k; i++) {
        int max_r = 0;
        if (last != -1) {
            max_r = max(max_r, (last - y[i] + w) % w);
        }
        if (i != k - 1) {
            max_r = max(max_r, y[k - 1] - y[i]);
        }
        ans2 = min(ans2, {max_r + 1, max(0, min(y[i] - (w - 1 - max_r), w - y[i]))});
        if (i + 1 < k && y[i] != y[i + 1]) {
            last = y[i];
        }
    }
    cout << 1ll * ans1.first * ans2.first << " " << ans1.second + ans2.second << "\n";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}
