#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define sz(x) (ll)(x.size())

const ll MAXN = 2e5 + 1;
vector<ll> g[MAXN];
ll l[MAXN], r[MAXN];
ll s1 = 0, s2 = 0;
vector<ll> a1, a2;
ll dp[2][MAXN], par[2][MAXN];
vector<ll> a;

void dfs(ll v, ll p, bool f) {
    dp[1][v] = r[v];
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v, !f);
            dp[1][v] += dp[0][u];
            dp[0][v] += max(dp[1][u], dp[0][u]);
        }
    }
}

void get_ans(ll v, ll p, bool here) {
    if (here) {
        a.push_back(v);
        for (auto u : g[v]) {
            if (u != p) {
                get_ans(u, v, false);
            }
        }
    } else {
        for (auto u : g[v]) {
            if (u != p) {
                if (dp[0][u] > dp[1][u]) {
                    get_ans(u, v, false);
                } else {
                    get_ans(u, v, true);
                }
            }
        }
    }
}

void solve() {
    ll n, q, x, y, m;
    cin >> n >> q >> x >> y >> m;
    for (int i = 0; i < n - 1; ++i) {
        ll f, s;
        cin >> f >> s;
        g[f].push_back(s);
        g[s].push_back(f);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
    }
    vector<ll> v(q);
    for (int i = 0; i < q; ++i) {
        cin >> v[i];
    }
    dfs(1, -1, 0);
    if (dp[0][1] > dp[0][0]) {
        get_ans(1, -1, true);
    } else {
        get_ans(1, -1, false);
    }
    vector<bool> used(n + 1);
    for (auto i : a) {
        used[i] = true;
    }
    vector<ll> mass;
    for (int i = 1; i <= n; ++i) {
        mass.push_back(r[i]);
    }
    ll k = 0;
    for (int i = 1; i <= n; ++i) {
        k ^= ((x * i % m + y % m * mass[i - 1] % m * mass[i - 1] % m) % m);
    }
    for (int i = 0; i < q; ++i) {
        if (v[i] == max(dp[0][1], dp[1][1])) {
            cout << k << ' ';
        } else {
            cout << -1 << ' ';
        }
    }
    cout << endl;
    ll now;
    cin >> now;
    while (now != 0) {
        if (v[now - 1] == max(dp[0][1], dp[1][1])) {
            for (int i = 1; i <= n; ++i) {
                cout << r[i] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> now;
    }
}

int main() {
#ifdef LOCAL
//    freopen("inp.txt", "r", stdin);
//    freopen("out.txt", "w", stdout);
//    freopen("err.txt", "w", stderr);
#endif
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int times = 1;
    cin >> times;
    while (times--) {
        solve();
    }
    return 0;
}
