#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rd(a) for (auto &i: a) cin >> i;

ll INF = 1e9;

vector<vector<pair<ll, ll>>> num;
void add(ll n) {
    num = vector<vector<pair<ll, ll>>>(n + 1, vector<pair<ll, ll>>(n + 1, {-1, -1}));
    vector<pair<ll, ll>> st;
   for (int i1 = 1; i1 <= n; i1++) {
       for (int j1 = i1 + 1; j1 <= n; j1++) {
           if (num[i1][j1].first == -1) {
               if (st.empty()) {
                   st.push_back({i1, j1});
               } else {
                   auto [i2, j2] = st.back();
                   st.pop_back();
                   num[i1][j1] = {i2, j2};
                   num[i2][j2] = {i1, j1};
               }
           }
       }
   }
}

void solve1() {
    ll n, k;
    cin >> n >> k;
    add(n);
    ll x, y;
    cin >> x >> y;
    cout << num[x][y].first << " " << num[x][y].second;
    cout << endl;
}

void solve2() {
    ll n, k;
    cin >> n >> k;
    add(n);
    ll x, y;
    cin >> x >> y;
    cout << num[x][y].first << " " << num[x][y].second;
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int a;
    cin >> a;
    if (a == 1) {
        ll t; for (cin >> t; t--;) solve1();
    } else {
        ll t; for (cin >> t; t--;) solve2();
    }
//    ll t; for (cin >> t; t--;) solve();
//    solve();
    return 0;
}