#include <iostream>
#include <vector>

#define MAX(a, b) ((a) < (b) ? (b) : (a))

using namespace std;

vector <int> u, v;

int _count() {
    int a = -1, b = 10000000001, c = 0;
    for (int x : u) {
        if (x > a) {
            ++c;
            a = x;
        }
    }
    for (int x : v) {
        if (x < b) {
            ++c;
            b = x;
        }
    }
    return c;
}

int next(vector <int> &p, int i) {
    int m = 0, k;
    if (i == p.size()) return _count();

    u.push_back(p[i]);
    k = next(p, i + 1);
    m = MAX(m, k);
    u.pop_back();

    v.push_back(p[i]);
    k = next(p, i + 1);
    m = MAX(m, k);
    v.pop_back();

    return m;
}

int one() {
    int n, m = 0;
    cin >> n;
    vector <int> p(n);
    for (int &x : p) cin >> x;

    return next(p, 0);
}


int main() {
    int t;
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #else
        // ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #endif // LOCAL
    cin >> t;
    while (t--) {
        cout << one();
        cout << endl;
    }
    return 0;
}

