#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

const int MX = 2000 + 1;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, int>>> dp(n + 1, vector<pair<int, int>>(n + 1, make_pair(-1e9, 1e9)));
    dp[0][0] = {0, 1e9}; //dp[pref][lst_up] = {mx_ans, lst_down}
    for (int i = 1; i <= n; ++i) {
        for (int lst_up = 0; lst_up <= n; ++lst_up) {
            dp[i][lst_up] = dp[i - 1][lst_up];
        }
        for (int lst_up = 0; lst_up <= n; ++lst_up) {
            auto [ans, lst_down] = dp[i - 1][lst_up];
            if (ans == -1e9) continue;
            dp[i][max(lst_up, a[i])] = max(dp[i][max(lst_up, a[i])], make_pair(ans + (a[i] > lst_up), lst_down));
            dp[i][lst_up] = max(dp[i][lst_up], make_pair(ans + (a[i] < lst_down), min(lst_down, a[i])));
        }
    }
    int mx = 0;
    for (int i = 1; i <= n; ++i) {
        for (auto &[x, y]: dp[i]) {
            mx = max(mx, x);
        }
    }
    cout << mx << "\n";
}