#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int q = 1;
    cin >> q;
    for (int i = 1; i <= q; ++i) {
        solve();
    }
}

struct Fenw {
    vector<int> t;

    Fenw(int n) {
        t.resize(n + 1, 0);
    }

    int get(int len) {
        int ans = 0;
        for (; len > 0 ;len -= len & -len) ans = max(ans, t[len]);
        return ans;
    }

    void upd(int i, int nv) {
        for (; i < t.size(); i += i & -i) t[i] = max(t[i], nv);
    }
};

int get(const vector<int> &a, int n) {
    Fenw fenw(n);
    for (auto &el : a) {
        fenw.upd(el, fenw.get(el - 1) + 1);
    }
    return fenw.get(n);
}

int R = 1;

struct Tree {
    vector<int> t;

    Tree() {
        t.resize(R * 2, 0);
    }

    void update(int i, int nv) {
        t[i += R - 1] = nv, i /= 2;
        while (i) t[i] = min(t[i * 2], t[i * 2 + 1]), i /= 2;
    }

    int get(int ql, int qr) {
        int ans = R;
        for (ql += R, qr += R; ql <= qr; ql >>= 1, qr >>= 1) {
            if (ql & 1) {
                ans = min(ans, t[ql++]);
            }
            if (~qr & 1) {
                ans = min(ans, t[qr--]);
            }
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    R = 1;
    while (R <= n) R <<= 1;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    if (is_sorted(all(a))) {
        cout << n << "\n";
        return;
    }
    int mx = max(2, get(a, n));
    vector<int> pref(n + 1, 0);
    int srt;
    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1]) {
            srt = i;
            break;
        }
    }
    vector<int> d, near(n, n);
    for (int i = n - 1; i >= 0; --i) {
        while (!d.empty() && a[i] < a[d.back()]) {
            d.pop_back();
        }
        if (!d.empty()) {
            near[i] = d.back();
        }
        d.push_back(i);
    }
    for (int i = 0; i < srt; ++i) {
        pref[i] = 1;
    }
    vector<int> suf(n, 0);
    suf[n - 1] = 1;
    int r = n - 1;
    for (int i = n - 2; i >= 0; --i) {
        if (a[i] < a[i + 1]) {
            suf[i] = 1;
            r = i;
        } else {
            break;
        }
    }
    Tree tree;
    for (int i = 0; i < n; ++i) {
        tree.update(i + 1, near[i]);
    }
    int l = 0;
    for (int i = 0; i < n; ++i) {
        if (pref[i]) {
            l = i;
        }
    }
    int ans = mx;
    for (int i = 0, j = r; i <= l; ++i) {
        while (j < n && tree.get(i + 1, j - 1) >= j) {
            ++j;
        }
        if (j < n && tree.get(i + 1, j - 1) < j) {
            ans = max(ans, 2 + pref[i] + (a[i] < a[j]) * (n - j));
        }
    }
    cout << ans << "\n";
}