#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

using ll = long long;

#define int long long
#define all(a) a.begin(), a.end()
#define F first
#define S second
#define fastIo(a) ios_base::sync_with_stdio(a) ; cin.tie(a); cout.tie(a);

const int INF = 1e9;
const ll INFll = 1e18;


pair<int, int> ds[] = {
        {1, 1},
        {-1, -1},
        {1, -1},
        {-1, 1}
};

void code() {
    int n, k;
    cin >> n >> k;
    int a, b;
    cin >> a >> b;
    for (auto & d : ds) {
        int na = a + d.F, nb = b + d.S;
        if (na > n || nb > n || na <= 0 || nb <= 0) continue;
        else {
            cout << na << ' ' << nb << endl;
            return;
        }
    }
}

void decode() {
    int n, k;
    cin >> n >> k;
    int a, b;
    cin >> a >> b;
    for (auto & d : ds) {
        int na = a - d.F, nb = b - d.S;
        if (na > n || nb > n || na <= 0 || nb <= 0) continue;
        else {
            cout << na << ' ' << nb << endl;
            return;
        }
    }
}

signed main() {
    fastIo(0);
    int type;
    cin >> type;
    int t = 1;
    cin >> t;
    while (t--) {
        if (type == 1) code();
        else decode();
    }
}