#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

void solve() {
    int n;
    cin >> n;
    vector<int> p(n + 1);
    for (int i = 1; i <= n; ++i) {
        cin >> p[i];
        --p[i];
    }
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n, vector<int>(n, -INF)));
    dp[0][0][n - 1] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int b = 0; b < n; ++b) {
            for (int last_a = 0; last_a <= p[i]; ++last_a) {
                dp[i][p[i]][b] = max(dp[i][p[i]][b], dp[i - 1][last_a][b] + 1);
            }
        }
        for (int last_a = p[i] + 1; last_a < n; ++last_a) {
            for (int b = 0; b < n; ++b) {
                dp[i][last_a][b] = dp[i - 1][last_a][b];
            }
        }

        for (int last_b = p[i]; last_b < n; ++last_b) {
            for (int a = 0; a < n; ++a) {
                dp[i][a][p[i]] = max(dp[i][a][p[i]], dp[i - 1][a][last_b] + 1);
            }
        }
        for (int last_b = 0; last_b < p[i]; ++last_b) {
            for (int a = 0; a < n; ++a) {
                dp[i][a][last_b] = dp[i - 1][a][last_b];
            }
        }
    }

    int ans = 0;
    for (int a = 0; a < n; ++a) {
        for (int b = 0; b < n; ++b) {
            ans = max(ans, dp[n][a][b]);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}