#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;
const int MAX_N = 200;

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

int p[MAX_N + 1];

int dp1[MAX_N][MAX_N];
int dp2[MAX_N][MAX_N];

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> p[i];
        --p[i];
    }

    auto dp = dp1;
    auto new_dp = dp2;
    for (int a = 0; a < n; ++a) {
        for (int b = 0; b < n; ++b) {
            dp[a][b] = -INF;
        }
    }
    dp[0][n - 1] = 0;
    for (int i = 1; i <= n; ++i) {
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                new_dp[a][b] = -INF;
            }
        }
        for (int b = 0; b < n; ++b) {
            for (int last_a = 0; last_a <= p[i]; ++last_a) {
                new_dp[p[i]][b] = max(new_dp[p[i]][b], dp[last_a][b] + 1);
            }
        }
        for (int last_a = p[i] + 1; last_a < n; ++last_a) {
            for (int b = 0; b < n; ++b) {
                new_dp[last_a][b] = dp[last_a][b];
            }
        }

        for (int last_b = p[i]; last_b < n; ++last_b) {
            for (int a = 0; a < n; ++a) {
                new_dp[a][p[i]] = max(new_dp[a][p[i]], dp[a][last_b] + 1);
            }
        }
        for (int last_b = 0; last_b < p[i]; ++last_b) {
            for (int a = 0; a < n; ++a) {
                new_dp[a][last_b] = max(new_dp[a][last_b], dp[a][last_b]);
            }
        }
        swap(dp1, dp2);
    }

    int ans = 0;
    for (int a = 0; a < n; ++a) {
        for (int b = 0; b < n; ++b) {
            ans = max(ans, dp[a][b]);
        }
    }
    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}