#include <iostream>
#include <vector>
#include <algorithm>

#define int int64_t

using namespace std;

const int MAX_A = 5057;

const int64_t INF_LL = 1LL << 57;

signed main() {
    int n, q; cin >> n >> q;
    vector<int64_t> as(n);
    for (int64_t &i : as) {
        cin >> i;
    }
    sort(as.begin(), as.end());
    vector<int64_t> dp(MAX_A, -INF_LL);
    dp[0] = 0;
    for (int i = 0; i < n; i++) {
        vector<int64_t> new_dp = dp;
        int64_t x = as[i];
        for (int a = 0; a < MAX_A; a++) {
            if (a >= x) {
                new_dp[a] = max(new_dp[a], dp[a - x]);
            }
            if (x <= new_dp[a] + 1 && dp[a] + x > new_dp[a]) {
                new_dp[a] = dp[a] + x;
            }
        }
        dp.swap(new_dp);
    }
    int z; cin >> z; // z == 0
    while (q--) {
        int64_t k, a, b; cin >> k >> a >> b;
        cout << (dp[a] >= b ? "Yes" : "No") << endl;
    }
}
