#include<iostream>
#include<vector>

using namespace std;

typedef long long ll;

#ifdef LOCAL
#define debug(x) cerr<<(#x)<<'\t'<<(x)<<endl;
#else
#define debug(x) ;
#endif

ll n,q,k,m;

struct Node
{
	ll l,r,ans;
};

void dfs(int v,vector<Node> &tree,int povs,bool dir)
{
	debug(v)
	debug(povs)
	debug(dir)
	debug(tree[v].l)
	debug(tree[v].r)
	if(povs>k)
	{
		tree[v].ans=0;
		debug("out")
		return;
	}
	if(tree[v].l==-1)
	{
		tree[v].ans=1;
		return;
	}
	if(v==0)
	{
		dfs(tree[v].l,tree,povs,0);
		dfs(tree[v].r,tree,povs,1);
		tree[v].ans=tree[tree[v].l].ans+tree[tree[v].r].ans;
		return;
	}
	if(dir)
	{
		dfs(tree[v].l,tree,povs+1,0);
		dfs(tree[v].r,tree,povs,1);
		tree[v].ans=tree[tree[v].l].ans+tree[tree[v].r].ans;
		return;
	}
	else
	{
		dfs(tree[v].l,tree,povs,0);
		dfs(tree[v].r,tree,povs+1,1);
		tree[v].ans=tree[tree[v].l].ans+tree[tree[v].r].ans;
		return;
	}
}


int main()
{
	cin>>n>>k>>q;
	vector<Node> tree(n);
	ll v,u;
	for(int i=0;i<n;i++)
	{
		cin>>m;
		if(m==0)
		{
			tree[i]={-1,-1,0};
			continue;
		}
		else
		{
			cin>>v>>u;
			v--;u--;
			tree[i]={v,u,0};
		}
	}
	dfs(0,tree,0,0);
	while(q--)
	{
		cin>>v;
		v--;
		cout<<tree[v].ans<<'\n';
	}
}
