#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <algorithm>


#define int long long


using namespace std;


const int mn = 2e5;
int mi[mn];
int sz[mn];
int k;

void dfs (int v, vector <vector <int>> &gr, int lst, int pov) {
    if (gr[v].size() != 0) {
        if (lst == 0) {
            mi[gr[v][0]] = pov;
            mi[gr[v][1]] = pov + 1;
            dfs(gr[v][0], gr, lst, pov);
            dfs(gr[v][1], gr, 1, pov + 1);
            sz[v] += sz[gr[v][0]];
            sz[v] += sz[gr[v][1]];
        }
        else {
            mi[gr[v][0]] = pov + 1;
            mi[gr[v][1]] = pov;
            dfs(gr[v][0], gr, 0, pov + 1);
            dfs(gr[v][1], gr, 1, pov);
            sz[v] += sz[gr[v][0]];
            sz[v] += sz[gr[v][1]];
        }
    }
    else {
        if (mi[v] <= k) {
            sz[v]++;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector <vector <int>> s(n);
        for (int i = 0; i < n; i++) {
            int l, r;
            cin >> l >> r;
            s[i] = {r, l, i + 1};
        }
        sort(s.begin(), s.end());
        int m = 0;
        int pr = -1;
        for (int i = 0; i < n; i++) {
            if (pr < s[i][1]) {
                pr = s[i][0];
                m++;
            }
        }
        for (int i = 0; i < n / 2; i++) {
            cout << s[i][2] << " ";
        }
        cout << "\n";
    }
}
