#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <chrono>
#include <random>
#include <bitset>

using namespace std;

mt19937 rnd(chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now().time_since_epoch()).count());


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define uset unordered_set
#define umap unordered_map

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef set<int> si;
typedef vector<si> vsi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef set<pi> spi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef tuple<int, int, int> ti;
typedef set<ti> sti;

template<typename t> void input(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename t> void print(t& a, int i = 0, int j = -1) {
	if (j == -1)
		j = a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k];
}
template<typename t> bool minravno(t& a, const t& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}
template<typename t> bool maxravno(t& a, const t& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

const int MAX = 1e5 + 1, INF = 1e18;

bitset<1> dp[MAX], dp2[MAX];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, q;
	cin >> n >> q;
	vi a(n);
	input(a);
	sort(all(a));
	int z;
	cin >> z;
	dp[0][0] = true;
	vector<tuple<int, int, int, int>> qs;
	for (int i = 0; i < q; ++i) {
		int k, a, b;
		cin >> k >> a >> b;
		qs.push_back({ k, a, b, i });
	}
	sort(all(qs));
	int j = 0;
	vector<string> ans(q);
	for (auto x : a) {
		vi mx(MAX, INF);
		for (int i = 0; i < MAX; ++i) {
			if (i > 0)
				mx[i] = mx[i - 1];
			dp[i] = ~dp[i];
			int j = dp[i]._Find_first();
			dp[i] = ~dp[i];
			minravno(mx[i], j - 1);
		}
		while (j < qs.size() && get<0>(qs[j]) < x) {
			auto [k, a, b, id] = qs[j++];
			ans[id] = (mx[a] >= b ? "Yes\n" : "No\n");
		}
		for (int i = 0; i < MAX; ++i) {
			dp2[i] = (dp[i] << x);
			if (i - x >= 0)
				dp2[i] |= dp[i - x];
		}
		for (int i = 0; i < MAX; ++i)
			dp[i] |= dp2[i];
	}

	vi mx(MAX, INF);
	for (int i = 0; i < MAX; ++i) {
		if (i > 0)
			mx[i] = mx[i - 1];
		dp[i] = ~dp[i];
		int j = dp[i]._Find_first();
		dp[i] = ~dp[i];
		minravno(mx[i], j - 1);
	}
	while (j < qs.size()) {
		auto [k, a, b, id] = qs[j++];
		ans[id] = (mx[a] >= b ? "Yes\n" : "No\n");
	}
	for (auto i : ans)
		cout << i;
	return 0;
}