#include <bits/stdc++.h>
#define int long long 
#define pb push_back
#define pii pair < int, int >
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 100000 + 100, L = 20;

int l[maxn], r[maxn], dp[maxn], n;

bool cmp(int x, int y)
{
    return r[x] < r[y];
}

int get(vector < int > &used)
{
    sort(all(used), cmp);
    for (int i = 0; i < 2 * n; ++i)
        dp[i] = 0;
    int mx = 0;
    for (auto j : used)
    {
        int tmp = 0;
        for (int i = 0; i <= l[j]; ++i)
            tmp = max(tmp, dp[i]);
        dp[r[j] + 1] = max(dp[r[j] + 1], tmp + 1);
        mx = max(dp[r[j] + 1], mx);
    }
    return mx;
}

void solve()
{
    cin >> n;
    vector < int > st;
    for (int i = 0; i < n; ++i)
    {
        cin >> l[i] >> r[i];
        st.pb(l[i]);
        st.pb(r[i]);
    }
    sort(all(st));
    st.erase(unique(all(st)), st.end());
    vector < int > us;
    for (int i = 0; i < n; ++i)
    {
        l[i] = lower_bound(all(st), l[i]) - st.begin();
        r[i] = lower_bound(all(st), r[i]) - st.begin();
        us.pb(i);
    }
    int ans = get(us);
    vector < int > used;
    for (int i = 0; i < (1 << n); ++i)
    {
        int cnt = 0;
        for (int j = 0; j < n; ++j)
        {
            if (i & (1 << j))
            {
                cnt++;
            }
        }
        if (2 * cnt != n)
            continue;
        
        for (int j = 0; j < n; ++j)
        {
            if (i & (1 << j))
                used.pb(j);
        }
        int tmp = get(used);
        if (2 * tmp == ans)
        {
            for (auto i : used)
                cout << i + 1 << ' ';
            cout << endl;
            return;
        }
        used.clear();
    }
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}