#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#define int long long

void speed(){
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

vector<int> w;
bool check(int i, int c_x, int c_y, int x, int y, int k){
    if (c_x == x && c_y == y) return 1;
    if (i == w.size() || w[i] > k || c_x > x || c_y > y) return 0;
    return check(i+1, c_x, c_y, x, y, k) || check(i+1, c_x + w[i], c_y, x, y, k) || check(i+1, c_x, c_y + w[i], x, y, k);
}

void main0() {
    int n, q; cin >> n >> q;
    w.resize(n); for (int& i : w) cin >> i;
    sort(w.begin(), w.end());
    int t; cin >> t;
    int u = 0;
    for (int i = 1; i <= q; i++){
        int j, c, d; cin >> j >> c >> d;
        int k = j - u * t, a = c - t * u, b = d - t * u;
        int fl = 1;
        for (int x = 0; x <= a; x++){
            for (int y = 0; y <= b; y++){
                //cout << x << ' ' << y << ' ' << check(0, 0, 0, x, y, k) << '\n';
                fl &= check(0, 0, 0, x, y, k);
            }
        }
        if (fl) {
            u += i; cout << "Yes\n";
        } else {
            cout << "No\n";
        };
    }
}

signed main(){
    //speed();
    int t = 1; //cin >> t;
    while (t--){
        main0();
        cout << '\n';
    }
}