#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define endl '\n'
#define F first
#define S second
#define vi vector <int>
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define sz(a) (int)(a.size())
#define pb push_back
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,tune=native")
//
//#define int long long

const int INF = 1e7 + 7, INFLL = 1e18 + 7, MAX = 205;

pii dp[2][MAX][MAX];

void solve() {
    int n; cin >> n;
    int p[n]; FOR(i, 0, n) cin >> p[i];
    FOR(i, 0, n + 2) FOR(j, 0, n + 2) dp[1][i][j] = {-INF, -INF};
    dp[1][0][n + 1] = {0, 0};
    FOR(g, 0, n) {
        FOR(i, 0, n + 2) FOR(j, 0, n + 2) dp[g & 1][i][j] = dp[!(g & 1)][i][j];
        FOR(i, 0, n + 2) FOR(j, 0, n + 2) {
            if (dp[!(g & 1)][i][j].F + dp[!(g & 1)][i][j].S + (i < p[g]) > dp[g & 1][max(i, p[g])][j].F + dp[g & 1][max(i, p[g])][j].S) dp[g & 1][max(i, p[g])][j] = {dp[!(g & 1)][i][j].F + (i < p[g]), dp[!(g & 1)][i][j].S};
            if (dp[!(g & 1)][i][j].F + dp[!(g & 1)][i][j].S + (j > p[g]) > dp[g & 1][i][min(j, p[g])].F + dp[g & 1][i][min(j, p[g])].S) dp[g & 1][i][min(j, p[g])] = {dp[!(g & 1)][i][j].F, dp[!(g & 1)][i][j].S + (j > p[g])};
        }
    }
    int ans = 0;
    FOR(i, 0, n + 2) FOR(j, 0, n + 2) ans = max(ans, dp[!(n & 1)][i][j].F + dp[!(n & 1)][i][j].S);
    cout << ans << endl;
}

const int R = 16;
int tu[2 * R], td[2 * R];
void updu(int p, int x) {
    p += R;
    tu[p] = x;
    while (p >>= 1) tu[p] = max(tu[2 * p], tu[2 * p + 1]);
}
int getu(int l, int r) {
    l += R, r += R;
    int v = 0;
    while (l < r) {
        if (l & 1) v = max(v, tu[l++]);
        if (!(r & 1)) v = max(v, tu[r--]);
        l >>= 1, r >>= 1;
    }
    if (l == r) v = max(v, tu[l]);
    return v;
}
void updd(int p, int x) {
    p += R;
    td[p] = x;
    while (p >>= 1) td[p] = max(td[2 * p], td[2 * p + 1]);
}
int getd(int l, int r) {
    l += R, r += R;
    int v = 0;
    while (l < r) {
        if (l & 1) v = max(v, td[l++]);
        if (!(r & 1)) v = max(v, td[r--]);
        l >>= 1, r >>= 1;
    }
    if (l == r) v = max(v, td[l]);
    return v;
}

void solve_2nn2() {
    int n, ans = 0; cin >> n;
    int p[n]; FOR(i, 0, n) cin >> p[i], --p[i];
    FOR(mask, 1, (1 << n) - 1) {
        memset(tu, 0, sizeof tu);
        memset(td, 0, sizeof td);
        FOR(i, 0, n) {
            if ((mask >> i) & 1) updu(p[i], getu(0, p[i] - 1) + 1);
            else updd(p[i], getd(p[i] + 1, R) + 1);
        }
        ans = max(ans, tu[1] + td[1]);
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int tc; cin >> tc;
    while (tc--) solve_2nn2();
}
