#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using i128 = __int128_t;

#define int ll
#define all(a) (a).begin(), (a).end()

const ll INF64 = 2'000'000'000'000'000'228;
const int INF = 2'000'000'228;
const int MOD = 1'000'004'099;

const int seed = chrono::steady_clock().now().time_since_epoch().count();
mt19937_64 rnd(seed);

template<>
struct std::hash<pair<int, int>> {
    ll operator()(pair<int, int> p) const {
        return ((i128) p.first * MOD + p.second) % INF64;
    }
};

unordered_map<pair<int, int>, bool> ans;
unordered_map<pair<int, int>, bool> global_ans;

bool f(vector<int> &w, int i, int nx, int ny, int k) {
    if (i == w.size()) {
        return nx == 0 && ny == 0;
    }
    return !(!f(w, i + 1, nx, ny, k) && (k < w[i] || (!f(w, i + 1, nx - w[i], ny, k) && !f(w, i + 1, nx, ny - w[i], k))));
}

bool ch(int i, int j) {
    if (i < 0 || j < 0)
        return true;
    return global_ans[{i, j}];
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (int &i: w)
        cin >> i;
    int z;
    cin >> z;
//    assert(z == 0);
    while (q--) {
        int ppp, c, d;
        cin >> ppp >> c >> d;
        int k = ppp, a = c, b = d;
        bool flag = true;
        for (int i = 0; i <= a; ++i)
            for (int j = 0; j <= b; ++j)
                flag &= f(w, 0, i, j, k);
        cout << (flag ? "Yes\n" : "No\n");
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    return 0;
}