#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define fi first
#define se second
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()
const int MX = 301;

int n, q;
int w[MX];

int dp[MX][MX][MX];
int res[MX][MX];
int ans[300010];

struct node{
    int k, a, b, id;
};

vector<node> quest[MX];

void solve() {
    cin >> n >> q;
    for (int i = 0; i < n; i++) cin >> w[i];
    int z; cin >> z;

    sort(w, w + n);
    w[n] = 1e18 + 1;

    for (int i = 0; i < q; i++) {
        ll k, a, b; cin >> k >> a >> b;
        int ind = upper_bound(w, w + n, k) - w;
        //cout << ind << "!\n";
        quest[ind].push_back({k, a, b, i});
    }


    dp[0][0][0] = 1;

    for (int i = 1; i <= n; i++) {
        res[0][0] = 1;
        for (int ii = 0; ii < MX; ii++) {
            for (int jj = 0; jj < MX; jj++) {
                if (ii == 0 && jj == 0) continue;
                if (ii == 0) {
                    res[ii][jj] = res[ii][jj - 1] && dp[i - 1][ii][jj];
                } else if (jj == 0) {
                    res[ii][jj] = res[ii - 1][jj] && dp[i - 1][ii][jj];
                } else {
                    res[ii][jj] = res[ii - 1][jj] && res[ii][jj - 1] && dp[i - 1][ii][jj];
                }
            }
        }

        /// answer all quests

        for (node Q : quest[i - 1]) {
            int a = Q.a, b = Q.b;
            //cout << w[i-1] << ": " << a << " " << b << " " << Q.id << "\n";
            if (res[a][b]) ans[Q.id] = 1;
        }



        for (int x = 0; x < MX; x++) {
            for (int y = 0; y < MX; y++) dp[i][x][y] = dp[i - 1][x][y];
        }
        for (int x = w[i - 1]; x < MX; x++) {
            for (int y = 0; y < MX; y++) dp[i][x][y] |= dp[i - 1][x - w[i - 1]][y];
        }
        for (int y = w[i - 1]; y < MX; y++) {
            for (int x = 0; x < MX; x++) dp[i][x][y] |= dp[i - 1][x][y - w[i - 1]];
        }
    }


    for (int i = 0; i < q; i++) {
        if (ans[i]) cout << "Yes\n";
        else cout << "No\n";
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie(0);
#endif
    int T = 1;
    // cin >> T;
    while (T--) solve();
    return 0;
}
