#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize(3)
#pragma GCC optimize("O3")
using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define fi first
#define se second
#define sz(x) (int)(x.size())
#define all(x) x.begin(), x.end()
const int MX = 2e5 + 10;

int n, q;
vector<int> g[MX];
int w[MX];
int dp[2][MX];

void dfs(int u, int p) {
    dp[0][u] = 0;
    dp[1][u] = w[u];
    for (int v : g[u]) {
        if (v == p) continue;
        dfs(v, u);
        dp[1][u] += dp[0][v];
        dp[0][u] += max(dp[0][v], dp[1][v]);
    }
}


void solve() {
    cin >> n >> q;
    int x, y, m; cin >> x >> y >> m;
    for (int i = 0; i < n - 1; i++) {
        int u, v; cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 1; i <= n; i++) cin >> w[i] >> w[i];
    dfs(1, 1);
    int d = max(dp[0][1], dp[1][1]);

    int k = 0;
    for (int i = 1; i <= n; i++) { k ^= (x * i + y * w[i] % m * w[i] % m) % m;}
    int p = 0;
    for (int i = 0; i < q; i++) {
        int t; cin >> t;
        if (t != d) cout << "-1 ";
        else {
            p = i + 1;
            cout << k << " ";
        }
    }
    cout << endl;

    cin >> x;
    while (x != 0) {
        if (x == p) {
            for (int i = 1; i <= n; i++) cout << w[i] << " ";
        } else {
            cout << "-1";
        }
        cout << endl;
        cin >> x;
    }
    for (int i = 0; i <= n; i++) g[i].clear();
    cout << endl;

}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie(0);
#endif
    int T = 1;
    cin >> T;
    while (T--) solve();
    return 0;
}
