﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <tuple>
#include <cassert>
using namespace std;

#define all(x) x.begin(), x.end()
typedef long long ll;

int main() {
	cin.tie(0)->sync_with_stdio(0);
	int tt;
	cin >> tt;
	while (tt-- > 0) {
		int n;
		cin >> n;
		vector<pair<int, int>> a;
		for (int i = 0; i < n; ++i) {
			int x, y;
			cin >> x >> y;
			a.emplace_back(x, y);
		}
		vector<int> ord(n);
		iota(all(ord), 0);
		sort(all(ord), [&](int i, int j) { return a[i] < a[j]; });
		bool group1 = true;
		for (int i = 1; i < n; ++i) {
			if (a[ord[i - 1]].second >= a[ord[i]].first) group1 = false;
		}
		if (group1) {
			for (int i = 0; i < n / 2; ++i) {
				cout << i + 1 << ' ';
			}
			cout << endl;
		}
	}
	return 0;
}