#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using vi = vector<int>;

const int maxN = 3e5;

int a, test, n, k, p[maxN];
unordered_set<int> used;
vi ans;

void solve1() {
    used.clear();
    cin >> n >> k;
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
        used.insert(p[i]);
    }
    ans.clear();
    for (int i = 0, j = 0; i < k; i++) {
        j = max(j, p[i]);
        int id = j % n;
        while (used.find(id) != used.end()) {
            j++;
            id = (id + 1 == n ? 0 : id + 1);
        }
        used.insert(id);
        ans.push_back(id + 1);
    }
    sort(ans.begin(), ans.end());
    for (int i : ans)
        cout << i << " ";
    cout << endl;
}

void solve2() {
    used.clear();
    cin >> n >> k;
    for (int i = 0; i < k; i++) {
        cin >> p[i];
        p[i]--;
        used.insert(p[i]);
    }
    ans.clear();
    for (int i = k - 1, j = n - 1; i >= 0; i--) {
        j = min(j, p[i]);
        int id = (j % n + n) % n;
        while (used.find(id) != used.end()) {
            j--;
            id = (id - 1 == -1 ? n - 1 : id - 1);
        }
        used.insert(id);
        ans.push_back(id + 1);
    }
    sort(ans.begin(), ans.end());
    for (int i : ans)
        cout << i << " ";
    cout << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> a >> test;
    if (a == 1) {
        while (test--)
            solve1();
    } else {
        while (test--)
            solve2();
    }
    return 0;
}
