#include <bits/stdc++.h>

using namespace std;
#define all(x) (x).begin(), (x).end()

void solve() {
    int n;
    cin >> n;
    vector<array<int, 3>> segs(n);
    vector<int> cords;
    for (int i = 0; i < n; i++) {
        cin >> segs[i][0] >> segs[i][1];
        segs[i][2] = i;
        cords.push_back(segs[i][0]);
        cords.push_back(segs[i][1]);
    }
    sort(all(cords));
    cords.resize(unique(all(cords)) - cords.begin());
    auto get = [&](int x) {
        return (int) (lower_bound(all(cords), x) - cords.begin());
    };
    for (int i = 0; i < n; i++) {
        segs[i][0] = get(segs[i][0]);
        segs[i][1] = get(segs[i][1]);
    }
    auto calc = [](vector<array<int, 3>> segs) {
        sort(all(segs), [](auto &a, auto &b) {
            return array<int, 3>{a[1], a[0], a[2]} < array<int, 3>{b[1], b[0], b[2]};
        });
        int cnt = 0;
        int pr = -1;
        for (auto [l, r, id]: segs) {
            if (l > pr) {
                cnt++;
                pr = r;
            }
        }
        return cnt;
    };
    auto calc2 = [](vector<array<int, 3>> &segs) {
        int nn = segs.size();
        vector<bool> is(nn);
        for (int i = 0; i < nn; i++) {
            bool ok = true;
            for (int j = 0; j < nn; j++) {
                if (i == j) {
                    continue;
                }
                ok &= !(segs[j][0] >= segs[i][0] && segs[j][1] <= segs[i][1]);
            }
            is[i] = ok;
        }
        return is;
    };
    int m = calc(segs);
    int nn = n;
    int mm = m;
    while (nn != n / 2) {
        auto is = calc2(segs);
        vector<int> cnt(nn);
        for (int i = 0; i < nn; i++) {
            if (is[i]) {
                continue;
            }
            for (int j = 0; j < nn; j++) {
                if (segs[j][0] >= segs[i][0] && segs[j][1] <= segs[i][1] && is[j]) {
                    cnt[i]++;
                }
            }
        }
        vector<int> del;
        vector<int> old;
        for (int i = 0; i < nn; i++) {
            if (!is[i]) {
                old.push_back(i);
                continue;
            }
            bool fl = false;
            for (int j = 0; j < nn; j++) {
                if (i == j) {
                    continue;
                }
                if (segs[j][0] <= segs[i][0] && segs[j][1] >= segs[i][1]) {
                    if (cnt[j] == 1) {
                        fl = true;
                    }
                }
            }
            if (fl) {
                old.push_back(i);
            } else {
                del.push_back(i);
            }
        }

        if (mm > m / 2 && !del.empty()) {
            cout << segs[del.back()][2] + 1 << ' ';
            cout.flush();
            mm--;
            del.pop_back();
        } else {
            assert(mm == m / 2);
            assert(!old.empty());
            cout << segs[old.back()][2] + 1 << ' ';
            cout.flush();
            old.pop_back();
        }
        segs.clear();
        for (int i: old) {
            segs.push_back(segs[i]);
        }
        for (int i: del) {
            segs.push_back(segs[i]);
        }
        nn--;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}