#include <algorithm>
#include <iomanip>
#include <vector>
#include <string>
#include <iostream>
#include <set>
#include <map>
using namespace std;
typedef long long ll;
typedef long double ld;
vector<vector<ll>> g;
vector<pair<ll, ll>> lim;
vector<pair<ll, ll>> dp;
ll n, q;
ll x, y, m;

void dfs(ll v, ll p = -1) {
	ll sum = 0;
	ll sum2 = 0;
	for (ll to : g[v]) {
		if (to == p) continue;
		dfs(to, v);
		sum += dp[to].second;
		sum2 += max(dp[to].second, dp[to].first);
	}
	dp[v].first = sum + lim[v].first;
	dp[v].second = sum2;
}

void solve() {
	cin >> n >> q;
	cin >> x >> y >> m;
	g.clear(); g.resize(n);
	dp.assign(n, { 0, 0 });
	for (int i = 0; i < n - 1; ++i) {
		ll s, f;
		cin >> s >> f;
		--s; --f;
		g[s].push_back(f);
		g[f].push_back(s);
	}
	lim.resize(n);
	for (int i = 0; i < n; ++i) cin >> lim[i].first >> lim[i].second;
	dfs(0);
	ll res = max(dp[0].first, dp[0].second);
	vector<ll> qr(q);
	for (int i = 0; i < q; ++i) {
		ll v; cin >> v;
		ll k = 0;
		if (v == res) {
			for (int j = 0; j < n; ++j) {
				k ^= ((x * (j + 1) + y * lim[j].first * lim[j].first) % m);
			}
			qr[i] = k;
			cout << k << " ";
			cout.flush();
		}
		else {
			cout << -1 << " ";
			qr[i] = -1;
			cout.flush();
		}
	}
	ll c;
	while (1) {
		cin >> c;
		if (!c) break;
		if (qr[c - 1] == -1) cout << -1 << endl;
		else {
			for (int i = 0; i < n; ++i) {
				cout << lim[i].first << " ";
			}
			cout << endl;
		}
	}

}

int main() {
	ios::sync_with_stdio(0); cout.tie(0); cin.tie(0);
	ll tc;
	cin >> tc;
	while (tc--) {
		solve();
	}
}