#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 2e18;

inline void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> w(n);
    for (auto& i : w)
        cin >> i;
    sort(w.begin(), w.end());
    int z;
    cin >> z;
    for (int i = 0; i < q; ++i) {
        int k, a, b;
        cin >> k >> a >> b;
        vector<int> neww;
        for (auto j : w) {
            if (j <= k)
                neww.push_back(j);
            else
                break;
        }
        int maxmask = 1;
        for (int j = 0; j <= neww.size(); ++j)
            maxmask *= 3;
        if (maxmask == 1) {
            cout << (a == b && a == 0 ? "Yes\n" : "No\n");
            continue;
        }
        set<pair<int, int>> used;
        for (int mask = 0; mask < maxmask; ++mask) {
            int curmask = mask;
            vector<int> cur(3);
            int ii = 0;
            while (curmask) {
                cur[curmask % 3] += neww[ii++];
                curmask /= 3;
            }
            used.insert({cur[0], cur[1]});
        }
        bool flag = true;
        for (int j = 0; j <= a; ++j) {
            for (int kk = 0; kk <= b; ++kk) {
                flag &= used.find({j, kk}) != used.end();
                if (!flag) {
                    // cout << j << ' ' << kk << '\n';
                    break;
                }
            }
            if (!flag)
                break;
        }
        cout << (flag ? "Yes\n" : "No\n");
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    for (int t = 1; t <= tests; ++t)
        solve();
    return 0;
}
