#include <bits/stdc++.h>

#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#define showTest(x) cout << "_____TEST #" << x << "_____\n";
#else
#define dbg(x)
#define showTest(x)
#endif

using namespace std;

using ll = long long;
using ld = long double;

template <class A> 
inline bool umin(A& x, const A&y) {
    if (x <= y) return false;
    x = y;
    return true;
}

template <class A>
inline bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}

// #define int ll
#define sz(x) int((x).size())

void solve() {
    int n, k, q;
    cin >> n >> k >> q;

    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        while (t--) {
            int j;
            cin >> j;
            --j;
            g[i].push_back(j);
        }
    }

    vector<int> qrs(q);
    for (int& x : qrs) {
        cin >> x;
        --x;
    }

    int t = 0;
    vector<int> tin(n), tout(n), cnt(n);

    vector<int> val(2 * n, 2 * n);

    auto dfs = [&](auto dfs, int u, int d) -> void {
        tin[u] = t++;
        if (g[u].empty()) {
            val[tin[u]] = cnt[u];
        }
        if (!g[u].empty()) {
            for (int i = 0; i < 2; ++i) {
                int v = g[u][i];
                cnt[v] = cnt[u] + (d != -1 && d != i);
                dfs(dfs, v, i);
            }
        }
        tout[u] = t++;
    };
    dfs(dfs, 0, -1);

    vector<int> p(2 * n + 1);
    for (int i = 0; i < 2 * n; ++i) {
        p[i + 1] = p[i] + (val[i] <= k);
    }

    for (int u : qrs) {
        cout << p[tout[u] + 1] - p[tin[u]] << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    for (int t = 1; t <= T; ++t) {
        showTest(t);
        solve();
    }
}