#include <bits/stdc++.h>

#ifdef DESPAIR_101
#include "debug.h"
#define dbg(x) cout << #x << ":\n "; debug::print(x); cout << "\n"
#define showTest(x) cout << "_____TEST #" << x << "_____\n";
#else
#define dbg(x)
#define showTest(x)
#endif

using namespace std;

using ll = long long;
using ld = long double;

template <class A> 
inline bool umin(A& x, const A&y) {
    if (x <= y) return false;
    x = y;
    return true;
}

template <class A>
inline bool umax(A& x, const A& y) {
    if (x >= y) return false;
    x = y;
    return true;
}

// #define int ll
#define sz(x) int((x).size())

mt19937 rnd(101);

int calc(vector<pair<int, int>> e) {
    int n = sz(e);
    
    vector<pair<int, int>> ev;
    for (int i = 1; i <= n; ++i) {
        ev.emplace_back(e[i - 1].first, -i);
        ev.emplace_back(e[i - 1].second, i);
    }

    sort(ev.begin(), ev.end());

    vector<int> dp(n);
    int best = 0;

    for (auto [x, ind] : ev) {
        if (ind > 0) {
            --ind;
            ++dp[ind];
            umax(best, dp[ind]);
        } else {
            ++ind;
            ind = -ind;
            dp[ind] = best;
        }
    }

    return best;
}

void solve() {
    int n;
    cin >> n;

    vector<pair<int, int>> e(n);
    for (auto& [l, r] : e) {
        cin >> l >> r;
    }

    int kok = calc(e);
    vector<int> ind(n);
    iota(ind.begin(), ind.end(), 0);

    sort(ind.begin(), ind.end(), [&](int i, int j) {
        return e[i] < e[j];
    });

    vector<int> kek(n / 2);
    iota(kek.begin(), kek.end(), 0);
    shuffle(kek.begin(), kek.end(), rnd);

    for (int i : kek) {
        vector<pair<int, int>> sus;
        for (int j = 0; j < n / 2; ++j) {
            sus.push_back(e[ind[i + j]]);
        }

        if (2 * calc(sus) == kok) {
            for (int j = 0; j < n / 2; ++j) {
                cout << ind[i + j] + 1 << ' ';
            }
            cout << '\n';
            return;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    for (int t = 1; t <= T; ++t) {
        showTest(t);
        solve();
    }
}