#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <stack>
#include <queue>
#include <cmath>
#include <random>

using namespace std;

#define int long long
#define endl '\n'

vector<int> getbin(int x)
{
	vector<int> ret;
	for (int j = 0; j < 8; j++)
	{
		ret.push_back(x % 2);
		x /= 2;
	}
	return ret;
}

void task()
{
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
	{
		cin >> v[i];
	}
	vector<vector<vector<int>>> dp(n + 1, vector<vector<int>>(n + 2, vector<int>(n + 2, LLONG_MIN)));
	dp[0][0][n + 1] = 0;

	for (int i = 1; i <= n; i++)
	{
		int x = v[i - 1];
		for (int j = 0; j < n + 2; j++)
		{
			for (int k = 0; k < n + 2; k++)
			{
				if (x > j) dp[i][x][k] = max(dp[i][x][k], dp[i - 1][j][k] + 1);
				else dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);

				if (x < k) dp[i][j][x] = max(dp[i][j][x], dp[i - 1][j][k] + 1);
				else dp[i][j][k] = max(dp[i][j][k], dp[i - 1][j][k]);
			}
		}
	}

	int maxans = 0;
	for (int i = 0; i < n + 2; i++)
	{
		for (int j = 0; j < n + 2; j++)
		{
			maxans = max(maxans, dp[n][i][j]);
		}
	}

	cout << maxans << endl;
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 1;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}
