#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <random>
#include <climits>
#include <deque>
#include <stack>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <chrono>
#include <iomanip>
#include <stdio.h>

using namespace std;

#define int long long
#define endl '\n'

int binpow(int x, int y)
{
	if (y == 0) return 1;
	if (y == 1) return x;

	int k = binpow(x, y / 2);
	if (y % 2 == 0) return k * k;
	else return k * k * x;
}

struct Q
{
	int k, a, b, num;
	int ans = 0;
};

void task()
{
	int n, q;
	cin >> n >> q;
	vector<int> v(n);
	for (int i = 0; i < n; i++) cin >> v[i];
	sort(v.begin(), v.end());

	int z;
	cin >> z;

	vector<Q> qs;
	vector<vector<int>> nn(v.size());

	int i = 0;
	while (q--)
	{
		int k, a, b;
		cin >> k >> a >> b;
		qs.push_back({ k,a,b,i++ });

		if (k < v[0])
		{
			if (a != 0 || b != 0)
			{
				qs[i - 1].ans = 0;
			}
			else
			{
				qs[i - 1].ans = 1;
			}
		}
		else
		{
			int l = 0;
			int r = v.size();
			while (r - l > 1)
			{
				int m = (r + l) / 2;
				if (v[m] <= k) l = m;
				else r = m;
			}
			nn[l].push_back(i - 1);
		}
	}

	vector<pair<int, int>> s;
	s.push_back({ 0,0 });

	for (int i = 0; i < n; i++)
	{
		int x = v[i];
		for (int j = 0; j < s.size(); j++)
		{
			s.push_back({ s[i].first + x, s[i].second + x });
		}
		sort(s.begin(), s.end());
		vector<pair<int, int>> ns{ {0, 0} };
		for (int j = 0; j < s.size(); j++)
		{
			if (s[i].first <= ns.back().second)
			{
				ns.back().second = max(ns.back().second, s[j].second);
			}
		}

		int m = ns[0].second;

		for (int j = 0; j < nn.size(); j++)
		{
			if (qs[nn[i][j]].a <= m) qs[nn[i][j]].ans = 1;
			else qs[nn[i][j]].ans = 0;
		}
	}

	for (int i = 0; i < qs.size(); i++)
	{
		if (qs[i].ans) cout << "Yes" << endl;
		else cout << "No" << endl;
	}
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cout << fixed << setprecision(15);

	bool multitest = 0;
	int t = 1;
	if (multitest) cin >> t;
	while (t--) task();

	return 0;
}