#include <iostream>
#include <vector>
#include <algorithm>

using namespace  std;
vector<int> g[2000 * 101];
int turn[2000 * 101];
int d[2000 * 101];
int dp[2000 * 101][21];

void dfs(int v, int now, int was, int de = 0) {
    turn[v] = now;
    d[v] = de;
    int i = 0;
    for (auto u : g[v]) {
        if (was == -1 || was == i) {
            dfs(u, now, i, de + 1);
        } else {
            dfs(u, now + 1, i, de + 1);
        }
        i++;
    }

    if (g[v].size() == 0) {
        for (int i = 0; i <= 20; i++) {
            dp[v][i] = 1;
        }
        return;
    }

    for (int rest = 0; rest < 21; rest++) {
        i = 0;
        for (auto u : g[v]) {
            if (was == -1 || was == i) {
                dp[v][rest] += dp[u][rest];
            } else {
                if (rest > 0) {
                    dp[v][rest] += dp[u][rest - 1];
                }
            }
            i++;
        }

    }

}



int main() {
    int n, k, q;
    cin >> n >> k >> q;
    for (int i = 1; i <= n; i++) {
       int t;
       cin >> t;
       for (int j = 0; j < t; j++) {
           int x;
           cin >> x;
           g[i].push_back(x);
       }
    }

    dfs(1, 0, -1);


    for (int i = 0; i < q; i++) {
        int u;
        cin >> u;
        int rest = k - turn[u];
        if (rest < 0) {
            cout << 0 << endl;
            continue;
        }
        if (rest > 20) {
            rest = 20;
        }
        cout << dp[u][rest] << endl;
    }

}
