#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

using namespace  std;

bool cmp(pair<pair<int, int>, int> a, pair<pair<int, int>, int> b) {
    return a.first.second < b.first.second;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first.first >> v[i].first.second;
        v[i].second = i + 1;
    }
    sort(v.begin(), v.end(), cmp);
    int mn = 0;
    vector<int> ends;
    for (int i = 0; i < n; i++) {
        if (v[i].first.first > mn) {
            mn = v[i].first.second;
            ends.push_back(mn);
        }
    }
    vector<vector<pair<pair<int, int>, int>>> bu(ends.size());
    for (int i = 0; i < n; i++) {
        auto it = lower_bound(ends.begin(), ends.end(), v[i].first.first) - ends.begin();
        bu[it].push_back(v[i]);
    }
    vector<pair<int, int>> sz;
    for (int i = 0; i < ends.size(); i++) {
        sz.push_back({bu[i].size(), i});
    }
    sort(sz.begin(), sz.end());
    vector<int> to_del(n);
    int need = n / 2;
    for (int i = 0; i < ends.size() / 2; i++) {
        for (auto x : bu[sz[i].second]) {
            to_del[x.second] = 1;
            need--;
        }
    }
    for (int i = ends.size() / 2; i < ends.size(); i++) {
        if (need == 0) {
            break;
        }
        sort(bu[sz[i].second].begin(), bu[sz[i].second].end());
        reverse(bu[sz[i].second].begin(), bu[sz[i].second].end());
        for (int j = 0; j < sz[i].first; j++) {
            to_del[bu[sz[i].second][j].second] = 1;
            need--;
            if (need == 0) {
                break;
            }
        }
    }
    for (int i = 1; i <= n; i++) {
        if (!to_del[i]) {
            cout << i << ' ';
        }
    }
    cout << endl;
}

int main() {
    int t;
    cin >> t;

    for (int i = 0; i < t; i++) {
        solve();
    }

}
