#include<bits/stdc++.h>


using namespace std;
typedef long long ll;
const int INF = 1e9 + 1;


pair<int, vector<bool>> nvp(vector<int>& a, int z1, int z2)
{
    vector<int> dp(a.size() + 1, INF);
    dp[0] = 0;
    int ans = 1;
    vector<vector<int>> rem(dp.size());
    vector<int> pred(dp.size(), -1);
    rem[0].push_back(0);
    for (int i = 0; i < a.size(); i++)
    {
        if (a[i] == z1 || a[i] == z2)
        {
            continue;
        }
        int L = 0;
        int R = dp.size() - 1;
        while (R - L != 1)
        {
            int mid = (R + L) >> 1;
            if (dp[mid] > a[i])
            {
                R = mid;
            }
            else
            {
                L = mid;
            }
        }
        dp[R] = a[i];
        pred[a[i]] = dp[R - 1];
        int L1 = -1;
        int R1 = rem[R - 1].size() - 1;
        while (R1 - L1 != 1)
        {
            int mid = (R1 + L1) >> 1;
            if (rem[R - 1][mid] < a[i])
            {
                R1 = mid;
            }
            else
            {
                L1 = mid;
            }
        }
        pred[a[i]] = rem[R - 1][R1];
        rem[R].push_back(a[i]);
        ans = max(ans, R);
    }
    vector<bool> used(dp.size(), false);
    int nw = rem[ans][0];
    while (nw != -1)
    {
        used[nw] = true;
        nw = pred[nw];
    }
    return {ans, used};
}



int main()
{
    int t;
    cin >> t;
    for (int T = 0; T < t; T++)
    {
        int n;
        cin >> n;
        vector<int> a(n);
        vector<int> order;
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
            if (i > 0 && a[i] < a[i - 1])
            {
                order.push_back(i - 1);
            }
        }
        auto [ans, used1] = nvp(a, 0, 0);
        random_shuffle(order.begin(), order.end());
        ans = min(ans + 1, n);
        for (int i = 0; i < min(100, (int)order.size()); i++)
        {
            int mx = 0;
            auto [ansnow, used] = nvp(a, a[order[i]], a[order[i] + 1]);
            ansnow = min(ansnow + 1, n);
            for (auto el: a)
            {
                if (!used[el] && el < mx)
                {
                ansnow++;
                break;
                }
                mx = max(el, mx);
            }
            ans = max(ansnow, ans);
        }

        cout << ans << endl;
    }
    return 0;
}
