#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend

void solve1(int n, int k, const vector<int> &a) {
    set<int> used;
    for (int x : a) {
        used.insert(x);
    }
    vector<int> res;
    int cur = 0;
    for (int i = 0; i < k; i++) {
        cur++;
        int ind = (a[i] + 1) % n;
        int nxt = a[(i + 1) % k];
        if (i == k - 1) {
            nxt = 1000000000000000;
        }
        while (cur > 0 && ind != nxt) {
            if (used.find(ind) == used.end()) {
                res.push_back(ind);
                used.insert(ind);
                cur--;
            }
            ind = (ind + 1) % n;
        }
    }
    sort(all(res));
    for (int x : res) {
        cout << x + 1 << ' ';
    }
    cout << endl;
}

void solve2(int n, int k, vector<int> a) {
    for (int i = 0; i < k; i++) {
        a[i] = n - 1 - a[i];
    }
    reverse(all(a));
    set<int> used;
    for (int x : a) {
        used.insert(x);
    }
    vector<int> res;
    int cur = 0;
    for (int i = 0; i < k; i++) {
        cur++;
        int ind = (a[i] + 1) % n;
        int nxt = a[(i + 1) % k];
        if (i == k - 1) {
            nxt = 1000000000000000;
        }
        while (cur > 0 && ind != nxt) {
            if (used.find(ind) == used.end()) {
                res.push_back(ind);
                used.insert(ind);
                cur--;
            }
            ind = (ind + 1) % n;
        }
    }
    for (int i = 0; i < k; i++) {
        res[i] = n - 1 - res[i];
    }
    sort(all(res));
    for (int x : res) {
        cout << x + 1 << ' ';
    }
    cout << endl;
}

void solve() {
    int type;
    cin >> type;
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int n, k;
        cin >> n >> k;
        vector<int> a(k);
        for (int j = 0; j < k; j++) {
            cin >> a[j];
            a[j]--;
        }
        if (type == 1) {
            solve1(n, k, a);
        } else {
            solve2(n, k, a);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}