#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;

int x, y, m;

vector<vector<int>> g;

vector<pair<int, int>> dp;

void dfs_calc(int v, int p) {
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs_calc(u, v);
        dp[v].X += dp[u].Y;
        dp[v].Y += max(dp[u].X, dp[u].Y);
    }
}

pair<int, int> calc(int n, const vector<int> &a) {
    dp.assign(n, {});
    for (int i = 0; i < n; i++) {
        dp[i] = {a[i], 0};
    }
    dfs_calc(0, 0);
    int k = 0;
    for (int i = 0; i < n; i++) {
        k ^= (x * (i + 1) + y * ((a[i] * a[i]) % m)) % m;
    }
    return {max(dp[0].X, dp[0].Y), k};
}

void solve() {
    int n, q;
    cin >> n >> q;
    cin >> x >> y >> m;
    g.assign(n, vector<int>());
    for (int i = 0; i < n - 1; i++) {
        int s, f;
        cin >> s >> f;
        s--, f--;
        g[s].push_back(f);
        g[f].push_back(s);
    }
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    vector<int> v(q);
    for (int i = 0; i < q; i++) {
        cin >> v[i];
    }
    pair<int, int> ans = calc(n, r);
    for (int i = 0; i < q; i++) {
        if (v[i] == ans.X) {
            cout << ans.Y << ' ';
        } else {
            cout << -1 << ' ';
        }
        cout << endl;
    }
    int ind;
    cin >> ind;
    while (ind != 0) {
        if (v[ind] == ans.X) {
            for (int i = 0; i < n; i++) {
                cout << r[i] << ' ';
            }
            cout << endl;
        } else {
            cout << -1 << endl;
        }
        cin >> ind;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}