#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cmath>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
using namespace std;

typedef int64_t ll;
typedef uint64_t ull;

const ll inf = 1234567891;
const ll M = 1e9 + 7;
const ll INF = 1e18 + 21;
const double PI = acos(-1);

int n;
vector<ll> a;
vector<ll> f, s;
ll ans = 0;

void rec(int i) {
	if (i == n) {
		ll cur = 0;
		bool ok = true;
		for (int i = 0; i < f.size(); ++i) {
			ok = true;
			for (int j = 0; j < i; ++j) {
				if (f[i] <= f[j]) {
					ok = false;
					break;
				}
			}
			if (ok) ++cur;
		}
		for (int i = 0; i < s.size(); ++i) {
			ok = true;
			for (int j = 0; j < i; ++j) {
				if (s[i] >= s[j]) {
					ok = false;
					break;
				}
			}
			if (ok) ++cur;
		}
		if (cur > ans) {
			ans = cur;
		}
		return;
	}
	f.push_back(a[i]);
	rec(i + 1);
	f.pop_back();
	s.push_back(a[i]);
	rec(i + 1);
	s.pop_back();
}

void solve() {
	cin >> n;
	a.resize(n);
	for (auto& e : a) cin >> e;
	ans = 0;
	rec(0);
	cout << ans << '\n';
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
	}
}