#include <bits/stdc++.h>

using namespace std;

const int INF = INT_MAX;

map<vector<int>, int> mapa;

int get(vector<int> a) {
    if (mapa.find(a) != mapa.end()) return mapa[a];
    return 0;
}

int solve(int n, vector<int> p) {
    vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int> (n + 2, -INF)));
    dp[0][0][n + 1] = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j <= n; j++) {
            for (int k = n + 1; k >= 0; k--) {
                dp[i + 1][max(j, p[i])][k] = max(dp[i][j][k] + (p[i] > j), dp[i + 1][max(j, p[i])][k]);
                dp[i + 1][j][min(k, p[i])] = max(dp[i][j][k] + (p[i] < k), dp[i + 1][j][min(k, p[i])]);
            }
        }
    }
//    mapa.clear();
//    mapa[{0, -1, -1}] = 0;
//    set<vector<int>> q;
//    q.insert({0, 0, n + 1});
//    while (!q.empty()) {
//        auto v = *q.begin();
//        q.erase(q.begin());
//        int i = v[0], j = v[1], k = v[2];
//        int val = mapa[v];
//        if (i != n) {
//            mapa[{i + 1, max(p[i], j), k}] = max(val + (p[i] > j), get({i + 1, max(p[i], j), k}));
//            q.insert({i + 1, max(p[i], j), k});
//
//            mapa[{i + 1, j, min(p[i], k)}] = max(val + (p[i] < k), get({i + 1, j, min(p[i], k)}));
//            q.insert({i + 1, j, min(p[i], k)});
//        }
//    }
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            ans = max(ans, dp[n][i][j]);
        }
    }
//    for (int i = 1; i <= n; i++) {
//        for (int j = 1; j <= n; j++) {
//            //if (get({n, i, j}) != 0) cout << get({n, i, j}) << " " << i << " " << j << endl;
//            ans = max(ans, get({n, i, j}));
//        }
//    }
    return ans;
}

int ochev(int n, vector<int> p, vector<int>& l1, vector<int>& l2) {
    int ans = 0;
    for (int i = 0; i < (1 << n); i++) {
        vector<int> l, r;
        for (int j = 0; j < n; j++) {
            if (i & (1 << j)) {
                l.push_back(p[j]);
            } else {
                r.push_back(p[j]);
            }
        }
        if (!l.empty() && !r.empty()) {
            int mx = 0, mn = n + 1;
            int c = 0;
            for (int j : l) {
                if (j > mx) {
                    c++;
                    mx = j;
                }
            }
            for (int j : r) {
                if (j < mn) {
                    c++;
                    mn = j;
                }
            }
            if (c > ans) {
                ans = c;
                l1 = l;
                l2 = r;
            }
        }
    }
    return ans;
}

mt19937 rnd(3);

vector<int> gen() {
    int n = rnd() % 15 + 1;
    vector<int> a(n);
    for (int i = 0; i < n; i++) a[i] = i + 1;
    shuffle(a.begin(), a.end(), rnd);
    return a;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    int n;
    vector<int> p;
    while(t--) {
        cin >> n;
        p.assign(n, 0);
        for (int& i : p) cin >> i;
        cout << solve(n, p) << endl;
    }

//    vector<int> l1, l2;
//    for (int _ = 0; _ < 100; _++) {
//        vector<int> t = gen();
//        int ans1 = solve(t.size(), t);
//        int ans2 = ochev(t.size(), t, l1, l2);
//        if (ans1 != ans2) {
//            cout << t.size() << endl;
//            for (int i : t) cout << i << " ";
//            cout << endl << ans1 << " " << ans2 << endl;
//            for (int i : l1) cout << i << " ";
//            cout << endl;
//            for (int i : l2) cout << i << " ";
//            cout << endl;
//            break;
//        }
//    }
}
