#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;

struct Solution {
    int TEST = -1;

    Solution(int TEST = -1) : TEST(TEST) {}

    vector<vector<int>> g;
    vector<bool> lft;
    vector<vector<int>*> pths;
    vector<int> dps;

    void dfs1(int v, int d = 0) {
        dps[v] = d;
        for (auto it : g[v]) {
            dfs1(it, d + 1);
        }
    }

    void fmn(int v, vector<int>* cur) {
        if (g[v].empty()) {
            pths.push_back(cur);
            return;
        }
        sort(g[v].begin(), g[v].end(), [&](int l, int r) {
            return dps[l] > dps[r];
        });
        for (int i = 1; i < (int)g[v].size(); ++i) {
            fmn(g[v][i], new vector<int>{g[v][i]});
        }
        cur->push_back(g[v][0]);
        fmn(g[v][0], cur);
    }

    signed operator()() {
        int n; cin >> n;
        vector<array<int, 3>> ar(n);
        for (int i = 0; i < n; ++i) {
            cin >> ar[i][0] >> ar[i][1];
            ar[i][2] = i;
        }
        sort(ar.begin(), ar.end(), [&](array<int, 3> l, array<int, 3> r) {
            if (l[0] != r[0]) {
                return l[0] < r[0];
            }
            return l[1] > r[1];
        });
        g.resize(n);
        vector<int> ids;
        int kjd = 0;
        vector<int> rts;
        for (auto& it : ar) {
            while (!ids.empty() && ar[ids.back()][1] < it[0])
                ids.pop_back();
            if (ids.empty()) {
                rts.push_back(it[2]);
            }
            if (ids.size())
                g[ar[ids.back()][2]].push_back(it[2]);
            ids.push_back(kjd++);
        }
        g.push_back(rts);
        int m = 0;
        for (int i = 0; i < n; ++i) {
            if (g[i].empty()) {
                m++;
            }
        }
        int hm = m / 2;
        int nlft = n / 2;
        lft.resize(n, true);
        dps.resize(n);
        dfs1((int)g.size() - 1);
        fmn((int)g.size() - 1, new vector<int>{});
        sort(pths.rbegin(), pths.rend(), [](vector<int>* l, vector<int>* r) {
            return l->size() < r->size();
        });
        while (hm--) {
            vector<int> td = *pths.back();
            pths.pop_back();
            for (auto& it : td) {
                lft[it] = false;
                nlft--;
            }
        }
        vector<int> odl;
        for (int i = 0; i < n; ++i) {
            if (lft[i]) {
                int cnt = 0;
                for (auto &it: g[i]) {
                    if (lft[it]) {
                        cnt++;
                    }
                }
                if (cnt != 0) {
                    odl.push_back(i);
                }
            }
        }
        for (auto& it : odl) {
            if (nlft == 0)
                break;
            nlft--;
            lft[it] = 0;
        }
        for (int i = 0; i < n; ++i) {
            if (lft[i]) {
                cout << i + 1 << " ";
            }
        }
        cout << endl;
        return 0;
    }
};

signed main() {
    (*cin.tie(0)).sync_with_stdio(0);
    int t = 1;
    cin >> t;
    for (int test = 1; test <= t; ++test) {
        int res = Solution(test)();
        if (res != 0) {
            return res;
        }
    }
    return 0;
}





//228
//6
//1 6
//2 4
//7 12
//8 11
//13 20
//21 22

//4 228
//1 1 3 5
//1234
//100 4 4

//

//10
//1 3
//4 7
//5 6
//8 13
//9 12
//10 11
//14 19
//15 18
//16 17
//1 20
