#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
vector<vector<ll>> ch;
vector<ll> x, tin, s, a;
vector<vector<ll>> tree;
ll T = 0;
void dfs(ll v, ll z = -1) {
	tin[v] = T++;
	if ((ll)ch[v].size() == 0) return;
	x[ch[v][0]] = x[v] + (z == 1);
	dfs(ch[v][0], 0);
	s[v] += s[ch[v][0]];
	x[ch[v][1]] = x[v] + (z == 0);
	dfs(ch[v][1], 1);
	s[v] += s[ch[v][1]];
}
void build(ll v, ll l, ll r) {
	for (ll i = l; i < r; ++i) tree[v].push_back(a[i]);
	sort(tree[v].begin(), tree[v].end());
	if (r - l == 1) return;
	ll m = (l + r) / 2;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
}
ll Cnt(ll v, ll l, ll r, ll a, ll b, ll x) {
	if (l >= b || r <= a) return 0;
	if (l >= a && r <= b) {
		ll L = -1, R = (ll)tree[v].size();
		while (R - L > 1) {
			ll M = (L + R) / 2;
			if (tree[v][M] > x) R = M;
			else L = M;
		}
		return R;
	}
	ll m = (l + r) / 2;
	return Cnt(2 * v + 1, l, m, a, b, x) + Cnt(2 * v + 2, m, r, a, b, x);
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, k, q;
	cin >> n >> k >> q;
	ch.resize(n);
	for (ll i = 0; i < n; ++i) {
		ll z;
		cin >> z;
		ch[i].resize(z);
		for (ll j = 0; j < z; ++j) cin >> ch[i][j], --ch[i][j];
	}
	x.assign(n, 0);
	s.assign(n, 1);
	tin.resize(n);
	dfs(0);
	a.resize(n);
	for (ll i = 0; i < n; ++i) a[tin[i]] = (((ll)ch[i].size() == 0) ? (x[i]) : (1e18));
	tree.resize(4 * n);
	build(0, 0, n);
	while (q--) {
		ll u;
		cin >> u;
		--u;
		cout << Cnt(0, 0, n, tin[u], tin[u] + s[u], k) << "\n";
	}
	cout << endl;
	return 0;
}