#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    long long n, m, k;
    cin >> n >> m >> k;
    vector<pair<long long, long long>> a(k);
    vector<long long> xs(k);
    vector<long long> ys(k);
    for (long long i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
        a[i].first--;
        a[i].second--;
        xs[i] = a[i].second;
        ys[i] = a[i].first;
    }

    sort(xs.begin(), xs.end());
    sort(ys.begin(), ys.end());

    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());
    ys.resize(unique(ys.begin(), ys.end()) - ys.begin());

    long long miny = n;
    long long minx = m;
    long long xop = 0;
    long long yop = 0;

    for (long long i = 0; i < (long long)xs.size(); i++) {
        long long cend = i - 1;
        if (cend < 0) {
            cend += xs.size();
        }
        long long clastcoord = xs[cend];
        if (clastcoord < xs[i]) {
            clastcoord += m;
        }
        // minx = min(minx, clastcoord - xs[i] + 1);
        long long cop = max(0ll, min(m - xs[i], clastcoord - m + 1));

        if (clastcoord - xs[i] + 1 < minx) {
            minx = clastcoord - xs[i] + 1;
            xop = cop;
        } else if (clastcoord - xs[i] + 1 == minx) {
            xop = min(xop, cop);
        }
    }

    for (long long i = 0; i < (long long)ys.size(); i++) {
        long long cend = i - 1;
        if (cend < 0) {
            cend += ys.size();
        }
        long long clastcoord = ys[cend];
        if (clastcoord < ys[i]) {
            clastcoord += n;
        }
        // miny = min(miny, clastcoord - ys[i] + 1);
        long long cop = max(0ll, min(n - ys[i], clastcoord - n + 1));

        if (clastcoord - ys[i] + 1 < miny) {
            miny = clastcoord - ys[i] + 1;
            yop = cop;
        } else if (clastcoord - ys[i] + 1 == miny) {
            yop = min(yop, cop);
        }
    }

    cout << minx * miny << " " << xop + yop << "\n";
    return 0;
}