// I am forced to conform!!
// HEAT FROM FIRE --- FIRE FROM HEAT
// deadnaming and misgendering is a serious crime.


/*
10-10 I may have some good ideas for task A, now will try to implement them.
 I can even achieve full score on it --- this will be a good start despite task B being "run twice"...
*/

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
using Int = long long;


const int _n = 2'000'179;
unordered_map<Int, int> fen[_n];
void add(int _i, int _j, int x) {
    for (int i = _i; i < _n; i += i & -i) {
        for (int j = _j; j < _n; j += j & -j) {
            fen[i][j] += x;
        }
    }
}
int sum(int _i, int _j) {
    int s = 0;
    for (int i = _i; i > 0; i -= i & -i) {
        for (int j = _j; j > 0; j -= j & -j) {
            s += fen[i][j];
        }
    }
    return s;
}

void add_point(int r, int c) {
    add(1 + r, 1 + c, 1);
}
int count_points(int r1, int c1, int r2, int c2) {
    int r2c2 = sum(r2 + 1, c2 + 1);
    int r2c1 = sum(r2 + 1, c1);
    int r1c2 = sum(r1, c2 + 1);
    int r1c1 = sum(r1, c1);
    return r2c2 - r2c1 - r1c2 + r1c1;
}


int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n; Int w, h; cin >> h >> w >> n;

    vector<pair<Int, Int>> ipts;
    vector<Int> rows, cols;
    for (int i = 0; i < n; ++i) {
        Int r, c; cin >> r >> c;
        --r, --c;
        ipts.emplace_back(r, c);
        rows.push_back(r);
        cols.push_back(c);
    }

#define all(x) begin(x), end(x)
    sort(all(rows));
    sort(all(cols));
    rows.resize(unique(all(rows)) - begin(rows));
    cols.resize(unique(all(cols)) - begin(cols));
    int R = size(rows);
    int C = size(cols);

    vector<pair<int, int>> pts;
    for (auto [r, c] : ipts) {
        r = lower_bound(all(rows), r) - begin(rows);
        c = lower_bound(all(cols), c) - begin(cols);
        pts.emplace_back(r, c);
        add_point(r, c);
        add_point(r+R,c);
        add_point(r,c+C);
        add_point(r+R,c+C);
    }

    Int ans_idx = -1, ans_val = w * h + 1, ans_st = 0;
    auto update_ans = [&](int r, int c, int r2, int c2, int pi) {
        Int _c = cols[c], _c2 = cols[c2 % C];
        Int _r = rows[r], _r2 = rows[r2 % R];
        Int _w = (_c2 - _c + 1 + w) % w; if (_w == 0) _w = w;
        Int _h = (_r2 - _r + 1 + h) % h; if (_h == 0) _h = h;
        Int _area = _w * _h;
        if (_area < ans_val) {
            ans_val = _area;
            ans_st = (pi != -1 ? min(_r, h-_r) + min(_c, w-_c) : 0);
            ans_idx = pi;
        }
    };
    // when ZERO steps...
    update_ans(0, 0, R-1, C-1, -1);
    for (int pi = 0; pi < n; ++pi) {
        int r, c;
        tie(r, c) = pts[pi];

        int r2 = r+R-1, c2 = c+C-1;
        int le, ri;

        // Two binary searches; need range query---

        // first: height
        le = 0, ri = R;  // (0 -> R] is (r-1 -> r-1+R] = [r -> r+R)
        while (ri - le > 1) {
            int mi = le + (ri - le) / 2;
            int cnt = count_points(r, c, r-1+mi, c2);
            if (cnt == n) {
                ri = mi;
            } else {
                le = mi;
            }
        }
        r2 = r-1+ri;

        // second: width
        le = 0, ri = C;  // (0 -> C] is (c-1 -> c-1+C] = [c -> c+C)
        while (ri - le > 1) {
            int mi = le + (ri - le) / 2;
            int cnt = count_points(r, c, r2, c-1+mi);
            if (cnt == n) {
                ri = mi;
            } else {
                le = mi;
            }
        }
        c2 = c-1+ri;

        // find area
        update_ans(r, c, r2, c2, pi);
    }

    cout << ans_val << " " << ans_st << endl;
    cerr << ans_idx;

    return 0;
}
