#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;
typedef long long ll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

void encode(){
    int n, k;
    cin >> n >> k;
    vector<int> a(k), used(k);
    for (int i = 0; i < k; i++)
        cin >> a[i];
    if (k == 1){
        cout << (a[0]) % n + 1 << endl;
    } else if (k == 2){
        ll x = a[0], y = a[1];
        x--, y--;
        if (y - x == 1 || y - x == n - 1){
            x = (x + 2) % n, y = (y + 2) % n;
        } else {
            x = (x + 1) % n, y = (y + 1) % n;
        }
        vector<ll> xs = {x + 1, y + 1};
        sort(all(xs));
        for (ll x: xs)
            cout << x << " ";
        cout << endl;
    }
}

void decode(){
    ll n, k;
    cin >> n >> k;
    vector<int> a(k), used(k);
    for (int i = 0; i < k; i++)
        cin >> a[i];
    if (k == 1)
        cout << (a[0] - 2 + n * 2) % n + 1 << endl;
    else if (k == 2){
        ll x = a[0], y = a[1];
        x--, y--;
        if (y - x == 1 || y - x == n - 1){
            x = (x - 2 + n) % n, y = (y - 2 + n) % n;
        } else {
            x = (x - 1 + n) % n, y = (y - 1 + n) % n;
        }
        vector<ll> xs = {x + 1, y + 1};
        sort(all(xs));
        for (ll x: xs)
            cout << x << " ";
        cout << endl;
    }
}

void run(){
    int a, t;
    cin >> a >> t;
    while (t--){
        if (a == 1)
            encode();
        else
            decode();
    }

}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    //fastio();
#endif
    run();
    return 0;
}