#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;
typedef long long ll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

//----------------------------------------------------

const int MAXN = 205;

int dp1[MAXN][MAXN], dp2[MAXN][MAXN];
int p[MAXN];

void solve(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> p[i];
    for (int i = 0; i <= n + 1; i++){
        fill(dp2[i], dp2[i] + n + 2, -1e9);
    }
    dp2[0][n + 1] = 0;
    for (int i = 0; i < n; i++){
        swap(dp1, dp2);
        for (int j = 0; j <= n + 1; j++)
            fill(dp2[j], dp2[j] + n + 2, -1e9);
        int x = p[i];
        for (int mx = 0; mx <= n + 1; mx++){
            for (int mn = 0; mn <= n + 1; mn++){
                if (dp1[mx][mn] < 0)
                    continue;
                if (x > mx)
                    dp2[x][mn] = max(dp2[x][mn], dp1[mx][mn] + 1);
                else
                    dp2[mx][mn] = max(dp2[mx][mn], dp1[mx][mn]);
                if (x < mn)
                    dp2[mx][x] = max(dp2[mx][x], dp1[mx][mn] + 1);
                else
                    dp2[mx][mn] = max(dp2[mx][mn], dp1[mx][mn]);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i <= n + 1; i++)
        ans = max(ans, *max_element(dp2[i], dp2[i] + n + 2));
    cout << ans << '\n';
}

void run(){
    int t;
    cin >> t;
    while (t--)
        solve();
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    run();
    return 0;
}
