#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second

using namespace std;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

//--------------------------------------

const int MAXN = 1000;

ll w[MAXN];

bitset<2 * MAXN * MAXN> bt, b1;

int pref[MAXN][MAXN];

void run(){
    int n, q;
    cin >> n >> q;
    for (int i = 0; i < n; i++)
        cin >> w[i];
    int z;
    cin >> z;
    ll k = 1e18;
    bt[0] = true;
    for (int i = 0; i < MAXN; i++){
        for (int j = 0; j < MAXN * 2; j++){
            b1[i * (2 * MAXN) + j] = j < MAXN;
        }
    }
    for (int i = 0; i < n; i++){
        ll x = w[i];
        if (x > k || x >= MAXN)
            continue;
        bitset<MAXN * MAXN * 2> bt2 = bt | (bt << (2 * MAXN * x));
        bt2 |= (bt << x);
        bt = b1 & bt2;
        //cout << endl;
        /*for (int j = 0; j < MAXN * MAXN * 2; j++){
            if (j % (2 * MAXN) == 0)
                cout << '\n';
            cout << bt[j] << " ";
        }*/
    }
    /*for (int i = 0; i < MAXN; i++){
        for (int j = 0; j < MAXN; j++){
            if (bt[i * (2 * MAXN) + j])
                cout << i << " " << j << endl;
        }
    }*/
    pref[0][0] = bt[0];
    for (int j = 1; j < MAXN; j++)
        pref[0][j] = pref[0][j - 1] + bt[j];
    for (int i = 1; i < MAXN; i++)
        pref[i][0] = pref[i - 1][0] + bt[i * (2 * MAXN)];
    for (int i = 1; i < MAXN; i++){
        for (int j = 1; j < MAXN; j++)
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + bt[i * (2 * MAXN) + j];
    }
    while (q--){
        ll a, b;
        cin >> k >> a >> b;
        if (pref[a][b] == (a + 1) * (b + 1))
            cout << "Yes\n";
        else
            cout << "No\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    run();
    return 0;
}
