#include <bits/stdc++.h>

using namespace std;
#define int long long
int A;

vector<int> uk;

int get(int u) {
    if (uk[u] == u) {
        return u;
    }
    return uk[u] = get(uk[u]);
}

void solve() {
    uk.clear();
    if (A == 1) {
        int n, k;
        cin >> n >> k;
        uk.resize(n);
        iota(uk.begin(), uk.end(), 0);
        vector<int> vec;
        for (int i = 0; i < k; ++i) {
            int a;
            cin >> a;
            a--;
            uk[a] = (a + 1) % n;
            vec.push_back(a);
        }
        vector<int> ans;
        sort(vec.begin(), vec.end());
        for (auto c : vec) {
            c = get(c);
            uk[c] = (c + 1) % n;
            ans.push_back(c + 1);
        }
        sort(ans.begin(), ans.end());
        for (auto c : ans) {
            cout << c << " ";
        }
        cout << endl;
    } else {
        int n, k;
        cin >> n >> k;
        vector<bool> used(n);
        vector<int> vec;
        for (int i = 0; i < k; ++i) {
            int a;
            cin >> a;
            a--;
            used[a] = true;
            vec.push_back(a);
        }
        vector<int> ans;
        sort(vec.begin(), vec.end());
        for (auto c : vec) {
            while (used[c]) {
                c--;
                c += n;
                c %= n;
            }
            used[c] = true;
            ans.push_back(c + 1);
        }
        sort(ans.begin(), ans.end());
        for (auto c : ans) {
            cout << c << " ";
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt;
    cin >> A >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
