//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void dfs(ll v, vector<vector<ll>>& arr, vector<bool>& wc, vector<ll>& dist) {
	for (auto i : arr[v]) {
		dist[i] = dist[v] + (wc[v] != wc[i]);
		dfs(i, arr, wc, dist);
	}
}

void dfs2(ll v, vector<vector<ll>>& arr, vector<ll>& dp) {
	for (auto i : arr[v]) {
		dfs2(i, arr, dp);
		dp[v] += dp[i];
	}
}

void solve() {
	ll n, k, q;
	cin >> n >> k >> q;
	vector<vector<ll>> arr(n);
	vector<ll> p(n, 0);
	for (ll i = 0; i < n; i++) {
		ll c;
		cin >> c;
		for (ll j = 0; j < c; j++) {
			ll b;
			cin >> b;
			b--;
			arr[i].push_back(b);
			p[b] = i;
		}
	}
	vector<bool> wc(n);
	for (ll i = 1; i < n; i++) {
		wc[i] = i == arr[p[i]][0];
	}
	vector<ll> dist(n, 0);
	for (auto i : arr[0]) {
		dfs(i, arr, wc, dist);
	}
	vector<ll> dp(n, 0);
	for (ll i = 0; i < n; i++) {
		if (arr[i].empty() && dist[i] <= k) {
			dp[i] = 1;
		}
	}
	dfs2(0, arr, dp);
	for (ll i = 0; i < q; i++) {
		ll a;
		cin >> a;
		a--;
		cout << dp[a] << '\n';
	}
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
}
