//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,abm,popcnt,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

ll x, y, m;

void dfs(ll v, ll p, vector<ll>& dpv, vector<ll>& dp, vector<vector<ll>>& tree, vector<ll>& c) {
	dp[v] = c[v];
	for (auto i : tree[v]) {
		if (i != p) {
			dfs(i, v, dpv, dp, tree, c);
			dp[v] += dpv[i];
			dpv[v] += dp[i];
		}
	}
	assign_max(dp[v], dpv[v]);
}


void dfs2(ll v, ll p, vector<ll>& dpv, vector<ll>& dp, vector<vector<ll>>& tree, vector<bool>& have, bool cb = true) {
	if (!cb || dp[v] == dpv[v]) {
		for (auto i : tree[v]) {
			if (i != p) {
				dfs2(i, v, dpv, dp, tree, have, true);
			}
		}
	} else {
		have[v] = true;
		for (auto i : tree[v]) {
			if (i != p) {
				dfs2(i, v, dpv, dp, tree, have, false);
			}
		}
	}
}

void solve() {
	ll n, q;
	cin >> n >> q;
	cin >> x >> y >> m;
	vector<vector<ll>> tree(n);
	for (ll i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		a--;
		b--;
		tree[a].push_back(b);
		tree[b].push_back(a);
	}
	vector<ll> arr(n);
	for (ll i = 0; i < n; i++) {
		ll x;
		cin >> x >> arr[i];
	}
	vector<pair<ll, ll>> qs(q);
	vector<ll> qns(q);
	for (ll i = 0; i < q; i++) {
		cin >> qs[i].first;
		qns[i] = qs[i].first;
		qs[i].second = i;
	}
	sort(qs.begin(), qs.end());
	vector<ll> dp(n), dpv(n);
	dfs(0, 0, dpv, dp, tree, arr);
	ll ma = dp[0];
	vector<bool> have(n, false);
	dfs2(0, 0, dpv, dp, tree, have);
	vector<ll> now(n, 0);
	vector<ll> all;
	for (ll i = 0; i < n; i++) {
		if (have[i]) {
			all.push_back(i);
		}
	}
	vector<ll> allo = all;
	vector<ll> ans(q);
	ll nh = 0, na = 0;
	for (ll i = 0; i < n; i++) {
		na ^= (x * (i + 1)) % m;
	}
	for (auto[i, j] : qs) {
		if (i > ma) {
			ans[j] = -1;
			continue;
		}
		while (nh < i) {
			ll nv = all.back();
			na ^= (x * (nv + 1) + now[nv] * now[nv] % m * y) % m;
			if (arr[nv] - now[nv] > i - nh) {
				now[nv] += i - nh;
				nh = i;
			} else {
				nh += arr[nv] - now[nv];
				now[nv] = arr[nv];
				all.pop_back();
			}
			na ^= (x * (nv + 1) + now[nv] * now[nv] % m * y) % m;
		}
		ans[j] = na;
	}
	for (auto i : ans) {
		cout << i << ' ';
	}
	cout << endl;
	ll x;
	cin >> x;
	while (x) {
		x--;
		ll nq = qns[x];
		if (nq > ma) {
			cout << -1 << endl;
			cin >> x;
			continue;
		}
		vector<ll> na(n, 0);
		all = allo;
		while (nq) {
			ll nv = all.back();
			all.pop_back();
			na[nv] = min(nq, arr[nv]);
			nq -= na[nv];
		}
		for (auto i : na) {
			cout << i << ' ';
		}
		cout << endl;
		cin >> x;
	}
}

bool l = false;

int main() {
#ifdef LOCAL
	l = true;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		solve();
	}
}
