#ifdef LOCAL_JUDGE
#define _GLIBCXX_DEBUG
#endif

#pragma GCC optimize("Ofast")
#pragma GCC target("tune=native")
#include <bits/stdc++.h>
using namespace std;
using ps = pair<size_t, size_t>;

#define ws paodgoiarg


struct DebugPrint : ostream {} cnul;
template <class T>
DebugPrint& operator<<(DebugPrint& dst, const T& src) {return dst;}
#ifdef LOCAL_JUDGE
#define cdbg cout
#define dprint(x) cdbg << #x << ": " << x << endl;
#else
#define cdbg cnul
#define dprint(x)
#endif

size_t make_key(size_t a, size_t b) {
  return (a << 32) | b;
}
pair<size_t, size_t> unpack_key(size_t v) {
  return make_pair(v >> 32, v & ((1ull << 32) - 1));
}


size_t n, q, i, z, k, a, b, v;
vector<size_t> ws, cr;
int main() {
  #ifdef LOCAL_JUDGE
  freopen("/home/roi/work/0405C/test.in", "r", stdin);
  #endif

  ios_base::sync_with_stdio(false); cin.tie(NULL);

  cin >> n >> q;
  ws.resize(n); for (auto& w : ws) cin >> w;
  sort(ws.begin(), ws.end());


  cr.resize(n + 1);
  for (i = 0; i < n; i++) {
    cr[i] = v;
    if (ws[i] <= v + 1) v += ws[i];
  }
  cr.back() = v;


  /*
  array<bitset<1501>, 1501> min_apple_r, min_apple_i;
  min_apple_r[make_key(0, 0)] = 0; new_min_apple_r[make_key(0, 0)] = 0;
  min_apple_i[make_key(0, 0)] = 0;
  for (auto& w : ws) {
    if (w > 1500) break;

    for (auto& [key, c] : min_apple_r) {
      auto [a, b] = unpack_key(key);
      if (!new_min_apple_r.count(make_key(a + w, b))) new_min_apple_r[make_key(a + w, b)] = w;
      if (!new_min_apple_r.count(make_key(a, b + w))) new_min_apple_r[make_key(a, b + w)] = w;
    }
    swap(new_min_apple_r, min_apple_r);
  }

  dprint(min_apple_r.size());

  for (size_t a = 0; a <= 1500; a++) {
    for (size_t b = 0; b <= 1500; b++) {
      if (a && !min_apple_r.count(make_key(a - 1, b))) {
        min_apple_i[make_key(a, b)] = -1ull;
        break;
      }
      if (b && !min_apple_r.count(make_key(a, b - 1))) {
        min_apple_i[make_key(a, b)] = -1ull;
        break;
      }

      min_apple_i[make_key(a, b)] = min_apple_r[make_key(a, b)];
      if (a) min_apple_i[make_key(a, b)] = max(min_apple_i[make_key(a, b)], min_apple_i[make_key(a - 1, b)]);
      if (b) min_apple_i[make_key(a, b)] = max(min_apple_i[make_key(a, b)], min_apple_i[make_key(a, b - 1)]);
    }
  }

  dprint(min_apple_i.size());
  */

  cin >> z;

  v = i = 0;
  while (q--) {
    cin >> k >> a >> b;
    k -= v * z;
    a -= v * z;
    b -= v * z;

    ++i;

    size_t apple_idx = upper_bound(ws.begin(), ws.end(), k) - ws.begin();
    if (a + b <= cr[apple_idx]) {
      cout << "Yes\n";
      v += i;
    } else {
      cout << "No\n";
    }

    /*
    if (min_apple_i[make_key(a, b)] <= k) {
      cout << "Yes\n";
      v += i;
    } else {
      cout << "No\n";
    }
    */
  }

  return 0;
}
