#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n, q, z;
vector<ll> w;


int main() {
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    cin >> n >> q;
    w.resize(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    vector <pair<int, int>> qr(q);
    cin >> z;
    if (n<=10 and q<=10) {
        while (q--) {
            ll k, a, b;
            cin >> k >> a >> b;
            if (a>2000 or b>2000) {
                cout << "No\n";
                continue;
            }
            set <pair<int, int>> s;
            s.insert({0, 0});
            for (int i = 0; i<n; i++) {
                if (w[i] > k or w[i] > 2000) continue;
                set <pair <int, int>> ss;
                for (auto v : s) {
                    if (v.first > 2000 or v.second > 2000) continue;
                    ss.insert(v);
                    ss.insert({v.first+w[i], v.second});
                    ss.insert({v.first, v.second+w[i]});
                }
                swap(s, ss);
            }

            vector<vector<bool>> dp(2000, vector<bool>(2000, false));
            vector<vector<bool>> ans(2000, vector<bool>(2000, false));
            while (!s.empty()) {
                auto p = *s.begin();
                s.erase(s.begin());
                if (p.first >= 2000 or p.second >= 2000) continue;
                dp[p.first][p.second] = true;
            }
            int mx = 1e9;
            for (int i = 0; i<2000; i++) {
                for (int j = 0; j<min(2000, mx); j++) {
                    if (!dp[i][j]) {
                        mx = j;
                        break;
                    }
                    ans[i][j] = true;
                }
            }
            if (ans[a][b]) cout << "Yes\n";
            else cout << "No\n";
        }
        return 0;
    }
    int A = 0;
    int B = 0;
    for (int i = 0; i<q; i++) {
        ll useless;
        cin >> useless;
        cin >> qr[i].first >> qr[i].second;
        A = max(A, qr[i].first + 1);
        B = max(B, qr[i].second + 1);
    }
    vector<vector<bool>> dp(A, vector<bool>(B, false));
    dp[0][0] = true;
    for (int i = 0; i < n; i++) {
        vector<vector<bool>> dd(A, vector<bool>(B, false));
        if (w[i] > A) continue;
        for (int a = 0; a < A; a++) {
            for (int b = 0; b < B; b++) {
                dd[a][b] = dp[a][b];
            }
        }
        for (int a = A-1; a >= 0; a--) {
            for (int b = 0; b < B; b++) {
                if (!dp[a][b]) continue;
                if (a + w[i] < A) dp[a+w[i]][b] = true;
            }
        }
        for (int b = B-1; b >= 0; b--) {
            for (int a = 0; a < A; a++) {
                if (!dd[a][b]) continue;
                if (b + w[i] < B) dd[a][b+w[i]] = true;
            }
        }
        for (int a = 0; a < A; a++) {
            for (int b = 0; b < B; b++) {
                dp[a][b] = dp[a][b] or dd[a][b];
            }
        }
    }
    vector<vector<bool>> ans(A, vector<bool>(B, false));
    int mx = 1e9;
    for (int i = 0; i<A; i++) {
        for (int j = 0; j<min(B, mx); j++) {
            if (!dp[i][j]) {
                mx = j;
                break;
            }
            ans[i][j] = true;
        }
    }
    for (int i = 0; i<q; i++) {
        ll k, a, b;
        a = qr[i].first;
        b = qr[i].second;
        if (ans[a][b]) cout << "Yes\n";
        else cout << "No\n";
    }
}