#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

using ll = long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-6;

#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(a) cerr << a << endl;
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
// #define int ll

int nvp[1 << 17], nup[1 << 17];


void solve4 () {
    int n; cin >> n;
    vector <int> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }
    for (int i = 0; i < (1 << n); ++i) {
        int pref = -1, cnt = 0;
        bool ok1 = true, ok2 = true;
        for (int j = 0; j < n; ++j) {
            if ((i >> j) & 1) {
                ++cnt;
                nvp[i] = max(nvp[i], nvp[i ^ (1 << j)]);
                nup[i] = max(nup[i], nup[i ^ (1 << j)]);
                if (pref != -1 && p[j] < pref) {
                    ok1 = false;
                }
                if (pref != -1 && p[j] > pref) {
                    ok2 = false;
                }
                pref = p[j];
            }
        }
        if (ok1) {
            nvp[i] = cnt;
        }
        if (ok2) {
            nup[i] = cnt;
        }
    }
    int ans = 0;
    for (int i = 0; i < (1 << n); ++i) {
        int b = 0, c = 0;
        for (int j = 0; j < n; ++j) {
            if ((i >> j) & 1) {
                b += (1 << j);
            }
            else {
                c += (1 << j);
            }
        }
        ans = max(ans, nvp[b] + nup[c]);
    }
    cout << ans << endl;
    for (int i = 0; i < (1 << 17); ++i) {
        nvp[i] = nup[i] = 0;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t; cin >> t;
    while (t--) {
        solve4();
    }
}