#include <bits/stdc++.h>
#define int long long

using namespace std;

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt;
  cin >> tt;
  while (tt--) {
    int n;
    cin >> n;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; i++) {
      cin >> p[i].first >> p[i].second;
    }
    vector<vector<int>> g(n), rg(n);
    sort(p.begin(), p.end());
    bool flag = true;
    for (int i = 1; i < n; i++) {
      flag &= p[i].first > p[i - 1].second;
    }
    if (flag) {
      cout << n / 2 << '\n';
      continue;
    }
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < n; j++) {
        if (p[i].second < p[j].first) {
          g[i].push_back(j);
          rg[j].push_back(i);
        }
      }
    }
    vector<int> topsort;
    vector<bool> used(n);
    function<void(int)> dfs1 = [&](int v) {
      used[v] = true;
      for (auto& to : g[v]) {
        if (!used[to]) {
          dfs1(to);
        }
      }
      topsort.push_back(v);
    };
    for (int i = 0; i < n; i++) {
      if (!used[i]) {
        dfs1(i);
      }
    }
    reverse(topsort.begin(), topsort.end());
    vector<int> dp(n);
    for (auto& v : topsort) {
      for (auto& to : rg[v]) {
        dp[v] = max(dp[v], dp[to]);
      }
      dp[v] += 1;
    }
    for (int i = 0; i < n; i++) {
      for (auto& to : g[i]) {
        assert(dp[i] < dp[to]);
      }
    }
    int m = *max_element(dp.begin(), dp.end());
    assert(m % 2 == 0);
    vector<vector<int>> h(m + 1);
    for (int i = 0; i < n; i++) {
      h[dp[i]].push_back(i);
    }
    int need = m / 2;
    int d = 0;
    vector<bool> bl(n);
    while (need > 0) {
      int mn = -1;
      for (int i = 1; i <= m; i++) {
        if (!h[i].empty() && (mn == -1 || h[mn].size() > h[i].size())) {
          mn = i;
        }
      }
      for (auto& i : h[mn]) bl[i] = true;
      assert(mn != -1);
      d += (int)h[mn].size();
      need -= 1;
      h[mn].clear();
    }
    assert(d <= n / 2);
    set<int> cc;
    vector<int> pr(n, -1);
    dp.assign(n, 0);
    for (int v : topsort) {
      if (bl[v]) continue;
      for (auto& to : rg[v]) {
        if (bl[to]) continue;
        if (dp[to] > dp[v]) {
          dp[v] = dp[to];
          pr[v] = to;
        }
      }
      dp[v] += 1;
    }
    int x = -1;
    for (int i = 0; i < n; i++) {
      if (bl[i]) continue;
      if (x == -1 || dp[i] > dp[x]) {
        x = i;
      }
    }
    while (x != -1) {
      cc.insert(x);
      x = pr[x];
    }
    for (int i = 1; i <= m; i++) {
      for (int j = (int)h[i].size() - 1; j >= 0; j--) {
        if (d < n / 2 && cc.find(h[i][j]) == cc.end()) {
          h[i].erase(h[i].begin() + j);
          d++;
        }
      }
    }
    vector<int> ans;
    for (int i = 1; i <= m; i++) {
      for (auto& j : h[i]) ans.push_back(j);
    }
    sort(ans.begin(), ans.end());
    assert(ans.size() == n / 2);
    for (auto& i : ans) cout << i + 1 << ' ';
    cout << '\n';
  }
}